//---------------------------------------
// CARG Class - Argc, Argv[eBeB
// Copyright (c) 2002, K. Yoshida
//---------------------------------------

class CARG
{
public:
	int		m_Argc;					//R}hC̐
	CSTR	m_Argv[MAX_PATH];		//R}hC
	CSTR	m_Drive;				//P̃hCu
	CSTR	m_Path;					//P̃pX
	CSTR	m_FileName;				//P̃t@C
	CSTR	m_Ext;					//P̊gq

	CARG();						//R}hC𕪉
	CARG(char*);				//𕪉ihCuApXAt@C͗pj
	int c() {return m_Argc;}
	char* v(int i) {return m_Argv[i].ToChar();}
	char* Drive()  {return m_Drive.ToChar();}
	char* Path()  {return m_Path.ToChar();}
	char* FileName()  {return m_FileName.ToChar();}
	char* Ext() {return m_Ext.ToChar();}
	char* GetLongName(char*);	//ɃXy[X΃_uR[e[V
	char* GetQuatoOff(char*);	//Ƀ_uR[e[V΂Ƃ
	CARG& operator = (char*);
};

//R}hC𕪉
CARG::CARG() {

	//R}hCBuffɃRs[
	CSTR Buff(GetCommandLine());
	//Xy[Xŋ؂ꂽi""ň͂܂ꂽ̂܂ށj؂o
	for(m_Argc = 0; Buff.Next(m_Argv[m_Argc]); m_Argc++);
	//P𕪉
	Buff = m_Argv[0].ToChar();
	//̐擪ispjƖ(epj̃|C^[ݒ肷
	unsigned char* sp = (unsigned char*)Buff.ToChar();
	unsigned char* ep = (unsigned char*)Buff.ToChar() + lstrlen(Buff.ToChar()) - 1;
	char* last = 0;				//Ō'\'w|C^[
	if(*sp == '\"' && *ep == '\"')
		*ep = NULL;	//u""vň͂܂ĂΊOiNULLwj
	//'\'T
	while(sp < ep) {
		if(*sp == '\\')
		last = (char*)sp;		//spi߂̂lastɋL^
		//Shift-JIS̑1oCgi0x81-0x9F܂0xE0-0xEFjȂ2oCgi߂
		if((*sp >= 0x81 && *sp <= 0x9F) || (*sp >= 0xE0 && *sp <= 0xEF))
			sp += 2;
		else
			sp++;				//spi߂
	}
	if(!last) {					//'\\'ꍇAlast0ł
		MessageBox(NULL, "̍\@ł", "G[", MB_OK | MB_ICONERROR);
		return;
	}
	*last = NULL;				//pXƃt@C؂藣
	//P̃t@Co
	m_FileName = (last + 1);
	//P̊gqo
	char* p = strstr(m_FileName.ToChar(), ".");
	p ? (m_Ext = (p + 1)) : (m_Ext = "");
	//P̃pXo
	m_Path = Buff;
	for(p =  Buff.ToChar(); *p && *p != ':'; p++);
	if(*p == ':') {
		*(p + 1) = NULL;
		//P̃hCuo
		m_Drive = Buff;
	}
	else
		m_Drive = "";
}

//𕪉ihCuApXAt@C͗pj
CARG::CARG(char* str) {

	//strBuffɃRs[
	CSTR Buff(str);
	//Xy[Xŋ؂ꂽi""ň͂܂ꂽ̂܂ށj؂o
	for(m_Argc = 0; Buff.Next(m_Argv[m_Argc]); m_Argc++);
	//P𕪉
	Buff = m_Argv[0].ToChar();
	//̐擪ispjƖ(epj̃|C^[ݒ肷
	unsigned char* sp = (unsigned char*)Buff.ToChar();
	unsigned char* ep = (unsigned char*)Buff.ToChar() + lstrlen(Buff.ToChar()) - 1;
	char* last = 0;				//Ō'\'w|C^[
	if(*sp == '\"' && *ep == '\"')
		*ep = NULL;	//u""vň͂܂ĂΊOiNULLwj
	//'\'T
	while(sp < ep) {
		if(*sp == '\\')
		last = (char*)sp;		//spi߂̂lastɋL^
		//Shift-JIS̑1oCgi0x81-0x9F܂0xE0-0xEFjȂ2oCgi߂
		if((*sp >= 0x81 && *sp <= 0x9F) || (*sp >= 0xE0 && *sp <= 0xEF))
			sp += 2;
		else
			sp++;				//spi߂
	}
	if(!last) {					//'\\'ꍇAlast0ł
		MessageBox(NULL, "̍\@ł", "G[", MB_OK | MB_ICONERROR);
		return;
	}
	*last = NULL;				//pXƃt@C؂藣
	//P̃t@Co
	m_FileName = (last + 1);
	//P̊gqo
	char* p = strstr(m_FileName.ToChar(), ".");
	p ? (m_Ext = (p + 1)) : (m_Ext = "");
	//P̃pXo
	m_Path = Buff;
	for(p =  Buff.ToChar(); *p && *p != ':'; p++);
	if(*p == ':') {
		*(p + 1) = NULL;
		//P̃hCuo
		m_Drive = Buff;
	}
	else
		m_Drive = "";
}

//ɃXy[X΃_uR[e[V
char* CARG::GetLongName(char* str) {

	static char Buff[MAX_PATH];
	bool IsSpace = FALSE;
	for(int i = lstrlen(str) - 1; i > 0; i--)
		if(isspace(str[i])) {
			IsSpace = TRUE;
			break;
		}
	if(IsSpace) {
		lstrcpy(Buff, "\"");
		lstrcat(Buff, str);
		lstrcat(Buff, "\"");
		return Buff;
	}
	else
		return str;
}

//Ƀ_uR[e[V΂Ƃ
char* CARG::GetQuatoOff(char* str) {

	if(*str == '\"') {
		lstrcpy(str, str + 1);
		for(int i = lstrlen(str) - 1; i >= 0; i--)
			if(str[i] == '\"') {
				str[i]= NULL;
				break;
			}
	}
	return str;
}

//̑
CARG& CARG::operator = (char* cp) {

	CARG arg(cp);
	m_Argc = arg.m_Argc;			//R}hC̐
	for(int i = 0; i < m_Argc; i++)
		m_Argv[i] = arg.m_Argv[i];	//R}hC
	m_Drive = arg.m_Drive;			//P̃hCu
	m_Path = arg.m_Path;			//P̃pX
	m_FileName = arg.m_FileName;	//łP̃t@C
	m_Ext = arg.m_Ext;			//łP̊gq
	return *this;
}
