//////////////////////////////////////
//  CDLGNXwb_[i`t@Cj
//////////////////////////////////////

class CDLG
{
protected:
	HANDLE	m_hMutex;
	char	m_UniqName[MAX_PATH];

public:	//o[ϐ
	HWND		m_hWnd;				//{_CAÕnh
	HWND		m_hParent;			//ẽnh
	HINSTANCE	m_hInstance;		//ẽCX^X
	HACCEL		m_Accel;			//Accelerator̗L
	MSG			m_Msg;				//EBhEbZ[W

public:	//o[֐
	CDLG();									//ftH[gRXgN^[
	CDLG(char*);							//UniqueNametRXgN^[
	~CDLG();								//fXgN^[
	HWND GetHandle() {return m_hWnd;}		//_CAOnhԂ
	void SetHandle(HWND h) {m_hWnd = h;}	//__CAÕnhݒ
	HINSTANCE GetInstance() {return m_hInstance;}	//CX^XԂ
	void SetInstance(HINSTANCE hInst) {m_hInstance = hInst;}	//CX^Xݒ
	int DoModal(HWND, LPCTSTR, DLGPROC,
				HINSTANCE);					//[__CAOJ
	bool EndModal(int);						//[__CAO߂
	bool Create(HWND, LPCTSTR, DLGPROC);	//[hX_CAOJiẽCX^Xj
	bool Create(HWND, HINSTANCE, LPCTSTR,
					DLGPROC);				//[hX_CAOJ
	bool Destroy();							//[hX_CAO߂
	bool IsCDLGMsg(MSG*);					//IsDialogMessage֐CDLG
	LRESULT SendMsg(UINT, WPARAM, LPARAM);	//_CAOւ̃bZ[W
	LRESULT SendItemMsg(int, UINT,
						WPARAM, LPARAM);	//_CAORg[ւ̃bZ[W
	virtual	bool OnInit(WPARAM, LPARAM);	//WM_INITDIALOG
	virtual	bool OnNotify(WPARAM, LPARAM);	//WM_NOTIFY
	virtual	bool OnClose(WPARAM, LPARAM);	//WM_CLOSE
	bool InclAccel(LPCTSTR);				//Modeless DialogpANZ[^[[h֐
	UINT Loop();							//Modeless DialogpbZ[W[v
	bool IsOnlyOne();						//QdNh~֐
};

//ftH[gRXgN^[
CDLG::CDLG() {
	m_hWnd = m_hParent = 0;
	m_Accel = 0;
	*m_UniqName = NULL;
}

//UniqueNametRXgN^[
CDLG::CDLG(char* UName) {
	m_hWnd = m_hParent = 0;
	m_Accel = 0;
	wsprintf(m_UniqName, "%d", UName);
}

//fXgN^[
CDLG::~CDLG() {

	if(m_hMutex)
		CloseHandle(m_hMutex);
}

//[__CAOJ
int CDLG::DoModal(HWND hParent, LPCTSTR DlgName, DLGPROC Proc,
				  HINSTANCE hInstance = 0) {

	if(m_hWnd) 	return FALSE;
	//eEBhẼnhL^
	m_hParent = hParent;
	//eEBhẼCX^X擾ċL^
	if(hInstance)
		m_hInstance = hInstance;	
	else
		m_hInstance = (HINSTANCE)GetWindowLong(hParent, GWL_HINSTANCE);
	//_CAOJ
	int ret = DialogBox(m_hInstance, DlgName, hParent, Proc);
	if(ret == -1)
		return FALSE;
	return ret;
}

//[__CAO߂
bool CDLG::EndModal(int i) {

	EndDialog(m_hWnd, i);
	m_hWnd = 0;		//gpԂɂ
	return TRUE;
}

//[hX_CAOJiẽCX^Xj
bool CDLG::Create(HWND hParent, LPCTSTR DlgName, DLGPROC Proc) {

	if(m_hWnd)	return FALSE;
	//eEBhẼnhL^
	m_hParent = hParent;
	//CX^X擾ċL^
	m_hInstance = (HINSTANCE)GetWindowLong(hParent, GWL_HINSTANCE);
	//_CAOJ
	m_hWnd = CreateDialog(m_hInstance, DlgName, m_hParent, Proc);
	if(!m_hWnd)
		return FALSE;
	ShowWindow(m_hWnd, SW_SHOWNORMAL);
	UpdateWindow(m_hWnd);
	return TRUE;
	//̌チbZ[W[vփbZ[ŴŁA{̃vO
	//bZ[W[vif(!IsDialogMessage(hDlg, &Msg))
}

//[hX_CAOJ
bool CDLG::Create(HWND hParent, HINSTANCE hInstance, LPCTSTR DlgName, DLGPROC Proc) {

	if(m_hWnd)	return FALSE;
	//eEBhẼnhL^
	m_hParent = hParent;
	//CX^X擾ċL^
	m_hInstance = hInstance;
	//_CAOJ
	m_hWnd = CreateDialog(m_hInstance, DlgName, m_hParent, Proc);
	if(!m_hWnd)
		return FALSE;
	ShowWindow(m_hWnd, SW_SHOWNORMAL);
	UpdateWindow(m_hWnd);
	return TRUE;
	//̌チbZ[W[vփbZ[ŴŁA{̃vO
	//bZ[W[vif(!IsDialogMessage(hDlg, &Msg))
}

//[hX_CAO߂
bool CDLG::Destroy() {

	DestroyWindow(m_hWnd);
	m_hWnd = 0;		//gpԂɂ
	return TRUE;
}

//IsDialogMessage֐CDLG
bool CDLG::IsCDLGMsg(MSG* msg) {

	return IsDialogMessage(m_hWnd, msg);
}

//SendDlgItemMessage֐CDLG
LRESULT CDLG::SendMsg(UINT Msg, WPARAM wParam, LPARAM lParam) {

	return SendMessage(m_hWnd, Msg, wParam, lParam);
}

//SendDlgItemMessage֐CDLG
LRESULT CDLG::SendItemMsg(int ID, UINT Msg, WPARAM wParam, LPARAM lParam) {

	return SendDlgItemMessage(m_hWnd, ID, Msg, wParam, lParam);
}

//WM_INITDIALOGiz֐j
bool CDLG::OnInit(WPARAM, LPARAM) {
	return TRUE;
}

//WM_NOTIFYiz֐j
bool CDLG::OnNotify(WPARAM, LPARAM) {
	return TRUE;
}

//WM_CLOSE(z֐j
bool CDLG::OnClose(WPARAM, LPARAM) {
	return TRUE;
}

//ANZ[^[
bool CDLG::InclAccel(LPCTSTR Name) {

	if(!(m_Accel = LoadAccelerators(m_hInstance, Name))) {
		MessageBox(NULL, "ANZ[^[̓ǍɎs܂",
					"G[", MB_OK);
		return FALSE;
	}
	return TRUE;
}

//bZ[W[v
UINT CDLG::Loop() {

	while(GetMessage(&m_Msg, NULL, 0, 0) > 0) {	//G[-1Ԃ
		if(!TranslateAccelerator(m_hWnd, m_Accel, &m_Msg) &&
		!IsDialogMessage(m_hWnd, &m_Msg)) {
			TranslateMessage(&m_Msg);
			DispatchMessage(&m_Msg);
		}
	}
	return m_Msg.wParam;
}

bool CDLG::IsOnlyOne() {

	m_hMutex = CreateMutex(NULL, TRUE, m_UniqName);
	if (!m_hMutex) 	return FALSE;
	// GetLastError()AERROR_ALREADY_EXISTSȂA
	// łɃAvP[VNĂ
	if (GetLastError() == ERROR_ALREADY_EXISTS) {
    //dN̏
    	return FALSE;
	}
	return TRUE;
}
