///////////////////////////////////
// LISTBOXRg[`t@C
///////////////////////////////////

class CLISTBOX : public CCTRL
{
public:
public:		//o[֐
	void Init(HINSTANCE);
	bool Create(LPCTSTR, DWORD,
				DWORD, HWND,
				int, int, int,
				int, int);			//EBhE쐬֐
	void Reset();
	bool AddString(char*);
	bool InsertString(int, char*);
	bool DeleteString(int);
	int GetCursel();
	int GetCount();
	int GetTextLen(int);
	bool GetText(int, char*);
	bool SetCursel(int);
	int SelectString(char*);
};

void CLISTBOX::Init(HINSTANCE hInst) {

	m_lpClassName = "LISTBOX";
	m_hInstance = hInst;
}

bool CLISTBOX::Create(LPCTSTR WindowName,
				DWORD Style = WS_CHILD | LBS_STANDARD, DWORD ExStyle = NULL,
				HWND hParent= NULL, int hMenu = NULL,
				int x = CW_USEDEFAULT, int y = CW_USEDEFAULT,
				int w = CW_USEDEFAULT, int h = CW_USEDEFAULT) {

	m_hWnd = CreateWindowEx(m_dwExStyle = ExStyle,
					    	m_lpClassName,
							m_lpWindowName = WindowName,
							m_dwStyle = Style,
							m_x = x,
							m_y = y,
							m_Width = w,
							m_Height = h,
							m_hParent = hParent,
							m_hMenu = (HMENU)hMenu,
							m_hInstance,
							m_lpParam
	);
	if(m_hWnd == NULL) {
		MessageBox(0, "EBhE܂ł!", "G[",
				MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return FALSE;
	}
	//EBhE̕\ƍĕ`
	ShowWindow(m_hWnd, SW_SHOWNORMAL);
	UpdateWindow(m_hWnd);
	return TRUE;
}

void CLISTBOX::Reset() {
	SendMessage(m_hWnd, LB_RESETCONTENT, 0, 0);
}

bool CLISTBOX::AddString(char* str) {
	return SendMessage(m_hWnd, LB_ADDSTRING, 0, (LPARAM)str) != LB_ERR;
}

bool CLISTBOX::InsertString(int n, char* str) {
	return SendMessage(m_hWnd, LB_INSERTSTRING, n, (LPARAM)str) != LB_ERR;
}

bool CLISTBOX::DeleteString(int n) {
	return SendMessage(m_hWnd, LB_DELETESTRING, (WPARAM)n, 0) != LB_ERR;
}

int CLISTBOX::GetCursel() {
	return SendMessage(m_hWnd, LB_GETCURSEL, 0, 0);
}

int CLISTBOX::GetCount() {
	return SendMessage(m_hWnd, LB_GETCOUNT, 0, 0);
}

int CLISTBOX::GetTextLen(int n) {
	return SendMessage(m_hWnd, LB_GETTEXTLEN, (WPARAM)n, 0);
}

bool CLISTBOX::GetText(int n, char* buff) {
	return SendMessage(m_hWnd, LB_GETTEXT, (WPARAM)n, (LPARAM)buff) != LB_ERR;
}

bool CLISTBOX::SetCursel(int n) {
	return SendMessage(m_hWnd, LB_SETCURSEL, (WPARAM)n, 0) != LB_ERR;
}

int CLISTBOX::SelectString(char* str) {
	return SendMessage(m_hWnd, LB_SELECTSTRING, (WPARAM)-1, (LPARAM)str);
}

/*
ʒmR[h		
-------------   ----------------------------------------------------
LBN_DBLCLK		ڂ_uNbN
LBN_ERRSPACE	Xg{bNXg胁擾łȂ
LBN_KILLFOCUS	L[{[htH[JX
LBN_SELCANCEL	IڂLZ
LBN_SELCHANGE	IڂɁA炩̕ύX
LBN_SETFOCUS	L[{[htH[JX𓾂
*/
