///////////////////////////////
// CLISTVIEWNX`t@C
///////////////////////////////

class CLISTVIEW : public CCTRL
{
public:
	HIMAGELIST m_hLIList;				//Xgr[pC[WXg(Large)
	HIMAGELIST m_hSIList;				//Xgr[pC[WXg(Small)
	int m_imgw1;						//C[WXg(Large)pC[W̕
	int m_imgh1;						//C[WXg(Large)pC[W̍
	int m_imgnum1;						//C[WXg(Large)pC[W̍ő吔
	int m_ext1;							//C[WXg(Large)pC[W̊g
	int m_imgw2;						//C[WXg(Small)pC[W̕
	int m_imgh2;						//C[WXg(Small)pC[W̍
	int m_imgnum2;						//C[WXg(Small)pC[W̍ő吔
	int m_ext2;							//C[WXg(Small)pC[W̊g
	LV_COLUMN m_lvCol;					//VXepLV_COLUMN\
	LV_ITEM m_lvItem;					//VXepLV_ITEM\
	LV_FINDINFO m_lvFind;				//VXepLV_FINDINFOM\

public:
	CLISTVIEW();					//RXgN^[iPj
	CLISTVIEW(int, int, int, UINT, int,
			int, int, int, UINT, int);	//RXgN^[iQj
	~CLISTVIEW();						//fXgN^[
	bool Create(HWND, HINSTANCE, int, int, 
				int, int, int);			//CLISTVIEWRg[쐬֐
	void Move(int, int, int, int);		//ListViewRg[̈ړ
	int AddLargeIcon(LPCTSTR, HINSTANCE);			//C[WXgւLargeACRo^
	int AddSmallIcon(LPCTSTR, HINSTANCE);			//C[WXgւSmallACRo^
	int InsertColumn(int, int, LPTSTR, int, UINT);	//R̒ǉ
	int InsertItem(int, LPTSTR, int, LPARAM, UINT);	//ACe̒ǉ
	int SetItem(int, int, LPTSTR);		//TuACe̒ǉ
	int GetItemCount();					//ACe(sj擾
	bool Arrange(UINT);					//ACe𐮗񂷂
	void DisplayLarge();				//LargeACR̕\
	void DisplaySmall();				//SmallACR̕\
	void DisplayList();					//Xg`̕\
	void DisplayReport();				//|[g`̕\
	void Editable();					//xҏW\ɂ
	LV_ITEM FAR* GetItem(int);			//ACe̎擾
	UINT GetItemState(int, UINT);		//ACȅԃtO̎擾
	void SetItemState(int, UINT, UINT);	//ACȅԃtO̐ݒ
	void GetItemText(int, int, LPSTR, int);	//ACe̎̕擾
	void SetItemText(int, int, LPSTR);		//ACe̐̕ݒ
	int GetNextItem(int, UINT);				//ACe֐
	HWND GetEditControl();					//GfBbgRg[̃nhԂ
	HWND EditLabel(int);					//xҏWiGfBbgRg[̃nhԂj
	LV_COLUMN* GetColumn(int, LPSTR, int);	//Ȓ擾
	bool SetColumn(int, int, int, LPSTR);	//ȒύX
	void DeleteColumns(int);				//R̍폜
	bool DeleteAllItems();					//SẴACe폜
	bool DeleteItem(int);					//w肵ACe폜
	int FindItem(int, LPSTR, LPARAM);		//w肵ACeim_lvFind̏j
	bool SortItem(PFNLVCOMPARE, LPARAM);	//ACe\[g
};

//RXgN^[iPj
CLISTVIEW::CLISTVIEW() {

	m_hWnd			= 0;
	m_dwExStyle		= WS_EX_CLIENTEDGE;
	m_lpClassName	= "SYSLISTVIEW32";
	m_dwStyle		= WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_SHOWSELALWAYS;
	m_hLIList = ImageList_Create(m_imgw1 = 0, m_imgh1 = 0, ILC_COLOR4, m_imgnum1 = 0, m_ext1 = 0);
	m_hSIList = ImageList_Create(m_imgw2 = 0, m_imgh2 = 0, ILC_COLOR4 | ILC_MASK, m_imgnum2 = 0, m_ext2 = 0);
}

//RXgN^[iQj
CLISTVIEW::CLISTVIEW(int imgw1, int imgh1, int imgnum1, UINT col1, int ext1,
				int imgw2, int imgh2, int imgnum2, UINT col2, int ext2) {

	m_hWnd			= 0;
	m_dwExStyle		= WS_EX_CLIENTEDGE;
	m_lpClassName	= "SYSLISTVIEW32";
	m_dwStyle		= WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_SHOWSELALWAYS;
	m_hLIList = ImageList_Create(m_imgw1 = imgw1, m_imgh1 = imgh1, col1, m_imgnum1 = imgnum1, m_ext1 = ext1);
	m_hSIList = ImageList_Create(m_imgw2 = imgw2, m_imgh2 = imgh2, col2, m_imgnum2 = imgnum2, m_ext2 = ext2);
}

//fXgN^[
CLISTVIEW::~CLISTVIEW() {

	//ׂẴXgr[ACe폜
	ListView_DeleteAllItems(m_hWnd);
	//c[r[ō쐬C[WXgp
	ImageList_Destroy(m_hLIList);
	ImageList_Destroy(m_hSIList);
}

//CLISTVIEWRg[쐬֐
bool CLISTVIEW::Create(HWND hWnd, HINSTANCE hInstance, int ID,
				int x = 0, int y = 0, int w = 0, int h = 0) {

	m_hInstance = hInstance;
	bool res = CCTRL::Create("", m_dwStyle, m_dwExStyle, hWnd, ID, x, y, w, h);
	//Xgr[1sAObh\ɂ
	INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC = ICC_LISTVIEW_CLASSES;
	InitCommonControlsEx(&ic);
	ListView_SetExtendedListViewStyle(m_hWnd,
			ListView_GetExtendedListViewStyle(m_hWnd) |
			LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	//c[r[ɃC[WRg[Zbg
	ListView_SetImageList(m_hWnd, m_hLIList, LVSIL_NORMAL);
	ListView_SetImageList(m_hWnd, m_hSIList, LVSIL_SMALL);
	return res;
}

//CLISTVIEWRg[̈ړ
void CLISTVIEW::Move(int x, int y, int w, int h) {

	MoveWindow(m_hWnd, x, y, w, h, TRUE);
}

//C[WXgւLargeACRo^
int CLISTVIEW::AddLargeIcon(LPCTSTR ID, HINSTANCE hInstance = 0) {

	if(!hInstance)	hInstance = m_hInstance;
	return ImageList_AddIcon(m_hLIList, LoadIcon(hInstance, ID));
}

//C[WXgւSmallACRo^
int CLISTVIEW::AddSmallIcon(LPCTSTR ID, HINSTANCE hInstance = 0) {

	if(!hInstance)	hInstance = m_hInstance;
	return ImageList_AddIcon(m_hSIList, LoadIcon(hInstance, ID));
}

//R̒ǉ
int CLISTVIEW::InsertColumn(int Col, int cx, LPSTR pszText, int fmt = LVCFMT_LEFT,
							UINT mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM) {

	m_lvCol.mask = mask;
	m_lvCol.fmt = fmt;
	m_lvCol.cx = cx;
	m_lvCol.pszText = pszText;
	m_lvCol.iSubItem = Col;
	return ListView_InsertColumn(m_hWnd, Col, &m_lvCol);
}

//ACe̒ǉ
int CLISTVIEW::InsertItem(int Item, LPTSTR pszText, int Image = -1,
				LPARAM lParam = -1, UINT mask = LVIF_TEXT) {

	m_lvItem.mask = mask;
	if(Image != -1)		m_lvItem.mask |= LVIF_IMAGE;
	if(lParam != -1)	m_lvItem.mask |= LVIF_PARAM;
	m_lvItem.pszText = pszText;
	m_lvItem.iItem = Item;
	m_lvItem.iSubItem = 0;
	m_lvItem.iImage = Image;		//mask̒lŖ
	m_lvItem.lParam = lParam;		//mask̒lŖ
	return ListView_InsertItem(m_hWnd, &m_lvItem);
}

//TuACe̒ǉ
int CLISTVIEW::SetItem(int Item, int SubItem, LPTSTR pszText) {

	m_lvItem.mask = LVIF_TEXT;
	m_lvItem.pszText = pszText;
	m_lvItem.iItem = Item;
	m_lvItem.iSubItem = SubItem;
	return ListView_SetItem(m_hWnd, &m_lvItem);
}

//ACe(sj擾
int CLISTVIEW::GetItemCount() {

	return ListView_GetItemCount(m_hWnd);
}

//ACe𐮗񂷂
bool CLISTVIEW::Arrange(UINT code) {

	return ListView_Arrange(m_hWnd, code);
}

//LargeACR̕\
void CLISTVIEW::DisplayLarge() {

	SetWindowLong(m_hWnd, GWL_STYLE, WS_CHILD | WS_VISIBLE | LVS_EDITLABELS | LVS_ICON);
	Arrange(LVA_ALIGNLEFT);
}

//SmallACR̕\
void CLISTVIEW::DisplaySmall() {

	SetWindowLong(m_hWnd, GWL_STYLE, WS_CHILD | WS_VISIBLE | LVS_SMALLICON);
	Arrange(LVA_ALIGNLEFT);
}

//Xg`̕\
void CLISTVIEW::DisplayList() {

	SetWindowLong(m_hWnd, GWL_STYLE, WS_CHILD | WS_VISIBLE | LVS_LIST);
	Arrange(LVA_ALIGNLEFT);
}

//|[g`̕\
void CLISTVIEW::DisplayReport() {

	SetWindowLong(m_hWnd, GWL_STYLE, WS_CHILD | WS_VISIBLE | LVS_REPORT);
	Arrange(LVA_ALIGNLEFT);
}

//xҏW\ɂ
void CLISTVIEW::Editable() {

	SetWindowLong(m_hWnd, GWL_STYLE,
					GetWindowLong(m_hWnd, GWL_STYLE) | LVS_EDITLABELS);
	Arrange(LVA_ALIGNLEFT);
}

//ACe̎擾
LV_ITEM FAR* CLISTVIEW::GetItem(int item) {

	m_lvItem.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE | LVIF_PARAM;
	ListView_GetItem(m_hWnd, &m_lvItem);
   return &m_lvItem;
}

//ACȅԃtO̎擾
UINT CLISTVIEW::GetItemState(int item, UINT mask) {

	return (UINT)SendMessage(m_hWnd, LVM_GETITEMSTATE, (WPARAM)item, (LPARAM)mask);
}

//ACȅԃtO̐ݒ
void CLISTVIEW::SetItemState(int item, UINT data, UINT mask) {

	ListView_SetItemState(m_hWnd, item, data, mask);
}

//ACe̎̕擾
void CLISTVIEW::GetItemText(int item, int SubItem, LPSTR pszText, int max) {

	m_lvItem.mask = LVIF_TEXT;
	m_lvItem.iItem = item;
	m_lvItem.iSubItem = SubItem;
	m_lvItem.pszText = pszText;
	m_lvItem.cchTextMax = max;
	SendMessage(m_hWnd, LVM_GETITEMTEXT , (WPARAM)item, (LPARAM)&m_lvItem); 
}

//ACe̐̕ݒ
void CLISTVIEW::SetItemText(int Item, int SubItem, LPSTR str) {

	ListView_SetItemText(m_hWnd, Item, SubItem, str);
}

//ACe֐
int CLISTVIEW::GetNextItem(int start, UINT flag) {

	return ListView_GetNextItem(m_hWnd, start, flag);
}

//GfBbgRg[̃nhԂ
HWND CLISTVIEW::GetEditControl() {

	return ListView_GetEditControl(m_hWnd);
}

//xҏWiGfBbgRg[̃nhԂj
HWND CLISTVIEW::EditLabel(int item) {

	return ListView_EditLabel(m_hWnd, item);
}

//Ȓ擾
LV_COLUMN* CLISTVIEW::GetColumn(int Col, LPSTR pszText, int max) {

	m_lvCol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	m_lvCol.pszText = pszText;
	m_lvCol.cchTextMax = max;
	ListView_SetColumn(m_hWnd, Col, &m_lvCol);
	return &m_lvCol;
}

//ȒύX
bool CLISTVIEW::SetColumn(int Col, int fmt, int cx, LPSTR pszText) {

	m_lvCol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	m_lvCol.fmt = fmt;
	m_lvCol.cx = cx;
	m_lvCol.pszText = pszText;
	return ListView_SetColumn(m_hWnd, Col, &m_lvCol);
}

//R̍폜
void CLISTVIEW::DeleteColumns(int Col) {

	ListView_DeleteColumn(m_hWnd, Col);
}

//SẴACe폜
bool CLISTVIEW::DeleteAllItems() {

	return ListView_DeleteAllItems(m_hWnd);
}

//w肵ACeisj폜
bool CLISTVIEW::DeleteItem(int hitem) {

	return ListView_DeleteItem(m_hWnd, hitem);
}

//w肵ACeim_lvFind̏j
int CLISTVIEW::FindItem(int item, LPSTR str = NULL, LPARAM lParam = -1) {

	if(str) {
		m_lvFind.flags = LVFI_PARTIAL | LVFI_STRING;	// | LVFI_WRAPsv
		m_lvFind.psz = str;
		if(lParam != -1) {
			m_lvFind.flags |= LVFI_PARAM;
			m_lvFind.lParam = lParam;
		}
	}
	else {
		if(lParam != -1)
			m_lvFind.flags = LVFI_PARAM;
			m_lvFind.lParam = lParam;
	}
	return ListView_FindItem(m_hWnd, item, &m_lvFind);
}

//ACe\[g
bool CLISTVIEW::SortItem(PFNLVCOMPARE CmpProc, LPARAM lParam) {

	return ListView_SortItems(m_hWnd, CmpProc, lParam);
}
