//----------------------------------
// CTIMER Class - TimerĂяo
// Copyright (c) 2002, K. Yoshida
//----------------------------------

class CTIMER
{
public:
	HWND m_hWnd;					//^C}[bZ[W̃EBhEnh
	UINT m_nIDEvent;				//^C}[ID
	UINT m_uElapse;					//ݒ莞ԁi~ZRhj

	CTIMER();						//RXgN^[
	CTIMER(HWND, UINT, UINT);		//tRXgN^[
	~CTIMER();						//fXgN^[
	UINT Begin(HWND, UINT, UINT);	//^C}[Jn
	bool Stop();					//^C}[~
};

//RXgN^[
CTIMER::CTIMER() {

	m_hWnd = 0;
	m_nIDEvent = m_uElapse = 0;
}

//tRXgN^[
CTIMER::CTIMER(HWND hWnd, UINT nIDEvent = 1, UINT uElapse = 1) {

	Begin(hWnd, nIDEvent, uElapse);
}

//fXgN^[
CTIMER::~CTIMER() {

	Stop();
}

//^C}[Jn
UINT CTIMER::Begin(HWND hWnd, UINT nIDEvent, UINT uElapse) {

	return m_nIDEvent = SetTimer(m_hWnd = hWnd, nIDEvent, m_uElapse = uElapse, NULL);
}

//^C}[~
bool CTIMER::Stop() {

	bool ret;
	if(m_hWnd && m_nIDEvent) {
		ret = KillTimer(m_hWnd, m_nIDEvent);
		m_hWnd = 0;
		m_nIDEvent = m_uElapse = 0;
		return ret;
	}
	else
		return FALSE;
}
