///////////////////////////////
// CTREEVIEWNX`t@C
///////////////////////////////

class CTREEVIEW : public CCTRL
{
public:
	HIMAGELIST m_hIList;				//c[r[pC[WXg
	int m_imgw;							//C[WXgpC[W̕
	int m_imgh;							//C[WXgpC[W̍
	int m_imgnum;						//C[WXgpC[W̍ő吔
	int m_ext;							//C[WXgpC[W̊g
	TV_ITEM m_tvItem;					//ACe\
	TV_INSERTSTRUCT m_tvInst;			//ACeǉ\

public:
	CTREEVIEW();						//RXgN^[iPj
	CTREEVIEW(int, int, int, UINT, int);		//RXgN^[iQj
	~CTREEVIEW();						//fXgN^[
	bool Create(HWND, HINSTANCE, int, int, 
				int, int, int);			//CTREEVIEWRg[쐬֐
	void Move(int, int, int, int);		//TreeViewRg[̈ړ
	int AddBitmap(LPCTSTR, HINSTANCE,
					COLORREF);			//C[WXgւ̃rbg}bvo^
	UINT GetCount();					//ACe擾
	HTREEITEM GetRoot();				//[g擾
	HTREEITEM GetSelection();			//ݑIĂACe擾
	HTREEITEM GetParent(HTREEITEM);		//w肳ꂽACe̐e擾
	HTREEITEM GetNext(HTREEITEM);		//w肳ꂽACe̎̌Z擾
	HTREEITEM GetChild(HTREEITEM);		//w肳ꂽACe̍ŏ̎q擾
	LPTV_ITEM GetItem(HTREEITEM, char*, int);	//ACe̎擾
	HTREEITEM GetNextItem(HTREEITEM, UINT);	//UINTŎw肵֌W̃ACe擾
	HTREEITEM FindItem(HTREEITEM, char*);	//HTREEITEMȉchar*Ŏw肵̃ACe擾
	bool SelectItem(HTREEITEM);			//HTREEITEMŎw肵ACeI
	HTREEITEM InsertItem(char*, HTREEITEM,
				HTREEITEM, int, int);	//ACeǉ
	bool SetItem(HTREEITEM);			//m_tvItem̃f[^\߃ZbgĎs
	bool DeleteAllItems();				//SẴACe폜
	bool DeleteItem(HTREEITEM);			//w肵ACe폜
	bool Expand(HTREEITEM, UINT);		//ACeWJ
	bool SortChildren(HTREEITEM);		//qB\[g
};

//RXgN^[iPj
CTREEVIEW::CTREEVIEW() {

	m_hWnd			= 0;
	m_dwExStyle		= WS_EX_CLIENTEDGE;
	m_lpClassName	= "SYSTREEVIEW32";
	m_dwStyle		= WS_CHILD | WS_VISIBLE | TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS;
	m_hIList = ImageList_Create(m_imgw = 0, m_imgh = 0, ILC_COLOR4 | ILC_MASK, m_imgnum = 0, m_ext = 0);
}

//RXgN^[iQj
CTREEVIEW::CTREEVIEW(int imgw, int imgh, int imgnum, UINT col, int ext) {

	m_hWnd			= 0;
	m_dwExStyle		= WS_EX_CLIENTEDGE;
	m_lpClassName	= "SYSTREEVIEW32";
	m_dwStyle		= WS_CHILD | WS_VISIBLE | TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS;
	m_hIList = ImageList_Create(m_imgw = imgw, m_imgh = imgh, col, m_imgnum = imgnum, m_ext = ext);
}

//fXgN^[
CTREEVIEW::~CTREEVIEW() {

	//ׂẴc[r[ACe폜
	TreeView_DeleteAllItems(m_hWnd);
	//c[r[ō쐬C[WXgp
	ImageList_Destroy(m_hIList);
}

//CTREEVIEWRg[쐬֐
bool CTREEVIEW::Create(HWND hWnd, HINSTANCE hInstance, int ID,
				int x = 0, int y = 0, int w = 0, int h = 0) {

	m_hInstance = hInstance;
	bool res = CCTRL::Create("", m_dwStyle, m_dwExStyle, hWnd, ID, x, y, w, h);
	//c[r[ɃC[WRg[Zbg
	TreeView_SetImageList(m_hWnd, m_hIList, TVSIL_NORMAL);
	return res;
}

//CTREEVIEWRg[̈ړ
void CTREEVIEW::Move(int x, int y, int w, int h) {

	MoveWindow(m_hWnd, x, y, w, h, TRUE);
}

//C[WXgւ̃rbg}bvo^
int CTREEVIEW::AddBitmap(LPCTSTR ID, HINSTANCE hInstance,
							COLORREF cMask = RGB(0, 0, 0)) {

	HBITMAP hBmp = LoadBitmap(hInstance, ID);
	int ret = ImageList_AddMasked(m_hIList, hBmp, cMask);
	DeleteObject(hBmp);
	return ret;			//-1͎s
}

//ACe擾
UINT CTREEVIEW::GetCount() {

	return TreeView_GetCount(m_hWnd);
}

//[g擾
HTREEITEM CTREEVIEW::GetRoot() {

	return TreeView_GetRoot(m_hWnd);
}

//ݑIĂACe擾
HTREEITEM CTREEVIEW::GetSelection() {

	return TreeView_GetSelection(m_hWnd);
}

//w肳ꂽACe̐e擾
HTREEITEM CTREEVIEW::GetParent(HTREEITEM hitem) {

	return TreeView_GetParent(m_hWnd, hitem);
}

//w肳ꂽACe̎̌Z擾
HTREEITEM CTREEVIEW::GetNext(HTREEITEM hitem) {

	return TreeView_GetNextSibling(m_hWnd, hitem);
}

//w肳ꂽACe̍ŏ̎q擾
HTREEITEM CTREEVIEW::GetChild(HTREEITEM hitem) {

	return TreeView_GetChild(m_hWnd, hitem);
}

//ACe̎擾
LPTV_ITEM CTREEVIEW::GetItem(HTREEITEM hitem, char* Buff = 0, int size = 0) {

	m_tvItem.hItem = hitem;
	if(!Buff) {
		m_tvItem.mask = TVIF_CHILDREN | TVIF_HANDLE | TVIF_IMAGE | TVIF_PARAM |
						TVIF_SELECTEDIMAGE | TVIF_STATE;
	}
	else {
		m_tvItem.mask = TVIF_CHILDREN | TVIF_HANDLE | TVIF_IMAGE | TVIF_PARAM |
						TVIF_SELECTEDIMAGE | TVIF_STATE | TVIF_TEXT;
		m_tvItem.cchTextMax = size;
		m_tvItem.pszText = Buff;
	}
	TreeView_GetItem(m_hWnd, &m_tvItem);
	return &m_tvItem;
}

//UINTŎw肵֌W̃ACe擾
HTREEITEM CTREEVIEW::GetNextItem(HTREEITEM hitem, UINT flag = TVGN_NEXT) {

	return TreeView_GetNextItem(m_hWnd, hitem, flag);
}

//char*Ŏw肵̃ACe擾
HTREEITEM CTREEVIEW::FindItem(HTREEITEM hitem, char* text) {

	HTREEITEM hSelected = hitem, hFound;
	TV_ITEM tvitem;					//TV_ITEM\
	char Buff[MAX_PATH];			//񒷂MAX_PATHx
	while(hSelected) {				//Ō܂ŌȂhSelected0ɂȂ
		tvitem.hItem = hSelected;
		tvitem.mask = TVIF_TEXT;
		tvitem.pszText = Buff;
		tvitem.cchTextMax = MAX_PATH;
		TreeView_GetItem(m_hWnd, &tvitem);
		if(!lstrcmp(Buff, text)) {	//擾񂪓ꍇ
			return hSelected;
		}
		else {						//łȂꍇ
			//q΍ċNďoŃT[`AΏI
			if(tvitem.cChildren) {
				if((hFound = FindItem(GetChild(hSelected), text)))
					return hFound;
			}
			//茩ȂΎT
			hSelected = GetNext(hSelected);
		}
	}
	return NULL;					//SĂSiblingɖNULLԂ
}

//HTREEITEMŎw肵ACeI
bool CTREEVIEW::SelectItem(HTREEITEM hitem) {

	return TreeView_SelectItem(m_hWnd, hitem);
}

//ACeǉ
HTREEITEM CTREEVIEW::InsertItem(char* Title,
								HTREEITEM InsAfter = TVI_LAST,
								HTREEITEM Parent = TVI_ROOT,
								int Image = -1,
								int SelImage = -1) {

	ZeroMemory(&m_tvInst, sizeof(TV_INSERTSTRUCT));
	m_tvInst.hInsertAfter = InsAfter;
	m_tvInst.hParent = Parent;
	m_tvInst.item.pszText = Title;
	if(Image == -1) {
		m_tvInst.item.mask = TVIF_TEXT;
	}
	else {
		m_tvInst.item.mask = TVIF_TEXT | TVIF_IMAGE;
		m_tvInst.item.iImage = Image;
		if(SelImage != -1) {
			m_tvInst.item.mask |= TVIF_SELECTEDIMAGE;
			m_tvInst.item.iSelectedImage = SelImage;
		}
	}
	return TreeView_InsertItem(m_hWnd, &m_tvInst);
}

//m_tvItem̃f[^\߃ZbgĎs
bool CTREEVIEW::SetItem(HTREEITEM hitem) {

	m_tvItem.mask = TVIF_CHILDREN | TVIF_HANDLE | TVIF_IMAGE | TVIF_PARAM |
					TVIF_SELECTEDIMAGE | TVIF_STATE | TVIF_TEXT;
	m_tvItem.hItem = hitem;
	return TreeView_SetItem(m_hWnd, &m_tvItem);
}

//SẴACe폜
bool CTREEVIEW::DeleteAllItems() {

	return TreeView_DeleteAllItems(m_hWnd);
}

//w肵ACe폜
bool CTREEVIEW::DeleteItem(HTREEITEM hitem) {

	return TreeView_DeleteItem(m_hWnd, hitem);
}

//ACeWJ
bool CTREEVIEW::Expand(HTREEITEM hitem, UINT flag = TVE_TOGGLE) {

	return TreeView_Expand(m_hWnd, hitem, flag);
}

//qB\[g
bool CTREEVIEW::SortChildren(HTREEITEM hitem) {

	return TreeView_SortChildren(m_hWnd, hitem, 0);
}
