////////////////////////////
// CVOICENX`t@C
////////////////////////////
#include <sapi.h>							//bcc55ł̓t@CȂARpCłȂ
#include <wchar.h>
#include <string>
#include <locale.h>
using namespace std;

#define	MAX_NUM	64							//g[N̍ő吔

class CVOICE {
private:
	//ϐ
	HRESULT m_hr;							//ʔpϐ
	ISpVoice* m_pVoice;						//IuWFNg|C^[
	DWORD m_Num_of_Token;					//g[Ni̎j̐
	ISpObjectToken* m_pToken[MAX_NUM];		//g[Nւ̃|C^[ilpj
	ISpObjectTokenCategory* m_pCategory;	//g[NJeS[ւ̃|C^[
	IEnumSpObjectTokens* m_pTokens;			//񋓗pg[NQւ̃|C^[
	char m_TokenID[MAX_NUM][MAX_PATH];		//g[NKey̕p
	char m_TokenName[MAX_NUM][32];			//g[NAttributeNamep
	char m_TokenGender[MAX_NUM][7];			//g[NAttributeGenderpiMale or Femalej
	char m_TokenLanguage[MAX_NUM][5];		//g[NAttributeLanguagepi411, 409 etc|4j
	wstring m_script;						//Ǐグ郏Chiidjւ̃|C^[
	//֐
	char* GetAttribute(LPWSTR, char*);		//̎wAttribute擾

public:
	//֐
	CVOICE();								//RXgN^[
	~CVOICE();								//fXgN^[
	bool GetVoices(HWND);					//p\ȉXg{bNXɓo^
	int GetCount()							//p\ȉԂ
		{return m_Num_of_Token;}
	char* GetGender(DWORD);					//p\ȓ̉̐ʂԂ
	char* GetLanguage(DWORD);				//p\ȓ̉̌Ԃ
	bool SetVoice(DWORD);					//p\ȓ̉I
	HRESULT Speak(char*);					//XNvgǂ
	HRESULT Speak(wstring);					//XNvgǂ
	void Pause();							//ǂݏグ̒f
	void Resume();							//ǂݏグ̍ĊJ
};

//RXgN^[
CVOICE::CVOICE() {

	//P[̐ݒ
	setlocale(LC_CTYPE, "JPN");				//Chgp̂߃P[̏iPCj
	m_hr = CoInitialize(NULL);				//񂾂ĂяoCOM̏
	if(FAILED(m_hr))
		MessageBox(0, "Failed to initialize COM (Error 404)", "COM Error", MB_OK | MB_ICONERROR);
	else {
		m_pVoice = NULL;					//IuWFNg|C^[
		for(int i =0; i < MAX_NUM; i++)		//IuWFNgg[Nւ̃|C^[
			m_pToken[i] = NULL;
		m_hr = CoCreateInstance(CLSID_SpVoice, NULL, CLSCTX_ALL, IID_ISpVoice, (void **)&m_pVoice);
		if(SUCCEEDED(m_hr))
			m_hr = m_pVoice->GetVoice(&m_pToken[0]);	//ftHg̉擾
		else
			MessageBox(0, "Failed to create SAPI instance", "SAPI Error", MB_OK | MB_ICONERROR);
	}
}

//fXgN^[
CVOICE::~CVOICE() {

	m_pVoice->Release();
	m_pVoice = NULL;
	CoUninitialize();
}

//̎wAttribute擾
char* CVOICE::GetAttribute(LPWSTR ptVoiceID, char* entry) {

	static BYTE Buff[64];	//擾entry̕iREG_SZjf[^̎擾p
	char* VoiceID;			//ChptVoiceID̎epoCg|C^[
	char* cp;				//ptVoiceID͗p
	VoiceID = new char[wcslen(ptVoiceID) + 12];	//Ch{"\\Attributes"{I[k
	wcstombs(VoiceID, ptVoiceID, wcslen(ptVoiceID) + 1);	//VoiceIDimcsj
	for(cp = VoiceID; *cp && *cp!= '\\'; cp++);		//cpgčŏ́u\vi߂
	if(*cp)					//*cpNULLłȂ'\\'ł
		*cp++ = NULL;		//ŏ́u\vNULLƂAcpi߂
	else
		return NULL;		//NULLI[܂ŗ̂ŃG[
	//VoiceID̓HKEY_LOCAL_MACHINEłȂNULLԂ
	if(lstrcmp(VoiceID, "HKEY_LOCAL_MACHINE"))
		return NULL;
	//VoiceID̃TuL[AttributesKeyɂhKey擾
	lstrcat(cp, "\\Attributes");
	HKEY hKey;
	DWORD dwResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, cp, 0, KEY_READ, &hKey);
	//VoiceIDKeyJȂNULLԂ
	if(dwResult != ERROR_SUCCESS)
		return NULL;
	//Attributesentry̕f[^擾
 	DWORD type;
	DWORD cbData = sizeof(Buff);
	dwResult = RegQueryValueEx(hKey, entry, NULL, &type, Buff, &cbData);
	//VoiceIDAttributesentryǂ߂ȂNULLԂ
	if(dwResult != ERROR_SUCCESS)
		return NULL;
	RegCloseKey(hKey);
	delete [] VoiceID;	
	return (char*)Buff;
}

bool CVOICE::GetVoices(HWND listbox) {	//p\ȉXg{bNXɓo^

	if(FAILED(m_hr)) {	//CX^X쐬ɌĂԂ߁ARXgN^[̌ʂ`FbN
		MessageBox(0, "Failed to get Default Voice token", "SAPI Error", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//PDftHgJeS[̎擾
	bool RetSign1 = FALSE;
	m_hr = m_pToken[0]->GetCategory(&m_pCategory);
	if(SUCCEEDED(m_hr)) {
		m_hr = m_pCategory->EnumTokens(0, 0, &m_pTokens);	//p\g[NQ̎擾
		if(SUCCEEDED(m_hr)) {
			//g[N̗
			DWORD i;							//JE^[ϐ
			LPWSTR ptVoiceID;					//idւ̃|C^[
			m_hr = m_pTokens->GetCount(&m_Num_of_Token);	//g[Nij̎擾
			if(SUCCEEDED(m_hr)) {
				char Buff[MAX_PATH];
				for (i = 0; i < m_Num_of_Token; i++) {
					m_hr = m_pTokens->Item(i, &m_pToken[i]);
					m_hr = m_pToken[i]->GetId(&ptVoiceID);
					//ptVoiceIDwcs->mbsϊAm_TokenID[i]mcsƂĎ[iMAX_PATHj
					wcstombs(m_TokenID[i], ptVoiceID, MAX_PATH);
					//m_TokenName[i]"Name"[
					lstrcpy(m_TokenName[i], GetAttribute(ptVoiceID, "Name"));
					//m_TokenGender[i]"Gender"[
					lstrcpy(m_TokenGender[i], GetAttribute(ptVoiceID, "Gender"));
					//m_TokenLanguage[i]"Language"[
					lstrcpy(m_TokenLanguage[i], GetAttribute(ptVoiceID, "Language"));
					wsprintf(Buff, "%s (a %s with the native language of %s)", m_TokenName[i], m_TokenGender[i], m_TokenLanguage[i]);
					SendMessage(listbox, LB_INSERTSTRING, i, (LPARAM)Buff);
					CoTaskMemFree(ptVoiceID);
					RetSign1 = TRUE;
				}
			}
		}
	}
	//QDSpeech_OneCorẻJeS[̎擾
	bool RetSign2 = FALSE;
	ISpObjectTokenCategory* pCategory;
	IEnumSpObjectTokens* pTokens;
	HRESULT hr = CoCreateInstance(CLSID_SpObjectTokenCategory, NULL, CLSCTX_ALL, IID_ISpObjectTokenCategory, (void **)&pCategory);
	if(SUCCEEDED(hr)) {
		hr = pCategory->SetId(L"HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Speech_OneCore\\Voices", FALSE);
		if(FAILED(hr))
			MessageBox(0, "Can't set category id", "OneCore - SetId", MB_OK | MB_ICONERROR);
		hr = pCategory->EnumTokens(0, 0, &pTokens);	//p\g[NQ̎擾
		if(SUCCEEDED(hr)) {
			//g[N̗
			DWORD n, i;							//擾pƃJE^[ϐ
			LPWSTR ptVoiceID;					//idւ̃|C^[
			hr = pTokens->GetCount(&n);			//g[Nij̎擾
			if(SUCCEEDED(hr)) {
				char Buff[MAX_PATH];
				for (i = 0; i < n; i++) {
					hr = pTokens->Item(i, &m_pToken[m_Num_of_Token + i]);
					hr = m_pToken[m_Num_of_Token + i]->GetId(&ptVoiceID);
					//ptVoiceIDwcs->mbsϊAm_TokenID[i]mcsƂĎ[iMAX_PATHj
					wcstombs(m_TokenID[m_Num_of_Token + i], ptVoiceID, MAX_PATH);
					//m_TokenName[i]"Name"[
					lstrcpy(m_TokenName[m_Num_of_Token + i], GetAttribute(ptVoiceID, "Name"));
					//m_TokenGender[i]"Gender"[
					lstrcpy(m_TokenGender[m_Num_of_Token + i], GetAttribute(ptVoiceID, "Gender"));
					//m_TokenLanguage[i]"Language"[
					lstrcpy(m_TokenLanguage[m_Num_of_Token + i], GetAttribute(ptVoiceID, "Language"));
					wsprintf(Buff, "(OneCore) %s (a %s with the native language of %s)", m_TokenName[m_Num_of_Token + i], m_TokenGender[m_Num_of_Token + i], m_TokenLanguage[m_Num_of_Token + i]);
					SendMessage(listbox, LB_INSERTSTRING, m_Num_of_Token + i, (LPARAM)Buff);
					CoTaskMemFree(ptVoiceID);
					RetSign2 = TRUE;
				}
				m_Num_of_Token += n;
			}
		}
		pCategory->Release();
		pCategory = NULL;
	}
	return RetSign1 * RetSign2;
}

//p\ȓ̉̌Ԃ
char* CVOICE::GetLanguage(DWORD num) {

	if(num > m_Num_of_Token)	//ISpObjectToken|C^[𒴂
		return NULL;
	else
		return m_TokenLanguage[num];
}

//p\ȓ̉̐ʂԂ
char* CVOICE::GetGender(DWORD num) {

	if(num > m_Num_of_Token)	//ISpObjectToken|C^[𒴂
		return NULL;
	else
		return m_TokenGender[num];
}

//p\ȉI
bool CVOICE::SetVoice(DWORD num) {

	if(num > m_Num_of_Token)	//ISpObjectToken|C^[𒴂
		return FALSE;
	if(SUCCEEDED(m_pVoice->SetVoice(m_pToken[num])))
		return TRUE;
	else
		return FALSE;
}

//XNvgǂ
HRESULT CVOICE::Speak(char* str) {

	SPVOICESTATUS status;
	m_pVoice->GetStatus(&status, NULL);
	if(!status.dwRunningState || status.dwRunningState == SPRS_IS_SPEAKING) {
		int ync = MessageBox(0, "ݓǂݏグA܂͖ǃXNvgcĂ܂Bf܂H", "TTS Busy", MB_YESNOCANCEL | MB_ICONQUESTION);
		if(ync == IDYES) {
			m_pVoice->Speak(L"<lang langid=\"411\">f܂</lang><lang langid=\"409\">All pendeling scripts abandoned</lang>", SPF_PURGEBEFORESPEAK, NULL);
		}
		else if(ync == IDCANCEL)
			return -1;	//HRESULTFAILED̈Ӗi32bitڂ1j
	}
	size_t mbslen = _mbstrlen(str);	//mbsi1NLLɂmbstowcs(NULL, str, 0)Ɠlj
	//ChPʂŏI[ă[m
	wchar_t* wcs = new wchar_t[mbslen + 1];
	mbslen = mbstowcs(wcs, str, mbslen + 1);
	m_script = wcs;
	delete [] wcs;
	return m_pVoice->Speak(m_script.c_str(), SVSFlagsAsync, NULL);	//񓯊
//	return m_pVoice->Speak(m_script.c_str(), SVSFDefault, NULL);	//
}

//XNvgǂ
HRESULT CVOICE::Speak(wstring script) {

	SPVOICESTATUS status;
	m_pVoice->GetStatus(&status, NULL);
	if(!status.dwRunningState || status.dwRunningState == SPRS_IS_SPEAKING) {
		int ync = MessageBox(0, "ݓǂݏグA܂͖ǃXNvgcĂ܂Bf܂H", "TTS Busy", MB_YESNOCANCEL | MB_ICONQUESTION);
		if(ync == IDYES) {
			m_pVoice->Speak(L"<lang langid=\"411\">f܂</lang><lang langid=\"409\">All pendeling scripts abandoned</lang>", SPF_PURGEBEFORESPEAK, NULL);
		}
		else if(ync == IDCANCEL)
			return -1;	//HRESULTFAILED̈Ӗi32bitڂ1j
	}
	m_script = script;
	return m_pVoice->Speak(m_script.c_str(), SVSFlagsAsync, NULL);	//񓯊
//	return m_pVoice->Speak(m_script.c_str(), SVSFDefault, NULL);	//
}

//ǂݏグ̒f
void CVOICE::Pause() {

	m_pVoice->Pause();
}

//ǂݏグ̍ĊJ
void CVOICE::Resume() {

	m_pVoice->Resume();
}
