/////////////////////////////////////////
// EBhE{NXCWND`t@C
/////////////////////////////////////////

class CWND
{
public:		//o[ϐ
	HWND		m_hWnd;			//EBhEnh
	HWND		m_hParent;		//eEBhEnh
	HINSTANCE	m_hInstance;	//CX^Xϐ
	//CreateExp
	DWORD 		m_dwExStyle;
	LPCTSTR		m_lpClassName;
	LPCTSTR		m_lpWindowName;
	DWORD		m_dwStyle;
	int			m_x;
	int			m_y;
	int			m_Width;
	int			m_Height;
	HMENU		m_hMenu;
	LPVOID		m_lpParam;

public:		//o[֐
	CWND();									//RXgN^[
	~CWND();								//fRXgN^[
	virtual bool Init(LPCTSTR, HINSTANCE,
						WNDPROC, LPCTSTR,
						LPCTSTR, LPCTSTR,
						HBRUSH);			//EBhE֐
	virtual bool Create(LPCTSTR, DWORD,
						DWORD, HWND,
						int, int, int,
						int, int);			//EBhE쐬֐
	HWND GetHandle() {return m_hWnd;}		//EBhEnhԂ
	void SetHandle(HWND hWnd)
						{m_hWnd = hWnd;}	//EBhEnhݒ
	HINSTANCE GetInstance()
					{return m_hInstance;}	//CX^X
	void SetInstance(HINSTANCE hInst)
					{m_hInstance = hInst;}	//CX^Xݒ
	LRESULT SendMsg(UINT, WPARAM, LPARAM);	//EBhEւ̃bZ[W
	LRESULT SendItemMsg(int, UINT,
						WPARAM, LPARAM);	//EBhERg[ւ̃bZ[W
};

//////////////////////
// o[֐̎
//////////////////////
//RXgN^[(̂݁j
CWND::CWND() {

	m_hWnd = 0;
	m_dwExStyle		= 0;
	m_lpClassName	= NULL;
	m_lpWindowName	= NULL;
	m_dwStyle		= WS_OVERLAPPEDWINDOW;
	m_x				= CW_USEDEFAULT;
	m_y				= CW_USEDEFAULT;
	m_Width			= CW_USEDEFAULT;
	m_Height		= CW_USEDEFAULT;
	m_hParent		= NULL;
	m_hMenu			= NULL;
	m_hInstance		= 0;
	m_lpParam		= NULL;
}

//fXgN^[
CWND::~CWND() {
}

//֐iEBhEpj
bool CWND::Init(LPCTSTR ClassName, HINSTANCE hInstance, WNDPROC Proc,
				LPCTSTR Menu = NULL,
				LPCTSTR Icon = "IDI_ICON",
				LPCTSTR cur = IDC_ARROW,
				HBRUSH brush = (HBRUSH)(COLOR_WINDOW + 1)) {

	WNDCLASSEX WndClass;
	//EBhENX̓o^
	WndClass.cbSize		= sizeof(WNDCLASSEX);			//̍\̂̃TCY
	WndClass.style		= CS_HREDRAW | CS_VREDRAW;		//cړATCYύXĕ`
	WndClass.lpfnWndProc= Proc;							//R[obN֐|C^[
	WndClass.cbClsExtra	= 0;							//̍\̈ȍ~ɒuoCg
	WndClass.cbWndExtra	= 0;							//CX^Xȍ~ɒuoCg
	WndClass.hInstance	= m_hInstance = hInstance;		//̃EBhẼCX^X
	WndClass.hIcon		= LoadIcon(hInstance, Icon);	//̃EBhENX̃ACR
	WndClass.hCursor	= LoadCursor(NULL, cur);		//̃EBhENX̃J[\
	WndClass.hbrBackground	= brush;					//̃EBhENX̔wiF
	WndClass.lpszMenuName	= Menu;						//̃EBhENX̃j[
	WndClass.lpszClassName	= m_lpClassName
							= ClassName;				//̃EBhENX̖
	WndClass.hIconSm	= LoadIcon(hInstance, Icon);	//ŏ̏ACR
	if(!RegisterClassEx(&WndClass)) {
		MessageBox(0, "EBhEo^ł܂łB", "G[",
				MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return FALSE;
	}
	return TRUE;
}

//EBhE쐬֐
bool CWND::Create(LPCTSTR WindowName = "MainWindow",
				DWORD Style = WS_OVERLAPPEDWINDOW, DWORD ExStyle = NULL,
				HWND hParent = NULL, int hMenu = NULL,
				int x = CW_USEDEFAULT, int y = CW_USEDEFAULT,
				int w = CW_USEDEFAULT, int h = CW_USEDEFAULT) {

	m_hWnd = CreateWindowEx(m_dwExStyle = ExStyle,
					    	m_lpClassName,
							m_lpWindowName = WindowName,
							m_dwStyle = Style,
							m_x = x,
							m_y = y,
							m_Width = w,
							m_Height = h,
							m_hParent = hParent,
							m_hMenu = (HMENU)hMenu,
							m_hInstance,
							m_lpParam
	);
	if(m_hWnd == NULL) {
		MessageBox(0, "EBhE܂ł!", "G[",
				MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return FALSE;
	}
	//EBhE̕\ƍĕ`
	ShowWindow(m_hWnd, SW_SHOWNORMAL);
	UpdateWindow(m_hWnd);
	return TRUE;
}

//Rg[ւ̂ւ̃bZ[W
LRESULT CWND::SendMsg(UINT Msg, WPARAM wParam, LPARAM lParam) {

	return SendMessage(m_hWnd, Msg, wParam, lParam);
}

//EBhERg[ւ̂ւ̃bZ[W
LRESULT CWND::SendItemMsg(int ID, UINT Msg, WPARAM wParam, LPARAM lParam) {

	return SendDlgItemMessage(m_hWnd, ID, Msg, wParam, lParam);
}
