//////////////////////////////////////
// ECCSkelton
// rbg}bvNXCBMP`t@C
// Copyright (c) August, 2022
//        By Ysama
//////////////////////////////////////

class CBMP
{
public:
	HWND				m_hWnd;			//rbg}bvgpĂEBhE
	HBITMAP				m_hBMP;			//rbg}bṽnh
	int					m_x;			//ŐṼrbg}bvxWL^
	int					m_y;			//ŐṼrbg}bvyWL^
	BITMAP				m_Bmp;			//m_hBMPBITMAP\
	WORD 				m_ClrBits;		//1, 4, 8 ,16, 2432̃J[rbg
	PBITMAPINFO 		m_PBmi;			//rbg}bv\̃|C^[
	PBITMAPFILEHEADER	m_PBmf;			//rbg}bvt@C\̃|C^[

	CBMP();								//RXgN^[iPĵ
	CBMP(HBITMAP);						//RXgN^[iQjnhɂ
	CBMP(HWND, LPCTSTR, bool);			//RXgN^[iRjLoadImageɂ
	~CBMP();							//fXgN^[
	HBITMAP Handle() {return m_hBMP;}	//nhԂ
	int Width() {return m_Bmp.bmWidth;}	//Ԃ
	int Height() {return m_Bmp.bmHeight;}//Ԃ
	int CBits() {return m_ClrBits;}		//J[rbgԂ
	//rbg}bv荞 LoadImag()ɂilIDATRUEȂt@Cj
	bool LoadBMP(HWND, LPCWSTR, bool);
	//t@Cփrbg}bv
	bool SaveBMP(LPWSTR, int);
	//ʂrbg}bv荞
	bool GetBMP(HWND, HDC, int, int, int, int);
	//ʂɃrbg}bv\iPj
	bool PutBMP(HWND, HDC, int, int, int);
	//ʂɃrbg}bv\iQj
	bool StretchBMP(HWND, HDC, int, int, int, int, int);
	//̃rbg}bv邩`FbNāA΃o[
	void CheckandInit();
	//o^ꂽrbg}bviDDBj̃rbg}bv쐬
	bool GetDDBInfo();
	//rbg}bvt@Crbg}bv擾
	bool GetDIBInfo(LPCWSTR);
	//Nbv{[hrbg}bvnh擾
	bool LoadFromClipboard();
	//ێĂrbg}bvNbv{[hɃRs[
	void SaveToClipboard();
};

//RXgN^[iPj
CBMP::CBMP() {

	m_hBMP = 0;
	m_PBmf = NULL;
	m_PBmi = NULL;
}

//RXgN^[iQj
CBMP::CBMP(HBITMAP hBMP) {

	m_hBMP = hBMP;
	GetDDBInfo();					//\ꂽrbg}bv̏擾
}

//RXgN^[iRj
CBMP::CBMP(HWND hWnd, LPCWSTR BMPName, bool flag = FALSE) {

	LoadBMP(hWnd, BMPName, flag);
}

//fXgN^[
CBMP::~CBMP() {

	CheckandInit();
}

//rbg}bvID(flag == FALSE)̓t@C(flag == TRUE)rbg}bvƑǂ
bool CBMP::LoadBMP(HWND hWnd, LPCWSTR BMPName, bool flag = FALSE) {

	//VKAύX̏
	m_hWnd = hWnd;
	CheckandInit();
	UINT fLoad;
	if(flag)
		fLoad = LR_DEFAULTCOLOR | LR_LOADFROMFILE;
	else
		fLoad = LR_DEFAULTCOLOR;
	//rbg}bv̓ǂݍ
	m_hBMP = (HBITMAP)LoadImageW((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
						BMPName,		//\[Xt@C
						IMAGE_BITMAP,	//rbg}bv̂
						0, 0,			//x, yTCYE\[XTCYɐݒ
					    fLoad);
	//rbg}bvǂݍ߂
	if(!m_hBMP) {
		MessageBoxW(NULL, L"rbg}bv̍쐬Ɏs܂",
					L"G[!", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	if(flag)		//t@C
		GetDIBInfo(BMPName);
	else			//Device Context
		GetDDBInfo();
	return TRUE;
}

//m_PBmfA m_PBmirbg}bvf[^t@Cɏ
bool CBMP::SaveBMP(LPWSTR pszFile, int CBit = 0) { 

	HANDLE hFile = NULL;	// tBnh
	LPBYTE lpBits = NULL;	// [ւ̃|C^[
	DWORD dwTmp;			//WriteFile()֐̏oCgp
	DWORD BMPSize;			//rbg}bvTCYvZp
	int nSuccess;			//GetDIBits֐̐tO
	HDC hDC, hMem;			//fXNgbvDCƃRp`rbg}bvDC
	BITMAP Bmp;				//ݗp
	PBITMAPINFO PBmi;		//ݗp
	PBITMAPFILEHEADER PBmf;	//ݗp

	if(!CBit)	CBit = m_ClrBits;	//CBit0̏ꍇ݂͌̃J[rbgƂ
	//PBITMAPINFO PBmïׂ̃[m
	if (CBit <= 8)
		PBmi = (PBITMAPINFO)LocalAlloc(LPTR,	//Œ胁[E[ŏ
				sizeof(BITMAPINFOHEADER) +
				sizeof(RGBQUAD) * (1 << CBit));
	//24bittH[}bg͖ܘ_16, 32bitBI_RGB̏ꍇɂRGBQUADȂ
	else
		PBmi = (PBITMAPINFO)LocalAlloc(LPTR,
				sizeof(BITMAPINFOHEADER));
	if(!PBmi) {	//[mێs
			MessageBoxW(NULL, L"PBmĩ[J[mۂɎs܂",
						L"G[!", MB_OK | MB_ICONSTOP);
			return FALSE;
	}
	//fXeBl[Ṽrbg}bv\̂
	GetObject(m_hBMP, sizeof(BITMAP), &Bmp);
	//BITMAPINFȌ
	PBmi->bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
	PBmi->bmiHeader.biWidth		= m_Bmp.bmWidth;
	PBmi->bmiHeader.biHeight	= m_Bmp.bmHeight;
	PBmi->bmiHeader.biPlanes	= 1;
	PBmi->bmiHeader.biBitCount	= CBit;
	PBmi->bmiHeader.biCompression	= BI_RGB;		//0x0
	PBmi->bmiHeader.biXPelsPerMeter	= 0;
	PBmi->bmiHeader.biYPelsPerMeter	= 0;
	PBmi->bmiHeader.biClrUsed		= 0;
	PBmi->bmiHeader.biClrImportant	= 0;
	//rbg}bvf[^TCYZo
	BMPSize = ((CBit * PBmi->bmiHeader.biWidth + 31) / 32) * 4
				* abs(PBmi->bmiHeader.biHeight);
	PBmi->bmiHeader.biSizeImage	= BMPSize;
	//BITMAPFILEHEADEȐ
	PBmf = (PBITMAPFILEHEADER)LocalAlloc(LPTR,
			sizeof(BITMAPFILEHEADER));
	if(!PBmf) {	//[mێs
			MessageBoxW(NULL, L"PBmf̃[J[mۂɎs܂",
						L"G[!", MB_OK | MB_ICONSTOP);
			LocalFree(PBmi);
			return FALSE;
	}
	PBmf->bfType = 0x4D42;
	PBmf->bfReserved1 = m_PBmf->bfReserved2 = 0;
	if(CBit <= 8)	//BITMAPFILEHEADER + BITMAPINFOHEADER + RGBQUAD
		PBmf->bfOffBits = 54 + (4 * (1 << CBit));
	else			//BITMAPFILEHEADER + BITMAPINFOHEADER
		PBmf->bfOffBits = 54;
	PBmf->bfSize = BMPSize + PBmf->bfOffBits;
	lpBits = (LPBYTE)GlobalAlloc(GMEM_FIXED, BMPSize);
	if(!lpBits) {
		MessageBoxW(NULL, L"O[o[mۂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree(PBmf);
		return FALSE;
	}
	//ŐFύX
	hDC = GetDC(0);					//fXNgbṽfoCXReLXg
	hMem = CreateCompatibleDC(hDC);	//̃Rp`DC
	SelectObject(hMem, m_hBMP);		//rbg}bvǂ܂
	//rbgzGetDIBits֐ŃO[o[Ɏo
	nSuccess = GetDIBits(hMem, m_hBMP, 0, Bmp.bmHeight,
							lpBits, PBmi, DIB_RGB_COLORS);
	DeleteDC(hMem) ;				//Rp`DC폜
	ReleaseDC(0, hDC);				//fXNgbṽfoCXReLXgJ
	if(!nSuccess) {	//FύXs
		MessageBoxW(NULL, L"FύXɎs܂",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree(PBmf);
		GlobalFree((HGLOBAL)lpBits);
		return FALSE;
	}
	//t@C쐬
	//ݗpt@CJ
	hFile = CreateFileW(pszFile,		//t@C
					GENERIC_WRITE,
					(DWORD)0,
					(LPSECURITY_ATTRIBUTES)NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL,
					(HANDLE)NULL);
	if(hFile == INVALID_HANDLE_VALUE) {
		MessageBoxW(NULL, L"t@CJƂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree(PBmf);
		GlobalFree((HGLOBAL)lpBits);
		return FALSE;
	}
	//ewb_[̏
	//BITMAPFILEHEADERt@C֏
	if(!WriteFile(hFile, PBmf, sizeof(BITMAPFILEHEADER),
					(LPDWORD)&dwTmp, (LPOVERLAPPED)NULL)) {
		MessageBoxW(NULL, L"rbg}bvt@Cwb_[ނƂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree(PBmf);
		GlobalFree((HGLOBAL)lpBits);
		CloseHandle(hFile);
		return FALSE;
	}
	//BITMAPINFOHEADERRGBQUADt@C֏
	if(!WriteFile(hFile, PBmi, PBmf->bfOffBits - 14,	//BITMAPINFOHEADER + RGBQUAD
					(LPDWORD)&dwTmp, (LPOVERLAPPED) NULL)) {
		MessageBoxW(NULL, L"rbg}bvƃJ[e[uނƂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree(PBmf);
		GlobalFree((HGLOBAL)lpBits);
		CloseHandle(hFile);
		return FALSE;
	}
	//rbg}bvrbgzt@C֏
	if(!WriteFile(hFile, (LPSTR)lpBits, BMPSize,
					(LPDWORD)&dwTmp, (LPOVERLAPPED)NULL)) {
		MessageBoxW(NULL, L"rbgzނƂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree(PBmf);
		GlobalFree((HGLOBAL)lpBits);
		CloseHandle(hFile);
		return FALSE;
	}
	//x.BMPt@CN[Y
	if(!CloseHandle(hFile))
		MessageBoxW(NULL, L"t@CN[Ył܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
	//[
	LocalFree(PBmi);
	LocalFree(PBmf);
	GlobalFree((HGLOBAL)lpBits);
	return TRUE;
}

//ʂrbg}bv荞
bool CBMP::GetBMP(HWND hWnd, HDC SourceDC, int x, int y, int w, int h) {

	CheckandInit();
	m_hWnd = hWnd;
	HDC hDC = GetDC(hWnd);							//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`DC쐬
	m_hBMP = CreateCompatibleBitmap(hDC, w, h);		//Rp`rbg}bv쐬
	SelectObject(memDC, m_hBMP);					//rbg}bvI
	StretchBlt(memDC, 0, 0, w, h, SourceDC, x, y, w, h, SRCCOPY);
	ReleaseDC(hWnd, hDC);							//EBhEDCJ
	DeleteObject(memDC);							//Rp`DC폜
	return GetDDBInfo();							//Vrbg}bv̏擾
}

//ʂɃrbg}bv\iPj
bool CBMP::PutBMP(HWND hWnd, HDC TargetDC, int x, int y, int ro = 0) {

	if(!m_hBMP)				//ɓǂ݂܂ꂽrbg}bv
		return FALSE;		//UԂ
	DWORD dwRop;
	switch(ro) {
		case 1:		dwRop = SRCAND;		break;	//And
		case 2:		dwRop = SRCPAINT;	break;	//Or
		case 3:		dwRop = SRCINVERT;	break;	//Xor
		default:	dwRop = SRCCOPY;	break;	//Pset
	}
	m_hWnd = hWnd;
	HDC hDC = GetDC(hWnd);							//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`DC쐬
	HGDIOBJ oldbm = SelectObject(memDC, m_hBMP);	//rbg}bvI
	bool success = BitBlt(TargetDC, m_x = x, m_y = y,
					m_Bmp.bmWidth, m_Bmp.bmHeight, memDC, 0, 0, dwRop);
	ReleaseDC(hWnd, hDC);							//EBhEDCJ
	SelectObject(memDC, oldbm);						//̃IuWFNgɖ߂
	DeleteObject(memDC);							//Rp`DC폜
	return success;
}

//ʂɃrbg}bv\iQj
bool CBMP::StretchBMP(HWND hWnd, HDC TargetDC, int x, int y, int w, int h, int ro = 0) {

	if(!m_hBMP)				//ɓǂ݂܂ꂽrbg}bv
		return FALSE;		//UԂ
	DWORD dwRop;
	switch(ro) {
		case 1:		dwRop = SRCAND;		break;	//And
		case 2:		dwRop = SRCPAINT;	break;	//Or
		case 3:		dwRop = SRCINVERT;	break;	//Xor
		default:	dwRop = SRCCOPY;	break;	//Pset
	}
	m_hWnd = hWnd;
	HDC hDC = GetDC(hWnd);							//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);			//Rp`DC쐬
	HGDIOBJ oldbm = SelectObject(memDC, m_hBMP);	//rbg}bvI
	bool success = StretchBlt(TargetDC, m_x = x, m_y = y, w, h,
					memDC, 0, 0, m_Bmp.bmWidth, m_Bmp.bmHeight, dwRop);
	ReleaseDC(hWnd, hDC);							//EBhEDCJ
	SelectObject(memDC, oldbm);						//̃IuWFNgɖ߂
	DeleteObject(memDC);							//Rp`DC폜
	return success;
}

//̃rbg}bv邩`FbNāA΃o[
void CBMP::CheckandInit() {

	if(m_hBMP) {				//̃rbg}bvIuWFNg̍폜
		DeleteObject(m_hBMP);
		m_hBMP = 0;
	}
	if(m_PBmf) {	//m_PBmfɃ[^Ăꍇ͂J
		if(LocalFree(m_PBmf)) {	//G[łȂNULL
			MessageBoxW(NULL, L"m_PBmf̃[J[̍폜Ɏs܂",
						L"G[!", MB_OK | MB_ICONSTOP);
		}
		else {
			m_PBmf = NULL;
		}
	}
	if(m_PBmi) {	//m_PBmiɃ[^Ăꍇ͂J
		if(LocalFree(m_PBmi)) {	//G[łȂNULL
			MessageBoxW(NULL, L"m_PBmĩ[J[̍폜Ɏs܂",
						L"G[!", MB_OK | MB_ICONSTOP);
		}
		else {
			m_PBmi = NULL;
		}
	}
}

//o^ꂽrbg}bviDDBj̃rbg}bv쐬
bool CBMP::GetDDBInfo() {

	if(!m_hBMP)					//ɓǂ݂܂ꂽrbg}bv
		return (PBITMAPINFO)0;	//sTC0Ԃ
	//rbg}bṽJ[tH[}bgAcATCY擾 
	if (!GetObject(m_hBMP, sizeof(BITMAP), (LPSTR)&m_Bmp)) {
		MessageBoxW(NULL, L"rbg}bv񂪓ǂ߂܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		return FALSE;			//sTCԂ
	}
	//J[tH[}bgvZ(bmPlanes * bmBitsPixel)
	m_ClrBits = (WORD)(m_Bmp.bmPlanes * m_Bmp.bmBitsPixel);
	//PBITMAPINFO m_PBmïׂ̃[m(1, 4, 8bit)
	if (m_ClrBits <= 8)
		m_PBmi = (PBITMAPINFO)LocalAlloc(LPTR,	//Œ胁[E[ŏ
				sizeof(BITMAPINFOHEADER) +
				sizeof(RGBQUAD) * (1 << m_ClrBits));
	//24bittH[}bg͖ܘ_16, 32bitBI_RGB̏ꍇɂRGBQUADȂ
	else
		m_PBmi = (PBITMAPINFO)LocalAlloc(LPTR,
				sizeof(BITMAPINFOHEADER));
	//BITMAPINFO\̗̂vf
	m_PBmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	m_PBmi->bmiHeader.biWidth = m_Bmp.bmWidth;
	m_PBmi->bmiHeader.biHeight = m_Bmp.bmHeight;
	m_PBmi->bmiHeader.biPlanes = m_Bmp.bmPlanes;
	m_PBmi->bmiHeader.biBitCount = m_Bmp.bmBitsPixel;
	if (m_ClrBits <= 8)
		m_PBmi->bmiHeader.biClrUsed = (1 << m_ClrBits);
	else	//tJ[ɂ0
		m_PBmi->bmiHeader.biClrUsed = 0;
	//rbg}bvkĂȂȂBI_RGB(0)tO𗧂Ă
	m_PBmi->bmiHeader.biCompression = BI_RGB;
	//Fz̃oCgvZbiSizeImageɂ܂
	m_PBmi->bmiHeader.biSizeImage = ((((m_PBmi->bmiHeader.biWidth * m_ClrBits) +
									31) & ~31) >> 3)
									* m_PBmi->bmiHeader.biHeight;
	//biClrImportant0ɂiSĂ̐FdvAӖj
	m_PBmi->bmiHeader.biClrImportant = 0;
	//rbg}bvt@Cwb_[쐬
	m_PBmf = (PBITMAPFILEHEADER)LocalAlloc(LPTR,
				sizeof(BITMAPFILEHEADER));
	m_PBmf->bfType = 0x4d42;	//0x420x4d"BM"Ńrbg}bv̈Ӗ
	//t@CTCY̌vZiBITMAPINFOHEADERւ̃|C^[쐬j
	PBITMAPINFOHEADER PBmih = (PBITMAPINFOHEADER)m_PBmi;
	m_PBmf->bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) +
							PBmih->biSize + PBmih->biClrUsed
							* sizeof(RGBQUAD) + PBmih->biSizeImage);
	m_PBmf->bfReserved1 = m_PBmf->bfReserved2 = 0;
	//J[܂ł̃ItZbgvZ
	m_PBmf->bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) +
								PBmih->biSize + PBmih->biClrUsed
								* sizeof (RGBQUAD);
	return TRUE;
}

//rbg}bvt@Crbg}bv擾
bool CBMP::GetDIBInfo(LPCWSTR BMPName) {

	HANDLE hFile;
	DWORD dwResult;
	//CreateFile֐Ńrbg}bvt@CI[v
	hFile = CreateFileW(BMPName, GENERIC_READ, 0, NULL, OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		return FALSE;
	}
	//t@CBITMAPFILEHEADER̃obt@쐬
	m_PBmf = (PBITMAPFILEHEADER)LocalAlloc(LPTR, sizeof(BITMAPFILEHEADER));
	//ReadFile֐Ńrbg}bvBITMAPFILEHEADER̕ǂݏo
	ReadFile(hFile, (LPBITMAPFILEHEADER)m_PBmf, sizeof(BITMAPFILEHEADER),
			&dwResult, NULL);
	//bfType0x4d42ł邱ƂmFi0x4d='M' 0x42='B'j 
	if(LOBYTE(m_PBmf->bfType) != 0x42 || HIBYTE(m_PBmf->bfType) != 0x4D) {
		return FALSE;
	}
	//ReadFile֐Ńrbg}bvBITMAPINFOHEADERǂݏo 
	m_PBmi = (PBITMAPINFO)LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER));
	ReadFile(hFile, (LPBITMAPINFOHEADER)m_PBmi, sizeof(BITMAPINFOHEADER),
			&dwResult, NULL);
	PBITMAPINFOHEADER PBmih = (PBITMAPINFOHEADER)m_PBmi;
	m_ClrBits = (WORD)(PBmih->biPlanes * PBmih->biBitCount);
	//t@C̃N[Y
	CloseHandle(hFile);
	//Ōm_BmpɃf[^ZbgiDDBf[^Ȃ̂Ńt@Cf[^ƈقȂj
	GetObject(m_hBMP, sizeof(BITMAP), &m_Bmp);
	return TRUE;
}

//Nbv{[hrbg}bvnh擾
bool CBMP::LoadFromClipboard() {

	if(IsClipboardFormatAvailable(CF_BITMAP)) {
		OpenClipboard(NULL);
		HBITMAP temp = (HBITMAP)GetClipboardData(CF_BITMAP);
		CloseClipboard();
		if(!temp) {
			//DIBSECTION쐬ănhn
			CheckandInit();
			m_hBMP = (HBITMAP)CopyImage(temp, IMAGE_BITMAP, 0, 0,
								LR_COPYRETURNORG | LR_COPYDELETEORG);
			GetDDBInfo();
			return TRUE;
		}
		else
			return FALSE;
	}
	return FALSE;
}

//ێĂrbg}bvNbv{[hɃRs[
void CBMP::SaveToClipboard() {

	if(m_hBMP) {
		if(!OpenClipboard(NULL)) {
			MessageBoxW(m_hWnd, L"Nbv{[hJ܂ł", L"G[", MB_OK | MB_ICONSTOP);
			return;
		}
		else
			EmptyClipboard();
		SetClipboardData(CF_BITMAP, (HBITMAP)CopyImage(m_hBMP, IMAGE_BITMAP, 0, 0, LR_COPYRETURNORG));
		CloseClipboard();	
	}
}
