/////////////////////////////
// ECCSkelton
// CEXTCHKNX`t@C
// Copyright (c) August, 2022
//        By Ysama
/////////////////////////////
//////////////////////////////////////////////////////////
// OPENFILENAME\̂lpstrFilterpgq`FbN
// Extension Check Class using OPENFILENAME's lpstrFilter
// OPENFILENAME's lpstrFilter̍\
// i\\0j
// igqf[^\0j
// ......
// i\\0j
// igqf[^\0j\0ŏINULL
// ȂAgqf[^"*.ext1;*.ext2;*ext3...\0"
// ɂ蕡̊gqΏۂƂ邱Ƃł
//////////////////////////////////////////////////////////
class CEXTCHK
{
public:
	//o[ϐ
	int m_Count = 0;				//gq
	WCHAR** m_Ext = 0;				//gqz
	//o[֐
	~CEXTCHK();						//fXgN^[
	void Init();					//SẴo[ϐ
	int GetExt(WCHAR*, WCHAR**&);	//'.'tgqzԂ
	void ConvertUC();				//'.'t啶gqzԂiKGetExt֐̌Ɏgj
	int CheckExt(WCHAR*, WCHAR*);	//tpXt@C̊gq`FbNi1`x[X̊gqԍԂj
};

//fXgN^[
CEXTCHK::~CEXTCHK() {

	Init();
}

//SẴo[ϐ
void CEXTCHK::Init() {
	if(m_Count) {							//gqz񂪂
		for(int i = 0; i < m_Count; i++)	//ׂĂ
			delete [] m_Ext[i];				//gqz
	}
	delete [] m_Ext;						//ŌɃ|C^[z
	m_Count = 0;							//gq
	m_Ext = 0;								//gqz
}

//'.'tgqzԂ
int CEXTCHK::GetExt(WCHAR* src, WCHAR**& pext) {

	if(m_Count)								//Ɏgꂽꍇ
		Init();								//ď
	WCHAR *cp1, *cp2, *cp3;					//p|C^[
	cp1 = src;								//\[XZbg
	while(*cp1) {							//cp1dNULLi\0\0jw܂
		//ŏ̕\pXLbv
		cp1 += lstrlenW(cp1) + 1;			//cp1NULLiL'\0'j̎܂Ői߂
		//cp1`3̓f[^i*.ext1;*.ext2;*.ext3;\0jwĂ
		cp3 = cp2 = cp1;
		//cp2擪ɒuAcp3Oɐi߂
		while(*cp3) {						//cp3NULL܂Ői߂
			//啶͏ɕϊ
			if(*cp3 >= L'A' && *cp3 <= L'Z')
				*cp3 += L'a' - L'A';
			//';'ŋ؂ꂽ̊gqݒ̏ꍇ
			if(*cp3 == L';') {				//L';'̏ꍇNULLƓl̏s
				//z|C^[extAm_Ext̃f[^ޔ
				WCHAR** ext = m_Ext;
				//vfz
				m_Ext = new WCHAR*[m_Count + 1];
				//ޔz̕|C^[f[^VzɈڂ
				for(int i = 0; i < m_Count; i++)
					m_Ext[i] = ext[i];
				//m_Ext̔zp[
				delete [] ext;
				//ǉzɃAX^XNȍ~(cp2 + 1)NULL܂łRs[
				m_Ext[m_Count] = new WCHAR[cp3 - cp2];				//́u(cp3 - cp2 - 1) + 1v
				wcsncpy(m_Ext[m_Count], cp2 + 1, cp3 - cp2 - 1);	//"(cp2)->*.ext(cp3)->;"
				m_Ext[m_Count][cp3 - cp2 - 1] = L'\0';				//m_Ext[m_Count]̎w̍ŌNULLu
				//z̒ǉÎŃJE^[𑝉
				m_Count++;
				//cp3Acp2';'̎ɐi߂
				cp3++;
				cp2 = cp3;
			}
			else
				cp3++;
		}
		//|C^[zAm_Ext̃f[^ޔ
		WCHAR** ext = m_Ext;
		//vfz
		m_Ext = new WCHAR*[m_Count + 1];
		//ޔz̕|C^[f[^VzɈڂ
		for(int i = 0; i < m_Count; i++)
			m_Ext[i] = ext[i];
		//m_Ext̔zp[
		delete [] ext;
		//ǉzɃAX^XNȍ~(cp2 + 1)NULL܂łRs[
		m_Ext[m_Count] = new WCHAR[lstrlenW(cp2)];
		lstrcpyW(m_Ext[m_Count], cp2 + 1);
		//z̒ǉÎŃJE^[𑝉
		m_Count++;
		//cp1'\0'̎܂Ői߂(\w)
		cp1 = cp3 + 1;
	}
	//2ɕz̃|C^\n
	pext = m_Ext;
	//߂lŕz̗vfԂ
	return m_Count;
}

//'.'t啶gqzԂiKGetExt֐̌Ɏgj
void CEXTCHK::ConvertUC() {

	for(int i = 0; i < m_Count; i++) {
		for(WCHAR* cp = m_Ext[i]; *cp; cp++)
			if(*cp >= L'a' && *cp <= L'z')
				*cp -= L'a' - L'A';
	}
}

//tpXt@C̊gq`FbNi1`x[X̊gqԍԂj
int CEXTCHK::CheckExt(WCHAR* filename, WCHAR* flt) {

	WCHAR** ext;
	int n = GetExt(flt, ext);
	//`FbN
	for(int i = 0; i < n; i++) {
		if(StrStrW(filename, ext[i])) {
			return i + 1;
		}
	}
	ConvertUC();
	//啶`FbN
	for(int i = 0; i < n; i++) {
		if(StrStrW(filename, ext[i])) {
			return i + 1;
		}
	}
	return NULL;
}
