/////////////////////////////
// ECCSkelton
// CHSPLITNX`t@C
// Copyright (c) August, 2022
//        By Ysama
/////////////////////////////

#define	_SPLITBORDER	2

class CHSPLIT : public CCTRL
{
public:		//o[ϐ
	int m_HBorder;							//؂̏cʒu
	int m_VBorder1;							//؂̉ʒu
	int m_VBorder2;							//؂̉ʒu
	int m_ClientWidth;						//NCAg̈̕
	int m_ClientHeight;						//NCAg̈̍
	HCURSOR m_NormCrs;						//WJ[\
	HCURSOR m_HCursor;						//J[\
	HCURSOR m_VCursor;						//J[\
	bool m_HSwitch;							//EړtO
	bool m_VSwitch1;						//cEPړtO
	bool m_VSwitch2;						//cEQړtO
	int m_CtrlID[4];						//eRg[ID(0-UL, 1-UR, 2LL, 3-LR)
	CTAB* m_Tab[4];							//Tabgꍇ̃|C^[(0-UL, 1-UR, 2LL, 3-LR)

public:		//o[֐
	CHSPLIT();										//RXgN^[iPj
	CHSPLIT(int, int, int);							//RXgN^[iQj
	~CHSPLIT();										//fRXgN^[
	bool Create(HWND, HINSTANCE, HMENU);			//CHSPLITEBhE쐬֐
	void AutoSize(HWND, HWND);						//TCY
	static LRESULT CALLBACK DummyProc(HWND, UINT, WPARAM, LPARAM);	//_~[̃R[obN֐
	virtual LRESULT CALLBACK SplitProc(HWND, UINT, WPARAM, LPARAM);	//{̃R[obN֐
	void SetBorders(int, int, int);					//Ëʒuݒ肷
	void MoveCtrl();								//Rg[ړ
	HWND SetCtrl(int, int);							//Rg[zu
	HWND GetCtrl(int);								//Rg[̃nhԂ
	void DeleteCtrl(int);							//Rg[폜
	CTAB* SetTab(int, HMENU, int, int, int);			//Tabzu
	CTAB* GetTab(int);								//Tab̃|C^[Ԃ
	void DeleteTab(int);							//Tab폜
};

//////////////////////
// o[֐̎
//////////////////////
//RXgN^[(Pj
CHSPLIT::CHSPLIT() {

	m_hWnd			= 0;
	m_dwExStyle		= 0;
	m_lpClassName	= L"HSPLITTER";
	m_lpWindowName	= NULL;
	m_dwStyle		= WS_CHILD | WS_CLIPCHILDREN;
	m_x				= 0;
	m_y				= 0;
	m_Width			= 0;
	m_Height		= 0;
	m_hParent		= NULL;
	m_hMenu			= NULL;
	m_hInstance		= 0;
	m_lpParam		= NULL;
	//J[\`
	m_NormCrs = LoadCursor(NULL, IDC_ARROW);	//WJ[\
	m_HCursor = LoadCursor(NULL, IDC_SIZEWE);	//J[\
	m_VCursor = LoadCursor(NULL, IDC_SIZENS);	//J[\
	m_HSwitch = m_VSwitch1 = m_VSwitch2 = FALSE;
	//Eʒȕ
	m_HBorder		= 300;
	m_VBorder1		= 150;
	m_VBorder2		= 150;
}

//RXgN^[(Qj
CHSPLIT::CHSPLIT(int v, int h1, int h2) {

	m_hWnd			= 0;
	m_dwExStyle		= 0;
	m_lpClassName	= L"HSPLITTER";
	m_lpWindowName	= NULL;
	m_dwStyle		= WS_CHILD | WS_CLIPCHILDREN;
	m_x				= 0;
	m_y				= 0;
	m_Width			= 0;
	m_Height		= 0;
	m_hParent		= NULL;
	m_hMenu			= NULL;
	m_hInstance		= 0;
	m_lpParam		= NULL;
	//J[\`
	m_NormCrs = LoadCursor(NULL, IDC_ARROW);	//WJ[\
	m_HCursor = LoadCursor(NULL, IDC_SIZEWE);	//J[\
	m_VCursor = LoadCursor(NULL, IDC_SIZENS);	//J[\
	m_HSwitch = m_VSwitch1 = m_VSwitch2 = FALSE;
	//Eʒȕ
	m_HBorder		= v;
	m_VBorder1		= h1;
	m_VBorder2		= h2;
}

//fXgN^[
CHSPLIT::~CHSPLIT() {

	//Tabj󂷂
	for(int i = 0; i < 4; i++)
		if(m_Tab[i])	delete m_Tab[i];
	DestroyWindow(m_hWnd);
}

//EBhE쐬֐
bool CHSPLIT::Create(HWND hParent, HINSTANCE hInstance, HMENU ID) {

	//EBhENX̓o^
	WNDCLASSEX WndClass;
	WndClass.cbSize		= sizeof(WNDCLASSEX);			//̍\̂̃TCY
	WndClass.style		= CS_HREDRAW | CS_VREDRAW;		//cړATCYύXĕ`
	WndClass.lpfnWndProc= DummyProc;					//_~[R[obN֐|C^[
	WndClass.cbClsExtra	= 0;							//̍\̈ȍ~ɒuoCg
	WndClass.cbWndExtra	= 0;							//CX^Xȍ~ɒuoCg
	WndClass.hInstance	= m_hInstance = hInstance;		//̃EBhẼCX^X
	WndClass.hIcon			= NULL;						//̃EBhENX̃ACR
	WndClass.hCursor		= m_NormCrs;				//̃EBhENX̃J[\
	WndClass.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);//̃EBhENX̔wiF
	WndClass.lpszMenuName	= NULL;						//̃EBhENX̃j[
	WndClass.lpszClassName	= m_lpClassName;			//̃EBhENX̖
	WndClass.hIconSm		= NULL;						//ŏ̏ACR
	if(!RegisterClassEx(&WndClass)) {
		MessageBoxW(0, L"EBhEo^ł܂łB", L"G[",
					MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	CCTRL::Create(L"", WS_CHILD | WS_CLIPCHILDREN, 0, m_hParent = hParent, ID);
	//vpeBɏ
 	SetPropW(m_hWnd, L"CHSPLIT", (HANDLE)this);
	return TRUE;
}

//Xvb^[̃TCYeEBhEɍ킹
void CHSPLIT::AutoSize(HWND hStatusBar = 0, HWND hToolBar = 0) {

	RECT rect;
	UINT x, y, w, h;
	//eEBhẼTCY擾
	GetClientRect(m_hParent, &rect);
	x = rect.left;
	y = rect.top;
	w = rect.right - rect.left;
	h = rect.bottom - rect.top;
	//c[o[̍擾
	if(hToolBar) {
		GetWindowRect(hToolBar, &rect);
		y += rect.bottom - rect.top;
		h -= rect.bottom - rect.top;
	}
	//Xe[^Xo[̍擾
	if(hStatusBar) {
		GetWindowRect(hStatusBar, &rect);
		h -= rect.bottom - rect.top;
	}
	//Xvb^[̃TCY킹
	MoveWindow(m_hWnd, x, y, w, h, TRUE);
	//CHSPLITEBhËʒuATCYۑ
	GetClientRect(m_hWnd, &rect);
	m_ClientWidth = rect.right - rect.left;
	m_ClientHeight = rect.bottom - rect.top;
}

//_~[R[obN֐
LRESULT CALLBACK CHSPLIT::DummyProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam) {

	//Inito[֐񂾂̃NX̃CX^Xւ̃|C^[ǂ
	CHSPLIT* pSplit = (CHSPLIT*)GetPropW(hWnd, L"CHSPLIT");
	//ꂪǂݍ߂
	if(pSplit) {
		//{̃R[obN֐iSplitProcjĂ
		LRESULT lResult = pSplit->SplitProc(hWnd, Message, wParam, lParam);
		//WM_DESTROYbZ[WiKŃEBhEvpeBp
		if (Message == WM_DESTROY)
			RemovePropW(hWnd, L"CHSPLIT");
		return lResult;
	}
	else
		//EBhEY̏ɔC
		return DefWindowProcW(hWnd, Message, wParam, lParam);
}

//{̃R[obN֐iz֐j
LRESULT CALLBACK CHSPLIT::SplitProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam) {

	switch(Message) {
		case WM_CREATE:
			//ẽNCAg̈ɂ킹
			RECT rec;
			GetClientRect(m_hParent, &rec);
			SendMessage(m_hParent, WM_SIZE, SIZE_RESTORED,
						MAKELONG(rec.right - rec.left, rec.bottom - rec.top));
			return 0;
		case WM_NOTIFY:
			//eɃbZ[W݉B
			SendMessage(m_hParent, WM_NOTIFY, (int)m_hMenu, lParam);
			//TabRg[
			for(int i = 0; i < 4; i++)
				if(m_Tab[i])	m_Tab[i]->FitSiblings(wParam);
			break;
		case WM_LBUTTONDOWN:
			//J[\`ωĐEP̈ړ
			if(HIWORD(lParam) < m_HBorder - _SPLITBORDER) {
				if(LOWORD(lParam) >= m_VBorder1 - _SPLITBORDER &&
					LOWORD(lParam) <= m_VBorder1 + _SPLITBORDER) {
					SetCursor(m_HCursor);
					m_VSwitch1 = TRUE;
					SetCapture(hWnd);
				}
			}
			//J[\`ωĐEQ̈ړ
			else if(HIWORD(lParam) > m_HBorder + _SPLITBORDER) {
				if(LOWORD(lParam) >= m_VBorder2 - _SPLITBORDER &&
					LOWORD(lParam) <= m_VBorder2 + _SPLITBORDER) {
					SetCursor(m_HCursor);
					m_VSwitch2 = TRUE;
					SetCapture(hWnd);
				}
			}
			//J[\`ωĐËړ
			else {
				SetCursor(m_VCursor);
				m_HSwitch = TRUE;
				SetCapture(hWnd);
			}
			break;
		case WM_MOUSEMOVE:
			//{^Ă΁AJ[\`ωċEړsȂ
			if(wParam & MK_LBUTTON) {
				POINTS pt = MAKEPOINTS(lParam);
				if(m_HSwitch) {
					SetCursor(m_VCursor);
					m_HBorder = pt.y;
					if(m_HBorder < _SPLITBORDER)
						m_HBorder = _SPLITBORDER;
					else if(m_HBorder > m_ClientHeight - _SPLITBORDER)
						m_HBorder = m_ClientHeight - _SPLITBORDER;
					MoveCtrl();
				}
				if(m_VSwitch1) {
					SetCursor(m_HCursor);
					m_VBorder1 = pt.x;
					if(m_VBorder1 < _SPLITBORDER)
						m_VBorder1 = _SPLITBORDER;
					else if(m_VBorder1 > m_ClientWidth - _SPLITBORDER)
						m_VBorder1 = m_ClientWidth - _SPLITBORDER;
					MoveCtrl();
				}
				if(m_VSwitch2) {
					SetCursor(m_HCursor);
					m_VBorder2 = pt.x;
					if(m_VBorder2 < _SPLITBORDER)
						m_VBorder2 = _SPLITBORDER;
					else if(m_VBorder2 > m_ClientWidth - _SPLITBORDER)
						m_VBorder2 = m_ClientWidth - _SPLITBORDER;
					MoveCtrl();
				}
			}
			//{^ĂȂ΃J[\`ω邾
			else {
				if(HIWORD(lParam) < m_HBorder - _SPLITBORDER) {
					if(LOWORD(lParam) >= m_VBorder1 - _SPLITBORDER &&
						LOWORD(lParam) <= m_VBorder1 + _SPLITBORDER) {
						SetCursor(m_HCursor);
					}
				}
				else if(HIWORD(lParam) > m_HBorder + _SPLITBORDER) {
					if(LOWORD(lParam) >= m_VBorder2 - _SPLITBORDER &&
						LOWORD(lParam) <= m_VBorder2 + _SPLITBORDER) {
						SetCursor(m_HCursor);
					}
				}
				else
					SetCursor(m_VCursor);
			}
			break;
		case WM_LBUTTONUP:
			//J[\`ɖ߂AEړ֎~
			m_HSwitch = FALSE;
			m_VSwitch1 = FALSE;
			m_VSwitch2 = FALSE;
			SetCursor(m_NormCrs);
			ReleaseCapture();
			for(int i = 0; i < 4; i++)
				if(m_Tab[i])	m_Tab[i]->FitSiblings(m_CtrlID[i]);
			break;
		case WM_SIZE:
			//CHSPLITEBhẼTCYۑ
			m_ClientWidth = LOWORD(lParam);
			m_ClientHeight = HIWORD(lParam);
			//Rg[̃TCY|m_CtrlID[1/3]ɍ킹m_CtrlID[0/2]𓮂
			//̓CVSPLITNXƈقȂ܂iE𒲍č͓Ȃj
			if(!m_CtrlID[2] && !m_CtrlID[3])
				m_HBorder = m_ClientHeight;
			RECT rect;
			if(!m_CtrlID[1])
				m_VBorder1 = m_ClientWidth;
			if(!m_CtrlID[3])
				m_VBorder2 = m_ClientWidth;
			MoveCtrl();
			break;
		default:
			return DefWindowProcW(hWnd, Message, wParam, lParam);
	}
	return 0;
}

//Ëʒuݒ肷
void CHSPLIT::SetBorders(int h, int v1, int v2) {

	m_HBorder = h;
	m_VBorder1 = v1;
	m_VBorder2 = v2;
	MoveCtrl();
}

//Rg[ړ
void CHSPLIT::MoveCtrl() {

	//h~̂߂ɁAEChE̍XVꎞXgbv
	LockWindowUpdate(m_hWnd);
	if(m_CtrlID[0])
		if(m_Tab[0])
			m_Tab[0]->MoveTab(0, 0, m_VBorder1 - _SPLITBORDER * 2, m_HBorder - _SPLITBORDER);
		else
			MoveWindow(GetCtrl(0), 0, 0, m_VBorder1 - _SPLITBORDER * 2, m_HBorder - _SPLITBORDER, TRUE);
	if(m_CtrlID[1])
		if(m_Tab[1])
			m_Tab[1]->MoveTab(m_VBorder1 + _SPLITBORDER, 0, m_ClientWidth - m_VBorder1 - _SPLITBORDER * 2, m_HBorder - _SPLITBORDER);
		else
			MoveWindow(GetCtrl(1), m_VBorder1 + _SPLITBORDER, 0, m_ClientWidth - m_VBorder1 - _SPLITBORDER * 2, m_HBorder - _SPLITBORDER, TRUE);
	if(m_CtrlID[2])
		if(m_Tab[2])
			m_Tab[2]->MoveTab(0, m_HBorder + _SPLITBORDER, m_VBorder2 - _SPLITBORDER * 2, m_ClientHeight - m_HBorder - _SPLITBORDER);
		else
			MoveWindow(GetCtrl(2), 0, m_HBorder + _SPLITBORDER, m_VBorder2 - _SPLITBORDER * 2, m_ClientHeight - m_HBorder - _SPLITBORDER, TRUE);
	if(m_CtrlID[3])
		if(m_Tab[3])
			m_Tab[3]->MoveTab(m_VBorder2 + _SPLITBORDER, m_HBorder + _SPLITBORDER, m_ClientWidth - m_VBorder2 - _SPLITBORDER * 2, m_ClientHeight - m_HBorder - _SPLITBORDER);
		else
			MoveWindow(GetCtrl(3), m_VBorder2 + _SPLITBORDER, m_HBorder + _SPLITBORDER, m_ClientWidth - m_VBorder2 - _SPLITBORDER * 2, m_ClientHeight - m_HBorder - _SPLITBORDER, TRUE);
	LockWindowUpdate(NULL);
	//ĊJł͏Ȃ̂ŁAĕ`
	UpdateWindow(m_hWnd);
}

//Rg[zu
HWND CHSPLIT::SetCtrl(int pos, int ID) {

	//ɍ쐬ĂΉȂŋA
	if(m_CtrlID[pos])	return FALSE;
	//Rg[ID̓o^
	m_CtrlID[pos] = ID;
	//SplitterRg[̐eɂ
	SetParent(GetDlgItem(m_hParent, m_CtrlID[pos]), m_hWnd);
	//Rg[̈ړ
	MoveCtrl();
	return GetDlgItem(m_hWnd, m_CtrlID[pos]);
}

//Rg[̃nhԂ
HWND CHSPLIT::GetCtrl(int pos) {

	return GetDlgItem(m_hWnd, m_CtrlID[pos]);
}

//Rg[폜
void CHSPLIT::DeleteCtrl(int pos) {

	//EBhEj󂷂
	DestroyWindow(GetDlgItem(m_hWnd, m_CtrlID[pos]));
	m_CtrlID[pos] = 0;	//s݂̏
}

//Tabzu
CTAB* CHSPLIT::SetTab(int pos, HMENU ID, int w = 16, int h  = 16, int c = ILC_COLOR4) {

	//ɍ쐬ĂΉȂŋA
	if(m_CtrlID[pos])	return FALSE;
	//Rg[ID̓o^
	m_CtrlID[pos] = (int)ID;
	//CTABNX̃IuWFNg𐶐
	m_Tab[pos] = new CTAB(w, h, c);
	m_Tab[pos]->Create(m_hWnd, m_hInstance, ID);
	//Rg[̈ړ
	MoveCtrl();
	return m_Tab[pos];
}

//Tab̃|C^[Ԃ
CTAB* CHSPLIT::GetTab(int pos) {

	return m_Tab[pos];
}

//Tab폜
void CHSPLIT::DeleteTab(int pos) {

	//Tab̃y[Wj󂷂
	for(int i = 0, j = m_Tab[pos]->TabCount(); i < j; i++) {
		TabCtrl_SetCurSel(m_Tab[pos]->m_hWnd, i);
		m_Tab[pos]->DeletePage();
	}
	//Tabj󂷂
	DestroyWindow(GetDlgItem(m_hWnd, m_CtrlID[pos]));
	delete m_Tab[pos];
	m_Tab[pos] = 0;
	m_CtrlID[pos] = 0;	//s݂̏
}
