/////////////////////////////
// ECCSkelton
// CSLIDERNX`t@C
// Copyright (c) August, 2022
//        By Ysama
/////////////////////////////

class CSLIDER : public CCTRL
{
public:
	//o[֐
	bool Create(HWND, int, int,
				int, int, int, DWORD);	//Rg[쐬֐
	void AutoSize(int, int, int);		//ẽTCYύXɍ킹Ĉʒui0-3jύX
	void SetSize(int, int, int, int);	//ʒuƑ傫ύX
	void SetRange(int, int);			//XC_[͈̔͐ݒ
	void SetPageSize(int);				//y[WTCYi}EXNbN̈ړʁjݒ
	void SetLineSize(int);				//CTCYiL[ɂړʁjݒ
	int  GetPosition();					//|WV̎擾
	void SetPosition(int);				//|WV̐ݒ
	void SetTic(int);					//ڐTCY̐ݒ
};

//Rg[쐬֐
bool CSLIDER::Create(HWND hParent, int cID, int x, int y, int w, int h,
					DWORD Style = WS_CHILD | WS_VISIBLE | TBS_AUTOTICKS) {

	m_hWnd = CreateWindowEx(m_dwExStyle = WS_EX_TOPMOST,
					    	m_lpClassName = TRACKBAR_CLASSW,
							m_lpWindowName = L"",
							m_dwStyle = Style,
							m_x = x,
							m_y = y,
							m_Width = w,
							m_Height = h,
							m_hParent = hParent,
							m_hMenu = (HMENU)cID,
							m_hInstance = (HINSTANCE)GetWindowLong(hParent, GWL_HINSTANCE),
							m_lpParam = NULL
	);
	if(m_hWnd == NULL) {
		MessageBoxW(0, L"XC_[Rg[܂ł", L"G[",
					MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	//Rg[̕\ƍĕ`
	ShowWindow(m_hWnd, SW_SHOWNORMAL);
	UpdateWindow(m_hWnd);
	return TRUE;
}

//ẽTCYύXɍ킹Ĉʒuiv0-3̋jύX
void CSLIDER::AutoSize(int pos, int marginx = 0, int marginy = 0) {

	RECT rec;
	GetClientRect(m_hParent, &rec);
	switch(pos) {
	case 0:		//
		m_x = marginx;
		m_y = marginy;
		break;
	case 1:		//E
		m_x = (rec.right - rec.left) - m_Width - marginx;
		m_y = marginy;
		break;
	case 2:		//E
		m_x = (rec.right - rec.left) - m_Width - marginx;
		m_y = (rec.bottom - rec.top) - m_Height - marginy;
		break;
	case 3:		//
		m_x = marginx;
		m_y = (rec.bottom - rec.top) - m_Height - marginy;
		break;
	default:
		return;
	}
	MoveWindow(m_hWnd, m_x, m_y, m_Width, m_Height, TRUE);
}

//ʒuƑ傫ύX
void CSLIDER::SetSize(int x, int y, int w, int h) {

	m_x = x;
	m_y = y;
	m_Width = w;
	m_Height = h;
//	SetWindowPos(m_hWnd, HWND_TOP, m_x, m_y, m_Width, m_Height, SWP_SHOWWINDOW);
	MoveWindow(m_hWnd, m_x, m_y, m_Width, m_Height, TRUE);
}

//XC_[͈̔͐ݒ
void CSLIDER::SetRange(int min, int max) {

	SendMessage(m_hWnd, TBM_SETRANGE, TRUE, (LPARAM)MAKELONG(min, max));
}

//y[WTCYi}EXNbN̈ړʁjݒ
void CSLIDER::SetPageSize(int dst) {

	SendMessageW(m_hWnd, TBM_SETPAGESIZE, 0, (LPARAM)dst);
}

//CTCYiL[ɂړʁjݒ
void CSLIDER::SetLineSize(int dst) {

	SendMessageW(m_hWnd, TBM_SETLINESIZE, 0, (LPARAM)dst);
}

//|WV̎擾
int CSLIDER::GetPosition() {

	return SendMessageW(m_hWnd, TBM_GETPOS, 0, 0);
}

//|WV̐ݒ
void CSLIDER::SetPosition(int pos) {

	SendMessageW(m_hWnd, TBM_SETPOS, TRUE, (LPARAM)pos);
}

//ڐTCY̐ݒ
void CSLIDER::SetTic(int tic) {

	//ڐ̃TCYݒ (30)
	SendMessageW(m_hWnd, TBM_SETTICFREQ, tic, 0);
}
