/////////////////////////////////////
// ECCSkelton
// c[o[NXCTBAR`t@C
// Copyright (c) August, 2022
//        By Ysama
/////////////////////////////////////

class CTBAR : public CCTRL
{
public:		//o[ϐ
	LRESULT	m_id;			//JX^rbg}bv̊JnID
public:		//o[֐
	CTBAR();
	bool Init(HWND, HINSTANCE, int, DWORD);
	LRESULT GetID() {return m_id;}
	bool AddBmp(bool);
	bool AddBmp(HINSTANCE, LPCTSTR, int);
	bool AddButtons(int, TBBUTTON*);
	bool InsertButton(int, TBBUTTON*);
	bool AutoSize();
};

//RXgN^[(NXݒƃRRg[j
CTBAR::CTBAR() {

	m_lpClassName = TOOLBARCLASSNAMEW;	//c[o[NX̖
	InitCommonControls();				//RRg[̏
}

//c[o[쐬\
bool CTBAR::Init(HWND hWnd, HINSTANCE hInstance,
				int ID, DWORD Style = WS_CHILD | WS_VISIBLE  | TBSTYLE_TOOLTIPS) {

	m_hWnd = CreateWindowExW(m_dwExStyle,
					m_lpClassName,
					NULL,
					Style, 0, 0, 0, 0,
					hWnd, (HMENU)ID, hInstance, NULL);
	return m_hWnd;
}

//RRg[X^_[hrbg}bv̐ݒiPj
bool CTBAR::AddBmp(bool flag = TRUE) {
	TBADDBITMAP tbab;
	//TB_BUTTONSTRUCT\̂̃TCY(bytes)
	SendMessageW(m_hWnd, TB_BUTTONSTRUCTSIZE, (WPARAM)sizeof(TBBUTTON), 0);
	//RRg[W[̃CX^X
	tbab.hInst = HINST_COMMCTRL;
	if(flag) {
		//̃rbg}bv
		// STD_FILENEW, STD_FILEOPEN,  STD_FILESAVE, STD_PROPERTIES, STD_PRINTPRE, STD_PRINT
		// STD_UNDO, STD_REDOW, STD_DELETE, STD_CUT, STD_COPY, STD_PASTE, STD_FIND, STD_REPLACE
		// STD_HELP
		tbab.nID = IDB_STD_SMALL_COLOR;
		return SendMessageW(m_hWnd, TB_ADDBITMAP, 0, (LPARAM)&tbab);
	}
	else {
		//rbg}bv̒ǉ
		//VIEW_LARGEICONS, VIEW_SMALLICONS
		//VIEW_SORTTYPE, VIEW_SORTNAME, VIEW_SORTSIZE, VIEW_SORTDATE
		//VIEW_LIST, VIEW_DETAILS
		tbab.nID = IDB_VIEW_SMALL_COLOR;
		return SendMessageW(m_hWnd, TB_ADDBITMAP, 0, (LPARAM)&tbab);
	}
}

//JX^rbg}bv̐ݒiQj
bool CTBAR::AddBmp(HINSTANCE hInst, LPCWSTR BMPName, int n) {
	TBADDBITMAP tbab;
	//TB_BUTTONSTRUCT\̂̃TCY(bytes)
	SendMessageW(m_hWnd, TB_BUTTONSTRUCTSIZE, (WPARAM)sizeof(TBBUTTON), 0);
	tbab.hInst = NULL;
	tbab.nID =(int) LoadImageW(hInst, BMPName, IMAGE_BITMAP,
								0, 0, LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT);
	return m_id = SendMessageW(m_hWnd, TB_ADDBITMAP, n, (LPARAM)&tbab);
}

//c[o[{^̒ǉ
bool CTBAR::AddButtons(int n, TBBUTTON* tbb) {
	//wParam ={^AlParam =TBBUTTON\̂̃AhX
	return SendMessageW(m_hWnd, TB_ADDBUTTONS, n, (LPARAM)tbb);
}

//c[o[{^̑}
bool CTBAR::InsertButton(int Index, TBBUTTON* btn) {
	//wParam ={^AlParam =TBBUTTON\̂̃AhX
	return SendMessageW(m_hWnd, TB_INSERTBUTTON, (WPARAM)Index, (LPARAM)btn); 
}

//TCY
bool CTBAR::AutoSize() {
	return SendMessageW(m_hWnd, TB_AUTOSIZE, 0, 0);
}
