//////////////////////////////////////////
// TestCanvas.cpp
//Copyright (c) 08/23/2022 by ECCSkelton
//////////////////////////////////////////
#include	"TestCanvas.h"
//[U[wb_[t@C
#include	"User.h"
#include	"TestCanvasProc.h"

////////////////
// WinMain֐
////////////////
int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPWSTR lpCmdLine, int nCmdShow) {

	//QdNh~
	if(!TestCanvas.IsOnlyOne()) {
		HWND hWnd = FindWindowW(L"MainWnd", L"TestCanvas");
		if(IsIconic(hWnd))
			ShowWindow(hWnd, SW_RESTORE);
		SetForegroundWindow(hWnd);
		return 0L;
	}

	//EBhEo^ | Init(ClassName, hInstance, WndProc, "IDM_MAIN",
	//						iȉȗj"IDI_ICON", IDC_ARROW, Brush)
	TestCanvas.Init(L"MainWnd", hInstance, L"IDM_MAIN", L"IDI_ICON");

	//EBhE쐬ƕ\|Create(WindowTitle, (ȉȗjStyle,
	//						ExStyle, hParent, hMenu, x, y, w, h)
	if(!TestCanvas.Create(L"TestCanvas"))
		return 0L;

	//ANZ[^[o^|InclAccel("(Accelerator ID)")
	TestCanvas.InclAccel(L"IDA_ACCEL");

	//bZ[W[vɓ
	return TestCanvas.Loop();
}
