//////////////////////////////////////////
// FileList.h
// Copyright (c) 08/30/2022 by ECCSkelton
//////////////////////////////////////////
//BCCSkeltoñwb_[|ɕKvȃwb_[Ă
#include	"ECCSkelton.h"
//\[XID̃wb_[
#include	"ResFileList.h"

/////////////////////////////////////////////////////////////////////
//CMyWndNXCDLGNXhAbZ[Wp̊֐錾
/////////////////////////////////////////////////////////////////////
class CFILELIST : public CDLG
{
public:	//ȉ̓R[obN֐}NƊ֘AĂ
	//QdNh~pMutexpID
	CFILELIST(WCHAR* UName) : CDLG(UName) {}
	//c[o[
	CTBAR m_TBar;
	//Xe[^Xo[
	CSBAR m_SBar;
	//Xgr[
	CLISTVIEW m_ListView;
	//j[ځA_CAORg[֘A
	bool OnOpen();
	bool OnSave();
	bool OnExit();
	bool OnAdd();
	bool OnSearch();
	bool OnEdit();
	bool OnDelete();
	bool OnSort();
	bool OnVersion();
	//EBhEbZ[W֘A
	CMDTABLE	//CMyWndNXOnCommand()֐錾
	bool OnInit(WPARAM, LPARAM);
	bool OnNotify(WPARAM, LPARAM);
	bool OnSize(WPARAM, LPARAM);
	bool OnClose(WPARAM, LPARAM);
	bool OnDropFiles(WPARAM, LPARAM);
	bool OnMinMax(WPARAM, LPARAM);
	//[U[`֐
	bool ChangeMenuStatus(bool);
	WCHAR* GetFileName(WCHAR*);
};

////////////////////////////////////////////////////////////////////////
//hCFILTERLISTNX̃CX^XƃR[obN֐(}Nj̍쐬
//EBhE̓_CAOƈႢAR[obN֐͈Ȃ
////////////////////////////////////////////////////////////////////////
CFILELIST FileList(L"FileList");	//EBhENXCX^X̐

//CFILELISTNXOnCommand()֐`
BEGIN_CMDTABLE(CFILELIST)
	ON(IDM_OPEN, OnOpen())
	ON(IDM_SAVE, OnSave())
	ON(IDM_EXIT, OnExit())
	ON(IDM_ADD, OnAdd())
	ON(IDM_SEARCH, OnSearch())
	ON(IDM_EDIT, OnEdit())
	ON(IDM_DELETE, OnDelete())
	ON(IDM_SORT, OnSort())
	ON(IDM_VERSION, OnVersion())
END_CMDTABLE

///////////////////////////////////////////
// CDLGNXEDITDLGNXh
// ̓_CAOϐƃ_CAO
// 邪A̃_CAOɈ̔h_C
// AONX쐬̂{
///////////////////////////////////////////
class EDITDLG : public CDLG {
public:
	//Rg[֘A
	bool OnIdok();
	bool OnIdcancel();
	//_CAObZ[W֘A
	CMDTABLE	//EDITDLGNXOnCommand()֐錾
	bool OnInit(WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////////////////////
// EDITDLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////
EDITDLG editdlg;

//EDITDLGNXOnCommand()֐`
BEGIN_CMDTABLE(EDITDLG)
	ON(IDOK, OnIdok())
	ON(IDCANCEL, OnIdcancel())
END_CMDTABLE

///////////////////////////////////////////
// CDLGNXSEARCHDLGNXh
// ̓_CAOϐƃ_CAO
// 邪A̃_CAOɈ̔h_C
// AONX쐬̂{
///////////////////////////////////////////
class SEARCHDLG : public CDLG {
public:
	WCHAR m_ToFind[MAX_PATH];
	//Rg[֘A
	bool OnIdok();
	bool OnIdcancel();
	//_CAObZ[W֘A
	CMDTABLE	//EDITDLGNXOnCommand()֐錾
	bool OnInit(WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////////////////////
// SEARCHDLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////
SEARCHDLG searchdlg;

//SEARCHDLGNXOnCommand()֐`
BEGIN_CMDTABLE(SEARCHDLG)
	ON(IDOK, OnIdok())
	ON(IDCANCEL, OnIdcancel())
END_CMDTABLE

///////////////////////////////////////////
// CDLGNXSORTDLGNXh
// ̓_CAOϐƃ_CAO
// 邪A̃_CAOɈ̔h_C
// AONX쐬̂{
///////////////////////////////////////////
class SORTDLG : public CDLG {
public:
	//Rg[֘A
	bool OnIdok();
	bool OnIdcancel();
	//_CAObZ[W֘A
	CMDTABLE	//EDITDLGNXOnCommand()֐錾
	bool OnInit(WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////////////////////
// SORTDLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////
SORTDLG sortdlg;

//SORTDLGNXOnCommand()֐`
BEGIN_CMDTABLE(SORTDLG)
	ON(IDOK, OnIdok())
	ON(IDCANCEL, OnIdcancel())
END_CMDTABLE

///////////////////////////////////////////
// CDLGNXVERSIONDLGNXh
// ̓_CAOϐƃ_CAO
// 邪A̃_CAOɈ̔h_C
// AONX쐬̂{
///////////////////////////////////////////
class VERSIONDLG : public CDLG {
public:
	//Rg[֘A
	bool OnIdok();
	//_CAObZ[W֘A
	CMDTABLE	//EDITDLGNXOnCommand()֐錾
};

////////////////////////////////////////////////////////////////////////////
// VERSIONDLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////
VERSIONDLG versiondlg;

//VERSIONDLGNXOnCommand()֐`
BEGIN_CMDTABLE(VERSIONDLG)
	ON(IDOK, OnIdok())
END_CMDTABLE
