//////////////////////////////////////////
// FileListProc.h
// Copyright (c) 08/30/2022 by ECCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECFILELIST̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CFILELIST::OnInit(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|SetHandle(hWnd))
	m_TBar.SetHandle(GetDlgItem(m_hWnd, IDC_TOOLBAR));
	//c[o[{^pJX^rbg}bvǉ
	m_TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TOOLBAR), 9);
	//c[o[{^ǉ
	TBBUTTON tbb[13];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = m_TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_OPEN;
	tbb[1].iBitmap = m_TBar.m_id + 1;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_SAVE;
	tbb[2].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[3].iBitmap = m_TBar.m_id + 2;
	tbb[3].fsState = TBSTATE_ENABLED;
	tbb[3].fsStyle = TBSTYLE_BUTTON;
	tbb[3].idCommand = IDM_EXIT;
	tbb[4].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[5].iBitmap = m_TBar.m_id + 3;
	tbb[5].fsState = TBSTATE_ENABLED;
	tbb[5].fsStyle = TBSTYLE_BUTTON;
	tbb[5].idCommand = IDM_ADD;
	tbb[6].iBitmap = m_TBar.m_id + 4;
	tbb[6].fsState = TBSTATE_ENABLED;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_SEARCH;
	tbb[7].iBitmap = m_TBar.m_id + 5;
	tbb[7].fsState = TBSTATE_ENABLED;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_EDIT;
	tbb[8].iBitmap = m_TBar.m_id + 6;
	tbb[8].fsState = TBSTATE_ENABLED;
	tbb[8].fsStyle = TBSTYLE_BUTTON;
	tbb[8].idCommand = IDM_DELETE;
	tbb[9].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[10].iBitmap = m_TBar.m_id + 7;
	tbb[10].fsState = TBSTATE_ENABLED;
	tbb[10].fsStyle = TBSTYLE_BUTTON;
	tbb[10].idCommand = IDM_SORT;
	tbb[11].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[12].iBitmap = m_TBar.m_id + 8;
	tbb[12].fsState = TBSTATE_ENABLED;
	tbb[12].fsStyle = TBSTYLE_BUTTON;
	tbb[12].idCommand = IDM_VERSION;
	m_TBar.AddButtons(13, tbb);

	//Xe[^Xo[o^|SetHandle(hWnd))
	m_SBar.SetHandle(GetDlgItem(m_hWnd, IDC_STATUSBAR));
	//Xe[^Xo[ݒ
	int sec[2] = {100, -1};
	m_SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	m_SBar.SetText(0, L"FileList Ver 1.0");
	m_SBar.SetText(1, L"t@CXgt@C");

	//Xgr[EBhEnh
	m_ListView.m_hWnd = GetDlgItem(m_hWnd, IDC_LISTVIEW);
	//Xgr[eEBhEnh
	m_ListView.m_hParent = m_hWnd;
	//Xgr[CX^X
	m_ListView.m_hInstance = m_hInstance;
	//Xgr[Rg[ID
	m_ListView.m_hMenu = (HMENU)IDC_LISTVIEW;
	//Xgr[񖼂ƕ̐ݒ
	m_ListView.InsertColumn(0, 30, L"No", LVCFMT_CENTER);
	m_ListView.InsertColumn(1, 190, L"t@C");
	m_ListView.InsertColumn(2, 496, L"l");
	m_ListView.InsertColumn(3, 0, L"tpX");
	//Xgr[gX^C̐ݒ
	INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(ic);
	ic.dwICC = ICC_LISTVIEW_CLASSES;
	InitCommonControlsEx(&ic);
	DWORD lvStyle = SendItemMsg(IDC_LISTVIEW, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0);
	lvStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
	SendItemMsg(IDC_LISTVIEW, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES, lvStyle);

	//j[nh̎擾
	g_hPopup = GetSubMenu(GetMenu(m_hWnd), 1);

	//Xgr[͍ږIȂ̂ŁuҏWvƁu폜v𖳌ɂ
	ChangeMenuStatus(FALSE);

	//hbOAhhbv̎tJn
	DragAcceptFiles(m_hWnd, TRUE);

	return TRUE;
}

bool CFILELIST::OnNotify(WPARAM wParam, LPARAM lParam) {

	if((int)wParam == IDC_LISTVIEW) {	//Xgr[̃bZ[W
		int n = m_ListView.GetNextItem(-1, LVNI_ALL | LVIS_SELECTED);
		if(n == -1) {	//IȂ
			//uҏWvƁu폜v𖳌ɂ
			ChangeMenuStatus(FALSE);
		}
		else {
			//uҏWvƁu폜vLɂ
			ChangeMenuStatus(TRUE);
		}
		//Xgr[̒ʒmbZ[Wɂ鏈
		switch(((LPNMLISTVIEW)lParam)->hdr.code) {
		case LVN_COLUMNCLICK:	//񌩏oNbNꂽ
			if(sortsubno[((LPNMLISTVIEW)lParam)->iSubItem] == UP)
				sortsubno[((LPNMLISTVIEW)lParam)->iSubItem] = DOWN;
			else
				sortsubno[((LPNMLISTVIEW)lParam)->iSubItem] = UP;
			m_ListView.SortItem(CompProc, ((LPNMLISTVIEW)lParam)->iSubItem);
			break;
		case NM_DBLCLK:		//_uNbN
			if(n != -1)
				OnEdit();
			break;
		case NM_RCLICK:		//ENbN
			//EChËʒu擾
			RECT rec;
			GetWindowRect(m_hWnd, &rec);
			//|bvAbvj[̕\ꏊݒ
			POINT pt;
			GetCursorPos(&pt);
			//|bvAbvj[̕\
			TrackPopupMenu(g_hPopup, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON, pt.x, pt.y, 0, m_hWnd, &rec);
			break;
		}
		return TRUE;
	}
	//c[o[c[`bv
	if(((LPNMHDR)lParam)->code == TTN_NEEDTEXT) {	//TTN_GETDISPINFOƓ
		((LPTOOLTIPTEXT)lParam)->hinst = m_hInstance;
		WCHAR* tag;
		switch(((LPTOOLTIPTEXT)lParam)->hdr.idFrom) {
		case IDM_OPEN:
			tag = L"XgJ";
			break;
		case IDM_SAVE:
			tag = L"Xg̕ۑ";
			break;
		case IDM_EXIT:
			tag = L"I";
			break;
		case IDM_ADD:
			tag = L"ǉ";
			break;
		case IDM_SEARCH:
			tag = L"";
			break;
		case IDM_EDIT:
			tag = L"ҏW";
			break;
		case IDM_DELETE:
			tag = L"폜";
			break;
		case IDM_SORT:
			tag = L"ёւ";
			break;
		case IDM_VERSION:
			tag = L"o[W";
			break;
		}
		((LPTOOLTIPTEXT)lParam)->lpszText = tag;
		return TRUE;
	}
	return FALSE;
}

bool CFILELIST::OnSize(WPARAM wParam, LPARAM lParam) {

	m_TBar.AutoSize();
	m_SBar.AutoSize();
	//Ṓulv𒲐m_ListViewNCAg̈ɍ킹
	m_ListView.m_x = 0;
	m_ListView.m_Width = LOWORD(lParam);
	m_ListView.m_Height = HIWORD(lParam);
	RECT rec;
	GetWindowRect(m_SBar.GetHandle(), &rec);
	m_ListView.m_Height -= rec.bottom - rec.top;
	GetWindowRect(m_TBar.GetHandle(), &rec);
	m_ListView.m_y = rec.bottom - rec.top;
	m_ListView.m_Height -= m_ListView.m_y;
	m_ListView.Move(m_ListView.m_x, m_ListView.m_y, m_ListView.m_Width, m_ListView.m_Height);
	m_ListView.SetColumn(2, LVCFMT_LEFT, m_ListView.m_Width - 224, L"l");
	return TRUE;
}

bool CFILELIST::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBoxW(m_hWnd, L"I܂", L"ImF",
					MB_YESNO | MB_ICONQUESTION) == IDYES) {
		//DestroyWindowAPostQuitMessageĂ΂
		if(!*g_File.ToChar() &&
			MessageBoxW(m_hWnd, L"t@CIĂ܂\ñ݂f[^ۑ܂H",
						L"ۑmF", MB_YESNO | MB_ICONQUESTION) == IDYES)
			OnSave();
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

//D&D
bool CFILELIST::OnDropFiles(WPARAM wParam, LPARAM lParam) {

	//hbOAhhbvꂽt@C擾Ə
	static WCHAR FileName[MAX_PATH];
	int n;									//t@C
	HDROP hDrop = (HDROP)wParam; 			//HDROP擾
	n = DragQueryFile(hDrop, -1, NULL, 0);	//t@C擾
	for(int i = 0; i < n; i++) {
		DragQueryFile(hDrop, i, FileName, MAX_PATH);	//t@C擾
		if(g_ExtChk.CheckExt(FileName, g_MFlt)) {
			g_Data = FileName;
			g_ByFile = TRUE;
			OnAdd();
		}
		else
			MessageBoxW(m_hWnd, FileName, L"ĐΏۊÕt@C", MB_OK | MB_ICONERROR);
	}
	DragFinish((HDROP)wParam);
	return TRUE;
}

//EBhEŏTCY
bool CFILELIST::OnMinMax(WPARAM wPram, LPARAM lParam) {

	//T^IȃEBhẼTCY
	MINMAXINFO *pmmi;
	pmmi = (MINMAXINFO*)lParam;
	pmmi->ptMinTrackSize.x = 496;	//NCAgGA480 + 16
	pmmi->ptMinTrackSize.y = 301;	//NCAgGA240 + 61
	return FALSE;					//DefWndProcɔC
}

/////////////////////////////////
//EBhECFILELIST̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CFILELIST::OnOpen() {

	//t@CXgt@CI
	WCHAR* fp = g_Cmndlg.GetFileName(m_hWnd, g_LFlt, TRUE, g_Ext, g_Path);
	if(!fp) {
		MessageBoxW(m_hWnd, L"LZ܂", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else
		g_File = fp;
	//It@CXgt@Cg_Dataɓǂݍ
	if(!g_Data.FromFile(g_File.ToChar())) {
		MessageBoxW(m_hWnd, L"t@CXgt@Cǂݍ߂܂ł", L"G[",
					MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
		//݂̍sf[^ׂč폜
		m_ListView.DeleteAllItems();
		int n = 0;
		while(WCHAR* cp = GetDelimtStr(g_Data.ToChar())) {
			//Đԍi999AŌnLVIF_PARAM\[gׂɒǉj
			WCHAR buff[4];
			wsprintf(buff, L"%d", n);
			m_ListView.InsertItem(n, buff, -1, n);
			//tpXif[^ۑj
			m_ListView.SetItem(n, 3, cp);
			//t@C
			m_ListView.SetItem(n, 1, GetFileName(cp));
			//l
			cp = GetDelimtStr(g_Data.ToChar());
			m_ListView.SetItem(n, 2, cp);
			n++;
			if(n > 999) {	//Ô߂̃G[
				MessageBoxW(m_hWnd, L"őĐi999j𒴂܂", L"G[", MB_OK | MB_ICONERROR);
				return FALSE;
			}
		}
	}
	m_SBar.SetText(1, g_File.ToChar());		//Xe[^Xo[ɃtpX\
	m_SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_File.ToChar());	//ToolTip
	return TRUE;
}

bool CFILELIST::OnSave() {

	WCHAR* fp = g_Cmndlg.GetFileName(m_hWnd, g_LFlt, FALSE, g_Ext, g_Path);
	if(!fp) {
		MessageBoxW(m_hWnd, L"LZ܂", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	g_File = fp;				//t@Cۑ
	//s񉻂JԂ
	int n = m_ListView.GetItemCount();
	//
	g_Data = L"";				//g_Data
	WCHAR buff[MAX_PATH * 4];	//ulv̍ő啶͖1KB
	CSTR row;
	for(int i = 0; i < n; i++) {
		row = L"\"";				//rowitpX́u""vň͂ށj
		//ListView2̃f[^ǂݏoAR}؂̕sƂ
		m_ListView.GetItemText(i, 3, buff, MAX_PATH);
		row = row + buff;
		row = row + L"\",\"";
		m_ListView.GetItemText(i, 2, buff, MAX_PATH * 4);
		row = row + buff;		//ŏIڂ񒆂'\n'̂
		row = row + L"\"\n";		//u""vň͂
 		//sf[^g_Data֑ł䂭
		g_Data = g_Data + row;
	}
	g_Data.ToFile(g_File.ToChar());		//t@Cۑ
	m_SBar.SetText(1, g_File.ToChar());	//Xe[^Xo[ɃtpX\
	m_SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_File.ToChar());	//ToolTip
	return TRUE;
}

bool CFILELIST::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CFILELIST::OnAdd() {

	WCHAR* fn;
	if(g_ByFile)
		g_ByFile = FALSE;
	else {
		//t@CI
		fn = g_Cmndlg.GetFileName(m_hWnd, g_MFlt, TRUE);
		if(!fn) {
			MessageBoxW(m_hWnd, L"LZ܂", L"G[", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		g_Data = fn;
	}
	//Xg̍ŌmF
	int n = m_ListView.GetItemCount();
	//Ô߂̃G[
	if(n > 999) {
		MessageBoxW(m_hWnd, L"őĐi999j𒴂܂", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//Đԍi999AŌnLVIF_PARAM\[gׂɒǉj
	WCHAR buff[4];
	wsprintfW(buff, L"%d", n);
	m_ListView.InsertItem(n, buff, -1, n);
	//tpXif[^ۑj
	m_ListView.SetItem(n, 3, g_Data.ToChar());
	//t@C
	m_ListView.SetItem(n, 1, GetFileName(g_Data.ToChar()));
	return TRUE;
}

bool CFILELIST::OnSearch() {

	static CSTR ToFind;					//ۑpϐ
	static int found = 0;				//l͍ŏ
	WCHAR buff[MAX_PATH];				//Xg{bNX擾pobt@
	int n = m_ListView.GetItemCount();	//Xg{bNX̍smF
	//擾_CAO
	searchdlg.DoModal(m_hWnd, L"IDD_SEARCH", GetInstance());
	//ǑƓłΌp
	if(g_Data != ToFind) {	//قȂ
		ToFind = g_Data;		//XV
		found = 0;			//ŏ猟
		m_ListView.SetItemState(-1, 0, LVIS_SELECTED);	//Ss̑IԂ̉
	}
	for(int i = found; i < n; i++) {		//s
		for(int j = 0; j < 3; j++) {		//
			m_ListView.GetItemText(i, j, buff, MAX_PATH);	//擾
			if(StrStrW(buff, ToFind.ToChar())) {			//񂪊܂܂
				found = i + 1;								//̌̂߂ɁAs̎w
				SetFocus(m_ListView.m_hWnd);				//m_ListViewɃtH[JXȂƑIԂ\Ȃ
				m_ListView.SetItemState(i, LVIS_SELECTED, LVIS_SELECTED);	//IԂɂ
				return TRUE;
			}
		}
	}
	MessageBoxW(m_hWnd, L"͌܂ł", L"", MB_OK | MB_ICONINFORMATION);
	m_ListView.SetItemState(-1, 0, LVIS_SELECTED);	//Ss̑IԂ̉
	return TRUE;
}

bool CFILELIST::OnEdit() {

	int n = m_ListView.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (n == -1) {
		MessageBoxW(m_hWnd, L"ڂIĂ܂", L"x", MB_OK);
		return FALSE;
	}
	//CSTR g_DataNoAt@CƃJ}؂ulvi[
	WCHAR buff[MAX_PATH * 4];
	//No
	m_ListView.GetItemText(n, 0, buff, MAX_PATH);
	g_Data = buff;
	g_Data = g_Data + L",";
	//t@C
	m_ListView.GetItemText(n, 1, buff, MAX_PATH);
	g_Data = g_Data + buff;
	g_Data = g_Data + L",\"";
	//l
	m_ListView.GetItemText(n, 2, buff, MAX_PATH * 4);
	g_Data = g_Data + buff;	//ŏIڂ͕񒆂'\n'
	g_Data = g_Data + L"\"";	//̂Łu""vň͂
	//ҏWp_CAOĂяo
	if(!editdlg.DoModal(m_hWnd, L"IDD_EDIT", GetInstance()))
		return FALSE;
	//CSTR g_DataɊi[ꂽNoƃJ}؂ulvi[
	WCHAR* cp = GetDelimtStr(g_Data.ToChar());
	m_ListView.SetItem(n, 0, cp);
	m_ListView.SetItem(n, 2, GetDelimtStr(g_Data.ToChar()));
	return TRUE;
}

bool CFILELIST::OnDelete() {

	//IɑΉ
	int n = m_ListView.GetNextItem(-1, LVNI_ALL | LVIS_SELECTED);
	while(n != -1) {
		m_ListView.DeleteItem(n); 
		n = m_ListView.GetNextItem(n - 1, LVNI_ALL | LVIS_SELECTED);
	}
	m_SBar.SetText(1, L"t@CXgt@C");	//Xe[^Xo[\ύX
	return TRUE;
}

bool CFILELIST::OnSort() {

	sortdlg.DoModal(m_hWnd, L"IDD_SORT", GetInstance());
	return TRUE;
}

bool CFILELIST::OnVersion() {

	versiondlg.DoModal(m_hWnd, L"IDD_VERSION", GetInstance());
	return TRUE;
}

//////////////////////////////////////
//[U[`֐
//IDM_EDITIDM_DELETȄԂύX
//////////////////////////////////////
bool CFILELIST::ChangeMenuStatus(bool flag) {

	EnableMenuItem(g_hPopup, IDM_EDIT, (flag ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	EnableMenuItem(g_hPopup, IDM_DELETE, (flag ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND);
	SendMessage(m_TBar.GetHandle(), TB_ENABLEBUTTON, IDM_EDIT, flag);
	SendMessage(m_TBar.GetHandle(), TB_ENABLEBUTTON, IDM_DELETE, flag);
	return TRUE;
}

////////////////////////////////////
//[U[`֐
//tpXt@C擾
////////////////////////////////////
WCHAR* CFILELIST::GetFileName(WCHAR* pathname) {

	static WCHAR fn[MAX_PATH];	//f[^X^bNɒuȂ
	lstrcpyW(fn, pathname);		//̃̕Rs[
	//cppassnamȅI[(NULL)̂ЂƂOɐi߂
	WCHAR* sp = (WCHAR*)fn;
	WCHAR* ep = (WCHAR*)fn + lstrlenW(fn) - 1;
	WCHAR* last = 0;				//Ō'\'w|C^[
	if(*sp == '\"' && *ep == '\"')
		*ep = '\0';	//u""vň͂܂ĂΊOiNULLwj
	//'\'T
	while(sp < ep) {
		if(*sp == '\\')
		last = sp;				//spi߂̂lastɋL^
		sp++;					//spi߂
	}
	return ++last;				//Ō'\\'̎t@C̐擪AhXԂ
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool EDITDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//GetDelimitStr̓\[XZkĂ܂̂g_Data͕ی삷
	CSTR Data = g_Data;
	//CSTR g_DatãJ}؂蕶Edit1`3܂łɊi[
	WCHAR* cp = GetDelimtStr(Data.ToChar());
	SendItemMsg(IDC_EDIT1, WM_SETTEXT, NULL, (LPARAM)cp); 
	cp = GetDelimtStr(Data.ToChar());
	SendItemMsg(IDC_EDIT2, WM_SETTEXT, NULL, (LPARAM)cp); 
	cp = GetDelimtStr(Data.ToChar());
	SendItemMsg(IDC_EDIT3, WM_SETTEXT, NULL, (LPARAM)cp); 
	return TRUE;
}

bool EDITDLG::OnIdok() {

	WCHAR buff[MAX_PATH * 4];	//i[pobt@
	//g_DataNoi[
	SendItemMsg(IDC_EDIT1, WM_GETTEXT, (WPARAM)MAX_PATH, (LPARAM)buff); 
	g_Data = buff;
	//g_DataɃJ}؂Łulvi[
	g_Data = g_Data + L",\"";
	SendItemMsg(IDC_EDIT3, WM_GETTEXT, (WPARAM)MAX_PATH * 4, (LPARAM)buff); 
	g_Data = g_Data + buff;
	g_Data = g_Data + L"\"";	//ulv͕񒆂'\n'̂Łu""vň͂
	EndModal(TRUE);
	return TRUE;
}

bool EDITDLG::OnIdcancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool SEARCHDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	SendItemMsg(IDC_EDIT1, WM_SETTEXT, 0, (LPARAM)m_ToFind);
	return TRUE;
}

bool SEARCHDLG::OnIdok() {

	SendItemMsg(IDC_EDIT1, WM_GETTEXT, MAX_PATH, (LPARAM)m_ToFind);
	g_Data = m_ToFind;
	EndModal(TRUE);
	return TRUE;
}

bool SEARCHDLG::OnIdcancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool SORTDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//R{{bNXɕo^
	SendItemMsg(IDC_COMBOBOX1, CB_ADDSTRING, 0, (LPARAM)L"No");
	SendItemMsg(IDC_COMBOBOX1, CB_ADDSTRING, 0, (LPARAM)L"t@C");
	SendItemMsg(IDC_COMBOBOX1, CB_ADDSTRING, 0, (LPARAM)L"l");
	SendItemMsg(IDC_COMBOBOX1, CB_SETCURSEL, 0, 0);	//ԖڂIԂɂ
	SendItemMsg(IDC_COMBOBOX2, CB_ADDSTRING, 0, (LPARAM)L"");
	SendItemMsg(IDC_COMBOBOX2, CB_ADDSTRING, 0, (LPARAM)L"~");
	SendItemMsg(IDC_COMBOBOX2, CB_SETCURSEL, 0, 0);	//ԖڂIԂɂ
	return TRUE;
}

bool SORTDLG::OnIdok() {

	//Iԍ̎擾
	int col = SendItemMsg(IDC_COMBOBOX1, CB_GETCURSEL, 0, 0);
	int dir = SendItemMsg(IDC_COMBOBOX2, CB_GETCURSEL, 0, 0);
	//\[gΏۍڂɏA~̃f[^
	sortsubno[col] = (bool)dir;
	//\[g
	FileList.m_ListView.SortItem(CompProc, col);
	EndModal(TRUE);
	return TRUE;
}

bool SORTDLG::OnIdcancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}
