//////////////////////////////////////////
// RTWEditor.h
// Copyright (c) 08/30/2022 by ECCSkelton
//////////////////////////////////////////

//VXe萔`
#define	IDC_TAB		1000	//^ũRg[ID
#define	IDC_EDIT	2000	//ŏ̃^uy[W̃GfBbgRg[ID
//ŏEBhETCY̋Kic[o[{^SČŏlj
#define		MINW	510
#define		MINH	255
//Ώۃt@C̃tB^[
#define		FILEFILTER	L"eLXgt@C(*.rtf;*.txt)\0*.rtf;*.txt\0C++t@C(*.h;*.cpp;*.rc;*.mak;*.ini)\0*.h;*.cpp;*.rc;*.mak;*.ini\0SẴt@C(*.*)\0*.*\0\0"
//BCCSkeltoñwb_[|ɕKvȃwb_[Ă
#include	"ECCSkelton.h"
//\[XID̃wb_[
#include	"ResRTWEditor.h"

/////////////////////////////////////////////////////////////////////
//CMyWndNXCSDINXhAbZ[Wp̊֐錾
/////////////////////////////////////////////////////////////////////
class CMyWnd : public CSDI
{
private:
	CTAB	m_Tab;					//CEBhEɓ\t^uRg[
	CREDIT	m_Edit;					//^uy[WRichEditRg[̃JvZCX^X
	int 	m_EditID = IDC_EDIT;	//VK^uy[W̃b`GfBbgpRg[IDij
									//Fj[NłׂɃRg[폜ĂivԂɂ
public:	//ȉ̓R[obN֐}NƊ֘AĂ
	//QdNh~pMutexpID
	CMyWnd(WCHAR* UName) : CSDI(UName) {}
	//j[ځA_CAORg[֘A
	bool OnNew();
	bool OnOpen();
	bool OnSave();
	bool OnSaveas();
	bool OnSetprint();
	bool OnPrint();
	bool OnExit();
	bool OnUndo();
	bool OnCut();
	bool OnCopy();
	bool OnPaste();
	bool OnSelall();
	bool OnFind();
	bool OnReplace();
	bool OnDelete();
	bool OnFont();
	bool OnLeft();
	bool OnCenter();
	bool OnRight();
	bool OnLindent();
	bool OnLoutdent();
	bool OnRindent();
	bool OnRoutdent();
	bool OnBrief();
	bool OnShortcut();
	bool OnVer();
	//EBhEbZ[W֘A
	CMDTABLE	//CMyWndNXOnCommand()֐錾
	bool OnCreate(WPARAM, LPARAM);
	bool OnNotify(WPARAM, LPARAM);
	bool OnSize(WPARAM, LPARAM);
	bool OnClose(WPARAM, LPARAM);
	bool OnDropFiles(WPARAM, LPARAM);
	bool OnGetMaxInfo(WPARAM, LPARAM);
	bool OnOthers(UINT, WPARAM, LPARAM);	//̃bZ[WȊȌ
	//[U[`֐
	bool AddTabEdit(WCHAR*);
	bool DelTabEdit();
	bool PopupMenu();
};

////////////////////////////////////////////////////////////////////////
//hCMyWndNX̃CX^XƃR[obN֐(}Nj̍쐬
//EBhE̓_CAOƈႢAR[obN֐͈Ȃ
////////////////////////////////////////////////////////////////////////
CMyWnd RTWEditor(L"RTWEditor");	//EBhENXCX^X̐

//CMyWndNXOnCommand()֐`
BEGIN_CMDTABLE(CMyWnd)
	//j[ځA_CAORg[֘A
	ON(IDM_NEW, OnNew())
	ON(IDM_OPEN, OnOpen())
	ON(IDM_SAVE, OnSave())
	ON(IDM_SAVEAS, OnSaveas())
	ON(IDM_SETPRINT, OnSetprint())
	ON(IDM_PRINT, OnPrint())
	ON(IDM_EXIT, OnExit())
	ON(IDM_UNDO, OnUndo())
	ON(IDM_CUT, OnCut())
	ON(IDM_COPY, OnCopy())
	ON(IDM_PASTE, OnPaste())
	ON(IDM_SELALL, OnSelall())
	ON(IDM_FIND, OnFind())
	ON(IDM_REPLACE, OnReplace())
	ON(IDM_DELETE, OnDelete())
	ON(IDM_FONT, OnFont())
	ON(IDM_LEFT, OnLeft())
	ON(IDM_CENTER, OnCenter())
	ON(IDM_RIGHT, OnRight())
	ON(IDM_LINDENT, OnLindent())
	ON(IDM_LOUTDENT, OnLoutdent())
	ON(IDM_RINDENT, OnRindent())
	ON(IDM_ROUTDENT, OnRoutdent())
	ON(IDM_BRIEF, OnBrief())
	ON(IDM_SHORTCUT, OnShortcut())
	ON(IDM_VER, OnVer())
END_CMDTABLE

///////////////////
//c[o[̍쐬
///////////////////
CTBAR TBar;

///////////////////////
//Xe[^Xo[̍쐬
///////////////////////
CSBAR SBar;

////////////////////////
//R_CAO̍쐬
////////////////////////
CMNDLG cmndlg;

//////////////////////
//CEXTCHK̃CX^X
//////////////////////
CEXTCHK g_ExtChk;

///////////////////////////////////////////
// CDLGNXVERSIONDLGNXh
// ̓_CAOϐƃ_CAO
// 邪A̃_CAOɈ̔h_C
// AONX쐬̂{
///////////////////////////////////////////
class VERSIONDLG : public CDLG {
public:
	CMDTABLE	//VERSIONDLGNXOnCommand()֐錾
	bool OnIdok();
};

////////////////////////////////////////////////////////////////////////////
// VERSIONDLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////
VERSIONDLG versiondlg;

//VERSIONDLGNXOnCommand()֐`
BEGIN_CMDTABLE(VERSIONDLG)
	//j[ځA_CAORg[֘A
	ON(IDOK, OnIdok())
END_CMDTABLE
