//////////////////////////////////////////
// RTWEditorProc.h
// Copyright (c) 08/30/2022 by ECCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnCreate(WPARAM wParam, LPARAM lParam) {
	//RRg[̏
	InitCommonControls();

	//c[o[o^|Init(hWnd, hIinstance, ID, Style)|c[`bvt
	TBar.Init(m_hWnd, m_hInstance, TOOLBAR, WS_CHILD | WS_VISIBLE | TBSTYLE_TOOLTIPS);
	//c[o[{^prbg}bvǉ
	TBar.AddBmp();
	//c[o[{^ǉ
	TBBUTTON tbb[26];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = STD_FILENEW;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_NEW;
	tbb[1].iBitmap = STD_FILEOPEN;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_OPEN;
	tbb[2].iBitmap = STD_FILESAVE;
	tbb[2].fsStyle = TBSTYLE_BUTTON;
	tbb[2].idCommand = IDM_SAVE;
	tbb[3].iBitmap = STD_PROPERTIES;
	tbb[3].fsState = TBSTATE_ENABLED;
	tbb[3].fsStyle = TBSTYLE_BUTTON;
	tbb[3].idCommand = IDM_SETPRINT;
	tbb[4].iBitmap = STD_PRINT;
	tbb[4].fsStyle = TBSTYLE_BUTTON;
	tbb[4].idCommand = IDM_PRINT;
	tbb[5].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[6].iBitmap = STD_UNDO;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_UNDO;
	tbb[7].iBitmap = STD_CUT;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_CUT;
	tbb[8].iBitmap = STD_COPY;
	tbb[8].fsStyle = TBSTYLE_BUTTON;
	tbb[8].idCommand = IDM_COPY;
	tbb[9].iBitmap = STD_PASTE;
	tbb[9].fsStyle = TBSTYLE_BUTTON;
	tbb[9].idCommand = IDM_PASTE;
	tbb[10].iBitmap = STD_FIND;
	tbb[10].fsStyle = TBSTYLE_BUTTON;
	tbb[10].idCommand = IDM_FIND;
	tbb[11].iBitmap = STD_REPLACE;
	tbb[11].fsStyle = TBSTYLE_BUTTON;
	tbb[11].idCommand = IDM_REPLACE;
	tbb[12].fsStyle = TBSTYLE_SEP; 	//Zp[^[
	//JX^rbg}bv̒ǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_CUSTOM), 9);
	tbb[13].fsStyle = TBSTYLE_SEP; 	//Zp[^[
	tbb[14].iBitmap = TBar.m_id;
	tbb[14].fsStyle = TBSTYLE_BUTTON;
	tbb[14].idCommand = IDM_DELETE;
	tbb[15].fsStyle = TBSTYLE_SEP; 	//Zp[^[
	tbb[16].iBitmap = TBar.m_id + 1;
	tbb[16].fsStyle = TBSTYLE_BUTTON;
	tbb[16].idCommand = IDM_LEFT;
	tbb[17].iBitmap = TBar.m_id + 2;
	tbb[17].fsStyle = TBSTYLE_BUTTON;
	tbb[17].idCommand = IDM_CENTER;
	tbb[18].iBitmap = TBar.m_id + 3;
	tbb[18].fsStyle = TBSTYLE_BUTTON;
	tbb[18].idCommand = IDM_RIGHT;
	tbb[19].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[20].iBitmap = TBar.m_id + 4;
	tbb[20].fsStyle = TBSTYLE_BUTTON;
	tbb[20].idCommand = IDM_FONT;
	tbb[21].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[22].iBitmap = TBar.m_id + 5;
	tbb[22].fsStyle = TBSTYLE_BUTTON;
	tbb[22].idCommand = IDM_LINDENT;
	tbb[23].iBitmap = TBar.m_id + 6;
	tbb[23].fsStyle = TBSTYLE_BUTTON;
	tbb[23].idCommand = IDM_LOUTDENT;
	tbb[24].iBitmap = TBar.m_id + 7;
	tbb[24].fsStyle = TBSTYLE_BUTTON;
	tbb[24].idCommand = IDM_RINDENT;
	tbb[25].iBitmap = TBar.m_id + 8;
	tbb[25].fsStyle = TBSTYLE_BUTTON;
	tbb[25].idCommand = IDM_ROUTDENT;
	TBar.AddButtons(26, tbb);

	//Xe[^Xo[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	SBar.Init(m_hWnd, m_hInstance, STATUSBAR);
	//Xe[^Xo[ݒ
	int sec[4] = {120, 210, 330, -1};
	SBar.SetSection(4, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, L"RTWEditor Version 1.0");

	//^uRg[̍쐬ƃ^ÕtHgݒ
	m_Tab.Create(m_hWnd, m_hInstance, (HMENU)IDC_TAB);
	m_Tab.SetFont(9, L"lr o");

	//hbOAhhbv
	DragAcceptFiles(m_hWnd, TRUE);

	//j[nh̎擾
	g_hPopup = GetSubMenu(GetMenu(m_hWnd), 1);

	//t@CNΉig_ByFile^̎A1̂݁j
	if(g_ByFile) {
		for(int i = 1; i < g_Arg.c(); i++) {
			if(g_ExtChk.CheckExt(g_Arg.v(i), FILEFILTER))	//Ώۃt@Cۂ`FbN
				AddTabEdit(g_Arg.v(i));						//^u̒ǉ
			else
				MessageBoxW(m_hWnd, g_Arg.v(i), L"ΏۊÕt@C", MB_OK | MB_ICONERROR);
		}
		g_ByFile = FALSE;
	}

	return TRUE;
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	if(((LPNMHDR)lParam)->code == TTN_NEEDTEXT) {	//c[o[c[`bv̕\
		LPTOOLTIPTEXT lpTTText = (LPTOOLTIPTEXT)lParam;
		lpTTText->hinst = m_hInstance;
		switch(lpTTText->hdr.idFrom) {
		case IDM_NEW:
			lpTTText->lpszText = MAKEINTRESOURCE(String_00);
			break;
		case IDM_OPEN:
			lpTTText->lpszText = MAKEINTRESOURCE(String_01);
			break;
		case IDM_SAVE:
			lpTTText->lpszText = MAKEINTRESOURCE(String_02);
			break;
		case IDM_SETPRINT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_03);
			break;
		case IDM_PRINT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_04);
			break;
		case IDM_UNDO:
			lpTTText->lpszText = MAKEINTRESOURCE(String_05);
			break;
		case IDM_CUT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_06);
			break;
		case IDM_COPY:
			lpTTText->lpszText = MAKEINTRESOURCE(String_07);
			break;
		case IDM_PASTE:
			lpTTText->lpszText = MAKEINTRESOURCE(String_08);
			break;
		case IDM_FIND:
			lpTTText->lpszText = MAKEINTRESOURCE(String_09);
			break;
		case IDM_REPLACE:
			lpTTText->lpszText = MAKEINTRESOURCE(String_10);
			break;
		case IDM_DELETE:
			lpTTText->lpszText = MAKEINTRESOURCE(String_11);
			break;
		case IDM_LEFT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_12);
			break;
		case IDM_CENTER:
			lpTTText->lpszText = MAKEINTRESOURCE(String_13);
			break;
		case IDM_RIGHT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_14);
			break;
		case IDM_FONT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_15);
			break;
		case IDM_LINDENT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_16);
			break;
		case IDM_LOUTDENT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_17);
			break;
		case IDM_RINDENT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_18);
			break;
		case IDM_ROUTDENT:
			lpTTText->lpszText = MAKEINTRESOURCE(String_19);
			break;
		default://hdr.idFrom^uRg[̃y[Wԍi0`jŃc[`bvvׁA
				//^uRg[̃y[Wԍő̃Rg[ID݂Ă͂Ȃ
				if(lpTTText->hdr.idFrom < m_Tab.TabCount()) {		//^ũc[`bv
					lpTTText->lpszText = m_Tab.GetTitle(lpTTText->hdr.idFrom);
					break;
				}
				else
					return FALSE;
		}
		return TRUE;
	}
	//^ũy[WIύX
	else if(((LPNMHDR)lParam)->code == TCN_SELCHANGE) {
		//VɑIꂽ^ũb`GfBbgRg[m_EditŃJvZ
		m_Edit.SetHandle(m_Tab.GetCtrl());
		m_Tab.FitSiblings((WPARAM)IDC_TAB);
		SBar.SetText(1, L"");				//oCgNA
		SBar.SetText(2, L"");				//LbgʒuNA
		SBar.SetText(3, m_Tab.GetTitle());	//t@CύX
	}
	else if(((NMHDR*)lParam)->code == NM_RCLICK) {			//^ủE}EX{^ʒm
		//|bvAbvj[̕\
		PopupMenu();
	}
	//b`GfBbgeLXg̕ύXŃoCgƃLbgʒu\
	else if(((NMHDR*)lParam)->code == EN_SELCHANGE) {
		WCHAR str[19];	//"(6)+sF(6)+" + NULL, //"xxxxxxxxxxxoCg" + NULL
		wsprintfW(str, L"%doCg", m_Edit.GetSize());
		SBar.SetText(1, str);
		wsprintfW(str, L"%dsF%d", m_Edit.GetPos()->y + 1, m_Edit.GetPos()->x + 1);
		SBar.SetText(2, str);
	}
	//b`GfBbgRg[̒ʒmMSGFILTER\̂Ŏ󂯎
	else if(((NMHDR*)lParam)->code == EN_MSGFILTER && ((MSGFILTER*)lParam)->msg == WM_RBUTTONUP) {
		//|bvAbvj[̕\
		PopupMenu();
	}
	else
		return FALSE;
	return TRUE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	//c[o[AXe[^Xo[̎
	TBar.AutoSize();
	SBar.AutoSize();
	//݂̃^uƂ̃Rg[̎
	m_Tab.FitParent(SBar.GetHandle(), TBar.GetHandle());
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	int ret = MessageBoxW(m_hWnd, L"I܂B\n^uɊmF܂Hiu͂vj\niIɖ߂|uLZvj",
					L"ImF", MB_YESNOCANCEL | MB_ICONINFORMATION);
	if(ret == IDYES) {
		//b`GfBbgɕύX邩ׂẴ^uŃ`FbN
		for(int i = m_Tab.TabCount(); i > 0; i--) {
			m_Tab.SetPage(i - 1);			//Ō̃^uJgɂ
			if(!DelTabEdit())				//̃^uƃRg[j
				return FALSE;
		}
		//DestroyWindowAPostQuitMessageĂ΂
		return TRUE;
	}
	else if(ret == IDNO)
		return TRUE;
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

bool CMyWnd::OnDropFiles(WPARAM wParam, LPARAM lParam) {

	//hbOAhhbvꂽt@C擾Ə
	WCHAR fn[MAX_PATH];
	//hbOAhhbvꂽt@C̐擾
	int num = DragQueryFileW((HDROP)wParam, 0xFFFFFFFF, NULL, 0);
	//hbOAhhbvꂽt@C擾Ə
	for(int i = 0; i < num; i++) {
		DragQueryFileW((HDROP)wParam, i, fn, sizeof(fn));
		//OnOpen()֐Jt@C̐JԂ
		if(g_ExtChk.CheckExt(fn, FILEFILTER)) {		//Ώۃt@Cۂ`FbN
			AddTabEdit(fn);							//^u̒ǉ
			ChangeMenuStatus(TRUE);
			SBar.SetText(3, fn);
		}
		else
			MessageBoxW(m_hWnd, fn, L"ΏۊÕt@C", MB_OK | MB_ICONERROR);
	}
	DragFinish((HDROP)wParam);
	return TRUE;
}

bool CMyWnd::OnGetMaxInfo(WPARAM wParam, LPARAM lParam) {

	//T^IȃEBhẼTCY
	MINMAXINFO *pmmi;
	pmmi = (MINMAXINFO*)lParam;
	pmmi->ptMinTrackSize.x = MINW + 16;	//NCAgGA + 16
	pmmi->ptMinTrackSize.y = MINH + 61;	//NCAgGA + 61
	return FALSE;						//DefWndProcɔC
}

bool CMyWnd::OnOthers(UINT Msg, WPARAM wParam, LPARAM lParam) {

	//CREDITNX͕񌟍upɃ[U[bZ[ŴŁA
	//̂悤ȏs܂BCREDITt@C`ĂB
	if(Msg == m_Edit.m_frMsg)
		m_Edit.FindReplace(lParam);	//Eu
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnNew() {

	//V^uɃb`GfBbgRg[𒣂t
	AddTabEdit(NULL);
	SetFocus(m_Edit.GetHandle());
	return TRUE;
}

bool CMyWnd::OnOpen() {

	if(!g_ByFile) {
		//t@CJ_CAO
		WCHAR* fn = cmndlg.GetFileName(m_hWnd, FILEFILTER);
		if(!fn) {
			MessageBoxW(m_hWnd, L"̓LZ܂", L"bZ[W", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		g_FileName = fn;
	}
	//V^uɃb`GfBbgRg[𒣂tg_FileNameǂݍ
	AddTabEdit(g_FileName.ToChar());	//SetFocus͂̒łĂ
	return TRUE;
}

bool CMyWnd::OnSave() {

	WCHAR* fn = m_Tab.GetTitle();
	//tH[JX̂^ũb`GfBbgRg[̃^Cgǂ
	if(!lstrcmpW(fn, L"[]"))
		OnSaveas();
	else
		//tH[JX̂^ũb`GfBbgRg[̃f[^o
		m_Edit.SaveFile(fn);
	return TRUE;
}

bool CMyWnd::OnSaveas() {

	WCHAR* fn = cmndlg.GetFileName(m_hWnd, L"b`eLXgt@C(*.rtf)\0*.rtf\0Ẵt@C(*.*)\0*.*\0\0", FALSE);
	if(!fn)
		MessageBoxW(m_hWnd, L"̓LZ܂", L"G[", MB_OK | MB_ICONERROR);
	else {
		//tH[JX̂^ũb`GfBbgRg[̃f[^o
		m_Edit.SaveFile(fn);
		SBar.SetText(3, fn);
	}
	return TRUE;
}

bool CMyWnd::OnSetprint() {

	//tH[JX̂^ũb`GfBbgRg[
	return m_Edit.SetPrinter();
}

bool CMyWnd::OnPrint() {

	//tH[JX̂^ũb`GfBbgRg[
	return m_Edit.Print(m_Tab.GetTitle());
}

bool CMyWnd::OnExit() {

	SendMessage(m_hWnd, WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnUndo() {

	m_Edit.SendMsg(EM_UNDO, 0, 0);
	return TRUE;
}

bool CMyWnd::OnCut() {

	m_Edit.SendMsg(WM_CUT, 0, 0);
	return TRUE;
}

bool CMyWnd::OnCopy() {

	m_Edit.SendMsg(WM_COPY, 0, 0);
	return TRUE;
}

bool CMyWnd::OnPaste() {

	m_Edit.SendMsg(WM_PASTE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnSelall() {

	CHARRANGE cr;
	cr.cpMin = 0;
	cr.cpMax = -1;
	m_Edit.SendMsg(EM_EXSETSEL, 0, (LPARAM)&cr);
	return TRUE;
}

bool CMyWnd::OnFind() {

	m_hDlg = m_Edit.m_hFRDlg = FindTextW(m_Edit.SetFRDlg(L'F'));
	return TRUE;
}

bool CMyWnd::OnReplace() {

	m_hDlg = m_Edit.m_hFRDlg = ReplaceTextW(m_Edit.SetFRDlg(L'R'));
	return TRUE;
}

bool CMyWnd::OnDelete() {

	return DelTabEdit();
}

bool CMyWnd::OnFont() {

	m_Edit.SelFont();
	return TRUE;
}

bool CMyWnd::OnLeft() {

	m_Edit.Align(L'L');
	return TRUE;
}

bool CMyWnd::OnCenter() {

	m_Edit.Align(L'C');
	return TRUE;
}

bool CMyWnd::OnRight() {

	m_Edit.Align(L'R');
	return TRUE;
}

bool CMyWnd::OnLindent() {

	m_Edit.Indent(1);
	return TRUE;
}

bool CMyWnd::OnLoutdent() {
	m_Edit.Indent(2);
	return TRUE;
}

bool CMyWnd::OnRindent() {

	m_Edit.Indent(3);
	return TRUE;
}

bool CMyWnd::OnRoutdent() {

	m_Edit.Indent(4);
	return TRUE;
}

bool CMyWnd::OnBrief() {

	MessageBoxW(m_hWnd,
	L"RTWEditor̓eLXg⃊b`eLXgp̃GfB^[łB\n"\
	"gqb`eLXgi*.rtfj̏ꍇ̌`Ŏ舵A*.txt"\
	"̑̊gq̃t@Cł̓eLXgt@CƂĎ舵܂B\n"\
	"N̓_uNbN̑At@CvOACRփhbv邱Ƃł\łB"\
	"܂NhbOAhhbvŃt@CJƂł܂B",
	L"ȒPȐ", MB_OK | MB_ICONINFORMATION);
	return TRUE;
}

bool CMyWnd::OnShortcut() {

	MessageBoxW(m_hWnd,
	L"Ctrl+N|VK쐬\nCtrl+O|t@CJ\nCtrl+S|t@C̕ۑ\nCtrl+P|\nCtrl+X|I\n\n"\
	"Ctrl+U|ɖ߂\nCtrl+T|؂\nCtrl+C|Rs[\nCtrl+V|\t\n\nCtrl+F|̌\n"\
	"Ctrl+R|̒u\n\nF1|V[gJbgL[̉\nF2|o[W",
	L"V[gJbgL[̉", MB_OK | MB_ICONINFORMATION);
	return TRUE;
}

bool CMyWnd::OnVer() {

	versiondlg.DoModal(m_hWnd, L"IDD_VERSION", GetInstance());
	return TRUE;
}

///////////////////
//[U[`֐
///////////////////
bool CMyWnd::AddTabEdit(WCHAR* fn) {

	//V^uɕ\郊b`GfBbgRg[̍쐬
	if(!m_Edit.Create(L"", WS_CHILD | WS_VSCROLL | ES_AUTOHSCROLL | ES_AUTOVSCROLL |
				WS_HSCROLL | ES_NOHIDESEL | ES_MULTILINE | ES_WANTRETURN,
				WS_EX_CLIENTEDGE, m_hWnd, m_EditID)) {
		MessageBoxW(m_hWnd, L"b`GfBbgRg[܂ł",
					L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//b`GfBbgRg[̓ʒmiFENM_MOUSEEVENTSjJn
	m_Edit.FilterMsg(ENM_MOUSEEVENTS | ENM_KEYEVENTS | ENM_SELCHANGE);
	//b`GfBbgRg[̃tHgݒ
	m_Edit.SetFont(11, L"lr ");
	m_Edit.SetCol(RGB(0, 0, 0));
	//b`GfBbgRg[̕Fݒ
	if(!fn)	//ǂݍރt@Ciwt@CpXA|C^[NULLjꍇAu[]vɂ
		fn = L"[]";
	else	//ǂݍރt@CLΓǂݍ
		m_Edit.LoadFile(fn);
	//V^u쐬AVKb`GfBbgRg[t
	if(!m_Tab.AddPage(m_EditID, IDI_DOC, fn)) {
		MessageBoxW(m_hWnd, L"ɃRg[Ă邩Aȏ^uݒł܂",
					L"G[", MB_OK | MB_ICONERROR);
		DestroyWindow(m_Edit.GetHandle());	//ɍ쐬VKb`GfBbgRg[j
		return FALSE;
	}
	//j[ƃc[o[̏ԂύX
	ChangeMenuStatus(TRUE);
	//Xe[^Xo[Ƀt@C\
	SBar.SetText(3, fn);
	//̃b`GfBbgRg[ID̐ݒij[NɂׂɁARg[폜ĂivԂɂj
	m_EditID++;
	return TRUE;
}

bool CMyWnd::DelTabEdit() {

	int sel = m_Tab.GetPage();
	if(sel == -1) {
		MessageBoxW(m_hWnd, L"^uIĂ܂", L"G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	if(MessageBoxW(m_hWnd, L"IĂ^u폜܂H", L"폜mF", MB_YESNO | MB_ICONQUESTION) == IDYES) {
		//t@CύXĂ΁Aۑ邩ۂmF
		if(SendMessage(m_Edit.GetHandle(), EM_GETMODIFY, 0, 0)) {
			if(MessageBoxW(m_hWnd, L"t@CύXĂ܂Bۑ܂H", L"ۑmF", MB_YESNO | MB_ICONQUESTION) == IDYES)
				m_Edit.SaveFile(m_Tab.GetTitle());
		}
		m_Tab.DeletePage();		//݂̕\^uy[Wŕ\ĂẽRg[j󂵂Ă
		//Xe[^Xo[NA
		SBar.SetText(1, L"");
		SBar.SetText(2, L"");
		SBar.SetText(3, L"");
		if(m_Tab.TabCount() == 0) {		//ׂẴ^uȂȂ
			//j[ƃc[o[̏ԂύX
			ChangeMenuStatus(FALSE);
			return TRUE;
		}
		else {
			if(!m_Tab.SetPage(sel))
				m_Tab.SetPage(sel - 1);
			m_Edit.SetHandle(m_Tab.GetCtrl());
			m_Tab.FitSiblings((WPARAM)IDC_TAB);
			SBar.SetText(3, m_Tab.GetTitle());
			return TRUE;
		}
	}
	return FALSE;
}

bool CMyWnd::PopupMenu() {

		//EChËʒu擾
		RECT rec;
		GetWindowRect(m_hWnd, &rec);
		//|bvAbvj[̕\ꏊݒ
		POINT pt;
		GetCursorPos(&pt);
		//|bvAbvj[̕\
		return TrackPopupMenu(g_hPopup, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON, pt.x, pt.y, 0, m_hWnd, &rec);
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool VERSIONDLG::OnIdok() {

	versiondlg.EndModal(TRUE);
	return TRUE;
}
