//////////////////////////////////////////
// BCCMakerProc.h
// Copyright (c) 11/09/2020 by BCCSkelton
//////////////////////////////////////////
///////////////////////////////
//[U[_CAO̊֐`
//MAKEDLG
///////////////////////////////
bool MAKEDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|SetHandle(hWnd))
	TBar.SetHandle(GetDlgItem(m_hWnd, IDC_TOOLBAR));
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TOOLBAR), 8);
	//c[o[{^ǉ
	TBBUTTON tbb[12];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_NEW;
	tbb[1].iBitmap = TBar.m_id + 1;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_OPEN;
	tbb[2].iBitmap = TBar.m_id + 2;
	tbb[2].fsState = TBSTATE_ENABLED;
	tbb[2].fsStyle = TBSTYLE_BUTTON;
	tbb[2].idCommand = IDM_SAVE;
	tbb[3].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[4].iBitmap = TBar.m_id + 3;
	tbb[4].fsState = TBSTATE_ENABLED;
	tbb[4].fsStyle = TBSTYLE_BUTTON;
	tbb[4].idCommand = IDM_EXIT;
	tbb[5].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[6].iBitmap = TBar.m_id + 4;
	tbb[6].fsState = TBSTATE_ENABLED;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_MAKE;
	tbb[7].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[8].iBitmap = TBar.m_id + 5;
	tbb[8].fsState = TBSTATE_ENABLED;
	tbb[8].fsStyle = TBSTYLE_BUTTON;
	tbb[8].idCommand = IDM_SETTING;
	tbb[9].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[10].iBitmap = TBar.m_id + 6;
	tbb[10].fsState = TBSTATE_ENABLED;
	tbb[10].fsStyle = TBSTYLE_BUTTON;
	tbb[10].idCommand = IDM_HELP;
	tbb[11].iBitmap = TBar.m_id + 7;
	tbb[11].fsState = TBSTATE_ENABLED;
	tbb[11].fsStyle = TBSTYLE_BUTTON;
	tbb[11].idCommand = IDM_VERSION;
	TBar.AddButtons(12, tbb);

	//Xe[^Xo[o^|SetHandle(hWnd))
	SBar.SetHandle(GetDlgItem(m_hWnd, IDC_STATUSBAR));
	//Xe[^Xo[ݒ
	int sec[2] = {220, -1};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "BCCMaker Ver1.0C (c) 2002 By ysama");

	//t@CpX̐ݒ
	g_OwnPath = Arg.Path();
	g_IniFile = g_OwnPath + "\\BCCMaker.ini";
	Ini.SetName(g_IniFile.ToChar());
	g_Make = Ini.ReadStr("System", "MAKE");
	g_Bcc32 = Ini.ReadStr("System", "BCC32");
	g_Brc32 = Ini.ReadStr("System", "BCR32");
	g_Asm = Ini.ReadStr("System", "ASM");
	g_Edit = Ini.ReadStr("System", "EDITOR");
	g_HelpFile = g_OwnPath + "\\BCCMakerHelp.chm";

	//c[r[Rg[̏i_CAÕRg[Ɋ֘Atj
	tv.m_hWnd = GetDlgItem(m_hWnd, IDC_FILETREE);
	tv.m_hInstance = m_hInstance;
	tv.SetFont(8, "lr ");
	//rbg}bvo^
	tv.AddBitmap(MAKEINTRESOURCE(IDI_CLOSE), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_CPPBMP), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_RCBMP), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_ASMBMP), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_OBJBMP), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_LIBBMP), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_DOC), m_hInstance, RGB(255, 255, 255));
	//{Create()֐ŎIɍsA_CAOx[XȂ̂Ŏ蓮
	TreeView_SetImageList(tv.m_hWnd, tv.m_hIList, TVSIL_NORMAL);

	//R}hGfBbgRg[̏
	ce.m_hWnd = GetDlgItem(m_hWnd, IDC_OUTPUT);
	ce.m_hInstance = m_hInstance;
	ce.SetFont(8, "lr ");

	//_CAȌ
	g_Prj = "";
	SendItemMsg(IDC_PROJECT, WM_SETTEXT, 0, (LPARAM)g_Prj.ToChar());
	g_OutDir = FALSE;		//FALSE - Debug
	g_InclPath = "";
	g_Copt = "-tW -Od -6 -pc -AT -y -k -Q -b";
	SendItemMsg(IDC_BCC32OPTION, WM_SETTEXT, 0, (LPARAM)g_Copt.ToChar());
	g_Ropt = "-r";
	SendItemMsg(IDC_BRC32OPTION, WM_SETTEXT, 0, (LPARAM)g_Ropt.ToChar());
	g_Aopt = "-omf";
	SendItemMsg(IDC_ASMOPTION, WM_SETTEXT, 0, (LPARAM)g_Aopt.ToChar());
	SBar.SetText(1, g_Prj.ToChar());
	SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_Prj.ToChar());	//ToolTip

	//ݒ菉iUser.hQƁj
	InitDialog(m_hWnd);

	//TCYύXRg[̏ʒu擾
	RECT rec;
	GetWindowRect(GetDlgItem(m_hWnd, IDC_DETAIL), &rec);	//ڍ׃{^
	g_idc_detail.x = rec.left;
	g_idc_detail.y = rec.top;
	g_detail_wd = rec.right - rec.left;
	g_detail_ht = rec.bottom - rec.top;
	ScreenToClient(m_hWnd, &g_idc_detail);
	for(int i = IDC_PROJECT; i < IDC_OUTPUT; i++) {			//̑Rg[
		GetWindowRect(GetDlgItem(m_hWnd, i), &rec);
		g_righside[i].x = rec.left;
		g_righside[i].y = rec.top;
		ScreenToClient(m_hWnd, &g_righside[i]);
	}
	GetWindowRect(GetDlgItem(m_hWnd, IDC_OUTPUT), &rec);	//IDC_OUTPUTRg[
	g_idc_output.x = rec.left;
	g_idc_output.y = rec.top;
	ScreenToClient(m_hWnd, &g_idc_output);

	//CHISTORYϐinit@Cݒ
	history.SetPath(g_IniFile.ToChar());
	history.SetMenu(GetSubMenu(GetSubMenu(GetMenu(m_hWnd), 0), 5));
	history.Init();

	//f[^t@CŋNꂽꍇAt@CI[v
	if(g_ByFile)
		OnOpen();

	return TRUE;
}

bool MAKEDLG::OnNotify(WPARAM wParam, LPARAM lParam) {

	//c[o[̃c[`bv擾
	switch (((LPNMHDR)lParam)->code) {
		case TTN_NEEDTEXT:
			static LPTOOLTIPTEXT lptip;
			lptip = (LPTOOLTIPTEXT)lParam;
			switch (lptip->hdr.idFrom) {
				case IDM_NEW:
					lptip->lpszText = "VKCNt@C̍쐬";
					break;
				case IDM_OPEN:
					lptip->lpszText = "CNt@CJ";
					break;
				case IDM_SAVE:
					lptip->lpszText = "CNt@C̕ۑ";
					break;
				case IDM_EXIT:
					lptip->lpszText = "BCCMakeȑI";
					break;
				case IDM_MAKE:
					lptip->lpszText = "Makes";
					break;
				case IDM_SETTING:
					lptip->lpszText = "ݒ";
					break;
				case IDM_HELP:
					lptip->lpszText = "BCCMakerwv";
					break;
				case IDM_VERSION:
					lptip->lpszText = "o[W";
					break;
			}
	}
	//|bvAbvj[ǂ݂
	HMENU hMenu = LoadMenu(m_hInstance, "IDM_POPUP");
	HMENU hPopupMenu = GetSubMenu(hMenu, 0);
	if(wParam == IDC_FILETREE) {
		//IĂACe擾
		HTREEITEM hSelected = tv.GetSelection();
		//bZ[WǂA
		TV_DISPINFO* ptv_disp;
		ptv_disp = (TV_DISPINFO*)lParam;
		//_uNbN
		if(ptv_disp->hdr.code == NM_DBLCLK) {
			CSTR Cmd = "\"";
			Cmd = Cmd + g_Edit + "\" \"";
			char Buff[MAX_PATH];
			//IACe̕擾AŃtB^[쐬ăvOs
			if(hSelected) {
				tv.GetItem(hSelected, Buff, MAX_PATH);
				if(strstr(Buff, "t@C"))
					SendMsg(WM_COMMAND, IDC_ADD, NULL);
				else {
					Cmd = Cmd + Buff;
					Cmd = Cmd + "\"";
					WinExec(Cmd.ToChar(), SW_SHOWNORMAL);
				}
			}
		}
		//ENbN|bvAbvj[
		else if(ptv_disp->hdr.code == NM_RCLICK) {
			//|bvAbvj[̕\
			POINT pt;
			GetCursorPos(&pt);
			TrackPopupMenu(hPopupMenu, TPM_LEFTALIGN | TPM_LEFTBUTTON,
						  pt.x, pt.y, 0, m_hWnd, NULL);
		}
	}
	//j[\[X̊J
	DestroyMenu(hMenu);
	return TRUE;
}

bool MAKEDLG::OnDefault(WPARAM wParam) {	//WM_COMMAND̓ꏈ

	char menuitem[MAX_PATH];
	int num = LOWORD(wParam) - IDM_HISTORY;
	if(num >= 0 && num < ITEM_MAX) {
		MENUITEMINFO mii = {0};	//ZeroMemory(&mii, sizeof(MENUITEMINFO));Ɠݒ
		mii.cbSize		= sizeof(MENUITEMINFO);
		mii.fMask		= MIIM_ID | MIIM_TYPE;
		mii.fType		= MFT_STRING;
		mii.dwTypeData	= NULL;
		if(GetMenuItemInfo(GetSubMenu(GetSubMenu(GetMenu(m_hWnd), 0), 5), num, TRUE, &mii)) {
			mii.fType		= MFT_STRING;
			mii.dwTypeData	= menuitem;
			mii.cch++;
			if(GetMenuItemInfo(GetSubMenu(GetSubMenu(GetMenu(m_hWnd), 0), 5), num, TRUE, &mii)) {
				g_Prj = menuitem;
				//ɊYp[^[ȂΑÕf[^ĉŏ
				g_OutDir = FALSE;
				g_InclPath = "";
				g_Copt = "-tW -Od -6 -pc -AT -y -k -Q -b";
				g_Ropt = "-r";
				g_Aopt = "-omf";
				InitDialog(m_hWnd);
				ReadMakeFile(menuitem);
				SendItemMsg(IDC_PROJECT, WM_SETTEXT, 0, (LPARAM)g_Prj.ToChar());
				SendItemMsg(IDC_BCC32OPTION, WM_SETTEXT, 0, (LPARAM)g_Copt.ToChar());
				SendItemMsg(IDC_BRC32OPTION, WM_SETTEXT, 0, (LPARAM)g_Ropt.ToChar());
				SendItemMsg(IDC_ASMOPTION, WM_SETTEXT, 0, (LPARAM)g_Aopt.ToChar());
				SBar.SetText(1, g_Prj.ToChar());
				SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_Prj.ToChar());	//ToolTip
				return TRUE;
			}
		}
	}
	return FALSE;
}

bool MAKEDLG::OnSize(WPARAM wParam, LPARAM lParam) {

	RECT rec;
	//c[o[Đݒ
	TBar.AutoSize();
	//Xe[^Xo[Đݒ
	SBar.AutoSize();
	//IDC_DETAILĐݒ
	MoveWindow(GetDlgItem(m_hWnd, IDC_DETAIL), LOWORD(lParam) - g_detail_wd
			- g_idc_output.x, g_idc_detail.y, g_detail_wd, g_detail_ht, TRUE);
	//ERg[Đݒ
	for(int i = IDC_PROJECT; i < IDC_OUTPUT; i++) {
		GetWindowRect(GetDlgItem(m_hWnd, i), &rec);
		MoveWindow(GetDlgItem(m_hWnd, i), g_righside[i].x, g_righside[i].y,
				LOWORD(lParam) - g_righside[i].x - g_idc_output.x, rec.bottom
				- rec.top, TRUE);
	}
	//IDC_OUTPUTĐݒ
	GetWindowRect(SBar.GetHandle(), &rec);	//Xe[^Xo[擾
	MoveWindow(GetDlgItem(m_hWnd, IDC_OUTPUT), g_idc_output.x, g_idc_output.y,
			LOWORD(lParam) - g_idc_output.x * 2, HIWORD(lParam) - g_idc_output.y
			- (rec.bottom - rec.top), TRUE);

	return TRUE;
}

bool MAKEDLG::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES) {
		//DestroyWindowAPostQuitMessageĂ΂
		//Init@CɏŏI
		Ini.WriteStr("System", "BCCMAKER", g_OwnPath.ToChar());
		Ini.WriteStr("System", "MAKE", g_Make.ToChar());
		Ini.WriteStr("System", "BCC32", g_Bcc32.ToChar());
		Ini.WriteStr("System", "BCR32", g_Brc32.ToChar());
		Ini.WriteStr("System", "ASM", g_Asm.ToChar());
		Ini.WriteStr("System", "EDITOR", g_Edit.ToChar());
		//̏
		history.WriteIni();
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

//_CAOx[X̏ꍇ͂ꂪKv
bool MAKEDLG::OnDestroy(WPARAM wPram, LPARAM lParam) {

	PostQuitMessage(0);
	return TRUE;
}

///////////////////////////////
// MAKEDLG
//j[ARg[̊֐
///////////////////////////////
bool MAKEDLG::OnAdd() {

	//tB^[pϐ
	char Buff[MAX_PATH];
	char* Filter[] = {	"cppt@C\0*.cpp\0\0",
						"rct@C\0*.rc\0\0",
						"asmt@C\0*.asm\0\0",
						"objt@C\0*.obj\0\0",
						"libt@C\0*.lib\0\0",
						"SẴt@C\0*.*\0\0"};
	int nFilter;
	//IĂACe̕擾AŃtB^[쐬
	HTREEITEM hSelected = tv.GetSelection();
	if(hSelected) {
		tv.GetItem(hSelected, Buff, MAX_PATH);
		if(!lstrcmp(Buff, "CPPt@C"))		nFilter = 0;
		else if(!lstrcmp(Buff, "RCt@C"))	nFilter = 1;
		else if(!lstrcmp(Buff, "ASMt@C"))	nFilter = 2;
		else if(!lstrcmp(Buff, "OBJt@C"))	nFilter = 3;
		else if(!lstrcmp(Buff, "LIBt@C"))	nFilter = 4;
		else 									nFilter = 5;
	}
	else										nFilter = 5;
	//t@C擾
	char* FileName = cmndlg.GetFileName(m_hWnd, Filter[nFilter], TRUE);
	if(!FileName) {
		MessageBox(m_hWnd, "t@CI܂ł", "G[", MB_OK | MB_ICONSTOP);
		return TRUE;
	}
	//t@Cɑ݂邩mF
	hSelected = tv.GetChild(hSelected);		//̃JeS[̍ŏ̎qACe
	while(hSelected) {
		tv.GetItem(hSelected, Buff, MAX_PATH);
		if(!lstrcmp(FileName, Buff)) {		//ɓt@CΒǉȂ
			MessageBox(m_hWnd, "̃t@C͑IςłI", Buff, MB_OK | MB_ICONSTOP);
			return TRUE;
		}
		else
			hSelected = tv.GetNext(hSelected);
	}
	//t@Cc[r[ɕ\
	HTREEITEM tvParent;
	if(strstr(FileName, ".cpp") || strstr(FileName, ".CPP"))
		tvParent = g_hTreeCPP;
	else if(strstr(FileName, ".rc") || strstr(FileName, ".RC"))
		tvParent = g_hTreeRC;
	else if(strstr(FileName, ".asm") || strstr(FileName, ".ASM"))
		tvParent = g_hTreeASM;
	else if(strstr(FileName, ".obj") || strstr(FileName, ".OBJ"))
		tvParent = g_hTreeOBJ;
	else if(strstr(FileName, ".lib") || strstr(FileName, ".LIB"))
		tvParent = g_hTreeLIB;
	else {
		MessageBox(m_hWnd, "MakełȂt@Cł", "G[", MB_OK | MB_ICONSTOP);
		return TRUE;
	}
	tv.InsertItem(FileName, TVI_LAST, tvParent, 6, 6);
	tv.Expand(tvParent, TVE_EXPAND);
	return TRUE;
}

bool MAKEDLG::OnDel() {

	//IĂACe̕擾AŃtB^[쐬
	char Buff[MAX_PATH];
	HTREEITEM hSelected = tv.GetSelection();
	if(hSelected) {
		tv.GetItem(hSelected, Buff, MAX_PATH);
	}
	else {
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONSTOP);
		return TRUE;
	}
	CSTR ItemText = Buff;
	if(ItemText == "CPPt@C" || ItemText == "RCt@C" ||
		ItemText == "ASMt@C" || ItemText == "OBJt@C" ||
		ItemText == "LIBt@C")
		MessageBox(m_hWnd, "tH[_[͍폜ł܂", "x  ", MB_OK | MB_ICONSTOP);
	else
		tv.DeleteItem(hSelected);
	return TRUE;
}

bool MAKEDLG::OnDetail() {

	detaildlg.DoModal(m_hWnd, "IDD_DETAIL", detaildlgProc);
	return TRUE;
}


bool MAKEDLG::OnProject(WPARAM wParam, LPARAM lParam) {

	char buff[MAX_PATH];
	if(HIWORD(wParam) == EN_UPDATE) {
		SendItemMsg(IDC_PROJECT, WM_GETTEXT, MAX_PATH, (LPARAM)buff);
		g_Prj = buff;
		return TRUE;
	}
	else
		return FALSE;
}

bool MAKEDLG::OnBCCOption(WPARAM wParam, LPARAM lParam) {

	char buff[MAX_PATH];
	if(HIWORD(wParam) == EN_UPDATE) {
		SendItemMsg(IDC_BCC32OPTION, WM_GETTEXT, MAX_PATH, (LPARAM)buff);
		g_Copt = buff;
		return TRUE;
	}
	else
		return FALSE;
}

bool MAKEDLG::OnBRCOption(WPARAM wParam, LPARAM lParam) {

	char buff[MAX_PATH];
	if(HIWORD(wParam) == EN_UPDATE) {
		SendItemMsg(IDC_BRC32OPTION, WM_GETTEXT, MAX_PATH, (LPARAM)buff);
		g_Ropt = buff;
		return TRUE;
	}
	else
		return FALSE;
}

bool MAKEDLG::OnASMOption(WPARAM wParam, LPARAM lParam) {

	char buff[MAX_PATH];
	if(HIWORD(wParam) == EN_UPDATE) {
		SendItemMsg(IDC_ASMOPTION, WM_GETTEXT, MAX_PATH, (LPARAM)buff);
		g_Aopt = buff;
		return TRUE;
	}
	else
		return FALSE;
}

bool MAKEDLG::OnNew() {

	//VKt@C_CAOŏ
	if(newdlg.DoModal(m_hWnd, "IDD_NEW", newdlgProc)) {
		SendItemMsg(IDC_PROJECT, WM_SETTEXT, 0, (LPARAM)g_Prj.ToChar());
		SendItemMsg(IDC_BCC32OPTION, WM_SETTEXT, 0, (LPARAM)g_Copt.ToChar());
		SendItemMsg(IDC_BRC32OPTION, WM_SETTEXT, 0, (LPARAM)g_Ropt.ToChar());
		SendItemMsg(IDC_ASMOPTION, WM_SETTEXT, 0, (LPARAM)g_Aopt.ToChar());
		InitDialog(m_hWnd);
		SBar.SetText(1, g_Prj.ToChar());
		history.AddItem(g_Prj.ToChar());	//t@C𗚗ɋL^
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_Prj.ToChar());	//ToolTip
	}
	return TRUE;
}

bool MAKEDLG::OnOpen() {

	char* cp = NULL;
	//f[^t@CtŋNꂽꍇ̑Ή
	if(g_ByFile) {
		if(strstr(Arg.v(1), ".mak") || strstr(Arg.v(1), ".MAK"))
			cp = Arg.v(1);
		else
			MessageBox(m_hWnd, "MAKEt@Ci*.makjł͂܂", "G[", MB_OK | MB_ICONERROR);
		g_ByFile = FALSE;	//񂾂̏
 	}
	else
		cp = cmndlg.GetFileName(m_hWnd, "CNt@C(*.mak)\0*.mak\0\0", TRUE, "mak");
	if(cp) {
		g_Prj = cp;
		history.AddItem(g_Prj.ToChar());	//t@C𗚗ɋL^
		//ɊYp[^[ȂΑÕf[^ĉŏ
		g_OutDir = FALSE;
		g_InclPath = "";
		g_Copt = "-tW -Od -6 -pc -AT -y -k -Q -b";
		g_Ropt = "-r";
		g_Aopt = "-omf";
		InitDialog(m_hWnd);
		ReadMakeFile(cp);
		SendItemMsg(IDC_PROJECT, WM_SETTEXT, 0, (LPARAM)g_Prj.ToChar());
		SendItemMsg(IDC_BCC32OPTION, WM_SETTEXT, 0, (LPARAM)g_Copt.ToChar());
		SendItemMsg(IDC_BRC32OPTION, WM_SETTEXT, 0, (LPARAM)g_Ropt.ToChar());
		SendItemMsg(IDC_ASMOPTION, WM_SETTEXT, 0, (LPARAM)g_Aopt.ToChar());
		SBar.SetText(1, g_Prj.ToChar());
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_Prj.ToChar());	//ToolTip
		return TRUE;
	}
	return FALSE;
}

bool MAKEDLG::OnSave() {

	if(*g_Prj.ToChar())
		WriteMakeFile(g_Prj.ToChar());
	else
		MessageBox(m_hWnd, "t@Cw肳Ă܂", "x", MB_OK | MB_ICONSTOP);
	return TRUE;
}

bool MAKEDLG::OnSaveas() {

	char* cp = cmndlg.GetFileName(m_hWnd, "CNt@C(*.mak)\0*.mak\0\0", FALSE, "mak");
	if(*cp)
		WriteMakeFile(cp);
	else
		MessageBox(m_hWnd, "t@Cw肳Ă܂", "x", MB_OK | MB_ICONSTOP);
	return TRUE;
}

bool MAKEDLG::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool MAKEDLG::OnMake() {

	//݂̍ŐVmakevWFNgۑ
	if(*g_Prj.ToChar())
		WriteMakeFile(g_Prj.ToChar());
	else {
		MessageBox(m_hWnd, "makt@C܂w肳Ă܂", "  ", MB_OK | MB_ICONSTOP);
		return TRUE;
	}
	//bZ[Wo͗pGfBbgRg[iIDC_OUTPUTjNA
	SendItemMsg(IDC_OUTPUT, WM_SETTEXT, 0, (LPARAM)"");
	//݂̃fBNg[ۑ
	char CurrentDir[MAX_PATH];
	CSTR TargetDir(g_Prj);
	GetCurrentDirectory(MAX_PATH, CurrentDir);
	//makt@ĈfBNg[̈̃fBNg[ɏオ
	char* cp;
	cp = TargetDir.ToChar() + lstrlen(TargetDir.ToChar());
	while(*cp != '\\')	cp--;
	*cp = NULL;				//̃tH[_[
	if(*(cp - 1) != ':') {	//hCuLłȂ
		while(*cp != '\\')	cp--;
		*cp = NULL;			//̃tH[_[
	}
	SetCurrentDirectory(TargetDir.ToChar());
	//MakẽR}hC쐬
	char cmdstr[MAX_PATH * 2];
	lstrcpy(cmdstr, "\"");
	lstrcat(cmdstr, g_Make.ToChar());
	lstrcat(cmdstr, "\" \"-f");
	lstrcat(cmdstr, g_Prj.ToChar());
	lstrcat(cmdstr, "\"");
	//Make̎s
	ce.Exec(cmdstr, "Making starts ...\r\n\r\n",
			"\r\n-------------------- Make Process finished --------------------\r\n");
	//̃fBNg[ɖ߂
	SetCurrentDirectory(CurrentDir);
	MessageBox(m_hWnd, "Make܂", "Make", MB_OK | MB_ICONINFORMATION);
	return TRUE;
}

bool MAKEDLG::OnMakeedit() {

	char cmd[MAX_PATH];
	lstrcpy(cmd, "\"");
	lstrcat(cmd, g_Edit.ToChar());
	lstrcat(cmd, "\" \"");
	lstrcat(cmd, g_Prj.ToChar());
	lstrcat(cmd, "\"");
	//t@C邩mF
	OFSTRUCT ofs;
	ZeroMemory(&ofs, sizeof(OFSTRUCT));
	ofs.cBytes = sizeof(OFSTRUCT);
	if(OpenFile(g_Prj.ToChar(), &ofs, OF_EXIST) != HFILE_ERROR)
		WinExec(cmd, SW_SHOWNORMAL);
	else											//΃G[
		MessageBox(m_hWnd, "makt@CĂ܂", " ", MB_OK | MB_ICONSTOP);
	return TRUE;
}

bool MAKEDLG::OnRun() {

	if(g_Prj == "") {
		MessageBox(m_hWnd, "t@CĂ܂", " ", MB_OK | MB_ICONSTOP);
		return TRUE;
	}
	CSTR str = g_Prj;
	lstrcpy(strstr(str.ToChar(), ".mak"), ".exe");	//g_Prj(mak)"exe"ɕς
	WinExec(str.ToChar(), SW_SHOWNORMAL);
	return TRUE;
}

bool MAKEDLG::OnSetting() {

	setupdlg.DoModal(m_hWnd, "IDD_SETUP", setupdlgProc);
	return TRUE;
}

bool MAKEDLG::OnHelp() {

	CSTR cmd = "hh \"";
	cmd = cmd + g_HelpFile + "\"";
	WinExec(cmd.ToChar(), SW_SHOWNORMAL);
	return TRUE;
}

bool MAKEDLG::OnOption() {

	helpdlg.DoModal(m_hWnd, "IDD_HELP", helpdlgProc);
	return TRUE;
}

bool MAKEDLG::OnVersion() {

	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//NEWDLG
///////////////////////////////
bool NEWDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//o̓tH[_[̐ݒ
	SendItemMsg(IDC_TARGET, CB_ADDSTRING, 0, (LPARAM)"Debug");
	SendItemMsg(IDC_TARGET, CB_ADDSTRING, 0, (LPARAM)"Release");
	SendItemMsg(IDC_TARGET, CB_SETCURSEL, 0, 0);
	return TRUE;
}

bool NEWDLG::OnSelect() {

	char* cp;
	if(cp = cmndlg.GetPath(m_hWnd, "Debug/ReleasetH[_[_ƂȂtH[_[IĂ"))
		SendItemMsg(IDC_ORIGIN, WM_SETTEXT, 0, (LPARAM)cp);
	return TRUE;
}

bool NEWDLG::OnIdok() {

	//^[QbgfBNg[ǂ
	char Buff[MAX_PATH];
	SendItemMsg(IDC_ORIGIN, WM_GETTEXT, MAX_PATH, (LPARAM)Buff);
	g_Prj = Buff;
	switch(SendItemMsg(IDC_TARGET, CB_GETCURSEL, 0, 0)) {
		case 0:
			g_OutDir = FALSE;		//FALSE - Debug
			g_Copt = "-tW -6 -Od -w- -AT -pc -H- -k -Q -b -v -y";
			g_Prj = g_Prj + "\\Debug";
			break;
		case 1:
			g_OutDir = TRUE;		//TRUE - Release
			g_Copt = "-tW -6 -Od -w- -AT -pc -H- -k -b";
			g_Prj = g_Prj + "\\Release";
			break;
	}
	//ꍇltH[_[쐬
	CreateDirectory(g_Prj.ToChar(), NULL);
	//t@Ct
	SendItemMsg(IDC_NAME, WM_GETTEXT, MAX_PATH, (LPARAM)Buff);
	if(!strstr(Buff, ".mak"))	//gqȂ".mak"ǉ
		lstrcat(Buff, ".mak");
	g_Prj = g_Prj + "\\";
	g_Prj = g_Prj + Buff;
	//CN[hpX
	g_InclPath = "";
	//brc32Asembler̃IvV
	g_Ropt = "-r";
	g_Aopt = "-omf";

	EndModal(TRUE);
	return TRUE;
}

bool NEWDLG::OnCancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//DETAILDLG
///////////////////////////////
bool DETAILDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//^[Qbg^Cv̐ݒ
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"R\[AvP[V");
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"WindowsAvP[V");
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"Dynamic Link Liabrary");
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"Cu[iTLIBj");
	//o̓tH[_[̐ݒ
	SendItemMsg(IDC_TARGETDIR, CB_ADDSTRING, 0, (LPARAM)"Debug");
	SendItemMsg(IDC_TARGETDIR, CB_ADDSTRING, 0, (LPARAM)"Release");
	//œK̐ݒ
	SendItemMsg(IDC_OPTIMIZATION, CB_ADDSTRING, 0, (LPARAM)"");
	SendItemMsg(IDC_OPTIMIZATION, CB_ADDSTRING, 0, (LPARAM)"TCYœK");
	SendItemMsg(IDC_OPTIMIZATION, CB_ADDSTRING, 0, (LPARAM)"xœK");
	//߃R[h̐ݒ
	SendItemMsg(IDC_INSTRUCTIONSET, CB_ADDSTRING, 0, (LPARAM)"80386i-3j");
	SendItemMsg(IDC_INSTRUCTIONSET, CB_ADDSTRING, 0, (LPARAM)"80386/80486i-4j");
	SendItemMsg(IDC_INSTRUCTIONSET, CB_ADDSTRING, 0, (LPARAM)"Pentiumi-5j");
	SendItemMsg(IDC_INSTRUCTIONSET, CB_ADDSTRING, 0, (LPARAM)"Pentium Proi-6j");
	//ďoK̐ݒ
	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"Ci-pcj");
	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"Pascali-pj");
	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"stdcalli-psj");
	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"fastcalli-prj");
	//dl̐ݒ
	SendItemMsg(IDC_LANGUAGETYPE, CB_ADDSTRING, 0, (LPARAM)"Borlandi-ATj");
	SendItemMsg(IDC_LANGUAGETYPE, CB_ADDSTRING, 0, (LPARAM)"ANSIi-Aj");
	SendItemMsg(IDC_LANGUAGETYPE, CB_ADDSTRING, 0, (LPARAM)"UNIX Vi-AUj");
	SendItemMsg(IDC_LANGUAGETYPE, CB_ADDSTRING, 0, (LPARAM)"K&Ri-AKj");
	//fobO̐ݒ
	SendItemMsg(IDC_DEBUG, CB_ADDSTRING, 0, (LPARAM)"fobOti-vj");
	SendItemMsg(IDC_DEBUG, CB_ADDSTRING, 0, (LPARAM)"sԍti-yj");
	SendItemMsg(IDC_DEBUG, CB_ADDSTRING, 0, (LPARAM)"fobOEsԍt");

	//bcc32OptionGfBbgRg[ǂŉǂ
	char Temp[MAX_PATH * 32];
	makedlg.SendItemMsg(IDC_BCC32OPTION, WM_GETTEXT, MAX_PATH * 32, (LPARAM)Temp);
	CSTR BccOpt = Temp, Token;
	while(BccOpt.Next(Token)) {
		*Temp = NULL;
		if(Token == "-WC" || Token == "-tWC") {			//R\[Av
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 0, 0);
		}
		else if(Token == "-W" || Token == "-tW") {		//EBhEAv
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 1, 0);
		}
		else if(Token == "-WD" || Token == "-tWD") {	//DLLAv
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 2, 0);
		}
		else if(Token == "-WR" || Token == "-tWR") {	//Cu[
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 3, 0);
		}
		else if(Token == "-WM" || Token == "-tWM") {	//}`XbhAv
			SendItemMsg(IDC_MULTITHREAD, BM_SETCHECK, BST_CHECKED, 0);
		}
		else if(Token == "-Od") {						//œK
			SendItemMsg(IDC_OPTIMIZATION, CB_SETCURSEL, 0, 0);
		}
		else if(Token == "-O1") {						//TCYœK
			SendItemMsg(IDC_OPTIMIZATION, CB_SETCURSEL, 1, 0);
		}
		else if(Token == "-O2") {						//xœK
			SendItemMsg(IDC_OPTIMIZATION, CB_SETCURSEL, 2, 0);
		}
		else if(Token == "-3") {						//CPU߃Zbg386
			SendItemMsg(IDC_INSTRUCTIONSET, CB_SETCURSEL, 0, 0);
		}
		else if(Token == "-4") {						//CPU߃Zbg486
			SendItemMsg(IDC_INSTRUCTIONSET, CB_SETCURSEL, 1, 0);
		}
		else if(Token == "-5") {						//CPU߃ZbgPentium
			SendItemMsg(IDC_INSTRUCTIONSET, CB_SETCURSEL, 2, 0);
		}
		else if(Token == "-6") {						//CPU߃ZbgPentium Pro
			SendItemMsg(IDC_INSTRUCTIONSET, CB_SETCURSEL, 3, 0);
		}
		else if(Token == "-pc") {						//ČĂяoK
			SendItemMsg(IDC_CALLTYPE, CB_SETCURSEL, 0, 0);
		}
		else if(Token == "-p") {						//pXJ̌ĂяoK
			SendItemMsg(IDC_CALLTYPE, CB_SETCURSEL, 1, 0);
		}
		else if(Token == "-ps") {						//stdcalľĂяoK
			SendItemMsg(IDC_CALLTYPE, CB_SETCURSEL, 2, 0);
		}
		else if(Token == "-pr") {						//fastcalľĂяoK
			SendItemMsg(IDC_CALLTYPE, CB_SETCURSEL, 3, 0);
		}
		else if(Token == "-AT") {						//\BCC32.EXEɏ
			SendItemMsg(IDC_LANGUAGETYPE, CB_SETCURSEL, 0, 0);
		}
		else if(Token == "-A") {						//\ANSIɏ
			SendItemMsg(IDC_LANGUAGETYPE, CB_SETCURSEL, 1, 0);
		}
		else if(Token == "-AU") {						//\UNIXɏ
			SendItemMsg(IDC_LANGUAGETYPE, CB_SETCURSEL, 2, 0);
		}
		else if(Token == "-AK") {						//\K&Rɏ
			SendItemMsg(IDC_LANGUAGETYPE, CB_SETCURSEL, 3, 0);
		}
		else if(Token == "-H") {						//vRpCwb_[gp
			SendItemMsg(IDC_PRECOMPILEHEADER, BM_SETCHECK, BST_CHECKED, 0);
		}
		else if(Token == "-w") {						//x\gp
			SendItemMsg(IDC_WARNING, BM_SETCHECK, BST_CHECKED, 0);
		}
		else if(Token == "-v") {						//fobOt
			if(*Temp) {
				SendItemMsg(IDC_DEBUG, CB_SETCURSEL, 2, 0);
				*Temp = NULL;
			}
			else {
				SendItemMsg(IDC_DEBUG, CB_SETCURSEL, 0, 0);
				*Temp = TRUE;
			}
		}
		else if(Token == "-y") {						//sԍt
			if(*Temp) {
				SendItemMsg(IDC_DEBUG, CB_SETCURSEL, 2, 0);
				*Temp = NULL;
			}
			else {
				SendItemMsg(IDC_DEBUG, CB_SETCURSEL, 1, 0);
				*Temp = TRUE;
			}
		}
		else if(Token == "-d") {						//d𓝍
			SendItemMsg(IDC_STRINTEG, BM_SETCHECK, BST_CHECKED, 0);
		}
		else if(Token == "-k") {						//X^bNt[
			SendItemMsg(IDC_STACKFRAME, BM_SETCHECK, BST_CHECKED, 0);
		}
		else if(Token == "-Q") {						//gRpC[
			SendItemMsg(IDC_EXTERRORINFO, BM_SETCHECK, BST_CHECKED, 0);
		}
		else if(Token == "-b") {						//enumintɂ
			SendItemMsg(IDC_ENUM2INT, BM_SETCHECK, BST_CHECKED, 0);
		}
	}
	//o̓tH[_[
	if(g_OutDir)
		SendItemMsg(IDC_TARGETDIR, CB_SETCURSEL, 1, 0);
	else
		SendItemMsg(IDC_TARGETDIR, CB_SETCURSEL, 0, 0);
	//CN[hpX
	SendItemMsg(IDC_INCLPATH, WM_SETTEXT, 0, (LPARAM)g_InclPath.ToChar());
	return TRUE;
}

bool DETAILDLG::OnIdok() {

	//bcc32Option\
	char Temp[MAX_PATH * 4];
	CSTR BccOpt;
	switch(SendItemMsg(IDC_TARGETTYPE, CB_GETCURSEL, 0, 0)) {
		case 0:
			BccOpt = "-tWC";			//R\[Av
			break;
		case 1:
			BccOpt = "-tW";				//EBhEAv
			break;
		case 2:
			BccOpt = "-tWD";			//DLLAv
			break;
		case 3:
			BccOpt = "-tWR";			//Cu[
			break;
		case CB_ERR:
			BccOpt = "-tW";				//EBhEAv
			break;
	}
	if(SendItemMsg(IDC_MULTITHREAD, BM_GETCHECK, 0, 0) == BST_CHECKED)
		BccOpt = BccOpt + " -tWM";		//}`XbhAv
	switch(SendItemMsg(IDC_OPTIMIZATION, CB_GETCURSEL, 0, 0)) {
		case 0:
			BccOpt = BccOpt + " -Od";	//œK
			break;
		case 1:
			BccOpt = BccOpt + " -O1";	//TCYœK
			break;
		case 2:
			BccOpt = BccOpt + " -O2";	//xœK
			break;
		case CB_ERR:
			BccOpt = BccOpt + " -Od";	//œK
			break;
	}
	switch(SendItemMsg(IDC_INSTRUCTIONSET, CB_GETCURSEL, 0, 0)) {
		case 0:
			BccOpt = BccOpt + " -3";	//CPU߃Zbg386
			break;
		case 1:
			BccOpt = BccOpt + " -4";	//CPU߃Zbg486
			break;
		case 2:
			BccOpt = BccOpt + " -5";	//CPU߃ZbgPentium
			break;
		case 3:
			BccOpt = BccOpt + " -6";	//CPU߃ZbgPentium Pro
			break;
		case CB_ERR:
			BccOpt = BccOpt + " -6";	//CPU߃ZbgPentium Pro
			break;
	}
	switch(SendItemMsg(IDC_CALLTYPE, CB_GETCURSEL, 0, 0)) {
		case 0:
			BccOpt = BccOpt + " -pc";	//ČĂяoK
			break;
		case 1:
			BccOpt = BccOpt + " -p";	//pXJ̌ĂяoK
			break;
		case 2:
			BccOpt = BccOpt + " -ps";	//stdcalľĂяoK
			break;
		case 3:
			BccOpt = BccOpt + " -pr";	//fastcalľĂяoK
		case CB_ERR:
			BccOpt = BccOpt + " -pc";	//ČĂяoK
			break;
	}
	switch(SendItemMsg(IDC_LANGUAGETYPE, CB_GETCURSEL, 0, 0)) {
		case 0:
			BccOpt = BccOpt + " -AT";	//\BCC32.EXEɏ
			break;
		case 1:
			BccOpt = BccOpt + " -A";	//\ANSIɏ
			break;
		case 2:
			BccOpt = BccOpt + " -AU";	//\UNIXɏ
			break;
		case 3:
			BccOpt = BccOpt + " -AK";	//\K&Rɏ
		case CB_ERR:
			BccOpt = BccOpt + " -AT";	//\BCC32.EXEɏ
			break;
	}
	if(SendItemMsg(IDC_PRECOMPILEHEADER, BM_GETCHECK, 0, 0) == BST_CHECKED)
		BccOpt = BccOpt + " -H";			//vRpCwb_[gp
	if(SendItemMsg(IDC_WARNING, BM_GETCHECK, 0, 0) == BST_CHECKED)
		BccOpt = BccOpt + " -w";			//x\gp
	switch(SendItemMsg(IDC_DEBUG, CB_GETCURSEL, 0, 0)) {
		case 0:
			BccOpt = BccOpt + " -v";	//fobOt
			break;
		case 1:
			BccOpt = BccOpt + " -y";	//sԍt
			break;
		case 2:
			BccOpt = BccOpt + " -v -y";	//fobOEsԍt
			break;
	}
	if(SendItemMsg(IDC_STRINTEG, BM_GETCHECK, 0, 0) == BST_CHECKED)
		BccOpt = BccOpt + " -d";			//d𓝍
	if(SendItemMsg(IDC_STACKFRAME, BM_GETCHECK, 0, 0) == BST_CHECKED)
		BccOpt = BccOpt + " -k";			//X^bNt[
	if(SendItemMsg(IDC_EXTERRORINFO, BM_GETCHECK, 0, 0) == BST_CHECKED)
		BccOpt = BccOpt + " -Q";			//gRpC[
	if(SendItemMsg(IDC_ENUM2INT, BM_GETCHECK, 0, 0) == BST_CHECKED)
		BccOpt = BccOpt + " -b";			//enumintɂ
	//bcc32Option̐ݒ
	makedlg.SendItemMsg(IDC_BCC32OPTION, WM_SETTEXT, 0, (LPARAM)BccOpt.ToChar());
	//o̓tH[_[
	if(SendItemMsg(IDC_TARGETDIR, CB_GETCURSEL, 0, 0))
		g_OutDir = TRUE;
	else
		g_OutDir = FALSE;
	//CN[hpX
	SendItemMsg(IDC_INCLPATH, WM_GETTEXT, MAX_PATH, (LPARAM)Temp);
	g_InclPath = Temp;
	//_CAȌI
	EndModal(TRUE);
	return TRUE;
}

bool DETAILDLG::OnInclbtn() {

	char* cp;
	if(cp = cmndlg.GetPath(m_hWnd, "CN[ht@ĈtH[_[IĂ"))
		g_InclPath = cp;
	else
		g_InclPath = "";
	SendItemMsg(IDC_INCLPATH, WM_SETTEXT, 0, (LPARAM)cp);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//SETUPDLG
///////////////////////////////
bool SETUPDLG::OnInit(WPARAM, LPARAM) {

	SendItemMsg(IDC_MAKEPATH, WM_SETTEXT, 0, (LPARAM)g_Make.ToChar());
	SendItemMsg(IDC_BCCPATH, WM_SETTEXT, 0, (LPARAM)g_Bcc32.ToChar());
	SendItemMsg(IDC_BRCPATH, WM_SETTEXT, 0, (LPARAM)g_Brc32.ToChar());
	SendItemMsg(IDC_ASMPATH, WM_SETTEXT, 0, (LPARAM)g_Asm.ToChar());
	SendItemMsg(IDC_EDITPATH, WM_SETTEXT, 0, (LPARAM)g_Edit.ToChar());
	return TRUE;
}

bool SETUPDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}

bool SETUPDLG::OnMakebtn() {

	char* cp;
	if(cp = cmndlg.GetFileName(m_hWnd, "makevO\0make.exe\0\0", TRUE)) {
		g_Make = cp;
		SendItemMsg(IDC_MAKEPATH, WM_SETTEXT, 0, (LPARAM)cp);
	}
	return TRUE;
}

bool SETUPDLG::OnBccbtn() {

	char* cp;
	if(cp = cmndlg.GetFileName(m_hWnd, "Embarcadero 32bitRpC[\0bcc32.exe;bcc32c.exe;bcc32x.exe\0ׂĂ̎st@C\*.exe\0\0", TRUE)) {
		g_Bcc32 = cp;
		SendItemMsg(IDC_BCCPATH, WM_SETTEXT, 0, (LPARAM)cp);
	}
	return TRUE;
}

bool SETUPDLG::OnBrcbtn() {

	char* cp;
	if(cp = cmndlg.GetFileName(m_hWnd, "Embarcadero 32bitRpC[\0brc32.exe;rc.exe\0ׂĂ̎st@C\*.exe\0\0", TRUE)) {
		g_Brc32 = cp;
		SendItemMsg(IDC_BRCPATH, WM_SETTEXT, 0, (LPARAM)cp);
	}
	return TRUE;
}

bool SETUPDLG::OnAsmbtn() {

	char* cp;
	if(cp = cmndlg.GetFileName(m_hWnd, "AZu[\0*.exe\0\0", TRUE)) {
		g_Asm = cp;
		SendItemMsg(IDC_ASMPATH, WM_SETTEXT, 0, (LPARAM)cp);
	}
	return TRUE;
}

bool SETUPDLG::OnEditbtn() {

	char* cp;
	if(cp = cmndlg.GetFileName(m_hWnd, "GfB^[\0*.exe\0\0", TRUE)) {
		g_Edit = cp;
		SendItemMsg(IDC_EDITPATH, WM_SETTEXT, 0, (LPARAM)cp);
	}
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//HELPDLG
///////////////////////////////
bool HELPDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//GfBbgRg[readme.txtt@Cǂ܂
	CFILE File;
	CSTR ReadMe(g_OwnPath);
	ReadMe = ReadMe + "\\BCCMakerReadMe.txt";
	File.LoadFile(ReadMe.ToChar());
	SendItemMsg(IDC_EDIT, WM_SETTEXT, 0, (LPARAM)File.Read());
	return TRUE;
}

bool HELPDLG::OnSize(WPARAM wParam, LPARAM lParam) {

	MoveWindow(GetDlgItem(m_hWnd, IDC_EDIT), 10, 10, LOWORD(lParam) - 20, HIWORD(lParam) - 50, TRUE);
	RECT rect;
	GetWindowRect(GetDlgItem(m_hWnd, IDOK), &rect);
	MoveWindow(GetDlgItem(m_hWnd, IDOK), (LOWORD(lParam) - rect.right + rect.left) / 2, HIWORD(lParam) - 30, rect.right - rect.left, rect.bottom - rect.top, TRUE);
	return TRUE;
}

bool HELPDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//VERSIONDLG
///////////////////////////////
bool VERSIONDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	SendItemMsg(IDC_VERTXT, WM_SETTEXT,
				0, (LPARAM)"BCCMaker Ver 1.0C\r\nCopyright (c) 2002\r\nby ysama");
	return TRUE;
}

bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}
