//////////////////////////////////////////
// BatchGoodProc.h
// Copyright (c) 12/24/2021 by BCCSkelton
//////////////////////////////////////////
///////////////////////////////
//[U[_CAO̊֐`
//BATCHGOODDLG
///////////////////////////////
bool BATCHGOODDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|SetHandle(hWnd))
	TBar.SetHandle(GetDlgItem(m_hWnd, IDC_TOOLBAR));
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TOOLBAR), 7);
	//c[o[{^ǉ
	TBBUTTON tbb[11];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_OPEN;
	tbb[1].iBitmap = TBar.m_id + 1;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_CLOSED;
	tbb[2].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[3].iBitmap = TBar.m_id + 2;
	tbb[3].fsState = TBSTATE_ENABLED;
	tbb[3].fsStyle = TBSTYLE_BUTTON;
	tbb[3].idCommand = IDM_EXIT;
	tbb[4].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[5].iBitmap = TBar.m_id + 3;
	tbb[5].fsState = TBSTATE_ENABLED;
	tbb[5].fsStyle = TBSTYLE_BUTTON;
	tbb[5].idCommand = IDM_RUN;
	tbb[6].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[7].iBitmap = TBar.m_id + 4;
	tbb[7].fsState = TBSTATE_ENABLED;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_SETTING;
	tbb[8].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[9].iBitmap = TBar.m_id + 5;
	tbb[9].fsState = TBSTATE_ENABLED;
	tbb[9].fsStyle = TBSTYLE_BUTTON;
	tbb[9].idCommand = IDM_HELP;
	tbb[10].iBitmap = TBar.m_id + 6;
	tbb[10].fsState = TBSTATE_ENABLED;
	tbb[10].fsStyle = TBSTYLE_BUTTON;
	tbb[10].idCommand = IDM_VERSION;
	TBar.AddButtons(11, tbb);

	//Xe[^Xo[o^|SetHandle(hWnd))
	SBar.SetHandle(GetDlgItem(m_hWnd, IDC_STATUSBAR));
	//Xe[^Xo[ݒ
	int sec[2] = {210, -1};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "BatchGood Ver1.1 (c) 2021 By Ysama");

	//t@CpX̐ݒ
	g_OwnPath = Arg.Path();
	g_IniFile = g_OwnPath + "\\BatchGood.ini";
	Ini.SetName(g_IniFile.ToChar());
	g_Bcc32 = Ini.ReadStr("System", "BCC32");
	g_Brc32 = Ini.ReadStr("System", "BRC32");
	g_Edit = Ini.ReadStr("System", "EDITOR");
	g_HelpFile = g_OwnPath + "\\BatchGoodHelp.chm";

	//폜tO̐ݒ
	g_Deltds = Ini.ReadInt("System", "DELTDS");
	g_Delres = Ini.ReadInt("System", "DELRES");
	
	//c[r[Rg[̏i_CAÕRg[Ɋ֘Atj
	tv.m_hWnd = GetDlgItem(m_hWnd, IDC_FILETREE);
	tv.m_hInstance = m_hInstance;
	tv.SetFont(8, "lr ");
	//rbg}bvo^
	tv.AddBitmap(MAKEINTRESOURCE(IDI_CLOSE), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_CPPBMP), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_RCBMP), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_LIBBMP), m_hInstance, RGB(255, 255, 255));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_DOC), m_hInstance, RGB(255, 255, 255));
	//{Create()֐ŎIɍsA_CAOx[XȂ̂Ŏ蓮
	TreeView_SetImageList(tv.m_hWnd, tv.m_hIList, TVSIL_NORMAL);

	//R}hGfBbgRg[̏
	ce.m_hWnd = GetDlgItem(m_hWnd, IDC_OUTPUT);
	ce.m_hInstance = m_hInstance;
	ce.SetFont(8, "lr ");

	//_CAȌ
	InitFileVars();		//t@CpXAIvV̏
	InitTreeview();		//c[r\̏iUser.hQƁj

	//NCAgGA
	RECT rec;
	GetClientRect(m_hWnd, &rec);
	m_Width = rec.right - rec.left;
	m_Height = rec.bottom - rec.top;

	//hbOAhhbv̎tJn
	DragAcceptFiles(m_hWnd, TRUE);

	//f[^t@CŋNꂽꍇAt@CI[v
	if(g_ByFile) {
		int n = Arg.c();				//t@C擾
		for(int i = 1; i < n; i++) {	//t@CJԂ
			g_ptFile = Arg.v(i);		//g_ptFileŃt@CpXAn
			g_ByFile =TRUE;
			OnOpen();
		}
	}
	return TRUE;
}

bool BATCHGOODDLG::OnNotify(WPARAM wParam, LPARAM lParam) {

	//c[o[̃c[`bv擾
	switch (((LPNMHDR)lParam)->code) {
		case TTN_NEEDTEXT:
			static LPTOOLTIPTEXT lptip;
			lptip = (LPTOOLTIPTEXT)lParam;
			switch (lptip->hdr.idFrom) {
				case IDM_OPEN:
					lptip->lpszText = "t@CJ";
					break;
				case IDM_CLOSED:
					lptip->lpszText = "t@C";
					break;
				case IDM_EXIT:
					lptip->lpszText = "BatchGood̏I";
					break;
				case IDM_RUN:
					lptip->lpszText = "ob`t@C̎s";
					break;
				case IDM_SETTING:
					lptip->lpszText = "ݒ";
					break;
				case IDM_HELP:
					lptip->lpszText = "BatchGoodwv";
					break;
				case IDM_VERSION:
					lptip->lpszText = "o[W";
					break;
			}
	}
	//|bvAbvj[ǂ݂
	HMENU hMenu = LoadMenu(m_hInstance, "IDM_POPUP");
	HMENU hPopupMenu = GetSubMenu(hMenu, 0);
	if(wParam == IDC_FILETREE) {
		//IĂACe擾
		HTREEITEM hSelected = tv.GetSelection();
		//bZ[WǂA
		TV_DISPINFO* ptv_disp;
		ptv_disp = (TV_DISPINFO*)lParam;
		//_uNbN
		if(ptv_disp->hdr.code == NM_DBLCLK) {
			CSTR Cmd = "\"";
			Cmd = Cmd + g_Edit + "\" \"";
			char Buff[MAX_PATH];
			//IACe̕擾AŃtB^[쐬ăvOs
			if(hSelected) {
				tv.GetItem(hSelected, Buff, MAX_PATH);
				if(strstr(Buff, "t@C"))				//IACeCPPRC̃t@CȂ
					SendMsg(WM_COMMAND, IDC_OPEN, NULL);	//ut@CJvɈڍs
				else {										//LIBȊÕt@CȂGfB^[N
					if(tv.GetParent(hSelected) != g_hTreeLIB) {
						Cmd = Cmd + Buff;
						Cmd = Cmd + "\"";
						WinExec(Cmd.ToChar(), SW_SHOWNORMAL);
					}
				}
			}
		}
		//ENbN|bvAbvj[
		else if(ptv_disp->hdr.code == NM_RCLICK) {
			//|bvAbvj[̕\
			POINT pt;
			GetCursorPos(&pt);
			TrackPopupMenu(hPopupMenu, TPM_LEFTALIGN | TPM_LEFTBUTTON,
						  pt.x, pt.y, 0, m_hWnd, NULL);
		}
	}
	//j[\[X̊J
	DestroyMenu(hMenu);
	return TRUE;
}

bool BATCHGOODDLG::OnSize(WPARAM wParam, LPARAM lParam) {


	//c[o[Đݒ
	TBar.AutoSize();
	//Xe[^Xo[Đݒ
	SBar.AutoSize();
	//Rg[̈ʒuATCYύX
	RECT rec;	//`擾p
	POINT pt;	//XN[Wϊp
	int w, h;	//AvZp
	int diffx = LOWORD(lParam) - m_Width;	//Oƍ̍
	int diffy = HIWORD(lParam) - m_Height;	//Oƍ̍
	m_Width = LOWORD(lParam);				//̕
	m_Height = HIWORD(lParam);				//̍
	//Eړ̂
	//IDC_DETAIL
	GetWindowRect(GetDlgItem(m_hWnd, IDC_DETAIL), &rec);	//EBhEʒu擾
	w = rec.right - rec.left;
	h = rec.bottom - rec.top;
	pt.x = rec.left;
	pt.y = rec.top;
	ScreenToClient(m_hWnd, &pt);
	MoveWindow(GetDlgItem(m_hWnd, IDC_DETAIL), pt.x + diffx, pt.y, w, h, TRUE);
	//ύX̂
	//IDC_BCC32OPTIONAIDC_BRC32OPTIONAIDC_INCLPATH
	for(int i = IDC_BCC32OPTION; i <= IDC_INCLPATH; i++) {
		GetWindowRect(GetDlgItem(m_hWnd, i), &rec);	//EBhEʒu擾
		w = rec.right - rec.left;
		h = rec.bottom - rec.top;
		pt.x = rec.left;
		pt.y = rec.top;
		ScreenToClient(m_hWnd, &pt);
		MoveWindow(GetDlgItem(m_hWnd, i), pt.x, pt.y, w + diffx, h, TRUE);
	}
	//ύX
	//IDC_OUTPUT
	GetWindowRect(GetDlgItem(m_hWnd, IDC_OUTPUT), &rec);	//EBhEʒu擾
	w = rec.right - rec.left;
	h = rec.bottom - rec.top;
	pt.x = rec.left;
	pt.y = rec.top;
	ScreenToClient(m_hWnd, &pt);
	MoveWindow(GetDlgItem(m_hWnd, IDC_OUTPUT), pt.x, pt.y, w + diffx, h + diffy, TRUE);
	//NCAgGAĕ`
	InvalidateRect(m_hWnd, NULL, TRUE);
	return TRUE;
}

bool BATCHGOODDLG::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES) {
		//Init@CɏŏI
		Ini.WriteStr("System", "BCC32", g_Bcc32.ToChar());
		Ini.WriteStr("System", "BRC32", g_Brc32.ToChar());
		Ini.WriteStr("System", "EDITOR", g_Edit.ToChar());
		Ini.WriteInt("System", "DELTDS", g_Deltds);
		Ini.WriteInt("System", "DELRES", g_Delres);
		//DestroyWindowAPostQuitMessageĂ΂
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

//_CAOx[X̏ꍇ͂ꂪKv
bool BATCHGOODDLG::OnDestroy(WPARAM wPram, LPARAM lParam) {

	PostQuitMessage(0);
	return TRUE;
}

bool BATCHGOODDLG::OnDropFiles(WPARAM wParam, LPARAM lParam) {

	//T^IȃhbOAhhbv
	static char lpszFn[MAX_PATH];					//t@Cpobt@
	int n;											//t@C
	HDROP hDrop = (HDROP)wParam; 					//HDROP擾
	n = DragQueryFile(hDrop, -1, NULL, 0);			//t@C擾
	for(int i = 0; i < n; i++) {
		DragQueryFile(hDrop, i, lpszFn, MAX_PATH);	//t@C擾
		g_ptFile = lpszFn;							//g_ptFileŃt@CpXAn
		g_ByFile = TRUE;
		OnOpen();
	}
	DragFinish(hDrop);								//I
	return TRUE;
}

bool BATCHGOODDLG::OnMinMax(WPARAM wParam, LPARAM lParam) {

	//T^IȃEBhẼTCY
	MINMAXINFO *pmmi;
	pmmi = (MINMAXINFO*)lParam;
	pmmi->ptMinTrackSize.x = 439;	//NCAgGA423 + 16
	pmmi->ptMinTrackSize.y = 391;	//NCAgGA330 + 61

	return FALSE;					//DefWndProcɔC
}

/////////////////////
// BATCHGOODDLG
//Rg[̊֐
/////////////////////
bool BATCHGOODDLG::OnOpen() {

	//tB^[pϐ
	char Buff[MAX_PATH];
	char* Filter[] = {	"cppt@C\0*.cpp\0\0",
						"rct@C\0*.rc\0\0",
						"libt@C\0*.lib\0\0",
						"cppt@CArct@C܂libt@C\0*.cpp;*.rc;*.lib\0\0"};
	int nFilter;
	//c[r\pϐ
	HTREEITEM hSelected, tvParent;
    //j[Rg[ɂ̂AȊOɂ镪
	if(g_ByFile)		//t@CtNADrag and Drop܂̓j[̏ꍇ
		g_ByFile = FALSE;		//Ԃɖ߂
	else {				//Rg[̏ꍇ
		//IĂACe̕擾AŃtB^[쐬
		hSelected = tv.GetSelection();
		if(hSelected) {
			tv.GetItem(hSelected, Buff, MAX_PATH);
			if(!lstrcmp(Buff, "CPPt@C"))		nFilter = 0;
			else if(!lstrcmp(Buff, "RCt@C"))	nFilter = 1;
			else if(!lstrcmp(Buff, "LIBt@C"))	nFilter = 2;
			else 									nFilter = 3;
		}
		else										nFilter = 3;
		//t@C擾
		g_ptFile = cmndlg.GetFileName(m_hWnd, Filter[nFilter], TRUE);
		if(!g_ptFile) {
			MessageBox(m_hWnd, "t@CI܂ł", "G[", MB_OK | MB_ICONSTOP);
			return FALSE;
		}
	}
	//t@Cc[r\̐emF
	if(strstr(g_ptFile, ".cpp") || strstr(g_ptFile, ".CPP"))
		tvParent = g_hTreeCPP;
	else if(strstr(g_ptFile, ".rc") || strstr(g_ptFile, ".RC"))
		tvParent = g_hTreeRC;
	else if(strstr(g_ptFile, ".lib") || strstr(g_ptFile, ".LIB"))
		tvParent = g_hTreeLIB;
	else {
		MessageBox(m_hWnd, "RpCłȂt@Cł", "G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
 	//CPP܂RCt@CŁAɃt@C݂ꍇAւ邩ۂmF
	if(tvParent != g_hTreeLIB) {
		hSelected = tv.GetChild(tvParent);	//̃JeS[̍ŏ̎qACe
		if(hSelected) {
			if(MessageBox(m_hWnd, "Ƀt@C܂B\r\nւ܂H", "ւmF",
				MB_YESNO | MB_ICONQUESTION) == IDYES) {
				InitFileVars();				//ob`t@C쐬pϐ̏
				InitTreeview();				//c[r[̏
			}
			else {
				return FALSE;
			}
		}
	}
	//t@CCPPt@C܂RCt@CL^iLIBt@C͌ňꊇ{j
	//܂ւꍇl āňꏏɂȂ
	//InitTreeView()ꍇlAtvParentĐݒ
	if(strstr(g_ptFile, ".cpp") || strstr(g_ptFile, ".CPP")) {
		tvParent = g_hTreeCPP;
		g_CPPFile = g_ptFile;
	}
	else if(strstr(g_ptFile, ".rc") || strstr(g_ptFile, ".RC")) {
		tvParent = g_hTreeRC;
		g_RCFile = g_ptFile;
	}
	else if(strstr(g_ptFile, ".lib") || strstr(g_ptFile, ".LIB")) {
		tvParent = g_hTreeLIB;
	}
	//t@Cc[r[ɕ\
	tv.InsertItem(g_ptFile, TVI_LAST, tvParent, 4, 4);
	tv.Expand(tvParent, TVE_EXPAND);
	return TRUE;
}

bool BATCHGOODDLG::OnClosed() {

	//IĂACe̕擾
	char Buff[MAX_PATH];
	HTREEITEM hSelected = tv.GetSelection();
	if(hSelected)
		tv.GetItem(hSelected, Buff, MAX_PATH);
	else {
		MessageBox(m_hWnd, "c[r\̃t@CIĂ܂B\r\nt@CIĂB", "G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	CSTR ItemText = Buff;
	if(!lstrcmp(Buff, "CPPt@C") || !lstrcmp(Buff, "RCt@C") || !lstrcmp(Buff, "LIBt@C")) {
		MessageBox(m_hWnd, "tH[_[͍폜ł܂", "x  ", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	else {
		tv.DeleteItem(hSelected);		//Ic[r[ACeit@Cj폜
		if(strstr(Buff, ".cpp") || strstr(Buff, ".CPP"))	//̃t@C敪ɉ
			g_CPPFile = "";				//g_CPPFile
		else if(strstr(Buff, ".rc") || strstr(Buff, ".RC"))
			g_RCFile = "";				//g_RCFile
		//LIBt@C͌ňꊇ{
	}
	return TRUE;
}

bool BATCHGOODDLG::OnDetail() {

	//IDD_DETAIL_CAOĂяoAIvVڍׂ
	detaildlg.DoModal(m_hWnd, "IDD_DETAIL", detaildlgProc);
	return TRUE;
}

bool BATCHGOODDLG::OnBCCOption(WPARAM wParam, LPARAM lParam) {

	//eXVꂽg_CoptXV
	char buff[MAX_PATH];
	if(HIWORD(wParam) == EN_UPDATE) {
		SendItemMsg(IDC_BCC32OPTION, WM_GETTEXT, MAX_PATH, (LPARAM)buff);
		g_Copt = buff;
		return TRUE;
	}
	else
		return FALSE;
}

bool BATCHGOODDLG::OnBRCOption(WPARAM wParam, LPARAM lParam) {

	//eXVꂽg_RoptXV
	char buff[MAX_PATH];
	if(HIWORD(wParam) == EN_UPDATE) {
		SendItemMsg(IDC_BRC32OPTION, WM_GETTEXT, MAX_PATH, (LPARAM)buff);
		g_Ropt = buff;
		return TRUE;
	}
	else
		return FALSE;
}

//////////////////
// BATCHGOODDLG
//j[̊֐
//////////////////
bool BATCHGOODDLG::On_Open() {

	//CPPt@CARCt@C܂LIBt@CIAg_ByFiletO𗧂ĂOnOpen֐Ă
	g_ptFile = cmndlg.GetFileName(m_hWnd, "cppt@CArct@C܂LIBt@C\0*.cpp;*.rc;*.lib\0\0", TRUE);
	if(g_ptFile) {
		g_ByFile = TRUE;
		OnOpen();
		return TRUE;
	}
	else {
		MessageBox(m_hWnd, "t@CI܂ł", "G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
}

bool BATCHGOODDLG::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool BATCHGOODDLG::OnMakebatch() {

	//g_CPPFilȇ݊mF
	if(!*g_CPPFile.ToChar()) {
		MessageBox(m_hWnd, "RpCCPPt@C܂B", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//pϐ
	char Buff[MAX_PATH];				//擾obt@
	char Ext[5] = {'.', 0, 0, 0, 0};	//gqۑpz
	CSTR work;							//ƗpCSTRϐ
	//g_Copt̍쐬
	SendItemMsg(IDC_BCC32OPTION, WM_GETTEXT, MAX_PATH, (LPARAM)Buff);
	g_Copt = Buff;
	SendItemMsg(IDC_INCLPATH, WM_GETTEXT, MAX_PATH, (LPARAM)Buff);
	if(*Buff) {	//IDC_INCLPATHɕ-IIvVǉ
		g_Copt = g_Copt + " -I\"";
		g_Copt = g_Copt + Buff;
		g_Copt = g_Copt + "\"";
	}
	//g_Ropt̍쐬
	SendItemMsg(IDC_BRC32OPTION, WM_GETTEXT, MAX_PATH, (LPARAM)Buff);
	g_Ropt = Buff;	//BuffȂAg_Ropt
	//^[QbgfBNg[̍쐬
	Arg = g_CPPFile.ToChar();		//CPPt@CpXA
	lstrcpy(Ext + 1, Arg.Ext());	//CPPt@C̊gqۑicpp܂CPPj
	g_TargetDir = Arg.Path();		//pX擾
	if(g_OutDir)					//Release܂Debugt
		g_TargetDir = g_TargetDir + "\\Release";
	else
		g_TargetDir = g_TargetDir + "\\Debug";
	//^[QbgfBNg[̍쐬
	CreateDirectory(g_TargetDir.ToChar(), NULL);
	//ob`t@C쐬
	g_BatchFile = g_TargetDir + "\\" + Arg.FileName(); 	//CPPt@C
	lstrcpy(strstr(g_BatchFile.ToChar(), Ext), ".bat");	//".cpp"".bat"Ɠւ
	//s\t@C쐬
	g_ExeFile = g_BatchFile;
	//DLLt@C̏ꍇ̏
	g_DLL = strstr(g_Copt.ToChar(), "-tD");	//g_DLLtO̐ݒ
	if(g_DLL)	//DLLt@CȂ".bat"".dll"Ɠւ
		lstrcpy(strstr(g_ExeFile.ToChar(), ".bat"), ".dll");
	else		//EXEt@CȂ".bat"".exe"Ɠւ
		lstrcpy(strstr(g_ExeFile.ToChar(), ".bat"), ".exe");
	//Cu[t@Cꗗʁi""jtō쐬
	HTREEITEM hChild = tv.GetChild(g_hTreeLIB);	//LIBt@C̍ŏ̎qACe
	tv.GetItem(hChild, Buff, MAX_PATH);
	if(*Buff) {
		g_LIBFile = "\"";
		g_LIBFile = g_LIBFile + Buff;
		g_LIBFile = g_LIBFile + "\" ";
		while((hChild = tv.GetNext(hChild))) {
			tv.GetItem(hChild, Buff, MAX_PATH);
			g_LIBFile = g_LIBFile + "\"";
			g_LIBFile = g_LIBFile + Buff;
			g_LIBFile = g_LIBFile + "\" ";
		}
	}
	//ob`t@C쐬pϐ^Cgŏ
	CSTR Bat(TITLE);
	//chdirŃ^[QbgfBNg[Ɉړ
	Bat =Bat + "cd \"" + g_TargetDir;
	Bat =Bat + "\"\r\n";
	//bcc32cR}h
	Bat = Bat + "\"" + g_Bcc32 + "\" \"";
	Bat = Bat + g_CPPFile + "\" ";
	//Libt@CΕt
	if(*g_LIBFile.ToChar())
		Bat = Bat + g_LIBFile;
	Bat = Bat + g_Copt + "\r\n";
	//g_Deltds == TRUEȂAtdst@C폜
	if(g_Deltds) {
		work = g_BatchFile;
		lstrcpy(strstr(work.ToChar(), ".bat"), ".tds");	//".bat"".tds"Ɠւ
		Bat = Bat + "del \"" + work + "\"\r\n";			//tdst@C폜
	}
	//brc32cR}hig_RCFilȅꍇXLbvj
	if(*g_RCFile.ToChar()) {
		Bat = Bat + "\"" + g_Brc32 + "\" \"";
		Bat = Bat + g_RCFile + "\" \"";					//"brc32 <rc file> <exe file> opt"
		Bat = Bat + g_ExeFile + "\"";					//ƂRpCR}h̍쐬
		if(*g_Ropt.ToChar())							//AAopt͂ꍇ̂
			Bat = Bat + " " + g_Ropt;
		Bat = Bat + "\r\n";
		//g_Delres == TRUEȂArest@C폜
		if(g_Delres) {
			work = g_RCFile + " ";						//workrct@C1ǉ
			Arg = g_RCFile.ToChar();					//Argrct@CpXA
			lstrcpy(Ext + 1, Arg.Ext());				//RCt@C̊gqۑirc܂RCj
			lstrcpy(strstr(work.ToChar(), Ext), ".res");//".rc "".res"Ɠւ
			Bat = Bat + "del \"" + work + "\"\r\n";		//rest@C폜
		}
	}
	if(g_DLL) {		//DLLt@CȂLIBt@C
		work = g_Bcc32;
		lstrcpy(strstr(work.ToChar(), "bcc32c.exe"), "implib.exe");	//6+".exe"
		g_LIBFile = g_ExeFile;
		lstrcpy(strstr(g_LIBFile.ToChar(), ".dll"), ".lib");		//".dll "".lib"Ɠւ
		Bat = Bat + "\"" +  work.ToChar() + "\" \"" + g_LIBFile.ToChar() + "\" \"" + g_ExeFile.ToChar() + "\"\r\n";
		g_LIBFile = "";		//g_LIBFile]p̂ōďĂ
	}
	Bat =Bat + "pause\r\n";								//DOS߂Ȃ悤Ɏ~߂
	//ob`t@Co
	Bat.ToFile(g_BatchFile.ToChar());					//^[QbgfBNgɏo
	//GfBbgRg[iIDC_OUTPUTjBato͂
	SendItemMsg(IDC_OUTPUT, WM_SETTEXT, 0, (LPARAM)Bat.ToChar());
 	//ob`t@CXe[^Xo[ɕ\
	SBar.SetText(1, g_BatchFile.ToChar());
	SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_BatchFile.ToChar());	//ToolTip
	return TRUE;
}

bool BATCHGOODDLG::OnBatchedit() {

	if(!*g_BatchFile.ToChar()) {
		MessageBox(m_hWnd, "ob`t@CĂ܂B", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	CSTR cmd("\"");
	cmd = cmd + g_Edit + "\" \"" + g_BatchFile +"\"";
	WinExec(cmd.ToChar(), SW_SHOWNORMAL);
	return TRUE;
}

bool BATCHGOODDLG::OnRun() {

	if(!OnMakebatch())				//ob`t@C쐬As
		return FALSE;				//FALSEԂ
	DeleteFile(g_ExeFile.ToChar());	//exet@CU͍폜
	CSTR cmd(BAT);
	cmd = cmd + "\"" + g_BatchFile +"\"";
	//RpC{
	WinExec(cmd.ToChar(), SW_SHOWNORMAL);
	//(DLLłȂ)exet@Csɂ͊܂ł̃^COAԉ҂
	if(!g_DLL && MessageBox(m_hWnd, "exet@Cs܂H", 
							g_ExeFile.ToChar(),
							MB_YESNO | MB_ICONQUESTION) == IDYES)
		WinExec(g_ExeFile.ToChar(), SW_SHOWNORMAL);
	return TRUE;
}

bool BATCHGOODDLG::OnSetting() {

	setupdlg.DoModal(m_hWnd, "IDD_SETUP", setupdlgProc);
	return TRUE;
}

bool BATCHGOODDLG::OnHelp() {

	CSTR cmd = "hh \"";
	cmd = cmd + g_HelpFile + "\"";
	WinExec(cmd.ToChar(), SW_SHOWNORMAL);
	return TRUE;
}

bool BATCHGOODDLG::OnOption() {

	helpdlg.DoModal(m_hWnd, "IDD_HELP", helpdlgProc);
	return TRUE;
}

bool BATCHGOODDLG::OnVersion() {

	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//DETAILDLG
///////////////////////////////
bool DETAILDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//^[Qbg^Cv̐ݒ
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"R\[AvP[V");
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"R\[AvP[ViUnicodej");
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"WindowsAvP[V");
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"WindowsAvP[ViUnicodej");
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"Dynamic Link Liabrary");
	SendItemMsg(IDC_TARGETTYPE, CB_ADDSTRING, 0, (LPARAM)"Dynamic Link LiabraryiUnicodej");
	SendItemMsg(IDC_TARGETTYPE, CB_SETDROPPEDWIDTH, 224, 0);	//hbv_EXg̕ݒ
	//o̓tH[_[̐ݒ
	SendItemMsg(IDC_TARGETDIR, CB_ADDSTRING, 0, (LPARAM)"Debug");
	SendItemMsg(IDC_TARGETDIR, CB_ADDSTRING, 0, (LPARAM)"Release");
	//œK̐ݒ
	SendItemMsg(IDC_OPTIMIZATION, CB_ADDSTRING, 0, (LPARAM)"TCYœK");
	SendItemMsg(IDC_OPTIMIZATION, CB_ADDSTRING, 0, (LPARAM)"xœK");
	//ďoK̐ݒ
	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"Ci-pcj");
	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"stdcalli-psj");
	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"fastcalli-pmj");
//	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"Ci-mcdeclj");
//	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"stdcalli-mstdcallj");
//	SendItemMsg(IDC_CALLTYPE, CB_ADDSTRING, 0, (LPARAM)"fastcalli-mfastcallj");

	//bcc32OptionGfBbgRg[ǂŉǂ
	char Temp[MAX_PATH * 2];
	BatchGood.SendItemMsg(IDC_BCC32OPTION, WM_GETTEXT, MAX_PATH * 3, (LPARAM)Temp);
	CSTR BccOpt = Temp, Token;
	while(BccOpt.Next(Token)) {
		*Temp = NULL;
		if(Token == "-tC") {				//R\[Av
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 0, 0);
		}
		else if(Token == "-tCU") {			//Unicode R\[Av
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 1, 0);
		}
		else if(Token == "-tW") {			//EBhEAv
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 2, 0);
		}
		else if(Token == "-tWU") {			//Unicode EBhEAv
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 3, 0);
		}
		else if(Token == "-tD") {			//DLLAv
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 4, 0);
		}
		else if(Token == "-tDU") {			//Unicode DLLAv
			SendItemMsg(IDC_TARGETTYPE, CB_SETCURSEL, 5, 0);
		}
		else if(Token == "-tM") {			//}`XbhAv
			SendItemMsg(IDC_MULTITHREAD, BM_SETCHECK, BST_CHECKED, 0);
		}
		else if(Token == "-O1") {			//TCYœK
			SendItemMsg(IDC_OPTIMIZATION, CB_SETCURSEL, 0, 0);
		}
		else if(Token == "-O2") {			//xœK
			SendItemMsg(IDC_OPTIMIZATION, CB_SETCURSEL, 1, 0);
		}
		else if(Token == "-pc") {			//ČĂяoK
//		else if(Token == "-mcdecl") {		//ČĂяoK
			SendItemMsg(IDC_CALLTYPE, CB_SETCURSEL, 0, 0);
		}
		else if(Token == "-ps") {			//stdcalľĂяoK
//		else if(Token == "-mstdcall") {		//stdcalľĂяoK
			SendItemMsg(IDC_CALLTYPE, CB_SETCURSEL, 1, 0);
		}
		else if(Token == "-pm") {			//fastcalľĂяoK
//		else if(Token == "-mfastcall") {	//fastcalľĂяoK
			SendItemMsg(IDC_CALLTYPE, CB_SETCURSEL, 2, 0);
		}
		else if(Token == "-w") {			//x\gp
			SendItemMsg(IDC_WARNING, BM_SETCHECK, BST_CHECKED, 0);
		}
	}
	//o̓tH[_[
	if(g_OutDir)
		SendItemMsg(IDC_TARGETDIR, CB_SETCURSEL, 1, 0);
	else
		SendItemMsg(IDC_TARGETDIR, CB_SETCURSEL, 0, 0);
	//CN[hpX
	SendItemMsg(IDC_INCLPATH, WM_SETTEXT, 0, (LPARAM)g_InclPath.ToChar());
	return TRUE;
}

bool DETAILDLG::OnInclbtn() {

	char* cp = cmndlg.GetPath(m_hWnd, "CN[ht@ĈtH[_[IĂ");
	if(cp)
		g_InclPath = cp;
	else
		g_InclPath = "";
	SendItemMsg(IDC_INCLPATH, WM_SETTEXT, 0, (LPARAM)cp);
	return TRUE;
}

bool DETAILDLG::OnIdok() {

	//bcc32Option\
	CSTR BccOpt;
	switch(SendItemMsg(IDC_TARGETTYPE, CB_GETCURSEL, 0, 0)) {
		case 0:
			BccOpt = "-tC";				//R\[Av
			break;
		case 1:
			BccOpt = "-tCU";			//Unicode R\[Av
			break;
		case 2:
			BccOpt = "-tW";				//EBhEAv
			break;
		case 3:
			BccOpt = "-tWU";			//Unicode EBhEAv
			break;
		case 4:
			BccOpt = "-tD";				//DLLAv
			break;
		case 5:
			BccOpt = "-tDU";			//Unicode DLLAv
			break;
		case CB_ERR:
			BccOpt = "-tW";				//EBhEAv
			break;
	}
	if(SendItemMsg(IDC_MULTITHREAD, BM_GETCHECK, 0, 0) == BST_CHECKED)
		BccOpt = BccOpt + " -tM";		//}`XbhAv
	switch(SendItemMsg(IDC_OPTIMIZATION, CB_GETCURSEL, 0, 0)) {
		case 0:
			BccOpt = BccOpt + " -O1";	//TCYœK
			break;
		case 1:
			BccOpt = BccOpt + " -O2";	//xœK
			break;
		case CB_ERR:
			break;
	}
	switch(SendItemMsg(IDC_CALLTYPE, CB_GETCURSEL, 0, 0)) {
		case 0:
			BccOpt = BccOpt + " -pc";		//ČĂяoK
//			BccOpt = BccOpt + " -mcdecl";	//ČĂяoK
			break;
		case 1:
			BccOpt = BccOpt + " -ps";		//stdcalľĂяoK
//			BccOpt = BccOpt + " -mstdcall";	//stdcalľĂяoK
			break;
		case 2:
			BccOpt = BccOpt + " -pm";		//fastcalľĂяoK
//			BccOpt = BccOpt + " -mfastcall";	//fastcalľĂяoK
		case CB_ERR:
			break;
	}
	if(SendItemMsg(IDC_WARNING, BM_GETCHECK, 0, 0) == BST_CHECKED)
		BccOpt = BccOpt + " -w";			//x\gp
	else
		BccOpt = BccOpt + " -w-";			//x\sgp
	//bcc32Option̐ݒ
	BatchGood.SendItemMsg(IDC_BCC32OPTION, WM_SETTEXT, 0, (LPARAM)BccOpt.ToChar());
	//o̓tH[_[
	if(SendItemMsg(IDC_TARGETDIR, CB_GETCURSEL, 0, 0))
		g_OutDir = TRUE;
	else
		g_OutDir = FALSE;
	//CN[hpX
	char Buff[MAX_PATH];
	SendItemMsg(IDC_INCLPATH, WM_GETTEXT, MAX_PATH, (LPARAM)Buff);
	BatchGood.SendItemMsg(IDC_INCLPATH, WM_SETTEXT, 0, (LPARAM)Buff);
	//_CAȌI
	EndModal(TRUE);
	return TRUE;
}

bool DETAILDLG::OnCancel() {

	//_CAȌI
	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//SETUPDLG
///////////////////////////////
bool SETUPDLG::OnInit(WPARAM, LPARAM) {

	SendItemMsg(IDC_BCCPATH, WM_SETTEXT, 0, (LPARAM)g_Bcc32.ToChar());
	SendItemMsg(IDC_BRCPATH, WM_SETTEXT, 0, (LPARAM)g_Brc32.ToChar());
	SendItemMsg(IDC_EDITPATH, WM_SETTEXT, 0, (LPARAM)g_Edit.ToChar());
	if(g_Deltds)
		SendItemMsg(IDC_DELTDS, BM_SETCHECK, BST_CHECKED, 0);
	if(g_Delres)
		SendItemMsg(IDC_DELRES, BM_SETCHECK, BST_CHECKED, 0);
	return TRUE;
}

bool SETUPDLG::OnIdok() {

	if(SendItemMsg(IDC_DELTDS, BM_GETCHECK, 0, 0) == BST_CHECKED)
		g_Deltds = TRUE;
	if(SendItemMsg(IDC_DELRES, BM_GETCHECK, 0, 0) == BST_CHECKED)
		g_Delres = TRUE;
	EndModal(TRUE);
	return TRUE;
}

bool SETUPDLG::OnCancel() {

	EndModal(FALSE);
	return TRUE;
}

bool SETUPDLG::OnBccbtn() {

	char* cp = cmndlg.GetFileName(m_hWnd, "Embarcadero 32bitRpC[\0bcc32.exe;bcc32c.exe;bcc32x.exe\0ׂĂ̎st@C\*.exe\0\0", TRUE);
	if(cp) {
		g_Bcc32 = cp;
		SendItemMsg(IDC_BCCPATH, WM_SETTEXT, 0, (LPARAM)cp);
	}
	return TRUE;
}

bool SETUPDLG::OnBrcbtn() {

	char* cp = cmndlg.GetFileName(m_hWnd, "Embarcadero 32bitRpC[\0brc32.exe;rc.exe\0ׂĂ̎st@C\*.exe\0\0", TRUE);
	if(cp) {
		g_Brc32 = cp;
		SendItemMsg(IDC_BRCPATH, WM_SETTEXT, 0, (LPARAM)cp);
	}
	return TRUE;
}

bool SETUPDLG::OnEditbtn() {

	char* cp = cmndlg.GetFileName(m_hWnd, "GfB^[\0*.exe\0\0", TRUE);
	if(cp) {
		g_Edit = cp;
		SendItemMsg(IDC_EDITPATH, WM_SETTEXT, 0, (LPARAM)cp);
	}
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//HELPDLG
///////////////////////////////
bool HELPDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//GfBbgRg[readme.txtt@Cǂ܂
	CFILE File;
	CSTR ReadMe(g_OwnPath);
	ReadMe = ReadMe + "\\BatchGoodReadMe.txt";
	File.LoadFile(ReadMe.ToChar());
	SendItemMsg(IDC_EDIT, WM_SETTEXT, 0, (LPARAM)File.Read());
	return TRUE;
}

bool HELPDLG::OnSize(WPARAM wParam, LPARAM lParam) {

	MoveWindow(GetDlgItem(m_hWnd, IDC_EDIT), 10, 10, LOWORD(lParam) - 20, HIWORD(lParam) - 50, TRUE);
	RECT rect;
	GetWindowRect(GetDlgItem(m_hWnd, IDOK), &rect);
	MoveWindow(GetDlgItem(m_hWnd, IDOK), (LOWORD(lParam) - rect.right + rect.left) / 2, HIWORD(lParam) - 30, rect.right - rect.left, rect.bottom - rect.top, TRUE);
	return TRUE;
}

bool HELPDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}

bool HELPDLG::OnCancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//VERSIONDLG
///////////////////////////////
bool VERSIONDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	SendItemMsg(IDC_VERTXT, WM_SETTEXT,
				0, (LPARAM)"BatchGood Ver 1.1\r\nCopyright (c) 2021\r\nby Ysama");
	return TRUE;
}

bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}
