//////////////////////////////////////////
// DiceProc.h
// Copyright (c) 05/21/2022 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnInit(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();
	//gp̐ݒ
	if(MessageBox(m_hWnd, "\"Yes\" selects Japanese, while \"No\" does English.\r\nu͂v͓{A"\
					"uv͉pI܂B", "Choise of Language - ̑I",
					MB_YESNO | MB_ICONQUESTION) == IDYES)
		g_JAPANESE = TRUE;
	//C_CAORg[̃tHg{֕ύX
	if(g_JAPANESE) {
		g_Font.SetFont(m_hWnd, 8, "lr ");
		SendItemMsg(IDC_EDIT, WM_SETFONT, (WPARAM)g_Font.GetFont(), (LPARAM)TRUE);
		SendItemMsg(IDC_STATUSBAR, WM_SETFONT, (WPARAM)g_Font.GetFont(), (LPARAM)TRUE);
		SendMsg(WM_SETTEXT, 0, (LPARAM)Str_10);
		SendItemMsg(IDC_HOWTOUSE, WM_SETTEXT, 0, (LPARAM)Str_11);
		SendItemMsg(IDC_ROLL, WM_SETTEXT, 0, (LPARAM)Str_12);
		SendItemMsg(IDOK, WM_SETTEXT, 0, (LPARAM)Str_13);
	}/* _CAÕftHg΂ꂪKv
	else {
		g_Font.SetFont(m_hWnd, 8, "Times New Roman");
		SendItemMsg(IDC_EDIT, WM_SETFONT, (WPARAM)g_Font.GetFont(), (LPARAM)TRUE);
		SendItemMsg(IDC_STATUSBAR, WM_SETFONT, (WPARAM)g_Font.GetFont(), (LPARAM)TRUE);
		SendMsg(WM_SETTEXT, 0, (LPARAM)Str_00);
		SendItemMsg(IDC_HOWTOUSE, WM_SETTEXT, 0, (LPARAM)Str_01);
		SendItemMsg(IDC_ROLL, WM_SETTEXT, 0, (LPARAM)Str_02);
		SendItemMsg(IDOK, WM_SETTEXT, 0, (LPARAM)Str_03);
	}*/
	//Xe[^Xo[o^|SetHandle(hWnd))
	SBar.SetHandle(GetDlgItem(m_hWnd, IDC_STATUSBAR));
	//Xe[^Xo[ݒ
	int sec[2] = {100, -1};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "Dice Ver 1.0");
	if(g_JAPANESE)
		SBar.SetText(1, Str_14);
	else
		SBar.SetText(1, Str_04);
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	char *message, *title;
	if(g_JAPANESE) {
		message = Str_15;
		title = Str_16;
	}
	else {
		message = Str_05;
		title = Str_06;
	}
	if(MessageBox(m_hWnd, message, title, MB_YESNO | MB_ICONINFORMATION) == IDYES) {
		//DestroyWindowAPostQuitMessageĂ΂
		EndModal(0);	//WinMain̐I0LԂ
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnHowtouse() {

	CSTR str;
	char* title;
	if(g_JAPANESE) {
		str.FromFile("RurlesJP.txt");
		title = Str_17;
	}
	else {
		str.FromFile("RurlesEN.txt");
		title = Str_07;
	}
	MessageBox(m_hWnd, str.ToChar(), title, MB_OK | MB_ICONINFORMATION);
	return TRUE;
}

bool CMyWnd::OnRoll() {

	int num[3];
	char buff[256];
	CSTR str;
	PlaySound("IDS_DICESOUND", m_hInstance, SND_RESOURCE | SND_ASYNC);
	for(int i = 0; i < 3; i++) {
		num[i] = SendItemMsg(IDC_D1 + i, DM_ROLL, 0, 0);
		if(g_JAPANESE)
			wsprintf(buff, Str_18, num[i], i);
		else
			wsprintf(buff, Str_08, num[i], i);
		str = str + buff + "\r\n";
		SendItemMsg(IDC_EDIT, WM_SETTEXT, 0, (LPARAM)str.ToChar());
	}
	m_Times--;		//΂U񐔂炷iڂoȂ΁A3΂Uj
/* J̃eXgp
	if(g_JAPANESE) 
		str = 
		"/////////////////////////////////////////////////////////////////\r\n"\
		"// ``̖ځA̔ɂ\r\n"\
		"// 1  0 0 0 1\r\n"\
		"// 2  0 0 1 0\r\n"\
		"// 3  0 0 1 1\r\n"\
		"// 4  0 1 0 0\r\n"\
		"// 5  0 1 0 1\r\n"\
		"// 6  0 1 1 0\r\n"\
		"//uAVv\r\n"\
		"// num[0] | num[1] | num[2]i== num[0] & num[1] & num[2]j== num[0];\r\n"\
		"// SĂ̗vfORi܂ANDjvfłꍇB\r\n"\
		"//u456v\r\n"\
		"// num[0] ^ num[1] ^ num[2] == 7 && num[0] & num[1] & num[2] == 4\r\n"\
		"// ẽrbgĂASĂ̗vf4ȏłꍇB\r\n"\
		"//u123v\r\n"\
		"// num[0] ^ num[1] ^ num[2] == 0 && num[0] | num[1] | num[2] == 3\r\n"\
		"// ẽrbgĂASĂ̗vf3ȉłꍇB\r\n"\
		"//uځv\r\n"\
		"// num[0] == num[1]) | (num[1] == num[2]) | (num[0] == num[2]\r\n"\
		"// ̗vf̂ꂩꍇB\r\n"\
		"// ȂA3̗vf̔rI_aŌ̖ڂƂȂB\r\n"\
		"/////////////////////////////////////////////////////////////////\r\n";
	else
		str = 
		"/////////////////////////////////////////////////////////////////\r\n"\
		"// Aoubt the conditions to determine hands of \"Chinchirorin\"\r\n"\
		"// 1  0 0 0 1\r\n"\
		"// 2  0 0 1 0\r\n"\
		"// 3  0 0 1 1\r\n"\
		"// 4  0 1 0 0\r\n"\
		"// 5  0 1 0 1\r\n"\
		"// 6  0 1 1 0\r\n"\
		"// <Storm>\r\n"\
		"// num[0] | num[1] | num[2]i== num[0] & num[1] & num[2]j== num[0];\r\n"\
		"// In case that all numbers' OR (or AND) is any of the numbers\r\n"\
		"// <456>\r\n"\
		"// num[0] ^ num[1] ^ num[2] == 7 && num[0] & num[1] & num[2] == 4\r\n"\
		"// In case that every digit has odd of \'1\' AND all numbers are more than 3.\r\n"\
		"// <123>\r\n"\
		"// num[0] ^ num[1] ^ num[2] == 0 && num[0] | num[1] | num[2] == 3\r\n"\
		"// Incase that every digit has even of \'1\' AND all numbers are less than 4.\r\n"\
		"// <Point>\r\n"\
		"// num[0] == num[1]) | (num[1] == num[2]) | (num[0] == num[2]\r\n"\
		"// In case that any of two numbers are same.\r\n"\
		"// In such case, the other number must be XOR of the three numbers.\r\n"\
		"/////////////////////////////////////////////////////////////////\r\n";
*/
	int Num_OR = num[0] | num[1] | num[2];
	int Num_AND = num[0] & num[1] & num[2];
	int Num_XOR = num[0] ^ num[1] ^ num[2];
	int Num_EQ = (num[0] == num[1]) | (num[1] == num[2]) | (num[0] == num[2]);
/* J̃eXgp
	wsprintf(buff, "num[0]= %d, num[1] = %d, num[2] = %d\r\n", num[0], num[1], num[2]);
	str = str + buff;
	wsprintf(buff, "num[0] | num[1] | num[2] = %d\r\n", Num_OR);
	str = str + buff;
	wsprintf(buff, "num[0] & num[1] & num[2] = %d\r\n", Num_AND);
	str = str + buff;
	wsprintf(buff, "num[0] ^ num[1] ^ num[2] = %d\r\n", Num_XOR);
	str = str + buff;
	wsprintf(buff, "(num[0] == num[1]) | (num[1] == num[2]) | (num[0] == num[2]) = %d\r\n", Num_EQ);
	str = str + buff;
	SendItemMsg(IDC_EDIT, WM_SETTEXT, 0, (LPARAM)str.ToChar());
*/
	if(Num_OR == Num_AND) {					//AV̏ꍇ
		if(g_JAPANESE)
			wsprintf(buff, "AVo܂IȇłB\r\n");
		else
			wsprintf(buff, "Storm's here! You, Dealer's got everything!\r\n");
		m_Times = 3;						//
	}
	else if(Num_XOR == 7 && Num_AND == 4) {	//456̏ꍇ
		if(g_JAPANESE)
			wsprintf(buff, "456o܂IȇłB\r\n");
		else
			wsprintf(buff, "456's here! You, Dealer's got everything!\r\n");
		m_Times = 3;						//
	}
	else if(Num_XOR == 0 && Num_OR == 3) {	//123̏ꍇ
		if(g_JAPANESE)
			wsprintf(buff, "ȂƁA123łI{tzŐełB\r\n");
		else
			wsprintf(buff, "My God, 123's here! Gotta pay doubled bets and quit Dealer!\r\n");
		m_Times = 0;						//e
	}
	else if(Num_EQ) {
		if(Num_XOR == 6) {					//ڂ̏ꍇ
			if(g_JAPANESE)
				wsprintf(buff, "e%d̖ڂ܂IȇłB\r\n", Num_XOR);
			else
				wsprintf(buff, "You've got Point of %d! You, Dealer's got everything.\r\n", Num_XOR);
			m_Times = 3;					//

		}
		else if(Num_XOR == 1) {
			if(g_JAPANESE)
				wsprintf(buff, "Ȃ%d̖ڂłIȇtłB\r\n", Num_XOR);
			else
				wsprintf(buff, "My God, You've got Point of %d! Gotta pay everyone.\r\n", Num_XOR);
			m_Times = 0;					//e
		}
		else {
			if(g_JAPANESE)
				wsprintf(buff, "e%d̖ڂ܂B\r\n", Num_XOR);
			else
				wsprintf(buff, "You've got Point of %d.\r\n", Num_XOR);
			m_Times = 3;					//
		}
	}
	else
		*buff = NULL;
	//ڂ܂͖oꍇAXe[^Xo[ɕ\
	SBar.SetText(1, buff);
	//Ō΂Uc񐔂\
	if(g_JAPANESE) {
		wsprintf(buff, Str_19, m_Times);
		str = str + buff + "\r\n";
	}
	else {
		wsprintf(buff, Str_09, m_Times);
		str = str + buff + "\r\n";
	}
	SendItemMsg(IDC_EDIT, WM_SETTEXT, 0, (LPARAM)str.ToChar());
	//I`FbN
	if(!m_Times) {
		if(g_JAPANESE) {
			if(MessageBox(m_hWnd, "Ȃ̕łB܂܂H", "̏I",
							MB_YESNO | MB_ICONQUESTION) == IDYES)
				m_Times = 3;
			else
				OnIdok();
		}
		else {
			if(MessageBox(m_hWnd, "You lost. Wanna continue yet?", "Game over",
							MB_YESNO | MB_ICONQUESTION) == IDYES)
				m_Times = 3;
			else
				OnIdok();
		}
	}
	return TRUE;
}

bool CMyWnd::OnIdok() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnDice1(WPARAM wParam) {

	char buff[64], *cp;
	if(g_JAPANESE)
		cp = "%dԂ΂UA΂̖ڂ%dłB";
	else
		cp = "The dice of %d was rolled and made %d.";
	wsprintf(buff, cp, LOWORD(wParam) - IDC_D1 + 1, HIWORD(wParam));
	SBar.SetText(1, buff);
	return TRUE;
}

bool CMyWnd::OnDice2(WPARAM wParam) {

	char buff[64], *cp;
	if(g_JAPANESE)
		cp = "%dԂ΂UA΂̖ڂ%dłB";
	else
		cp = "The dice of %d was rolled and made %d.";
	wsprintf(buff, cp, LOWORD(wParam) - IDC_D1 + 1, HIWORD(wParam));
	SBar.SetText(1, buff);
	return TRUE;
}

bool CMyWnd::OnDice3(WPARAM wParam) {

	char buff[64], *cp;
	if(g_JAPANESE)
		cp = "%dԂ΂UA΂̖ڂ%dłB";
	else
		cp = "The dice of %d was rolled and made %d.";
	wsprintf(buff, cp, LOWORD(wParam) - IDC_D1 + 1, HIWORD(wParam));
	SBar.SetText(1, buff);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
