///////////////////////////
//CDSHOWNX`t@C
///////////////////////////
#include <DShow.h>					//DirectShowwb_[
#include <wchar.h>

//tB^[`ip҂̃tB^[̊ɂēKXύXKvj
#define	FILTER	"rfIt@C(*.avi;*.mp4;*.mov)\0*.avi;*.mp4;*.mov\0I[fBIt@C(*.mp3;*.wav;*.mid)\0*.mp3;*.wav;*.mid\0\0"

//eEBhEւ̒ʒmbZ[W
#define WM_GRAPHNOTIFY  WM_APP + 1

class CDSHOW {

protected:
	//DirectShoweEBhE
	HWND m_hWnd;
	//DirectShow֘Aϐ
	IGraphBuilder *m_pGraph;		//tB^[Otr_[NX|C^[
	IMediaControl *m_pControl;		//fBARg[C^[tF[X|C^[
	IMediaEventEx *m_pEvent;		//fBACxgC^[tF[X|C^[
	IVideoWindow *m_pVideoWindow;	//rfIEBhE|C^[
	IMediaPosition *m_pMPos;		//fBAĐʒuC^[tF[X|C^[
	//ʔpϐ
	HRESULT m_hr;
public:
	//t@C擾pϐ
	char m_FileName[MAX_PATH];
	WCHAR m_WFileName[MAX_PATH];
	//t@CĐԕϐidoublej
	REFTIME m_Len;
	//o[֐
	CDSHOW();						//RXgN^[
	~CDSHOW();						//fXgN^[
	void Init();					//o[֐̏
	bool Move(int, int, int, int);	//rfIEBhËʒuݒix, y, w, hj
	bool SetFileName(char*, char*);	//rfIt@Cݒ肷
	bool Show(HWND);				//rfIEBhȄƃrfI̍Đ
	REFTIME GetDuration();			//rfIĐԂԂ
	OAFilterState GetState(int);	//tB^[Ot̍ĐԂ擾i0-StoppedA1-PausedA2-Runningj
	bool Pause();					//rfÏꎞ~
	bool Continue();				//rfI̍ĊJ
	void Stop();					//rfI̒~
	REFTIME GetCurrentPos();		//݂̍ĐԂԂ
	bool SetCurrentPos(REFTIME);	//Đʒuiԁ|bjݒ肷
	bool IsOver(long&);				//eEBhEɒuIj^O֐
	void CleanUp();					//rfIEBhEAtB^[Ot̏I
};

//RXgN^[
CDSHOW::CDSHOW() {

	//Chgp̂߃P[̏i{j
	setlocale(LC_CTYPE, "JPN");
	//o[ϐ̏
	Init();
	//COM̏
	m_hr = CoInitialize(NULL);
	if(FAILED(m_hr))
		MessageBox(m_hWnd, "COMł܂ł", "G[", MB_OK | MB_ICONERROR);
}

//fXgN^[
CDSHOW::~CDSHOW() {

	//tB^[Ot̏I
	CleanUp();
	//COM̏I
	CoUninitialize();
}

//o[֐̏
void CDSHOW::Init() {

	//eEBh	Enh
	m_hWnd = NULL;
	//DirectShow֘Aϐ
	m_pGraph = NULL;
	m_pControl = NULL;
	m_pEvent = NULL;
	m_pVideoWindow = NULL;
	m_pMPos = NULL;
	m_Len = 0;
}

//rfIEBhËʒuݒ
bool CDSHOW::Move(int x, int y, int w, int h) {

	//rfIEBhEΉȂ
	if(!m_pVideoWindow)
		return FALSE;
	if(m_pVideoWindow) {
		//`EBhE̕`ʒu̐ݒ
		m_hr = m_pVideoWindow->SetWindowPosition(x, y, w, h);
	if(m_hr != S_OK && m_hr != E_NOINTERFACE) {	//VFW_E_NOT_CONNECTEDł͂ȂAE_NOINTERFACEԂ
			MessageBox(m_hWnd, "rfIEBhËʒuݒł܂ł", "G[", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		return TRUE;
	}
	else
		return FALSE;
}

//rfIt@Cݒ肷
bool CDSHOW::SetFileName(char* fn, char* ftr = FILTER) {

	if(*fn) {
		if(lstrlen(fn) > MAX_PATH - 1) {
			MessageBox(m_hWnd, "t@CpXA܂URL܂", "G[", MB_OK | MB_ICONERROR);
			*m_FileName = NULL;
			*m_WFileName = L'\0';	//16bit̏I[
			return FALSE;
		}
		else {
			//t@C̋L^
			lstrcpy(m_FileName, fn);
			//t@C̃Ch
			mbstowcs(m_WFileName, m_FileName, MAX_PATH);
			return TRUE;
		}
	}
	else {
		OPENFILENAME ofn;				//I[vt@C_CAO\
		ZeroMemory(&ofn, sizeof(ofn));	//[
		ofn.lStructSize		= sizeof(ofn);
		ofn.hwndOwner		= m_hWnd;
		ofn.lpstrFilter		= ftr;		//ŃtB^O
		ofn.nFilterIndex	= 1;
		ofn.lpstrFile		= m_FileName;
		ofn.nMaxFile		= MAX_PATH;
		ofn.lpstrTitle		= NULL;
		ofn.lpstrInitialDir = ".";
		ofn.Flags			= OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
		ofn.lpstrDefExt		= NULL;
		bool success = GetOpenFileName(&ofn);
		if(success) {
			//t@C̃Ch
			mbstowcs(m_WFileName, m_FileName, MAX_PATH);
			return TRUE;
		}
		else {
			*m_FileName = NULL;
			*m_WFileName = L'\0';	//16bit̏I[
			return FALSE;
		}
	}
}

//rfIEBhȄƃrfI̍Đ
bool CDSHOW::Show(HWND hWnd) {

	//eEBhE̋L^
	m_hWnd = hWnd;
	//tB^[Ot}l[W[쐬AIGraphBuilderC^[tFCX擾
	m_hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
							IID_IGraphBuilder, (void **)&m_pGraph);
	if(FAILED(m_hr)) {
		MessageBox(m_hWnd, "tB^[Ot}l[W[쐬ł܂ł",
					"G[", MB_OK | MB_ICONERROR);
		goto exit;
	}
	//IGraphBuilderIMediaControlC^[tFCX擾
	m_hr = m_pGraph->QueryInterface(IID_IMediaControl, (void **)&m_pControl);
	if(FAILED(m_hr)) {
		MessageBox(m_hWnd, "fBARg[C^[tF[X擾ł܂ł",
					"G[", MB_OK | MB_ICONERROR);
		goto exit;
	}
	//IGraphBuilderIMediaEventC^[tFCX擾
	m_hr = m_pGraph->QueryInterface(IID_IMediaEvent, (void **)&m_pEvent);
	if(FAILED(m_hr)) {
		MessageBox(m_hWnd, "fBACxgC^[tF[X擾ł܂ł",
					"G[", MB_OK | MB_ICONERROR);
		goto exit;
	}
	//w肳ꂽt@CĐłtB^[Ot쐬i݂ȂꍇAG[j
	m_hr = m_pGraph->RenderFile(m_WFileName, NULL);
	if(FAILED(m_hr)) {
		MessageBox(m_hWnd, "tB^[Ot쐬ł܂ł", "G[", MB_OK | MB_ICONERROR);
		goto exit;
	}
	//ĐʒuC^[tF[X擾
	m_pGraph->QueryInterface(IID_IMediaPosition, (LPVOID *)&m_pMPos);
	//t@C̒(b|doublej擾
	m_pMPos->get_Duration(&m_Len);
	//eEBhEւ̒ʒmJn
	m_pEvent->SetNotifyWindow((OAHWND)m_hWnd, WM_GRAPHNOTIFY, 0);
	//rfIRg[擾
	m_hr = m_pGraph->QueryInterface(IID_IVideoWindow, (LPVOID*)&m_pVideoWindow);
	if(FAILED(m_hr)) {
		MessageBox(m_hWnd, "rfIEBhE擾ł܂ł", "G[", MB_OK | MB_ICONERROR);
		goto exit;
	}
	//eEBhE̐ݒ
	m_hr = m_pVideoWindow->put_Owner((OAHWND)m_hWnd);
	if(m_hr != S_OK && m_hr != E_NOINTERFACE) {	//VFW_E_NOT_CONNECTEDł͂ȂAE_NOINTERFACEԂ
		MessageBox(m_hWnd, _T("eEBhEݒł܂ł"), _T("G["), MB_OK | MB_ICONERROR);
		goto exit;
	}
	//EBhEX^Cݒ肷
	m_hr = m_pVideoWindow->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS);
	if(m_hr != S_OK && m_hr != E_NOINTERFACE) {	//VFW_E_NOT_CONNECTEDł͂ȂAE_NOINTERFACEԂ
		MessageBox(m_hWnd, "EBhEX^Cݒł܂ł", "G[", MB_OK | MB_ICONERROR);
		goto exit;
	}
	//`EBhE640 x 480̕\sŏTCYɂ
	SetWindowPos(m_hWnd, HWND_TOP, 0, 0, 656, 541, SWP_NOMOVE);
	//TCYύXꍇׂ̈ɐeEBhEWM_SIZE𑗂
	SendMessage(m_hWnd, WM_SIZE, 0, (LPARAM)MAKELONG(640, 480));
	//w肵EBhEIVideoWindow̒ʒm𗬂
	m_hr = m_pVideoWindow->put_MessageDrain((OAHWND)m_hWnd);
	//EBhE\
	m_hr = m_pVideoWindow->put_Visible(OATRUE);
	if(m_hr != S_OK && m_hr != E_NOINTERFACE) {	//VFW_E_NOT_CONNECTEDł͂ȂAE_NOINTERFACEԂ
		MessageBox(m_hWnd, "rfIEBhE\ł܂ł", "G[", MB_OK | MB_ICONERROR);
		goto exit;
	}
	//\JnB
	m_hr = m_pControl->Run();
	if(SUCCEEDED(m_hr))
		return TRUE;
	//ȏオIŁAG[ƈȉs
exit:
	CleanUp();
	return FALSE;
}

//rfIĐԂԂ
REFTIME CDSHOW::GetDuration() {

	m_pMPos->get_Duration(&m_Len);
	return m_Len;
}

//tB^[Ot̍ĐԂ擾i0-StoppedA1-PausedA2-Runningj
OAFilterState CDSHOW::GetState(int delay) {

	OAFilterState fs = 0;
	if(m_pControl)
		m_pControl->GetState(delay, &fs);	//ẍׁAdelayi~bjɎ擾
	return fs;
}

//rfÏꎞ~
bool CDSHOW::Pause() {

	//\ꎞ~B
	m_hr = m_pControl->Pause();
	if(SUCCEEDED(m_hr))
		return TRUE;
	else
		return FALSE;
}

//rfI̍ĊJ
bool CDSHOW::Continue() {
	//\ꎞ~B
	m_hr = m_pControl->Run();
	if(SUCCEEDED(m_hr))
		return TRUE;
	else
		return FALSE;
}

//rfI̒~
void CDSHOW::Stop() {

	//\𒆎~AIs
	CleanUp();
}

//݂̍ĐԂԂ
REFTIME CDSHOW::GetCurrentPos() {

	REFTIME tm;
	m_pMPos->get_CurrentPosition(&tm);
	return tm;
}

//Đʒuiԁ|bjݒ肷
bool CDSHOW::SetCurrentPos(REFTIME tm) {

	m_pMPos->put_CurrentPosition(tm);
}

//eEBhEɒuIj^O֐
bool CDSHOW::IsOver(long& evtCode) {

	//IMediaEvent *m_pEventݒ肳ĂȂFALSEŕԂ
	if(!m_pEvent)
		return FALSE;
	//Cxg
	LONG_PTR Param1, Param2;
	while(SUCCEEDED(m_pEvent->GetEvent(&evtCode, &Param1, &Param2, 0))) {
		m_pEvent->FreeEventParams(evtCode, Param1, Param2);
		switch(evtCode) {
		case EC_COMPLETE:	//ĐI
		case EC_USERABORT:	//Đ~
		case EC_ERRORABORT:	//G[
			CleanUp();
			return TRUE;
		}
	}
	return FALSE;
}

//rfIEBhEAtB^[Ot̏I
void CDSHOW::CleanUp() {

	//[̊J
	if(m_pVideoWindow) {
		//\EBhE
		//m_pVideoWindow->put_Visible(OAFALSE);
		//efXNgbvƂ
		//m_pVideoWindow->put_Owner(NULL);
		m_pVideoWindow->Release();
	}
	if(m_pMPos)
		m_pMPos->Release();
	if(m_pControl) {
		//\𒆎~B
		m_pControl->Stop(); 
		m_pControl->Release();
	}
	if(m_pEvent) {
		//eEBhEւ̒ʒmI
		m_pEvent->SetNotifyWindow((OAHWND)NULL, 0, 0);
		m_pEvent->Release();
	}
	if(m_pGraph)
		m_pGraph->Release();
	//ď
	Init();
}
