//--------------------------------
// CICON Class
// Copyright (c) 2021, K. Yoshida
//--------------------------------
///////////
//萔`
///////////
#define	MAX_ICON	32	//ACR̍\rbg}bv̏
#define	DISPSIZE	128	//LoadImage̓ǂݍ݃TCY

/* `̏ꍇARgLOĂ
/////////////
//ǉ\
/////////////
//ICONDIR\̐錾@|@6oCg
typedef struct tagICONDIR {
	WORD	idReserved;			//\ς݁i0j
	WORD	idType;				//\[X^Cv:ACRF1AJ[\F2
	WORD	idCount;			//ACR̐
}ICONDIR, *LPICONDIR;

//ICONDIRENTRY\̐錾@|@16oCg
typedef struct tagICONDIRENTRY {
	BYTE	bWidth;				//摜iPʁFsNZj
	BYTE	bHeight;			//摜iPʁFsNZj
	BYTE	bColorCount;		//摜̐Fi256Fȏ0j
	BYTE	bReserved;			//\ς݁i0j
	WORD	wPlanes;			//J[v[iJ[\AXzbgX|bgj
	WORD	wBitCount;	  		//sNZ̃rbg[xiJ[\AYzbgX|bgj
	DWORD   dwBytesInRes;   	//sNZf[^̃oCg
	DWORD   dwImageOffset;  	//t@C擪sNZf[^܂ł̃ItZbg
}ICONDIRENTRY, *LPICONDIRENTRY;
*/

class CICON {
public:
	//////o[ϐ//////
	//ACRǂݍރEBhEnh
	HWND m_hWnd;
	//̃EBhẼfoCXReLXgnh
	HDC m_hDC;
	//ACRAJ\\̃nh
	HICON m_hIcon;
	//ICONDIR\
	ICONDIR m_Icondir;
	//ICONDIRENTRY\
	ICONDIRENTRY m_Iconentry[MAX_ICON];
	//\rbg}bvJE^[
	int m_BmpCounter;
	//\rbg}bvDIB擾p
	LPBYTE  m_ImageDat[MAX_ICON];	//\rbg}bvf[^
	LPBITMAPINFO m_lpBmi[MAX_ICON];	//BITMAPINFO\̂ւ̃|C^[
	LPBYTE m_XOR[MAX_ICON];			//J[rbg}bv|C^[
	LPBYTE m_AND[MAX_ICON];			//}XNrbg}bv|C^[
	//\rbg}bṽnh
	HBITMAP m_hBmp[MAX_ICON];		//J[rbg}bv
	HBITMAP m_hMaskBmp[MAX_ICON];	//}XNrbg}bv
	//////o[֐//////
	//RXgN^[iPj
	CICON();
	//RXgN^[iQj
	CICON(HWND);
	//fXgN^[
	~CICON();
	//CICON
	void Init();
	//ׂẴrbg}bv̔p
	void Clear();
	//EBhEw肷
	void SetWindow(HWND);
	//\rbg}bv擾
	int GetCount() {return m_BmpCounter;}
	//t@CACR܂̓J[\荞ށiIcon-1ACursor-2j
	bool Load_Icon(LPCTSTR, UINT, bool);
	//t@Crbg}bvǉ
	bool Add_Bitmap(LPCTSTR);
	//o^rbg}bv̍폜
	bool Del_Bitmap(int);
	//̃rbg}bvICONDIRENTRYւ̃|C^[Ԃ
	bool GetIDEntry(int, LPICONDIRENTRY*);
	//̃rbg}bvBITMAPINFOHEADERւ̃|C^[Ԃ
	bool GetBmpInfo(int, PBITMAPINFOHEADER*);
	//ACR̃nhԂ
	HICON GetIcon();
	//J[iXORjrbg}bṽnhԂ
	HBITMAP GetColBmp(int);
	//}XNiANDjrbg}bṽnhԂ
	HBITMAP GetMaskBmp(int);
	//t@CփACR܂̓J[\ށiIcon-1ACursor-2j
	bool Save_Icon(LPTSTR, UINT);
	//HotSpotX擾
	int GetHsX(int n) {return m_Iconentry[n].wPlanes;}
	//HotSpotY擾
	int GetHsY(int n) {return m_Iconentry[n].wBitCount;}
	//HotSpotXݒ肷
	int SetHsX(int n, int x) {m_Iconentry[n].wPlanes = x;}
	//HotSpotYݒ肷
	int SetHsY(int n, int y) {m_Iconentry[n].wBitCount = y;}
};

//RXgN^[iPj
CICON::CICON() {

	m_hIcon = 0;
}

//RXgN^[iQj
CICON::CICON(HWND hWnd) {

	m_hIcon = 0;
	SetWindow(hWnd);
}

//fXgN^[
CICON::~CICON() {

	//ACR̔j
	Init();
	//ׂẴrbg}bvƊ֘A̔j
	Clear();
	if(m_hDC)
		ReleaseDC(m_hWnd, m_hDC);
}

//CICON
void CICON::Init() {

	if(m_hIcon) {
		DestroyIcon(m_hIcon);
		m_hIcon = 0;
	}
}

//ׂẴrbg}bv̔p
void CICON::Clear() {

	//ׂẴrbg}bvƊ֘A̔j
	for(int i = m_BmpCounter; i > 0; i--) {
		LocalFree(m_ImageDat[i - 1]);
		DeleteObject(m_hBmp[i - 1]);
		DeleteObject(m_hMaskBmp[i - 1]);
	}
	m_BmpCounter = 0;
}

//EBhEw肷
void CICON::SetWindow(HWND hWnd) {

	m_hWnd = hWnd;
	if(m_hDC)
		ReleaseDC(m_hWnd, m_hDC);
	m_hDC = GetDC(hWnd);
}

///////////////////////////////////////////////////////////////
//ACR܂̓J[\ǂݍ
//FileName : t@CpXEO܂̓\[XID
//iType	: Icon = 1(IMAGE_ICON:Kl)ACursor = 2(IMAGE_CURSOR)
//flag	: t@C = TRUEiKljA\[X = FALSE
///////////////////////////////////////////////////////////////
bool CICON::Load_Icon(LPCTSTR FileName, UINT iType = IMAGE_ICON,
						bool flag = TRUE) {

	//C[W^Cv`FbNiIMAGE_ICON, IMAGE_CURSORȊO̓G[j
	if(iType != 1 && iType != 2) {
		MessageBox(m_hWnd, "IMAGE_ICON(1)AIMAGE_CURSOR(2)ł͂܂",
					"G[", MB_OK | MB_ICONSTOP);
    		return FALSE;
	}
	//ύX̏
	if(m_hIcon) {
		if(MessageBox(m_hWnd, "ɃACRf[^ǂݍ܂Ă܂B\r\n"\
							"݂̃ACRf[^j܂H",
							"mF", MB_YESNO | MB_ICONQUESTION) == IDYES)
			Init();
		else
			return FALSE;
		if(MessageBox(m_hWnd, "ACR̃rbg}bvf[^j܂H",
							"mF", MB_YESNO | MB_ICONQUESTION) == IDYES)
			Clear();
	}
	/////////////////////////////
	//ACRAJ[\̃[h
	/////////////////////////////
	UINT fLoad;	//[hIvViftHg̓t@Ćj
	if(flag)
		fLoad = LR_DEFAULTCOLOR | LR_LOADFROMFILE;
	else
		fLoad = LR_DEFAULTCOLOR;
	m_hIcon = (HICON)LoadImage((HINSTANCE)GetWindowLong(m_hWnd, GWL_HINSTANCE),
				FileName, iType, DISPSIZE, DISPSIZE, fLoad);
	if(!m_hIcon) {	//ACR܂̓J[\̓ǂݍ݂ɎsꍇG[
		MessageBox(m_hWnd, "ACR܂̓J[\̓ǂݍ݂Ɏs܂",
					"G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	/////////////////////////////
	//ACRt@Cǂݍ
	/////////////////////////////
	//ACRAJ[\f[^ǂݍ
	HANDLE hFile = CreateFile(FileName, GENERIC_READ, 0, NULL, OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE) {
		MessageBox(m_hWnd, "t@CJ܂ł",
					"G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	DWORD dwRead;
	if(!ReadFile(hFile, &m_Icondir, sizeof(ICONDIR), &dwRead, NULL)) {
		MessageBox(m_hWnd, "m_Icondirǂݍ߂܂ł",
					"G[", MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return FALSE;
	}
	//摜߂ꍇ̃G[
	if((m_BmpCounter + m_Icondir.idCount) > MAX_ICON) {
		MessageBox(m_hWnd, "摜Ǎx𒴂Ă܂", "G[",
					MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	//idCountICONDIRENTRYǂݍ
	for(int i = 0; i < m_Icondir.idCount; i++) {
		if(!ReadFile(hFile, &m_Iconentry[m_BmpCounter + i], sizeof(ICONDIRENTRY),
					&dwRead, NULL)) {
			MessageBox(m_hWnd, "m_Iconentryzǂݍ߂܂ł",
					"G[", MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return FALSE;
		}
	}
	//idCount̃C[Wǂ݁A|C^[ݒ肷
	for(int i = 0; i < m_Icondir.idCount; i++) {
		int rgbq;		//RGBQUAD̃rbg
		WORD BmpSize;	//J[rbg}bṽrbgf[^TCY
		//m_ImageDat̃[mۂ
		m_ImageDat[m_BmpCounter + i] = (LPBYTE)LocalAlloc(LPTR,
									m_Iconentry[m_BmpCounter + i].dwBytesInRes);
		if(!m_ImageDat[m_BmpCounter + i]) {
			MessageBox(m_hWnd, "m_ImageDat̃[mۏo܂ł",
					"G[", MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return FALSE;
		}
		//C[Wf[^t@CǍׂ݂̈̃t@C|C^[ړ
		SetFilePointer(hFile, m_Iconentry[m_BmpCounter + i].dwImageOffset,
						NULL, FILE_BEGIN);
		//C[Wf[^t@Cǂݍ
		if(!ReadFile(hFile, m_ImageDat[m_BmpCounter + i],
			m_Iconentry[m_BmpCounter + i].dwBytesInRes, &dwRead, NULL)) {
			MessageBox(m_hWnd, "m_ImageDatǂݍ߂܂ł",
					"G[", MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return FALSE;
		}
		//C[Wf[^t@Cɂe|C^[ݒ
		m_lpBmi[m_BmpCounter + i] = (LPBITMAPINFO)m_ImageDat[m_BmpCounter + i];
		//biBitCountɊÂRGBQUAĎvZ
		switch(m_lpBmi[m_BmpCounter + i]->bmiHeader.biBitCount) {
		case 1:		//256 - 1 << 1 (= 2)
			rgbq = 8;	//sizeof(RGBQUAD) * (1 << biBitCount)
			break;
		case 4:		//256 - 1 << 4 (= 16)
			rgbq = 64;	//sizeof(RGBQUAD) * (1 << biBitCount)
			break;
		case 8:		//256 - 1 << 8 (= 256)
			rgbq = 1024;
			break;
		default:	//16, 24, 32bitF̃rbg}bvRGBQUADe[uȂ
			 rgbq = 0;
			 break;
		}
		//J[rbg}bṽrbgf[^ւ̃|C^[̐ݒ
		m_XOR[m_BmpCounter + i] = (LPBYTE)m_lpBmi[m_BmpCounter + i] +
									sizeof(BITMAPINFOHEADER) + rgbq;
		//J[rbg}bviXORjf[^TCYZo
		BmpSize = ((m_lpBmi[m_BmpCounter + i]->bmiHeader.biBitCount *
					m_lpBmi[m_BmpCounter + i]->bmiHeader.biWidth + 31) / 32) *
					4 * abs(m_lpBmi[m_BmpCounter + i]->bmiHeader.biHeight / 2);
		//}XNrbg}bṽrbgf[^ւ̃|C^[̐ݒ
		m_AND[m_BmpCounter + i] = (LPBYTE)m_lpBmi[m_BmpCounter + i] +
									sizeof(BITMAPINFOHEADER) + rgbq + BmpSize;
		/////////////////////////////////////
		//擾f[^Ńrbg}bv쐬
		/////////////////////////////////////
		LPBYTE Bmi = (LPBYTE)LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER) + rgbq);
		memcpy(Bmi, (LPBYTE)m_lpBmi[m_BmpCounter + i],
				sizeof(BITMAPINFOHEADER) + rgbq);
		//Bmi̍C
		((LPBITMAPINFOHEADER)Bmi)->biHeight /= 2;	//2{ɂȂĂ邽
		//J[rbg}bv쐬
		m_hBmp[m_BmpCounter + i] = CreateCompatibleBitmap(m_hDC,
										((LPBITMAPINFOHEADER)Bmi)->biWidth,
										((LPBITMAPINFOHEADER)Bmi)->biHeight);
		//J[rbg}bvBitf[^^
		if(SetDIBits(m_hDC, m_hBmp[m_BmpCounter + i], 0,
					((LPBITMAPINFOHEADER)Bmi)->biHeight, m_XOR[m_BmpCounter + i],
					(LPBITMAPINFO)Bmi, DIB_RGB_COLORS)
					== ERROR_INVALID_PARAMETER) {
			MessageBox(m_hWnd, "J[rbg}bv̍쐬Ɏs܂",
						"G[", MB_OK | MB_ICONERROR);
			DeleteObject(m_hBmp[m_BmpCounter + i]);
		}
		//}XNrbg}bv쐬
		m_hMaskBmp[m_BmpCounter + i] = CreateCompatibleBitmap(m_hDC,
										((LPBITMAPINFOHEADER)Bmi)->biWidth,
										((LPBITMAPINFOHEADER)Bmi)->biHeight);
		//mNɂ
		((LPBITMAPINFOHEADER)Bmi)->biBitCount = 1;
		RGBQUAD mono[2] =	{{0, 0, 0, 0},
							 {0xff, 0xff, 0xff, 0}
							};
		memcpy(Bmi + sizeof(BITMAPINFOHEADER), mono, sizeof(RGBQUAD) * 2);
		//}XNrbg}bvBitf[^^
		if(SetDIBits(m_hDC, m_hMaskBmp[m_BmpCounter + i], 0,
					((LPBITMAPINFOHEADER)Bmi)->biHeight,
					m_AND[m_BmpCounter + i],(LPBITMAPINFO)Bmi, DIB_RGB_COLORS)
					== ERROR_INVALID_PARAMETER) {
			MessageBox(m_hWnd, "}XNrbg}bv̍쐬Ɏs܂",
						"G[", MB_OK | MB_ICONERROR);
			DeleteObject(m_hMaskBmp[m_BmpCounter + i]);
		}
		//Bmi̊J
		LocalFree(Bmi);
	}
	//Icont@CN[Y
	if(!CloseHandle(hFile))
		MessageBox(m_hWnd, "t@CN[Ył܂ł",
					"G[", MB_OK | MB_ICONSTOP);
	//rbg}bvJE^[ǂݍ񂾐i߂
	m_BmpCounter += m_Icondir.idCount;

	return TRUE;
}

///////////////////////////////////////////////////////////////
//t@Crbg}bvǉ
//FileName : t@CpXEO܂̓\[XID
//flag	: t@C = TRUEiKljA\[X = FALSE
///////////////////////////////////////////////////////////////
bool CICON::Add_Bitmap(LPCTSTR FileName) {

	//[Jϐ
	LPBITMAPINFOHEADER PBmi;//rbg}bvCtHwb_[
	int rgbq;				//J[e[uiRGBQUADjTCY
	int BmpSize;			//XORrbg}bvTCY
	int MaskSize;			//ANDrbg}bvTCY
	int BkCol;				//wiFpbgԍiCbit == 1, 4, 8̏ꍇj
	char BkC[4];			//wiFpbgԍiCbit == 24̏ꍇj
	//t@CI[v
	DWORD dwResult;
	HANDLE hFile = CreateFile(FileName, GENERIC_READ, 0, NULL, OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE) {
		MessageBox(m_hWnd, "t@CJ܂ł",
					"G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	//BITMAPFILEHEADERXLbv
	SetFilePointer(hFile, sizeof(BITMAPFILEHEADER), NULL, FILE_BEGIN);
	//UBITMAPINFOHEADERǂݍ
	PBmi = (LPBITMAPINFOHEADER)LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER));
	if(!PBmi) {
		MessageBox(m_hWnd, "PBmip̃[mۂł܂ł",
				"G[", MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return FALSE;
 	}
	ReadFile(hFile, PBmi, sizeof(BITMAPINFOHEADER), &dwResult, NULL);
	//J[pbgTCYmF
	switch(PBmi->biBitCount) {
	case 1:		//256 - 1 << 1 (= 2)
		rgbq = 8;	//sizeof(RGBQUAD) * (1 << biBitCount)
		break;
	case 4:		//256 - 1 << 4 (= 16)
		rgbq = 64;	//sizeof(RGBQUAD) * (1 << biBitCount)
		break;
	case 8:		//256 - 1 << 8 (= 256)
		rgbq = 1024;
		break;
	case 16:	//16bitF̃rbg}bvRGBQUADe[uȂ
	case 24:	//24bitF̃rbg}bvRGBQUADe[uȂ
	case 32:	//32bitF̃rbg}bvRGBQUADe[uȂ
		 rgbq = 0;
		 break;
	}
	LocalFree(PBmi);
	//J[rbg}bṽf[^TCYZo
	BmpSize = ((PBmi->biBitCount * PBmi->biWidth + 31) / 32) * 4 * abs(PBmi->biHeight);
	//}XNrbg}bṽf[^TCYZo
	MaskSize = ((PBmi->biWidth + 31) / 32) * 4 * abs(PBmi->biHeight);
	//m_ImageDat̃[mۂ
	m_ImageDat[m_BmpCounter] = (LPBYTE)LocalAlloc(LPTR,
						sizeof(BITMAPINFOHEADER) + rgbq + BmpSize + MaskSize);
	//t@CBITMAPINFOHEADERAJ[pbgXORrbg}bvǂݍ
	SetFilePointer(hFile, sizeof(BITMAPFILEHEADER), NULL, FILE_BEGIN);
	ReadFile(hFile, m_ImageDat[m_BmpCounter], sizeof(BITMAPINFOHEADER) + rgbq +
				BmpSize, &dwResult, NULL);
	m_lpBmi[m_BmpCounter] = (LPBITMAPINFO)m_ImageDat[m_BmpCounter];
	PBmi = (LPBITMAPINFOHEADER)m_lpBmi[m_BmpCounter];
	//[J[̊mۂƃrbgp^[f[^̓ǂݍ
	m_XOR[m_BmpCounter] = (LPBYTE)PBmi + sizeof(BITMAPINFOHEADER) + rgbq;
	//[J[̊mۂƃrbgp^[f[^̓ǂݍ
	m_AND[m_BmpCounter] = (LPBYTE)PBmi + sizeof(BITMAPINFOHEADER) + rgbq + BmpSize;
	//ColBmpŉE[sNZ̐FwiFɐݒ肵A1oCgo
	if(PBmi->biHeight > 0) {	//{gAbv
		switch(PBmi->biBitCount) {
		case 1:		//mN̏ꍇ́u / 8voCg̑1rbgl
			BkCol = m_XOR[m_BmpCounter][PBmi->biWidth / 8 - 1] & 1;	//01ƂȂ
			break;
		case 4:		//16F̏ꍇu / 2voCĝ͉4rbgl
			BkCol = m_XOR[m_BmpCounter][PBmi->biWidth / 2 - 1] & 0xF;
			break;
		case 8:		//256F̏ꍇ8rbgl
			BkCol = m_XOR[m_BmpCounter][PBmi->biWidth - 1];
			break;
		case 16:	//16bit̏ꍇ2byte(RGB555 or 565̏)l
			BkC[0] = m_XOR[m_BmpCounter][PBmi->biWidth * 2 - 2];	//RGB555܂
			BkC[1] = m_XOR[m_BmpCounter][PBmi->biWidth * 2 - 1];	//RGB565z
			break;
		case 24:	//24bit̏ꍇ3byte(BGȐ)l
			BkC[0] = m_XOR[m_BmpCounter][PBmi->biWidth * 3 - 3];	//B
			BkC[1] = m_XOR[m_BmpCounter][PBmi->biWidth * 3 - 2];	//G
			BkC[2] = m_XOR[m_BmpCounter][PBmi->biWidth * 3 - 1];	//R
			break;
		case 32:	//32bit̏ꍇ4byte(BRGRsvd̏)l
			BkC[0] = m_XOR[m_BmpCounter][PBmi->biWidth * 4 - 4];	//B
			BkC[1] = m_XOR[m_BmpCounter][PBmi->biWidth * 4 - 3];	//G
			BkC[2] = m_XOR[m_BmpCounter][PBmi->biWidth * 4 - 2];	//R
			BkC[3] = m_XOR[m_BmpCounter][PBmi->biWidth * 4 - 1];	//Rsvd
			break;
		}
    }
	else {						//{g_E
		switch(PBmi->biBitCount) {
		case 1:		//mN̏ꍇ͍ŏIoCg̑1rbgl
			BkCol = m_XOR[m_BmpCounter][BmpSize - 1] & 1;	//01ƂȂ
			break;
		case 4:		//16F̏ꍇ͍ŏIoCg̉4rbgl
			BkCol = m_XOR[m_BmpCounter][BmpSize - 1] & 0xf;
			break;
		case 8:		//256F̏ꍇŏIoCgl
			BkCol = m_XOR[m_BmpCounter][BmpSize - 1];
			break;
		case 16:	//16bit̏ꍇ͂2byte(RGB555 or 565̏)l
			BkC[0] = m_XOR[m_BmpCounter][BmpSize - 2];		//RGB555܂
			BkC[1] = m_XOR[m_BmpCounter][BmpSize - 1];		//RGB565z
			break;
		case 24:	//24bit̏ꍇ3byte(BRG̏)l
			BkC[0] = m_XOR[m_BmpCounter][BmpSize - 3];		//B
			BkC[1] = m_XOR[m_BmpCounter][BmpSize - 2];		//G
			BkC[2] = m_XOR[m_BmpCounter][BmpSize - 1];		//R
			break;
		case 32:	//32bit̏ꍇ4byte(BRGRsvd̏)l
			BkC[0] = m_XOR[m_BmpCounter][BmpSize - 4];		//B
			BkC[1] = m_XOR[m_BmpCounter][BmpSize - 3];		//G
			BkC[2] = m_XOR[m_BmpCounter][BmpSize - 2];		//R
			BkC[3] = m_XOR[m_BmpCounter][BmpSize - 1];	//Rsvd
			break;
		}
	}
	//}XNrbgp^[̍쐬
	char Bit, tmp;	//eoCg̑lZopϐitmp1|߂ORĂ䂭j
	int Dat;		//4bitrbg}bvpFf[^pϐ
	for(int i = 0; i < MaskSize; i++) {
		Bit = 0;					//oCg0ɏ
		for(int j = 7; j >= 0; j--) {	//E֌čs
			switch(PBmi->biBitCount) {
			case 1:
				tmp = 1 << j;
				if(m_XOR[m_BmpCounter][i] & tmp) {	//?0000000'1'ۂ̃`FbN
					if(BkCol)			//wiF'1'̏ꍇ
						Bit |= tmp;		//rbg'1'ɂē
				}
				else {					//OiF'0'̏ꍇł
					if(!BkCol)			//wiF'0'ł
						Bit |= tmp;		//rbg'1'ɂē
				}
				break;
			case 4:
				if(j % 2)
					Dat = m_XOR[m_BmpCounter][i * 4 + (7 - j) / 2] >> 4;
				else
					Dat = m_XOR[m_BmpCounter][i * 4 + (7 - j) / 2] & 0xF;
				if(Dat == BkCol) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			case 8:
				if(m_XOR[m_BmpCounter][i * 8 + 7 - j] == BkCol) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			case 16:
				if(m_XOR[m_BmpCounter][(i * 8 + 7 - j) * 2] == BkC[0] &&
				   m_XOR[m_BmpCounter][(i * 8 + 7 - j) * 2 + 1] == BkC[1]) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			case 24:
				if(m_XOR[m_BmpCounter][(i * 8 + 7 - j) * 3] == BkC[0] &&
				   m_XOR[m_BmpCounter][(i * 8 + 7 - j) * 3 + 1] == BkC[1] &&
				   m_XOR[m_BmpCounter][(i * 8 + 7 - j) * 3 + 2] == BkC[2]) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			case 32:
				if(m_XOR[m_BmpCounter][(i * 8 + 7 - j) * 4] == BkC[0] &&
				   m_XOR[m_BmpCounter][(i * 8 + 7 - j) * 4 + 1] == BkC[1] &&
				   m_XOR[m_BmpCounter][(i * 8 + 7 - j) * 4 + 2] == BkC[2] &&
				   m_XOR[m_BmpCounter][(i * 8 + 7 - j) * 4 + 3] == BkC[3]) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			}
    	}
		m_AND[m_BmpCounter][i] = Bit;
	}
	// 16̎ɂ2oCg0̂ŏCiȉ̓{gAbvj
	//@@@@̃f[^[̏ԁ@@@@@@@@@@@f[^@@@]0iǉj
	//											  00000000 00000000 00000000 00000000
	//											  00000000 00000000 00000000 00000000
	//											  00000000 00000000 00000000 00000000
	//											  00000000 00000000 00000000 00000000
	// 00000000 00000000 00000000 00000000 || 11111111 11111111 00000000 00000000
	// 00000000 00000000 00000000 00000000 || 10000000 00000001 00000000 00000000
	// 10000000 00000001 11111111 11111111 || 10000000 00000001 00000000 00000000
	// 11111111 11111111 10000000 00000001 || 11111111 11111111 00000000 00000000
	// -------------------------------------------------------------------------------
	// 01234567 89ABCDEF 01234567 89ABCDEF		   01234567 89ABCDEF 01234567 89ABCDEF
	if(PBmi->biWidth == 16) {
		LPBYTE temp = (LPBYTE)LocalAlloc(LPTR, MaskSize);
		if(!temp) {
			MessageBox(NULL, "[J[mۂł܂ł",
						"G[", MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return FALSE;
		}
		int j = 0;
		for(int i = 0; i < MaskSize / 2; i += 2, j += 4) {
			temp[j] = m_AND[m_BmpCounter][i];
			temp[j + 1] = m_AND[m_BmpCounter][i + 1];
			temp[j + 2] = 0;
			temp[j + 3] = 0;
		}
		memcpy(m_AND[m_BmpCounter], temp, MaskSize);
		GlobalFree((HGLOBAL)temp);
	}
	//J[rbg}bv쐬
	m_hBmp[m_BmpCounter] = CreateCompatibleBitmap(m_hDC, PBmi->biWidth, PBmi->biHeight);
	//J[rbg}bvBitf[^^
	if(SetDIBits(m_hDC, m_hBmp[m_BmpCounter], 0, PBmi->biHeight, m_XOR[m_BmpCounter],
				(LPBITMAPINFO)PBmi, DIB_RGB_COLORS) == ERROR_INVALID_PARAMETER) {
		MessageBox(m_hWnd, "}XNrbg}bv̍쐬Ɏs܂",
				"G[", MB_OK | MB_ICONERROR);
		DeleteObject(m_hBmp[m_BmpCounter]);
		CloseHandle(hFile);
		return FALSE;
	}
	//}XNrbg}bv쐬
	m_hMaskBmp[m_BmpCounter] = CreateCompatibleBitmap(m_hDC, PBmi->biWidth, PBmi->biHeight);
	//mNɂ
	WORD OldCol = PBmi->biBitCount;
	PBmi->biBitCount = 1;
	RGBQUAD Oldrgb[2];
	memcpy(Oldrgb, PBmi + sizeof(BITMAPINFOHEADER), sizeof(RGBQUAD) * 2);
	RGBQUAD mono[2] =	{{0, 0, 0, 0},
						 {0xff, 0xff, 0xff, 0}
						};
	memcpy(PBmi + sizeof(BITMAPINFOHEADER), mono, sizeof(RGBQUAD) * 2);
	//}XNrbg}bvBitf[^^
	if(SetDIBits(m_hDC, m_hMaskBmp[m_BmpCounter], 0, PBmi->biHeight, m_AND[m_BmpCounter],
				(LPBITMAPINFO)PBmi, DIB_RGB_COLORS) == ERROR_INVALID_PARAMETER) {
		MessageBox(m_hWnd, "}XNrbg}bv̍쐬Ɏs܂",
				"G[", MB_OK | MB_ICONERROR);
		DeleteObject(m_hMaskBmp[m_BmpCounter]);
		CloseHandle(hFile);
		return FALSE;
	}
	//ɖ߂
	PBmi->biBitCount = OldCol;
	memcpy(PBmi + sizeof(BITMAPINFOHEADER), Oldrgb, sizeof(RGBQUAD) * 2);
	//ACRAJ[\t@CpɏC
	PBmi->biHeight *= 2;	//biHeight2{ɂȂĂ
	PBmi->biSizeImage += MaskSize;	//ANDrbg}bṽTCYǉ
	//t@CN[Y
	if(!CloseHandle(hFile))
		MessageBox(m_hWnd, "t@CN[Ył܂ł",
					"G[", MB_OK | MB_ICONSTOP);
	//(ICONDIRENTRY)m_IconentryɃf[^
	m_Iconentry[m_BmpCounter].bWidth = PBmi->biWidth;
	m_Iconentry[m_BmpCounter].bHeight = PBmi->biHeight / 2;
	switch(PBmi->biBitCount) {
	case 1:
		m_Iconentry[m_BmpCounter].bColorCount = 2;
		break;
	case 4:
		m_Iconentry[m_BmpCounter].bColorCount = 16;
		break;
	default:
		m_Iconentry[m_BmpCounter].bColorCount = 0;
		break;
	}
	m_Iconentry[m_BmpCounter].bReserved = 0;
	m_Iconentry[m_BmpCounter].wPlanes = PBmi->biPlanes;
	m_Iconentry[m_BmpCounter].wBitCount = PBmi->biBitCount;
	m_Iconentry[m_BmpCounter].dwBytesInRes = sizeof(BITMAPINFOHEADER) + rgbq + BmpSize + MaskSize;
	m_Iconentry[m_BmpCounter].dwImageOffset = 0;	//ۑ܂Ŗ
	//ǉrbg}bvJE^[i߂
	m_BmpCounter++;

	return TRUE;
}

/////////////////////////
//o^rbg}bv̍폜
/////////////////////////
bool CICON::Del_Bitmap(int del) {

	if(del >= m_BmpCounter)
		return FALSE;
	//C[Wf[^
	LocalFree(m_ImageDat[del]);
	//쐬σrbg}bv
	DeleteObject(m_hBmp[del]);
	DeleteObject(m_hMaskBmp[del]);
	for(int i = del; i < m_BmpCounter; i++) {
		//ICONDIRENTRY\
		m_Iconentry[i] = m_Iconentry[i + 1];
		//\rbg}bvDIB擾p
		m_ImageDat[i] = m_ImageDat[i + 1];	//\rbg}bvf[^
		m_lpBmi[i] = m_lpBmi[i + 1];		//BITMAPINFO\̂ւ̃|C^[
		m_XOR[i] = m_XOR[i + 1];			//J[rbg}bv|C^[
		m_AND[i] = m_AND[i + 1];			//}XNrbg}bv|C^[
		//\rbg}bṽnh
		m_hBmp[i] = m_hBmp[i + 1];			//J[rbg}bv
		m_hMaskBmp[i] = m_hMaskBmp[i + 1];	//}XNrbg}bv
	}
	m_BmpCounter--;
	m_ImageDat[m_BmpCounter] = 0;
	m_lpBmi[m_BmpCounter] = 0;
	m_XOR[m_BmpCounter] = 0;
	m_AND[m_BmpCounter] = 0;
	m_hBmp[m_BmpCounter] = 0;
	m_hMaskBmp[m_BmpCounter] = 0;
	return TRUE;
}

//////////////////////////////////////////////////////
//̃rbg}bvICONDIRENTRYւ̃|C^[Ԃ
//////////////////////////////////////////////////////
bool CICON::GetIDEntry(int i, LPICONDIRENTRY *lpide) {

	if(i < m_BmpCounter) {
		*lpide = &m_Iconentry[i];
		return TRUE;
	}
	else
		return FALSE;
}

//////////////////////////////////////////////////////////
//̃rbg}bvBITMAPINFOHEADERւ̃|C^[Ԃ
//////////////////////////////////////////////////////////
bool CICON::GetBmpInfo(int i, PBITMAPINFOHEADER *pbmi) {

	if(i < m_BmpCounter) {
		*pbmi = (PBITMAPINFOHEADER)m_lpBmi[i];
		return TRUE;
	}
	else
		return FALSE;
}

//ACR̃nhԂ
HICON CICON::GetIcon() {

	return m_hIcon;
}

//J[iXORjrbg}bṽnhԂ
HBITMAP CICON::GetColBmp(int i) {

 	return m_hBmp[i];
}

//}XNiANDjrbg}bṽnhԂ
HBITMAP CICON::GetMaskBmp(int i) {

 	return m_hMaskBmp[i];
}

///////////////////////////////////////////////////////////////
//t@CփACR܂̓J[\ށiIcon-1ACursor-2j
//iType	: Icon = 1(IMAGE_ICON:Kl)ACursor = 2(IMAGE_CURSOR)
//hspx, y:zbgX|bgx, yWiC[WTCYȓj
///////////////////////////////////////////////////////////////
bool CICON::Save_Icon(LPTSTR FileName, UINT iType = IMAGE_ICON) {

	//C[W^Cv`FbNiIMAGE_ICON, IMAGE_CURSORȊO̓G[j
	if(iType != 1 && iType != 2) {
		MessageBox(m_hWnd, "IMAGE_ICON(1)AIMAGE_CURSOR(2)ł͂܂",
					"G[", MB_OK | MB_ICONSTOP);
    		return FALSE;
	}
	////////////////////////////////////
	//ACRAJ[\f[^
	////////////////////////////////////
	//t@CJ
	HANDLE hFile = CreateFile(FileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE) {
		MessageBox(m_hWnd, "t@CJ܂ł",
					"G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	//ICONDIR
	m_Icondir.idReserved = 0;
	m_Icondir.idType = iType;
	m_Icondir.idCount = m_BmpCounter;
	DWORD dwWrite;
	if(!WriteFile(hFile, &m_Icondir, sizeof(ICONDIR), &dwWrite, NULL)) {
		MessageBox(m_hWnd, "m_Icondir߂܂ł",
					"G[", MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return FALSE;
	}
	//ICONDIENTRYR
	DWORD Offset = sizeof(ICONDIR) + sizeof(ICONDIRENTRY) * m_BmpCounter;
	for(int i = 0; i < m_BmpCounter; i++) {
		m_Iconentry[i].dwImageOffset = Offset;	//ItZbgl
		Offset += m_Iconentry[i].dwBytesInRes;	//̃ItZbglɍXV
		if(!WriteFile(hFile, &m_Iconentry[i], sizeof(ICONDIRENTRY),
					&dwWrite, NULL)) {
			MessageBox(m_hWnd, "m_Iconentry߂܂ł",
						"G[", MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return FALSE;
		}
	}
	for(int i = 0; i < m_BmpCounter; i++) {
		if(!WriteFile(hFile, m_ImageDat[i], m_Iconentry[i].dwBytesInRes,
					&dwWrite, NULL)) {
			MessageBox(m_hWnd, "m_ImageDat߂܂ł",
						"G[", MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return FALSE;
		}
	}
	CloseHandle(hFile);
	return TRUE;
}
