//////////////////////////////////////////
// FileHandler.cpp
//Copyright (c) 12/13/2020 by BCCSkelton
//////////////////////////////////////////
#include	"CSHELL.h"
#include	"FileHandler.h"
#include	"CSPLIT.h"
#include	"User.h"
#include	"FileHandlerProc.h"

////////////////
// WinMain֐
////////////////
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPSTR lpCmdLine, int nCmdShow) {

	//QdNh~
	if(!FileHandler.IsOnlyOne()) {
		HWND hWnd = FindWindow("MainWnd", "FileHandler");
		if(IsIconic(hWnd))
			ShowWindow(hWnd, SW_RESTORE);
		SetForegroundWindow(hWnd);
		return 0L;
	}

	//EBhEo^ | Init(ClassName, hInstance, WndProc, "IDM_MAIN",
	//						iȉȗjMAKEINTRESOURCE(IDI_ICON), IDC_ARROW, Brush)
	FileHandler.Init("MainWnd", hInstance, SDIPROC, "IDM_MAINMENU", MAKEINTRESOURCE(IDI_ICON));

	//EBhE쐬ƕ\|Create(WindowTitle, (ȉȗjStyle,
	//						ExStyle, hParent, hMenu, x, y, w, h)
	if(!FileHandler.Create("FileHandler"))
		return 0L;

	//ANZ[^[o^|InclAccel("(Accelerator ID)")
	FileHandler.InclAccel("IDA_ACCEL");

	//bZ[W[vɓ
	return FileHandler.Loop();
}
