//////////////////////////////////////////
// FileHandlerProc.h
// Copyright (c) 12/13/2020 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnCreate(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	TBar.Init(m_hWnd, m_hInstance, TOOLBAR);
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TBAR), 7);
	//c[o[{^ǉ
	TBBUTTON tbb[11];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_EXIT;
	tbb[1].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[2].iBitmap = TBar.m_id + 1;
	tbb[2].fsState = TBSTATE_ENABLED;
	tbb[2].fsStyle = TBSTYLE_BUTTON;
	tbb[2].idCommand = IDM_EXE;
	tbb[3].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[4].iBitmap = TBar.m_id + 2;
	tbb[4].fsState = TBSTATE_ENABLED;
	tbb[4].fsStyle = TBSTYLE_BUTTON;
	tbb[4].idCommand = IDM_DEL;
	tbb[5].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[6].iBitmap = TBar.m_id + 4;
	tbb[6].fsState = TBSTATE_ENABLED;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_CUT;
	tbb[7].iBitmap = TBar.m_id + 3;
	tbb[7].fsState = TBSTATE_ENABLED;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_COPY;
	tbb[8].iBitmap = TBar.m_id + 5;
	tbb[8].fsState = TBSTATE_ENABLED;
	tbb[8].fsStyle = TBSTYLE_BUTTON;
	tbb[8].idCommand = IDM_RENAME;
	tbb[9].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[10].iBitmap = TBar.m_id + 6;
	tbb[10].fsState = TBSTATE_ENABLED;
	tbb[10].fsStyle = TBSTYLE_BUTTON;
	tbb[10].idCommand = IDM_VERSION;
	TBar.AddButtons(11, tbb);

	//Xe[^Xo[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	SBar.Init(m_hWnd, m_hInstance, STATUSBAR);
	//Xe[^Xo[ݒ
	int sec[2] = {120, -1};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "FileHandler Ver 1.3");

	//Xvb^[̍쐬
	g_Split.Create(m_hWnd, m_hInstance, IDC_SPLIT);
	//Xvb^[̋E̐ݒ
	g_Split.SetBorders(300);
	
	//c[r[̍쐬
	g_tv.Create(m_hWnd, m_hInstance, IDC_TREEVIEW);
	g_tv.SetFont(9, "lr ");
	//Xvb^[̑PyCɃc[r[𒣂t
	g_Split.SetCtrl(0, IDC_TREEVIEW);
	//Xg[r[̍쐬
	g_lv.Create(m_hWnd, m_hInstance, IDC_LISTVIEW);
	//Xvb^[̑QyCɃXg[r[𒣂t
	g_Split.SetCtrl(1, IDC_LISTVIEW);

	//t@CVXeIuWFNg񂩂C[WXg쐬
	HIMAGELIST hImglist;
	SHFILEINFO shFileInfo;
	hImglist = (HIMAGELIST)SHGetFileInfo(TEXT("C:\\"), 0, &shFileInfo, sizeof(SHFILEINFO), SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
	//C[WXgXgr[Ac[r[ɐݒ
	ListView_SetImageList(g_lv.GetHandle(), hImglist, LVSIL_SMALL);		//LVSIL_SMALL->Image list with small icons
	TreeView_SetImageList(g_tv.GetHandle(), hImglist, TVSIL_NORMAL);	//LVSIL_SMALL->Image list with small icons

	//VF̏
	g_Shell.SetHandles(g_tv.GetHandle(), g_lv.GetHandle());	//֘Atc[r\AXgr[o^
	//Xgr[Ac[r[̏
	g_Shell.InsertTreeItem(g_Shell.GetDesktop(), TVI_ROOT, TEXT(g_Root.ToChar()), SFGAO_HASSUBFOLDER);	//c[r\ɃfXNgbv[gݒ
	g_Shell.ResetListViewColumn(g_Shell.GetShellFolder());	//Xgr[̗񏉊ݒitH[_[ɂĈقȂj
	g_Shell.SetSHChangeNoticeRegister(m_hWnd);				//VFύXʒm̐ݒ

	//j[nh̎擾
	g_hPopup = GetSubMenu(GetMenu(m_hWnd), 0);

	return TRUE;
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	LPNMHDR lpNmhdr = (LPNMHDR)lParam;
	if((int)wParam == IDC_TREEVIEW) {	//c[r[̃bZ[W
		switch(lpNmhdr->code) {
			LPTVITEM lp;
		case TVN_ITEMEXPANDING:			//c[r\̓WJ
			lp = &((LPNMTREEVIEW)lParam)->itemNew;
			//߂Ă̓WJ̏ꍇAi3FALSEjȂ̂ŃXgr[͂炸񋓂
			if(!(lp->state & TVIS_EXPANDEDONCE))
				g_Shell.ViewEnumItem((PIDLIST_ABSOLUTE)lp->lParam, m_hWnd, FALSE, lp->hItem, CompareFunc);
			break;
		case TVN_DELETEITEM: 			//c[r\ACe폜ꍇ
			lp = &((LPNMTREEVIEW)lParam)->itemOld;
			CoTaskMemFree((LPVOID)lp->lParam);		//PIDL̃[
			break;
		case TVN_SELCHANGED:			//c[r\̑IACeύX
			//itemNew = VIACe
			lp = &((LPNMTREEVIEW)lParam)->itemNew;
			//VIACePIDLL^
			g_Shell.SetCurFolder((PIDLIST_ABSOLUTE)lp->lParam);
			//lp->lParamiVIACe̐PIDLISTjpX擾
			SHGetPathFromIDList((PCIDLIST_ABSOLUTE)lp->lParam, g_CurrentPath);
			//ACeIit@CpXj̕ύXɔApX̃Xgr[őIt@Cobt@
			*g_FileName = NULL;						//t@Cobt@
			g_SelectedFile = g_CurrentPath;
			g_SelectedFile = g_SelectedFile + "\\" + g_FileName;
			//Xe[^Xo[֕\itH[_[j
			SBar.SetText(1, g_SelectedFile.ToChar());
			SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_SelectedFile.ToChar());	//ToolTip
			//Xgr[ɂ́uqv\i3TRUEj
			g_Shell.ViewEnumItem((PIDLIST_ABSOLUTE)lp->lParam, m_hWnd, TRUE, NULL, CompareFunc);
			break;
/*
		case TVN_ENDLABELEDIT:
			//t@CpXEL^
			CSTR OldPathName = g_SelectedFile;
			//xҏW
			TreeView_SetItem(g_tv.GetHandle(), &((TV_DISPINFO*)lParam)->item);
			//߂ăpX擾
			LPTVITEM lp = &((LPNMTREEVIEW)lParam)->itemNew;	//itemNew = VIACe
			//lp->lParamiVIACe̐PIDLISTjpX擾
			SHGetPathFromIDList((PCIDLIST_ABSOLUTE)lp->lParam, g_CurrentPath);
			//It@CVɕύX
			g_SelectedFile = g_CurrentPath;
			g_SelectedFile = g_SelectedFile + "\\" + g_FileName;
			//t@CVt@CɕύX
			g_Shell.FileOperation(m_hWnd, 'R', OldPathName.ToChar(), g_SelectedFile.ToChar());
			//Vt@CXe[^Xo[ɕ\
			SBar.SetText(1, g_SelectedFile.ToChar());	//Vt@CɕύX
			SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_SelectedFile.ToChar());	//ToolTip
			//xҏWsɖ߂
			g_Style ^= TVS_EDITLABELS;
			SetWindowLong(g_tv.GetHandle(), GWL_STYLE, g_Style);
			//xҏW{^𗘗p\ɂ
			SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_RENAME, MAKELONG(TRUE, 0));
			break;
		case NM_RCLICK:
			SetContextMenu(lpNmhdr, lParam);
			break;
*/
		default:
			break;
		}
	}
	else if((int)wParam == IDC_LISTVIEW) {	//Xgr[̃bZ[W
		//Xgr[̒ʒmbZ[Wɂ鏈
		switch(((LPNMLISTVIEW)lParam)->hdr.code) {
			static HWND hEdit;	//Xgr[xҏWpGfBbgRg[
		case LVN_COLUMNCLICK:	//񌩏oNbNꂽ
			if(sortsubno[((LPNMLISTVIEW)lParam)->iSubItem] == UP)
				sortsubno[((LPNMLISTVIEW)lParam)->iSubItem] = DOWN;
			else
				sortsubno[((NM_LISTVIEW*)lParam)->iSubItem] = UP;
			g_lv.SortItem(CompProc, ((LPNMLISTVIEW)lParam)->iSubItem);
			break;
		case LVN_DELETEITEM:
			//item.lParam = 폜ACepidl
			LVITEM item;
			item.mask  = LVIF_PARAM;
			item.iItem = ((LPNMLISTVIEW)lParam)->iItem;
			ListView_GetItem(g_lv.GetHandle(), &item);
			CoTaskMemFree((LPVOID)item.lParam);
			break;
		case LVN_BEGINLABELEDIT:
			hEdit = ListView_GetEditControl(g_lv.GetHandle());
			break;
		case LVN_ENDLABELEDIT:
			GetWindowText(hEdit, g_FileName, sizeof(g_FileName));
			ListView_SetItemText(g_lv.GetHandle(), ((LPNMLISTVIEW)lParam)->iItem, 0, g_FileName);
			g_SelectedFile = g_CurrentPath;
			g_SelectedFile = g_SelectedFile + "\\" + g_FileName;
			//Xe[^Xo[֕\itH[_[j
			SBar.SetText(1, g_SelectedFile.ToChar());
			SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_SelectedFile.ToChar());	//ToolTip
			//xҏWsɖ߂
			g_Style ^= TVS_EDITLABELS;
			SetWindowLong(g_lv.GetHandle(), GWL_STYLE, g_Style);
			//xҏW{^𗘗p\ɂ
			SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_RENAME, MAKELONG(TRUE, 0));
			break;
		case NM_CLICK:		//NbN̏ꍇ
			//ACeIĂ΃Xe[^Xo[֕\
		case NM_DBLCLK:		//_uNbN̏ꍇ
			//\ɉAOnExe
			if((g_SelRow = g_lv.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED | LVNI_FOCUSED)) != -1) {
				g_lv.GetItemText(g_SelRow, 0, g_FileName, MAX_PATH);
				g_SelectedFile = g_CurrentPath;
				g_SelectedFile = g_SelectedFile + "\\" + g_FileName;
				//Xe[^Xo[֕\itH[_[j
				SBar.SetText(1, g_SelectedFile.ToChar());
				SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_SelectedFile.ToChar());	//ToolTip
				if(((LPNMLISTVIEW)lParam)->hdr.code == NM_DBLCLK) OnExe();			//OnExe
			}
			break;
		case NM_RCLICK:		//ENbN̏ꍇ
			if(g_Context)
				SetContextMenu(lpNmhdr, lParam);
			else {
				//EChËʒu擾
				RECT rec;
				GetWindowRect(m_hWnd, &rec);
				//|bvAbvj[̕\ꏊݒ
				POINT pt;
				GetCursorPos(&pt);
				//|bvAbvj[̕\
				TrackPopupMenu(g_hPopup, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON, pt.x, pt.y, 0, m_hWnd, &rec);
			}
			break;
		default:
			break;
		}
	}
	else if(lpNmhdr->code == TTN_NEEDTEXT) {
		((LPTOOLTIPTEXT)lParam)->hinst = m_hInstance;
		switch(((LPTOOLTIPTEXT)lParam)->hdr.idFrom) {
		case IDM_EXE:
			((LPTOOLTIPTEXT)lParam)->lpszText = "s";
			break;
		case IDM_DEL:
			((LPTOOLTIPTEXT)lParam)->lpszText = "폜";
			break;
		case IDM_CUT:
			((LPTOOLTIPTEXT)lParam)->lpszText = "t@C̈ړ";
			break;
		case IDM_COPY:
			((LPTOOLTIPTEXT)lParam)->lpszText = "t@C̃Rs[";
			break;
		case IDM_RENAME:
			((LPTOOLTIPTEXT)lParam)->lpszText = "t@CύX";
			break;
		case IDM_VERSION:
			((LPTOOLTIPTEXT)lParam)->lpszText = "o[W";
			break;
		case IDM_EXIT:
			((LPTOOLTIPTEXT)lParam)->lpszText = "I";
			break;
		}
	}

	return TRUE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	//c[o[AXe[^Xo[ẽNCAg̈ɍ킹
	TBar.AutoSize();
	SBar.AutoSize();
	//Xvb^[ẽNCAg̈ɍ킹
	g_Split.AutoSize(SBar.m_hWnd, TBar.m_hWnd);
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONQUESTION) == IDYES) {
		//DestroyWindowAPostQuitMessageĂ΂
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

//////////////////////////
//VFʒmbZ[W
//////////////////////////
bool CMyWnd::OnShellChange(WPARAM wParam, LPARAM lParam) {

	LONG				lEvent;
	HANDLE				hLock;
	PIDLIST_ABSOLUTE	*pidlAbsolute;
	//͒ʒm~
	hLock = SHChangeNotification_Lock((HANDLE)wParam, (DWORD)lParam, &pidlAbsolute, &lEvent);
	if(hLock != NULL) {
		if(ILIsParent(g_Shell.GetCurFolder(), pidlAbsolute[0], TRUE))	//݂̃tH[_[̓CxgtH[_[̐eH
			g_Shell.NotifyShellChange(pidlAbsolute[0], pidlAbsolute[1], lEvent);
	//ʒmĊJ
		SHChangeNotification_Unlock(hLock);
		return TRUE;
	}
	return FALSE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnPopup() {

	g_Context = !g_Context;
	if(g_Context)
		 ModifyMenu(g_hPopup, IDM_POPUP, MF_BYCOMMAND, IDM_POPUP, "|bvAbvj[(&P)");
	else
		 ModifyMenu(g_hPopup, IDM_POPUP, MF_BYCOMMAND, IDM_POPUP, "ReLXgj[(&C)");

	return TRUE;
}

bool CMyWnd::OnExe() {

	if(!*g_FileName) {
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	do{
		if(!*g_CurrentPath) {	//
			CSTR errmsg(g_FileName);
			errmsg = errmsg + "I܂AztH[_[̃t@CȂ̂Ŏsł܂";
			MessageBox(m_hWnd, errmsg.ToChar(), "ztH[_[t@C", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		//IACefBNg[̏ꍇ̏
		if(GetFileAttributes(g_SelectedFile.ToChar()) & FILE_ATTRIBUTE_DIRECTORY) {
			g_tv.Expand(g_tv.GetSelection(), TVE_EXPAND);
			g_tv.SelectItem(g_tv.FindItem(g_tv.GetSelection(), g_FileName));
		}
		//IACet@C̏ꍇ̏
		else {
			g_lv.GetItemText(g_SelRow, 0, g_FileName, MAX_PATH);
			g_SelectedFile = g_CurrentPath;
			g_SelectedFile = g_SelectedFile + "\\" + g_FileName;
			if(WinExec(g_SelectedFile.ToChar(), SW_SHOWNORMAL) < 32) {
				if(MessageBox(m_hWnd, "s\t@Cł͂܂B֘AtꂽvO΂ŊJ܂H",
					"G[", MB_YESNO | MB_ICONEXCLAMATION) == IDYES) {
					char Path[MAX_PATH];
					lstrcpy(Path, g_SelectedFile.ToChar());
	                char *pt = strstr(Path, g_FileName);
					if(pt--) *pt = 0;
					char ExeFile[MAX_PATH];
					if((int)FindExecutable(g_FileName, Path, ExeFile) > 32) {
						CSTR Cmd = "\"";				//st@CpXAu"vň͂
						Cmd = Cmd + ExeFile;
						Cmd = Cmd + "\" \"";			//f[^t@CpXAu"vň͂
						Cmd = Cmd + g_SelectedFile;
						Cmd = Cmd + "\"";
						WinExec(Cmd.ToChar(), SW_SHOWNORMAL);
					}
					else
						MessageBox(m_hWnd, "֘AtꂽvO܂", "G[", MB_OK | MB_ICONERROR);
				}
			}
		}
	} while((g_SelRow = g_lv.GetNextItem(g_SelRow, LVNI_ALL | LVNI_SELECTED)) != -1);

	return TRUE;
}

bool CMyWnd::OnDel() {

	if(!*g_FileName) {
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
		CSTR msg = g_SelectedFile;
		msg = msg + "\n폜܂B낵łH";
		if(MessageBox(m_hWnd, msg.ToChar(), "t@C폜", MB_YESNO | MB_ICONWARNING) == IDYES) {
			g_Shell.FileOperation(m_hWnd, 'D', g_SelectedFile.ToChar());
			return TRUE;
		}
	}
}

bool CMyWnd::OnCut() {

	if(!*g_FileName) {
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//Ώۃt@CIĂ
	else {
		char Target[MAX_PATH] = {0};
		lstrcpy(Target, cmndlg.GetPath(m_hWnd, "ړ"));
		if(!*Target) {
			MessageBox(m_hWnd, "ړ悪w肳܂ł", "ړw莸s", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		//t@C̈ړ
		g_Shell.FileOperation(m_hWnd, 'M', g_SelectedFile.ToChar(), Target);
		return TRUE;
	}
}

bool CMyWnd::OnCopy() {

	if(!*g_FileName) {
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//Ώۃt@CIĂ
	else {
		char Target[MAX_PATH] = {0};
		lstrcpy(Target, cmndlg.GetPath(m_hWnd, "Rs["));
		if(!*Target) {
			MessageBox(m_hWnd, "Rs[悪w肳܂ł", "Rs[w莸s", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		//t@C̃Rs[
		g_Shell.FileOperation(m_hWnd, 'C', g_SelectedFile.ToChar(), Target);
		return TRUE;
	}
}

bool CMyWnd::OnRename() {

	if(!*g_FileName) {
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
/*		//xҏW\ɂ
		g_Style = GetWindowLong(g_tv.GetHandle(), GWL_STYLE);
		g_Style |= TVS_EDITLABELS;
		SetWindowLong(g_tv.GetHandle(), GWL_STYLE, g_Style);
		//xҏWJn
		TreeView_EditLabel(g_tv.GetHandle(), g_hSelected);
		//xҏW{^𗘗psɂ
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_RENAME, MAKELONG(FALSE, 0));
		return TRUE;
*/
		//xҏW\ɂ
		g_Style = GetWindowLong(g_lv.GetHandle(), GWL_STYLE);
		g_Style |= LVS_EDITLABELS;
		SetWindowLong(g_lv.GetHandle(), GWL_STYLE, g_Style);
		//xҏWJn
		ListView_EditLabel(g_lv.GetHandle(), g_SelRow);
		//xҏW{^𗘗psɂ
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_RENAME, MAKELONG(FALSE, 0));
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnVersion() {

	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}
