//////////////////////////////////////////
// FileList.h
// Copyright (c) 02/08/2022 by BCCSkelton
//////////////////////////////////////////
//BCCSkeltoñwb_[|ɕKvȃwb_[Ă
#include	"BCCSkelton.h"
//\[XID̃wb_[
#include	"ResFileList.h"

/////////////////////////////////////////////////////////////////////
//CMyWndNXCDLGNXhAbZ[Wp̊֐錾
/////////////////////////////////////////////////////////////////////
class CFILELIST : public CDLG
{
public:	//ȉ̓R[obN֐}NƊ֘AĂ
	//QdNh~pMutexpID
	CFILELIST(char* UName) : CDLG(UName) {}
	//c[o[
	CTBAR m_TBar;
	//Xe[^Xo[
	CSBAR m_SBar;
	//Xgr[
	CLISTVIEW m_ListView;
	//j[ځA_CAORg[֘A
	bool OnOpen();
	bool OnSave();
	bool OnExit();
	bool OnAdd();
	bool OnSearch();
	bool OnEdit();
	bool OnDelete();
	bool OnSort();
	bool OnVersion();
	//EBhEbZ[W֘A
	bool OnInit(WPARAM, LPARAM);
	bool OnNotify(WPARAM, LPARAM);
	bool OnSize(WPARAM, LPARAM);
	bool OnClose(WPARAM, LPARAM);
	bool OnDropFiles(WPARAM, LPARAM);
	bool OnMinMax(WPARAM, LPARAM);
	//[U[`֐
	bool ChangeMenuStatus(bool);
	char* GetFileName(char*);
};

////////////////////////////////////////////////////////////////////////
//hCFILTERLISTNX̃CX^XƃR[obN֐(}Nj̍쐬
//EBhE̓_CAOƈႢAR[obN֐͈Ȃ
////////////////////////////////////////////////////////////////////////
CFILELIST FileList("FileList");	//EBhENXCX^X̐

BEGIN_MODALDLGMSG(ModalProc, FileList)	//R[obN֐͎EBhȄꍇModalProcɂĂ
	//j[ځA_CAORg[֘A
	ON_COMMAND(FileList, IDM_OPEN, OnOpen())
	ON_COMMAND(FileList, IDM_SAVE, OnSave())
	ON_COMMAND(FileList, IDM_EXIT, OnExit())
	ON_COMMAND(FileList, IDM_ADD, OnAdd())
	ON_COMMAND(FileList, IDM_SEARCH, OnSearch())
	ON_COMMAND(FileList, IDM_EDIT, OnEdit())
	ON_COMMAND(FileList, IDM_DELETE, OnDelete())
	ON_COMMAND(FileList, IDM_SORT, OnSort())
	ON_COMMAND(FileList, IDM_VERSION, OnVersion())
	//EBhEbZ[W֘A
	//IɃ_CAO쐬OnInit()AIOnClose()Ăт܂
	ON_SIZE(FileList)
	ON_(FileList, WM_DROPFILES, OnDropFiles(wParam, lParam))
	ON_(FileList, WM_GETMINMAXINFO, OnMinMax(wParam, lParam))
END_DLGMSG

///////////////////////////////////////////
// CDLGNXEDITDLGNXh
// ̓_CAOϐƃ_CAO
// 邪A̃_CAOɈ̔h_C
// AONX쐬̂{
///////////////////////////////////////////
class EDITDLG : public CDLG {
public:
	//Rg[֘A
	bool OnIdok();
	bool OnIdcancel();
	//_CAObZ[W֘A
	bool OnInit(WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////////////////////
// EDITDLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////
EDITDLG editdlg;

BEGIN_MODALDLGMSG(editdlgProc, editdlg)	//1R[obN֐̖O
	ON_COMMAND(editdlg, IDOK, OnIdok())
	ON_COMMAND(editdlg, IDCANCEL, OnIdcancel())
END_DLGMSG

///////////////////////////////////////////
// CDLGNXSEARCHDLGNXh
// ̓_CAOϐƃ_CAO
// 邪A̃_CAOɈ̔h_C
// AONX쐬̂{
///////////////////////////////////////////
class SEARCHDLG : public CDLG {
public:
	char m_ToFind[MAX_PATH];
	//Rg[֘A
	bool OnIdok();
	bool OnIdcancel();
	//_CAObZ[W֘A
	bool OnInit(WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////////////////////
// SEARCHDLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////
SEARCHDLG searchdlg;

BEGIN_MODALDLGMSG(searchdlgProc, searchdlg)	//1R[obN֐̖O
	ON_COMMAND(searchdlg, IDOK, OnIdok())
	ON_COMMAND(searchdlg, IDCANCEL, OnIdcancel())
END_DLGMSG

///////////////////////////////////////////
// CDLGNXSORTDLGNXh
// ̓_CAOϐƃ_CAO
// 邪A̃_CAOɈ̔h_C
// AONX쐬̂{
///////////////////////////////////////////
class SORTDLG : public CDLG {
public:
	//Rg[֘A
	bool OnIdok();
	bool OnIdcancel();
	//_CAObZ[W֘A
	bool OnInit(WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////////////////////
// SORTDLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////
SORTDLG sortdlg;

BEGIN_MODALDLGMSG(sortdlgProc, sortdlg)	//1R[obN֐̖O
	ON_COMMAND(sortdlg, IDOK, OnIdok())
	ON_COMMAND(sortdlg, IDCANCEL, OnIdcancel())
END_DLGMSG

///////////////////////////////////////////
// CDLGNXVERSIONDLGNXh
// ̓_CAOϐƃ_CAO
// 邪A̃_CAOɈ̔h_C
// AONX쐬̂{
///////////////////////////////////////////
class VERSIONDLG : public CDLG {
public:
	//Rg[֘A
	bool OnIdok();
};

////////////////////////////////////////////////////////////////////////////
// VERSIONDLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////
VERSIONDLG versiondlg;

BEGIN_MODALDLGMSG(versiondlgProc, versiondlg)	//1R[obN֐̖O
	ON_COMMAND(versiondlg, IDOK, OnIdok())
END_DLGMSG
