//////////////////////////////////////////
// IDListProc.h
// Copyright (c) 09/29/2021 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnCreate(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|Init(hWnd, hIinstance, ID, Style)
	TBar.Init(m_hWnd, m_hInstance, TOOLBAR, WS_CHILD | WS_VISIBLE | TBSTYLE_TOOLTIPS);
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TOOLBAR), 10);
	//c[o[{^ǉ
	TBBUTTON tbb[14];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_OPEN;
	tbb[1].iBitmap = TBar.m_id + 1;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_SAVE;
	tbb[2].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[3].iBitmap = TBar.m_id + 2;
	tbb[3].fsState = TBSTATE_ENABLED;
	tbb[3].fsStyle = TBSTYLE_BUTTON;
	tbb[3].idCommand = IDM_EXIT;
	tbb[4].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[5].iBitmap = TBar.m_id + 3;
	tbb[5].fsState = TBSTATE_ENABLED;
	tbb[5].fsStyle = TBSTYLE_BUTTON;
	tbb[5].idCommand = IDM_ADD;
	tbb[6].iBitmap = TBar.m_id + 4;
	tbb[6].fsState = TBSTATE_ENABLED;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_SEARCH;
	tbb[7].iBitmap = TBar.m_id + 5;
	tbb[7].fsState = TBSTATE_ENABLED;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_EDIT;
	tbb[8].iBitmap = TBar.m_id + 6;
	tbb[8].fsState = TBSTATE_ENABLED;
	tbb[8].fsStyle = TBSTYLE_BUTTON;
	tbb[8].idCommand = IDM_DELETE;
	tbb[9].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[10].iBitmap = TBar.m_id + 7;
	tbb[10].fsState = TBSTATE_ENABLED;
	tbb[10].fsStyle = TBSTYLE_BUTTON;
	tbb[10].idCommand = IDM_SORT;
	tbb[11].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[12].iBitmap = TBar.m_id + 8;
	tbb[12].fsState = TBSTATE_ENABLED;
	tbb[12].fsStyle = TBSTYLE_BUTTON;
	tbb[12].idCommand = IDM_HELP;
	tbb[13].iBitmap = TBar.m_id + 9;
	tbb[13].fsState = TBSTATE_ENABLED;
	tbb[13].fsStyle = TBSTYLE_BUTTON;
	tbb[13].idCommand = IDM_VERSION;
	TBar.AddButtons(14, tbb);

	//Xe[^Xo[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	SBar.Init(m_hWnd, m_hInstance, STATUSBAR);
	//Xe[^Xo[ݒ
	int sec[2] = {100, 400};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "IDList Version 1.0");
	SBar.SetText(1, "Io[Vbv");

	//Xgr[Rg[̍쐬
	//IȂꍇAX^CLVS_SINGLESEL
	g_ListView.Create(m_hWnd, m_hInstance, IDC_LISTVIEW);
	g_ListView.InsertColumn(0, 240, "o[Vbv");
	g_ListView.InsertColumn(1, 160, "OCID", LVCFMT_CENTER);
	g_ListView.InsertColumn(2, 160, "pX[h", LVCFMT_CENTER);
	g_ListView.InsertColumn(3, 240, "l");

	//j[nh̎擾
	g_hPopup = GetSubMenu(GetMenu(m_hWnd), 1);

	//Xgr[͍ږIȂ̂ŁuҏWvƁu폜v𖳌ɂ
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_EDIT, MF_GRAYED | MF_BYCOMMAND);
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_DELETE, MF_GRAYED | MF_BYCOMMAND);
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_EDIT, FALSE);
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_DELETE, FALSE);

	//CHMwvt@C̏
	CARG arg;
	g_HelpFile = "hh \"";
	g_HelpFile = g_HelpFile + arg.Path();
	g_HelpFile = g_HelpFile + "\\IDListHelp.chm";

	//f[^t@CpXA
	g_File = arg.Path();
	g_File = g_File + "\\IDList.dat";

	//Nt@CǍ
	if(!DataLoad(m_hWnd, g_File.ToChar()))
		MessageBox(m_hWnd, "܂IDList.datĂȂ\nǂݍݏf܂B", "", MB_OK | MB_ICONWARNING);

	return TRUE;
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	if((int)wParam == IDC_LISTVIEW) {	//Xgr[̃bZ[W
		int n = g_ListView.GetNextItem(-1, LVNI_ALL | LVIS_SELECTED);
		if(n == -1) {	//IȂ
			//uҏWvƁu폜v𖳌ɂ
			EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_EDIT, MF_GRAYED | MF_BYCOMMAND);
			EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_DELETE, MF_GRAYED | MF_BYCOMMAND);
			SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_EDIT, FALSE);
			SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_DELETE, FALSE);
		}
		else {
			//uҏWvƁu폜vLɂ
			EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_EDIT, MF_UNCHECKED | MF_BYCOMMAND);
			EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_DELETE, MF_UNCHECKED | MF_BYCOMMAND);
			SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_EDIT, TRUE);
			SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_DELETE, TRUE);
			//Io[VbvXe[^Xo[ɕ\
			char buff[MAX_PATH];
			g_ListView.GetItemText(n, 0, buff, MAX_PATH);
			SBar.SetText(1, buff);
		}
		//Xgr[̒ʒmbZ[Wɂ鏈
		switch(((LPNMLISTVIEW)lParam)->hdr.code) {
		case LVN_COLUMNCLICK:	//񌩏oNbNꂽ
			if(sortsubno[((LPNMLISTVIEW)lParam)->iSubItem] == UP)
				sortsubno[((LPNMLISTVIEW)lParam)->iSubItem] = DOWN;
			else
				sortsubno[((NM_LISTVIEW*)lParam)->iSubItem] = UP;
			g_ListView.SortItem(CompProc, ((LPNMLISTVIEW)lParam)->iSubItem);
			break;
		case NM_DBLCLK:		//_uNbN
			if(g_ListView.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED) == -1)
				OnAdd();
			else
				OnEdit();
			break;
		case NM_RCLICK:		//ENbN
			//EChËʒu擾
			RECT rec;
			GetWindowRect(m_hWnd, &rec);
			//|bvAbvj[̕\ꏊݒ
			POINT pt;
			GetCursorPos(&pt);
			//|bvAbvj[̕\
			TrackPopupMenu(g_hPopup, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON, pt.x, pt.y, 0, m_hWnd, &rec);
			break;
		}
		return TRUE;
	}
	//c[o[c[`bv|݂ɂ̎idCtrl(wParam)̓j[ACeɂȂiFIDM_OPENj
	if(((LPNMHDR)lParam)->code == TTN_NEEDTEXT) {	//TTN_GETDISPINFOƓ
		((LPTOOLTIPTEXT)lParam)->hinst = m_hInstance;
		char* tag;
		switch(((LPTOOLTIPTEXT)lParam)->hdr.idFrom) {
		case IDM_OPEN:
			tag = "f[^J";
			break;
		case IDM_SAVE:
			tag = "f[^̕ۑ";
			break;
		case IDM_EXIT:
			tag = "I";
			break;
		case IDM_ADD:
			tag = "ǉ";
			break;
		case IDM_SEARCH:
			tag = "";
			break;
		case IDM_EDIT:
			tag = "ҏW";
			break;
		case IDM_DELETE:
			tag = "폜";
			break;
		case IDM_SORT:
			tag = "ёւ";
			break;
		case IDM_HELP:
			tag = "{\tg̎g";
			break;
		case IDM_VERSION:
			tag = "o[W";
			break;
		}
		((LPTOOLTIPTEXT)lParam)->lpszText = tag;
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	//c[o[AXe[^Xo[NCAg̈ɍ킹
	TBar.AutoSize();
	SBar.AutoSize();
	//Ṓulv𒲐g_ListViewNCAg̈ɍ킹
	RECT rec;
	GetClientRect(m_hWnd, &rec);
	g_ListView.m_x = rec.left;
	g_ListView.m_Width = rec.right - rec.left;
	g_ListView.m_Height = rec.bottom - rec.top;
	GetWindowRect(TBar.GetHandle(), &rec);
	g_ListView.m_y = rec.bottom - rec.top;
	g_ListView.m_Height -= g_ListView.m_y;
	GetWindowRect(SBar.GetHandle(), &rec);
	g_ListView.m_Height -= rec.bottom - rec.top;
	g_ListView.Move(g_ListView.m_x, g_ListView.m_y, g_ListView.m_Width, g_ListView.m_Height);
	g_ListView.SetColumn(3, LVCFMT_LEFT, g_ListView.m_Width - 560, "l");
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES) {
		//DestroyWindowAPostQuitMessageĂ΂
		//It@C
		DataSave(m_hWnd, g_File.ToChar());
		//f[^t@CBt@CƂ
		DWORD attrib = GetFileAttributes(g_File.ToChar());	//擾
		attrib |= FILE_ATTRIBUTE_HIDDEN;	//Bt@Cǉ
		SetFileAttributes(g_File.ToChar(), attrib);
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnOpen() {

	//f[^t@C̓ǂݍ
	char* cp = cmndlg.GetFileName(m_hWnd, "datt@C(*.dat)\0*.dat\0SẴt@C(*.*)\0*.*\0\0", TRUE, "dat", ".");
	if(cp) {
		bool cyph = (MessageBox(m_hWnd, "܂H", "", MB_YESNO | MB_ICONQUESTION) == IDYES);
		DataLoad(m_hWnd, cp, cyph);
	}
	else {
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	return TRUE;
}

bool CMyWnd::OnSave() {

	//t@C̕ۑꏊw肷
	char* cp = cmndlg.GetFileName(m_hWnd, "datt@C(*.dat)\0*.dat\00",
						FALSE, "dat", ".");
	if(cp) {
		//t@C̏
		bool cyph = (MessageBox(m_hWnd, "Í܂H", "Í", MB_YESNO | MB_ICONQUESTION) == IDYES);
		DataSave(m_hWnd, cp, cyph);
		return TRUE;
	}
	else {	
		MessageBox(m_hWnd, "LZ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnAdd() {

	//ǉ̏ꍇ́Af[^󂯓npg_DataiCSTRjiNULLjɂ
	g_Data = "";
	//ҏWp_CAOǉp_CAOƂĎg
	if(!editdlg.DoModal(m_hWnd, "IDD_EDIT", editdlgProc) ||
		!*g_Data.ToChar())				//LZꂽꍇA܂
		return FALSE;					//f[^̏ꍇ
	int n = g_ListView.GetItemCount();	//Xg̍ŌmF
	//CSTR g_DatãJ}؂蕶Edit1`4܂łɊi[
	char *cp = GetDelimtStr(g_Data.ToChar());
	g_ListView.InsertItem(n, cp, -1, n);	//LVIF_PARAM\[gׂ̈ɒǉ
	SBar.SetText(1, cp);				//Xe[^Xo[Ƀo[Vbv\
	cp = GetDelimtStr(g_Data.ToChar());
	g_ListView.SetItem(n, 1, cp);
	cp = GetDelimtStr(g_Data.ToChar());
	g_ListView.SetItem(n, 2, cp);
	cp = GetDelimtStr(g_Data.ToChar());
	g_ListView.SetItem(n, 3, cp);
	return TRUE;
}

bool CMyWnd::OnSearch() {

	static CSTR ToFind;					//ۑpϐ
	static int found = 0;				//l͍ŏ
	char buff[MAX_PATH];				//Xg{bNX擾pobt@
	int n = g_ListView.GetItemCount();	//Xg{bNX̍smF
	//擾_CAO
	SBar.SetText(1, "鍀ڂɊ܂܂镶͂Ă");
	searchdlg.DoModal(m_hWnd, "IDD_SEARCH", searchdlgProc);
	//ǑƓłΌp
	if(g_Data != ToFind) {	//قȂ
		ToFind = g_Data;		//XV
		found = 0;			//ŏ猟
		g_ListView.SetItemState(-1, 0, LVIS_SELECTED);	//Ss̑IԂ̉
	}
	for(int i = found; i < n; i++) {		//s
		for(int j = 0; j < 4; j++) {		//
			g_ListView.GetItemText(i, j, buff, MAX_PATH);	//擾
			if(strstr(buff, ToFind.ToChar())) {			//񂪊܂܂
				found = i + 1;				//̌̂߂ɁAs̎w
				SetFocus(g_ListView.m_hWnd);	//g_ListViewɃtH[JXȂƑIԂ\Ȃ
				g_ListView.SetItemState(i, LVIS_SELECTED, LVIS_SELECTED);	//IԂɂ
				return TRUE;
			}
		}
	}
	MessageBox(m_hWnd, "͌܂ł", "", MB_OK | MB_ICONINFORMATION);
	g_ListView.SetItemState(-1, 0, LVIS_SELECTED);	//Ss̑IԂ̉
	return TRUE;
}

bool CMyWnd::OnEdit() {

	int n = g_ListView.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (n == -1) {
		MessageBox(m_hWnd, "ڂIĂ܂", "x", MB_OK);
		return FALSE;
	}
	//CSTR g_Data4̍ڃf[^J}؂Ŋi[
	char buff[MAX_PATH];
	g_ListView.GetItemText(n, 0, buff, MAX_PATH);
	g_Data = buff;
	g_Data = g_Data + ",";
	g_ListView.GetItemText(n, 1, buff, MAX_PATH);
	g_Data = g_Data + buff;
	g_Data = g_Data + ",";
	g_ListView.GetItemText(n, 2, buff, MAX_PATH);
	g_Data = g_Data + buff;
	g_Data = g_Data + ",";
	g_ListView.GetItemText(n, 3, buff, MAX_PATH);
	g_Data = g_Data + "\"";	//ŏIڂ
	g_Data = g_Data + buff;	//񒆂'\n'̂
	g_Data = g_Data + "\"";	//u""vň͂
	//ҏWp_CAOĂяo
	if(!editdlg.DoModal(m_hWnd, "IDD_EDIT", editdlgProc))
		return FALSE;;
	//CSTR g_DataɊi[ꂽJ}؂f[^4̍ڂɊi[
	char *cp = GetDelimtStr(g_Data.ToChar());
	g_ListView.SetItemText(n, 0, cp);
	SBar.SetText(1, cp);
	cp = GetDelimtStr(g_Data.ToChar());
	g_ListView.SetItemText(n, 1, cp);
	cp = GetDelimtStr(g_Data.ToChar());
	g_ListView.SetItemText(n, 2, cp);
	cp = GetDelimtStr(g_Data.ToChar());
	g_ListView.SetItemText(n, 3, cp);
	return TRUE;
}

bool CMyWnd::OnDelete() {

	//IɑΉ
	int n = g_ListView.GetNextItem(-1, LVNI_ALL | LVIS_SELECTED);
	while(n != -1) {
		g_ListView.DeleteItem(n); 
		n = g_ListView.GetNextItem(n - 1, LVNI_ALL | LVIS_SELECTED);
	}
	SBar.SetText(1, "Io[Vbv");	//Xe[^Xo[\ύX

	return TRUE;
}

bool CMyWnd::OnSort() {

	sortdlg.DoModal(m_hWnd, "IDD_SORT", sortdlgProc);
	return TRUE;
}

bool CMyWnd::OnHelp() {

	WinExec(g_HelpFile.ToChar(), SW_SHOWNORMAL);	//g_HelpFileR}hC
	return TRUE;
}

bool CMyWnd::OnVersion() {

	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool EDITDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	if(!*g_Data.ToChar()) {
		SendMsg(WM_SETTEXT, 0, (LPARAM)"IDƃpX[h̒ǉ");
		SendItemMsg(IDOK, WM_SETTEXT, 0, (LPARAM)"o^I");
		return TRUE;
	}
	//GetDelimitStr̓\[XZkĂ܂̂g_Data͕ی삷
	CSTR Data = g_Data;
	//CSTR g_DatãJ}؂蕶Edit1`4܂łɊi[
	char *cp = GetDelimtStr(Data.ToChar());
	SendItemMsg(IDC_EDIT1, WM_SETTEXT, NULL, (LPARAM)cp); 
	cp = GetDelimtStr(Data.ToChar());
	SendItemMsg(IDC_EDIT2, WM_SETTEXT, NULL, (LPARAM)cp); 
	cp = GetDelimtStr(Data.ToChar());
	SendItemMsg(IDC_EDIT3, WM_SETTEXT, NULL, (LPARAM)cp); 
	cp = GetDelimtStr(Data.ToChar());
	SendItemMsg(IDC_EDIT4, WM_SETTEXT, NULL, (LPARAM)cp); 
	return TRUE;
}

bool EDITDLG::OnIdok() {

	//CSTR g_DataɃJ}؂Edit1`4܂ł̕i[
	char buff[MAX_PATH];
	SendItemMsg(IDC_EDIT1, WM_GETTEXT, (WPARAM)MAX_PATH, (LPARAM)buff); 
	g_Data = buff;
	g_Data = g_Data + ",";
	SendItemMsg(IDC_EDIT2, WM_GETTEXT, (WPARAM)MAX_PATH, (LPARAM)buff); 
	g_Data = g_Data + buff;
	g_Data = g_Data + ",";
	SendItemMsg(IDC_EDIT3, WM_GETTEXT, (WPARAM)MAX_PATH, (LPARAM)buff); 
	g_Data = g_Data + buff;
	g_Data = g_Data + ",";
	SendItemMsg(IDC_EDIT4, WM_GETTEXT, (WPARAM)MAX_PATH, (LPARAM)buff); 
	g_Data = g_Data + "\"";	//ŏIڂ
	g_Data = g_Data + buff;	//񒆂'\n'̂
	g_Data = g_Data + "\"";	//u""vň͂
	EndModal(TRUE);
	return TRUE;
}

bool EDITDLG::OnIdcancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool SEARCHDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	SendItemMsg(IDC_EDIT1, WM_SETTEXT, 0, (LPARAM)m_ToFind);
	return TRUE;
}

bool SEARCHDLG::OnIdok() {

	SendItemMsg(IDC_EDIT1, WM_GETTEXT, MAX_PATH, (LPARAM)m_ToFind);
	g_Data = m_ToFind;
	EndModal(TRUE);
	return TRUE;
}

bool SEARCHDLG::OnIdcancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool SORTDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//R{{bNXɕo^
	SendItemMsg(IDC_COMBOBOX1, CB_ADDSTRING, 0, (LPARAM)"o[Vbv");
	SendItemMsg(IDC_COMBOBOX1, CB_ADDSTRING, 0, (LPARAM)"OCID");
	SendItemMsg(IDC_COMBOBOX1, CB_ADDSTRING, 0, (LPARAM)"pX[h");
	SendItemMsg(IDC_COMBOBOX1, CB_ADDSTRING, 0, (LPARAM)"l");
	SendItemMsg(IDC_COMBOBOX1, CB_SETCURSEL, 0, 0);	//ԖڂIԂɂ
	SendItemMsg(IDC_COMBOBOX2, CB_ADDSTRING, 0, (LPARAM)"");
	SendItemMsg(IDC_COMBOBOX2, CB_ADDSTRING, 0, (LPARAM)"~");
	SendItemMsg(IDC_COMBOBOX2, CB_SETCURSEL, 0, 0);	//ԖڂIԂɂ
	return TRUE;
}

bool SORTDLG::OnIdok() {

	//Iԍ̎擾
	int col = SendItemMsg(IDC_COMBOBOX1, CB_GETCURSEL, 0, 0);
	int dir = SendItemMsg(IDC_COMBOBOX2, CB_GETCURSEL, 0, 0);
	//\[gΏۍڂɏA~̃f[^
	sortsubno[col] = dir;
	//\[g
	g_ListView.SortItem(CompProc, col);
	EndModal(TRUE);
	return TRUE;
}

bool SORTDLG::OnIdcancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool VERSIONDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//X^eBbNRg[ɕ\
	SendItemMsg(IDC_VERTXT, WM_SETTEXT,
					0, (LPARAM)"IDList\nVersion 1.0 by YSAMA");
	return TRUE;
}

bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}
