//////////////////////////////////////////
// ListViewProc.h
// Copyright (c) 01/11/2003 by BCCSkelton
//////////////////////////////////////////
/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnCreate(WPARAM wParam, LPARAM lParam) {

	//Xgr[Rg[̍쐬
	lv.Create(m_hWnd, m_hInstance, IDC_LISTVIEW);
	//Xgr[Rg[ɃACRo^
	lv.AddLargeIcon(MAKEINTRESOURCE(MYICON1));
	lv.AddLargeIcon(MAKEINTRESOURCE(MYICON2));
	lv.AddLargeIcon(MAKEINTRESOURCE(MYICON3));
	lv.AddLargeIcon(MAKEINTRESOURCE(MYICON4));
	lv.AddSmallIcon(MAKEINTRESOURCE(S1));
	lv.AddSmallIcon(MAKEINTRESOURCE(S2));
	lv.AddSmallIcon(MAKEINTRESOURCE(S3));
	lv.AddSmallIcon(MAKEINTRESOURCE(S4));
	//̕\쐬
	lv.InsertColumn(0, 100, "");
	lv.InsertColumn(1, 200, "s");
	lv.InsertColumn(2, 100, "");
	//f[^̓o^
	lv.InsertItem(0, "{", 0, 0, LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM);
	lv.SetItem(0, 1, "");
	lv.SetItem(0, 2, "Japanese");
	lv.InsertItem(1, "č", 1, 1, LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM);
	lv.SetItem(1, 1, "Vg");
	lv.SetItem(1, 2, "English");
	lv.InsertItem(2, "p", 2, 2, LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM);
	lv.SetItem(2, 1, "h");
	lv.SetItem(2, 2, "English");
	lv.InsertItem(3, "tX", 3, 3, LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM);
	lv.SetItem(3, 1, "p");
	lv.SetItem(3, 2, "French");
	return TRUE;
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	LV_DISPINFO* lvinfo;
	NM_LISTVIEW* pNMLV;
	static HWND hEdit;
	static char buf[1024];
	//Xgr[̃bZ[W
	if ((int)wParam == IDC_LISTVIEW) {
		lvinfo = (LV_DISPINFO*)lParam;
		switch (lvinfo->hdr.code) {
		//xҏWJn
		case LVN_BEGINLABELEDIT:
			hEdit = lv.GetEditControl();
			break;
		//xҏW
		case LVN_ENDLABELEDIT:
			SendMessage(hEdit, WM_GETTEXT, sizeof(buf), (LPARAM)buf);
			lv.SetItemText(lvinfo->item.iItem, 0, buf);
			break;
		//̕\蕔NbNꂽ
		case LVN_COLUMNCLICK:
			pNMLV = (NM_LISTVIEW*)lParam;
			if (sortsubno[pNMLV->iSubItem] == UP)
				sortsubno[pNMLV->iSubItem] = DOWN;
			else
				sortsubno[pNMLV->iSubItem] = UP;
			lv.SortItem(MyCompProc, pNMLV->iSubItem);
			break;
		}
	}
	return TRUE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	//Xgr[Rg[NCAg̈ɂ킹
	lv.Move(0, 0, LOWORD(lParam), HIWORD(lParam));
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES)
		//DestroyWindowAPostQuitMessageĂ΂
		return TRUE;
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnEnd() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnDel() {

	int count = 0, nItem;
	//IꂽACe̍폜
	while(1) {
		nItem = lv.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
		if (nItem == -1) {
			if(!count)
				MessageBox(m_hWnd, "ڂIĂ܂", "x", MB_OK);
			break;
		}
		lv.DeleteItem(nItem);
		lv.Arrange(LVA_ALIGNLEFT);
		count++;
	}
	return TRUE;
}

bool CMyWnd::OnEdit() {

	//x̕ҏW
	lv.Editable();	//ListViewxҏW\ȃ[hɂ
	int Selected = lv.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (Selected == -1) {
		MessageBox(m_hWnd, "ڂIĂ܂", "x", MB_OK);
		return TRUE;
	}
	lv.EditLabel(Selected);
	return TRUE;
}

bool CMyWnd::OnLarge() {

	//傫ȃACR̕\
	lv.DisplayLarge();
	return TRUE;
}

bool CMyWnd::OnSmall() {

	//ȃACR̕\
	lv.DisplaySmall();
	return TRUE;
}

bool CMyWnd::OnList() {

	//Xg\
	lv.DisplayList();
	return TRUE;
}

bool CMyWnd::OnTable() {

	//|[g`\
	lv.DisplayReport();
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
