//////////////////////
// Replacer.cs
//////////////////////
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Reflection;		//Assemblyg
using System.Resources;			//\[X֌WNX̎gp̈
using System.IO;				//Stream֌WNX̎gp̈
using System.Diagnostics;		//Processgp

///////////////////////////
//Gg[|CgNX
///////////////////////////
class MainApp
{
	[STAThread]
	public static void Main()
	{
		Application.Run(new MainWnd());
	}
}

///////////////////////
//CtH[NX
///////////////////////
public partial class MainWnd : Form
{
	//NXo[ϐ
	string OwnPath;
	MenuItem miRepManu, miRepLog;				//u蓮uvAuOuvj[ACe
	MenuItem miBackUp;							//uobNAbvvj[ACe
	ToolStrip toolStrip;						//c[o[
	ToolStripButton[] toolStripButton;			//c[o[{^
	StatusStrip statusStrip;					//Xe[^Xo[
	ToolStripStatusLabel[] tssl;				//Xe[^Xo[x
	Button SelFile_Btn;							//t@CI{^
	Button SelFolder_Btn;						//tH[_[I{^
	Button Replace_Btn;							//u{^
	TextBox tbPath;								//Path\peLXg{bNX
	TextBox tbToRep;							//peLXg{bNX
	TextBox tbRepWith;							//upeLXg{bNX
	ListView FileList;							//ϊΏۃt@CXgpXgr[
	Label lblSelFolder;							//tH[_[I{^x
	Label lblToRep;								//x
	Label lblRepWith;							//ux

	public MainWnd()
	{
		Assembly myOwn = Assembly.GetEntryAssembly();
		this.Icon = Icon.ExtractAssociatedIcon(myOwn.Location);	//vOACRtH[ɂ
		this.Load += new EventHandler(MainForm_Load);
		this.Text = "ꊇϊ[eBeB";
		this.ClientSize = new Size(480, 341);					//Size = (496, 380);
		this.MinimumSize = new Size(496, 380);					//ŏTCY
		this.BackColor = SystemColors.Window;
	}

	//WM_CREATE
	private void MainForm_Load(object sender, EventArgs e)
	{
		//j[쐬
		SetMenu();
		//c[o[ƃXe[^Xo[쐬
		SetBars();
		//Rg[쐬
		SetControls();
	}

	//WM_CLOSE
	protected override void OnFormClosing(FormClosingEventArgs e)
	{
		base.OnFormClosing(e);
		DialogResult dr = MessageBox.Show("I܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
		if(dr == DialogResult.No)
		{
			e.Cancel = true;
		}
	}

	//j[̐ݒ
	protected void SetMenu()
	{
		//Cj[쐬
		MainMenu menu = new MainMenu();
		Menu = menu;
		//j[ACet
		MenuItem miFile = new MenuItem();		//ut@Cvj[
		miFile.Text = "t@C(&F)";
		miFile.Index = 0;
		menu.MenuItems.Add(miFile);
		MenuItem miReplace = new MenuItem();	//uuvj[
		miReplace.Text = "u(&R)";
		miReplace.Index = 1;
		menu.MenuItems.Add(miReplace);
		MenuItem miHelp = new MenuItem();		//uwvvj[
		miHelp.Text = "wv(&H)";
		miHelp.Index = 2;
		menu.MenuItems.Add(miHelp);
		MenuItem miOpen = new MenuItem();		//uOt@CJvj[ACe
		miOpen.Text = "Ot@CJ(&O)";
		miOpen.Index = 0;
		miOpen.Click += OnOpen_Click;
		miOpen.Shortcut = Shortcut.CtrlO;
		miFile.MenuItems.Add(miOpen);
		miFile.MenuItems.Add("-");				//Zp[^[
		MenuItem miExit = new MenuItem();		//uIvj[ACe
		miExit.Text = "I(&X)";
		miExit.Index = 1;
		miExit.Click += OnExit_Click;
		miExit.Shortcut = Shortcut.CtrlX;
		miFile.MenuItems.Add(miExit);
		miRepManu = new MenuItem();				//u蓮uvj[ACe
		miRepManu.Text = "蓮u(&M)";
		miRepManu.Index = 0;
		miRepManu.Click += OnRepManu_Click;
		miRepManu.Shortcut = Shortcut.CtrlM;
		miReplace.MenuItems.Add(miRepManu);
		miRepLog = new MenuItem();				//uOuvj[ACe
		miRepLog.Text = "Ou(&C)";
		miRepLog.Index = 1;
		miRepLog.Click += OnRepLog_Click;
		miRepLog.Shortcut = Shortcut.CtrlC;
		miReplace.MenuItems.Add(miRepLog);
		miRepLog.Enabled = false;				//l͖
		miReplace.MenuItems.Add("-");			//Zp[^[
		miBackUp = new MenuItem();				//uݒvj[ACe
		miBackUp.Text = "obNAbv(&B)";
		miBackUp.Index = 2;
		miBackUp.Click += OnSetUp_Click;
		miBackUp.Checked = true;					//j[ڂɃ_
		miBackUp.Shortcut = Shortcut.CtrlS;
		miReplace.MenuItems.Add(miBackUp);
		MenuItem miHowtoUse = new MenuItem();	//ugvj[ACe
		miHowtoUse.Text = "g(&U)";
		miHowtoUse.Index = 0;
		miHowtoUse.Click += OnHowtoUse_Click;
		miHowtoUse.Shortcut = Shortcut.CtrlU;
		miHelp.MenuItems.Add(miHowtoUse);
		MenuItem miVer = new MenuItem();		//uo[Wvj[ACe
		miVer.Text = "o[W(&V)";
		miVer.Index = 1;
		miVer.Click += OnVersion_Click;
		miVer.Shortcut = Shortcut.CtrlV;
		miHelp.MenuItems.Add(miVer);
	}

	//c[o[ƃXe[^Xo[̐ݒ
	protected void SetBars()
	{
		//tH[̃CAEgꎞ~
		this.SuspendLayout();
		///////////////////////////////////
		//c[o[ƃXe[^Xo[̔zu
		///////////////////////////////////
		//ToolStripNXCX^X̐
		this.toolStrip = new ToolStrip();
		//c[o[̃CAEgꎞ~
		this.toolStrip.SuspendLayout();
		//ToolStripButtonz쐬
		this.toolStripButton = new ToolStripButton[12];
		//{vO̖ߍ݃\[X̃\[X}l[W[쐬
		Assembly asm = Assembly.GetExecutingAssembly();
		ResourceManager rm = new ResourceManager("Replacer", asm);
		//c[o[rbg}bv̓ǂݍ
		ImageList imgList = new ImageList();
		imgList.ImageSize = new Size(16, 15);
		imgList.Images.AddStrip((Bitmap)rm.GetObject("ToolBar"));
		imgList.TransparentColor = Color.White;
		//ToolStripButton[0]쐬
		this.toolStripButton[0] = new ToolStripButton();
		this.toolStripButton[0].Text = "J(&O)";								//eLXgݒ
		this.toolStripButton[0].Image = (Bitmap)imgList.Images[0];				//摜ݒ
		this.toolStripButton[0].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[0].Click += OnOpen_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[0]);						//{^ǉ
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[1]쐬
		this.toolStripButton[1] = new ToolStripButton();
		this.toolStripButton[1].Text = "I(&X)";								//eLXgݒ
		this.toolStripButton[1].Image = (Bitmap)imgList.Images[1];				//摜ݒ
		this.toolStripButton[1].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[1].Click += OnExit_Click;							//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[1]);						//{^ǉ
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[2]쐬
		this.toolStripButton[2] = new ToolStripButton();
		this.toolStripButton[2].Text = "蓮u(&R)";							//eLXgݒ
		this.toolStripButton[2].Image = (Bitmap)imgList.Images[2];				//摜ݒ
		this.toolStripButton[2].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[2].Click += OnRepManu_Click;						//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[2]);						//{^ǉ
		//ToolStripButton[3]쐬
		this.toolStripButton[3] = new ToolStripButton();
		this.toolStripButton[3].Text = "Ou(&R)";							//eLXgݒ
		this.toolStripButton[3].Image = (Bitmap)imgList.Images[3];				//摜ݒ
		this.toolStripButton[3].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[3].Click += OnRepLog_Click;						//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[3]);						//{^ǉ
		this.toolStripButton[3].Enabled = false;								//Ԃ͖
		//Zp[^[}
		this.toolStrip.Items.Add(new ToolStripSeparator());
		//ToolStripButton[4]쐬
		this.toolStripButton[4] = new ToolStripButton();
		this.toolStripButton[4].Text = "g(&U)";							//eLXgݒ
		this.toolStripButton[4].Image = (Bitmap)imgList.Images[4];				//摜ݒ
		this.toolStripButton[4].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[4].Click += OnHowtoUse_Click;						//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[4]);						//{^ǉ
		//ToolStripButton[5]쐬
		this.toolStripButton[5] = new ToolStripButton();
		this.toolStripButton[5].Text = "o[W(&V)";					//eLXgݒ
		this.toolStripButton[5].Image = (Bitmap)imgList.Images[5];				//摜ݒ
		this.toolStripButton[5].DisplayStyle = ToolStripItemDisplayStyle.Image;	//摜\̂
		this.toolStripButton[5].Click += OnVersion_Click;						//ClickCxgnhǉ
		this.toolStrip.Items.Add(this.toolStripButton[5]);						//{^ǉ
		//c[o[̐ݒ
		this.Controls.Add(this.toolStrip);
		//c[o[̃CAEgĊJ
		this.toolStrip.ResumeLayout(false);
		this.toolStrip.PerformLayout();

		//StatusStripNXCX^X̐
		this.statusStrip = new StatusStrip();
		//Xe[^Xo[̃CAEgꎞ~
		this.statusStrip.SuspendLayout();
		//Xe[^Xo[ɃplƃeLXgǉ
		tssl = new ToolStripStatusLabel[3];
		tssl[0] = new ToolStripStatusLabel();
		tssl[0].BorderSides = ToolStripStatusLabelBorderSides.All;
		tssl[0].BorderStyle = Border3DStyle.SunkenInner;
		tssl[0].BackColor = SystemColors.Control;
		tssl[0].Text = "Replacer Ver. 1.0";
		tssl[0].AutoSize = true;
		tssl[0].TextAlign = ContentAlignment.MiddleLeft;
		tssl[1] = new ToolStripStatusLabel();
		tssl[1].BorderSides = ToolStripStatusLabelBorderSides.All;
		tssl[1].BorderStyle = Border3DStyle.SunkenInner;
		tssl[1].BackColor = SystemColors.Control;
		tssl[1].Text = "蓮u";
		tssl[1].ToolTipText = "蓮u";				//ToolTipݒ
		tssl[1].AutoSize = true;
		tssl[1].TextAlign = ContentAlignment.MiddleLeft;
		tssl[2] = new ToolStripStatusLabel();
		tssl[2].BorderSides = ToolStripStatusLabelBorderSides.All;
		tssl[2].BorderStyle = Border3DStyle.SunkenInner;
		tssl[2].BackColor = SystemColors.Control;
		tssl[2].Text = "iOt@Cj";
		tssl[2].ToolTipText = "iOt@Cj";		//ToolTipݒ
		tssl[2].Spring = true;
		tssl[2].TextAlign = ContentAlignment.MiddleLeft;
		statusStrip.Items.AddRange(tssl);
		statusStrip.ShowItemToolTips = true;			//ToolTip\
		this.Controls.Add(this.statusStrip);			//StatusStrip(Xe[^Xo[)ǉ
		//Xe[^Xo[̃CAEgĊJ
		this.statusStrip.ResumeLayout(false);
		this.statusStrip.PerformLayout();
		//CtH[̃CAEgĊJ
		this.ResumeLayout(false);
		this.PerformLayout();
	}

	//Rg[̐ݒ
	protected void SetControls()
	{
		/////////////////////
		//Rg[̔zu
		/////////////////////
		//t@CI{^
		SelFile_Btn = new Button();
		SelFile_Btn.Size = new Size(140, 30);
		SelFile_Btn.Location = new Point(10, toolStrip.Height + 10);
		SelFile_Btn.Anchor = (AnchorStyles.Top | AnchorStyles.Left);
		SelFile_Btn.Text = "Ώۃt@CI";
		SelFile_Btn.Image = toolStripButton[0].Image;
		SelFile_Btn.TextImageRelation = TextImageRelation.ImageBeforeText;
		SelFile_Btn.TabStop = true;
		SelFile_Btn.TabIndex = 0;
		SelFile_Btn.Click += OnSelFile_Btn_Click;
		this.Controls.Add(SelFile_Btn);
		//tH[_[I{^x
		lblSelFolder = new Label();
		lblSelFolder.Size = new Size(200, 30);
		lblSelFolder.Location = new Point(this.ClientSize.Width - lblSelFolder.Width, toolStrip.Height + 5);
		lblSelFolder.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
		lblSelFolder.Text = "tH[_[St@CI\r\ni폜ɂ̓NbNōsIj";
		lblSelFolder.TextAlign = ContentAlignment.MiddleCenter;
		lblSelFolder.TabStop = false;
		this.Controls.Add(lblSelFolder);
		//tH[_[I{^
		SelFolder_Btn = new Button();
		SelFolder_Btn.Size = new Size(30, 30);
		SelFolder_Btn.Location = new Point(this.ClientSize.Width - SelFolder_Btn.Width - 10, toolStrip.Height + SelFile_Btn.Height + 5);
		SelFolder_Btn.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
		SelFolder_Btn.Image = toolStripButton[0].Image;
		SelFolder_Btn.TabStop = true;
		SelFolder_Btn.TabIndex = 1;
		SelFolder_Btn.Click += OnSelFolder_Btn_Click;
		this.Controls.Add(SelFolder_Btn);
		//Path\peLXg{bNX
		tbPath = new TextBox();
		tbPath.Size = new Size(ClientSize.Width - SelFolder_Btn.Width - 25, 20);
		tbPath.Location = new Point(10, toolStrip.Height + SelFile_Btn.Height + 15);
		tbPath.Anchor = (AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right);
		tbPath.Text = "";
		tbPath.ReadOnly = true;
		tbPath.TabStop = false;
		this.Controls.Add(tbPath);
		//Xgr[̐ƃvpeB̐ݒ
		//https://dot-sharp.com/csharp-listview-event-order/
		FileList = new ListView();
		FileList.Size = new Size(ClientSize.Width - 20, ClientSize.Height - 170);	//TCY
		FileList.Location = new Point(10,  toolStrip.Height + SelFile_Btn.Height + tbPath.Height + 20);	//ʒu
		FileList.Anchor = (AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right);
		FileList.FullRowSelect = true;					//sI
		FileList.GridLines = true;						//ObhC̕\
		FileList.Sorting = SortOrder.Ascending;			//ёւ\
		FileList.HoverSelection = false;				//|CgőIł悤ɂ
		FileList.Activation = ItemActivation.OneClick;	//VONbNI
		FileList.CheckBoxes = false;					//`FbN{bNXL
		FileList.View = View.Details;					//Xgr[̕\@
		FileList.TabStop = false;
		FileList.ItemActivate += new EventHandler(OnListView_ItemActivate);
		//wb_[`
		FileList.Columns.Add("t@C", 380, HorizontalAlignment.Left);
		FileList.Columns.Add("ϊ", 76, HorizontalAlignment.Left);
		FileList.Columns.Add("ڍ", 540, HorizontalAlignment.Left);
		//FormListViewǉ
		this.Controls.Add(FileList);
		//ux
		lblRepWith = new Label();
		lblRepWith.Location = new Point(10, ClientSize.Height - statusStrip.Height - lblRepWith.Height);
		lblRepWith.Size = new Size(75, 20);
		lblRepWith.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left);
		lblRepWith.Text = "u";
		lblRepWith.TextAlign = ContentAlignment.MiddleLeft;
		lblRepWith.TabStop = false;
		this.Controls.Add(lblRepWith);
		//x
		lblToRep = new Label();
		lblToRep.Location = new Point(10, ClientSize.Height - statusStrip.Height - lblToRep.Height - lblRepWith.Height);
		lblToRep.Size = new Size(75, 20);
		lblToRep.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left);
		lblToRep.Text = "";
		lblToRep.TextAlign = ContentAlignment.MiddleLeft;
		lblToRep.TabStop = false;
		this.Controls.Add(lblToRep);
		//u{^
		Replace_Btn = new Button();
		Replace_Btn.Size = new Size(70, 35);
		Replace_Btn.Location = new Point(this.ClientSize.Width - Replace_Btn.Width - 10, ClientSize.Height - statusStrip.Height - Replace_Btn.Height - 7);
		Replace_Btn.Anchor = (AnchorStyles.Bottom | AnchorStyles.Right);
		Replace_Btn.Image = toolStripButton[2].Image;
		Replace_Btn.TabStop = true;
		Replace_Btn.TabIndex = 4;
		Replace_Btn.Click += OnReplace_Btn_Click;
		this.Controls.Add(Replace_Btn);
		//upeLXg{bNX
		tbRepWith = new TextBox();
		tbRepWith.Location = new Point(85, ClientSize.Height - statusStrip.Height - tbRepWith.Height - 5);
		tbRepWith.Size = new Size(ClientSize.Width - Replace_Btn.Width - lblRepWith.Width - 25, 20);
		tbRepWith.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right);
		tbRepWith.Text = "";
		tbRepWith.TabStop = true;
		tbRepWith.TabIndex = 3;
		this.Controls.Add(tbRepWith);
		//peLXg{bNX
		tbToRep = new TextBox();
		tbToRep.Location = new Point(85, ClientSize.Height - statusStrip.Height - tbToRep.Height - tbRepWith.Height - 5);
		tbToRep.Size = new Size(ClientSize.Width - Replace_Btn.Width - lblToRep.Width - 25, 20);
		tbToRep.Anchor = (AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right);
		tbToRep.Text = "";
		tbToRep.TabStop = true;
		tbToRep.TabIndex = 2;
		this.Controls.Add(tbToRep);
	}

	///////////////////////////////////
	//j[Ac[o[֘A\bh
	///////////////////////////////////
	//uOt@CJv
	private void OnOpen_Click(object sender, EventArgs e)
	{
		DialogResult dr = MessageBox.Show("Ot@CJ܂Hiu͂vj\r\nƂẴt@CłHiuvj\r\n͒~܂HiuLZvj", "t@CފmF", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
		OpenFileDialog ofDlg = new OpenFileDialog();
		ofDlg.AddExtension = true;		//gqt
		switch(dr)
		{
		case DialogResult.Yes:
			ofDlg.FileName = "*.log";	//gq
			ofDlg.FilterIndex = 1;		//t@CtB^[CfbNX
			break;
		case DialogResult.No:
			ofDlg.FileName = "*.*";		//gq
			ofDlg.FilterIndex = 2;		//t@CtB^[CfbNX
			break;
		default:
			return;
		}
		//t@CtB^[̎w
		ofDlg.Filter = "Ot@C(*.log)|*.log|Ẵt@C(*.*)|*.*";
		ofDlg.RestoreDirectory = true;	//fBNg֕A
		ofDlg.CheckFileExists = true;	//t@C̑݃`FbN
		ofDlg.CheckPathExists = true;	//t@CpX̑݃`FbN
		ofDlg.InitialDirectory = ".";	// ftHg̃tH_[̎w
		ofDlg.Title = "t@CJ";	//_CAÕ^Cgw肷
		if(ofDlg.ShowDialog() == DialogResult.OK)	//_CAO\
		{
			SwitchManuLog(true);		//uOuvݒɂ
			tssl[2].ToolTipText = tssl[2].Text = ofDlg.FileName;	//Xe[^Xo[ɃOt@C\
		}
		else
		{
			MessageBox.Show("LZ܂B", "LZ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
		}
		// IuWFNgj
		ofDlg.Dispose();
	}

	//uIv
	private void OnExit_Click(object sender, EventArgs e)
	{
		Close();	//CmFOnClosing\bhōs
	}

	//u蓮uv
	private void OnRepManu_Click(object sender, EventArgs e)
	{
		if(String.IsNullOrEmpty(tbToRep.Text))
			MessageBox.Show("񂪓͂Ă܂","G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
		else
			RepFilesInLV(tbToRep.Text, tbRepWith.Text);	//uvAuuveLXg{bNXŏ
	}

	//uOuvit@Cɂob`j
	private void OnRepLog_Click(object sender, EventArgs e)
	{
		//ŏI̎smFs
		DialogResult res = MessageBox.Show("{ɃOus܂H", "ŏImF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
		if(res == DialogResult.Yes)
		{
			//Ot@CiesJ}؂2̕csvt@Cjɂu
			Encoding enc = Encoding.GetEncoding("shift_jis");	//Sift-JISIĂ邪AύX\
			//Ot@CiFile.ReadAllText(tssl[2].Text̓t@Cjǂ
			StringReader sr = new StringReader(File.ReadAllText(tssl[2].Text, enc));
			string line = string.Empty;			//sf[^ǂݍݗpϐ
			while(true)							//[v
			{
				line = sr.ReadLine();
				if(String.IsNullOrEmpty(line))	//`FbN
					break;
				else							//sf[^ꍇ
				{
					try							//sR[hi0X0D0Ajϊ]Ńf[^sȊO蔲ꍇ
					{
						//line.Contains(',')ŁulnulvG[郊XN
						if(!line.Contains(','))	//f[^sۂ̃`FbNiJ}ΏIj
							break;
						//uIndexz񋫊EOvG[XNΏ
						string[] words = line.Split(',');
						RepFilesInLV((tbToRep.Text = words[0]), (tbRepWith.Text = words[1]));
					}
					catch	//G[̓[v𔲂o
					{
						break;
					}
				}
			}
			sr.Close();
		}
		tssl[2].ToolTipText = tssl[2].Text = "iOt@Cj";	//Xe[^Xo[̃t@C\
		SwitchManuLog(false);				//u蓮uvݒɂ
		Replace_Btn.Enabled = true;			//u{^ALɂ
	}

	//uobNAbvv
	private void OnSetUp_Click(object sender, EventArgs e)
	{
		if(miBackUp.Checked)
			miBackUp.Checked = false;
		else
			miBackUp.Checked = true;
	}

	//ugv
	private void OnHowtoUse_Click(object sender, EventArgs e)
	{
		OwnPath = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);	//g̃pX擾
		//Process.Start("t@C", "");
		ProcessStartInfo processInfo = new ProcessStartInfo
		{
			FileName = "hh",
			Arguments = OwnPath + @"\ReplacerHelp.chm"
		};
		Process.Start(processInfo);

	}

	//uo[Wv
	private void OnVersion_Click(object sender, EventArgs e)
	{
		VersionDlg verDlg = new VersionDlg(this.Icon);	//o[W_CAO̕\
		verDlg.ShowDialog();
		verDlg.Dispose();
	}

	///////////////////////////
	//Rg[֘A\bh
	///////////////////////////
	//ut@CJv
	private void OnSelFile_Btn_Click(object sender, EventArgs e)
	{
		DialogResult dr = MessageBox.Show("ւ܂i͂jA܂\r\nǉ܂ijH", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
		if(dr == DialogResult.Yes)
		{
			FileList.Items.Clear();	//ւ̏ꍇAXgr[̍ڂS폜
		}
		OpenFileDialog ofDlg = new OpenFileDialog();
		ofDlg.FileName = "*.*";						//t@C̎w
		ofDlg.Filter = "C#t@C(*.cs)|*.cs|ׂẴt@C(*.*)|*.*";	//t@CtB^[̎w
		ofDlg.FilterIndex = 2;						//t@CtB^[CfbNX̎w
		ofDlg.RestoreDirectory = true;				//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
		ofDlg.CheckFileExists = true;				//݂Ȃt@C̖Ow肳ꂽƂx\
		ofDlg.CheckPathExists = true;				//݂ȂpXw肳ꂽƂx\
		ofDlg.Multiselect = true;					//t@C̑Is
		ofDlg.InitialDirectory = @".\";				// ftHg̃tH_w肷
		ofDlg.Title = "t@CJ";				//_CAÕ^Cgw肷
		if(ofDlg.ShowDialog() == DialogResult.OK)	//_CAO\
		{
			foreach(string fn in ofDlg.FileNames)	//It@CRNV̕\
			{
				ListViewItem item = FileList.Items.Add(Path.GetFileName(fn));
				item.SubItems.Add("0");
				item.SubItems.Add(fn);
			}
 		}
		else
		{
			MessageBox.Show("LZ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}
		// IuWFNgj
		ofDlg.Dispose();
	}

	//utH[_[Jv
	private void OnSelFolder_Btn_Click(object sender, EventArgs e)
	{
		DialogResult dr = MessageBox.Show("ւ܂i͂jA܂\r\nǉ܂ijH", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
		if(dr == DialogResult.Yes)
		{
			FileList.Items.Clear();	//ւ̏ꍇAXgr[̍ڂS폜
		}
		FolderBrowserDialog fbDlg = new FolderBrowserDialog();
		fbDlg.Description = "Ώۃt@ĈtH_[IĂB";	// _CAO̐
		fbDlg.SelectedPath = ".\\";					// ftHg̃tH_[
		if(fbDlg.ShowDialog() == DialogResult.OK)	//tH_I_CAO\
		{
			tbPath.Text = fbDlg.SelectedPath;		//upXveLXg{bNXɕ\
			//tH_̃t@C\
		 	IEnumerable<string> files = Directory.EnumerateFiles(fbDlg.SelectedPath, "*", SearchOption.TopDirectoryOnly);
			foreach (string fn in files)			//tH[_[t@C̕\
			{
				ListViewItem item = FileList.Items.Add(Path.GetFileName(fn));
				item.SubItems.Add("0");
				item.SubItems.Add(fn);
			}
		}
		else
		{
			MessageBox.Show("LZ܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}
		// IuWFNgj
		fbDlg.Dispose();
	}

	//us폜v
	private void OnListView_ItemActivate(object sender, EventArgs e)
	{
		ListView lv = (ListView)sender;
		//ACeANeBuɂȂ
		DialogResult dr = MessageBox.Show("I" + lv.FocusedItem.Text + "폜܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
		if(dr == DialogResult.Yes)
		{
			//tH[JX̂ACe폜
			lv.FocusedItem.Remove();
		}
	}

	//uu{^v
	private void OnReplace_Btn_Click(object sender, EventArgs e)
	{
		if(tssl[2].Text == "iOt@Cj")	//Kl̏ꍇ蓮u
		{
			OnRepManu_Click(sender, e);
		}
		else										//Ou
		{
			Replace_Btn.Enabled = false;			//̃{^ςނ܂Ŗɂ
			OnRepLog_Click(sender, e);
		}
	}

	//u蓮uvAuOuv[h̐؂ւ
	private void SwitchManuLog(bool flag)				//true|uOuvAfalse|u蓮uv
	{
		if(flag)
		{
			miRepManu.Enabled = false;					//蓮uj[𖳌ɂ
			miRepLog.Enabled = true;					//Ouj[Lɂ
			toolStripButton[2].Enabled = false;			//蓮u{^𖳌ɂ
			toolStripButton[3].Enabled = true;			//Ou{^Lɂ
			tssl[1].Text = "Ou";					//Xe[^Xo[\
			tssl[1].ToolTipText = "Ou";			//Xe[^Xo[ToolTipݒ
			tbRepWith.Text = "";						//eLXg{bNX
			tbRepWith.Enabled = false;					//eLXg{bNX𖳌ɂ
			tbToRep.Text = "";							//ueLXg{bNX
			tbToRep.Enabled = false;					//ueLXg{bNX𖳌ɂ
			Replace_Btn.Image = (Bitmap)toolStripButton[3].Image;	//{^C[W̕ύX
		}
		else
		{
			miRepManu.Enabled = true;					//蓮uj[Lɂ
			miRepLog.Enabled = false;					//Ouj[𖳌ɂ
			toolStripButton[2].Enabled = true;			//蓮u{^Lɂ
			toolStripButton[3].Enabled = false;			//Ou{^𖳌ɂ
			tssl[1].Text = "蓮u";					//Xe[^Xo[\
			tssl[1].ToolTipText = "蓮u";			//Xe[^Xo[ToolTipݒ
			tbRepWith.Text = "";						//eLXg{bNX
			tbRepWith.Enabled = true;					//eLXg{bNX𖳌ɂ
			tbToRep.Text = "";							//ueLXg{bNX
			tbToRep.Enabled = true;						//ueLXg{bNX𖳌ɂ
			Replace_Btn.Image = (Bitmap)toolStripButton[2].Image;	//{^C[W̕ύX
		}
	}

	/////////////////////////////////
	//t@Cu֘A\bh
	/////////////////////////////////
	//Xg{bNX̃t@C̒us
	private void RepFilesInLV(string ToRep, string RepWith)
	{
		foreach(ListViewItem item in FileList.Items)
		{
			//IWit@C̃obNAbv쐬
			string backup = Path.ChangeExtension(item.SubItems[2].Text, ".bak");
			if(miBackUp.Checked)
				File.Copy(item.SubItems[2].Text, backup, true);	//3Ԗڂ̈ɁAt@CIOG[ƂȂ
			//IWit@C̕ύX
			int n = CountFindRepInFile(item.SubItems[2].Text, ToRep, RepWith);
			if(n > 0)
				item.SubItems[1].Text = n.ToString();	//ϊ񐔂\
			else	//ϊȂꍇA쐬obNAbv폜
				File.Delete(backup);
		}
	}

	//t@C̕ui܂͌j񐔂Ԃ
	private int CountFindRepInFile(string filename, string ToRep, string RepWith)
	{
		//eLXgt@C̒gׂēǂݍ
		string str = string.Empty;		//t@Cǂݍݗpϐ
		using (StreamReader sr = new StreamReader(filename, Encoding.GetEncoding("shift_jis")))	// VtgJIS̃eLXgp
	//	using (StreamReader sr = new StreamReader(filename))	// UTF-8̃eLXgp
		{
			str = sr.ReadToEnd();	// t@C̃f[^uׂāv擾
			sr.Close();
		}
		int count = CountFindRep(ref str, ToRep, RepWith);
		using (StreamWriter sw = new StreamWriter(filename, false, Encoding.GetEncoding("shift_jis")))	// VtgJIS̃eLXg㏑ifalsejp|trueAppend
		{
			sw.Write(str);
			sw.Close();
		}
		return count;
	}

	//ui܂͌j񐔂Ԃ|ŏ̌Ώە͒û̂ƂȂ
	private int CountFindRep(ref string str, string ToRep, string RepWith = "")
	{
		int position, count = 0;
		position = str.IndexOf(ToRep, 0);
		while(position != -1)
		{
			count++;
			position = str.IndexOf(ToRep, position + 1);
		}
		if(!String.IsNullOrEmpty(RepWith))
			str = str.Replace(ToRep, RepWith);
		return count;
	}
}

/////////////////////
//Version _CAO
/////////////////////
class VersionDlg : Form
{
	public VersionDlg(Icon ico)
	{
		//_CAȎݒ
		this.Text = "o[V";
		this.ClientSize = new Size(320, 100);
		this.MaximizeBox = false;		// ő剻{^
		this.MinimizeBox = false;		// ŏ{^
		this.ShowInTaskbar = false;		//^XNo[\
		this.FormBorderStyle = FormBorderStyle.FixedDialog;		// ẼX^C
		this.StartPosition = FormStartPosition.CenterParent;	// etH[̒ɔzu
		//Rg[̑ݒ
		Button btnOK = new Button();
		btnOK.Size = new Size(40, 28);
		btnOK.Location = new Point(ClientSize.Width - btnOK.Width - 10, (ClientSize.Height - btnOK.Height) / 2);
		btnOK.Text = "OK";
		btnOK.Click += new EventHandler(OnOK_Click);
		Label imglabel = new Label();
		imglabel.Size = new Size(40, 40);
		imglabel.Location = new Point(10, (ClientSize.Height - imglabel.Height) / 2);
		imglabel.BorderStyle = BorderStyle.Fixed3D;
		imglabel.Image = ico.ToBitmap();	//ẽVXeACR
		Label label = new Label();
		label.Size = new Size(ClientSize.Width - imglabel.Width - btnOK.Width - 40, ClientSize.Height- 20);
		label.Location = new Point(imglabel.Width + 20, (ClientSize.Height - label.Height) / 2);
		label.BorderStyle = BorderStyle.Fixed3D;
		label.Text = "Replacer Version 1.0\r\nCopyright (c) 2023 by MS C# and Ysama\r\n";
		label.TextAlign = ContentAlignment.MiddleCenter;
		label.Font = new Font("Times New Roman", 10, FontStyle.Bold);
		this.Controls.Add(btnOK);
		this.Controls.Add(imglabel);
		this.Controls.Add(label);
	}

	private void OnOK_Click(object sender, EventArgs e)
	{
		Close();
	}
}
