/////////////////////////////////////////////
// GameWindow_Base.cpp
// OpenTKGameWindowŎgꍇ̃XPg
// Copyrignt (c) 2024 byYsama
/////////////////////////////////////////////
using System;
using OpenTK;						//OpenTKgpۂɕK{
using OpenTK.Graphics;				//OpenTK̃OtBbNgpۂɕK{
using OpenTK.Graphics.OpenGL;		//OpenGLgpۂɕKv
using OpenTK.Input;					//OpenTKœ͂sۂɕKviFKeyboiardj

namespace GameWindow_Base
{
	//AvP[VNX
	public class App
	{
		[STAThread]
		public static void Main()
		{
			gWindow gw= new gWindow();
			gw.Run();
		}
	}

	class gWindow : GameWindow	//GameWindowNX烆[U[EBhEh
	{
		public gWindow() : base(640, 480, GraphicsMode.Default, "OpenTK GameWindow")	//
		{
		}

		//EBhE̋NɎs
		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);								//菈
			GL.ClearColor(Color4.Black);				//ʏF̐ݒ
			GL.Enable(EnableCap.DepthTest);				//[x`FbNL
		}

		//EBhẼTCYύXꂽꍇɎs
		protected override void OnResize(EventArgs e)
		{
			base.OnResize(e);							//菈
			//r[|[g̐ݒ
			GL.Viewport(0, 0, ClientRectangle.Width, ClientRectangle.Height);
			//Ԃ̐ݒ
			SetProjection();
		}

		//EBhECxgXVꂽꍇɎsiOnRenderFramȇOɎsj
		protected override void OnUpdateFrame(FrameEventArgs e)
		{
			base.OnUpdateFrame(e);
			//ESCL[ꂽI
			if(Keyboard.GetState().IsKeyDown(Key.Escape))
			{
				Exit();
			}
		}

		//EBhE`悪XVꂽꍇɎs
		protected override void OnRenderFrame(FrameEventArgs e)
		{
			base.OnRenderFrame(e);						//菈
			GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);
			SetModelView();								//fr[[hŎ_ݒ肵Č_(0, 0, 0)
			//ȉɕ`揈s
			GL.Begin(PrimitiveType.Quads);
				GL.Color4(Color4.White);							//FŎ
				GL.Vertex3(-1.0f, 1.0f, 0.0f);
				GL.Color4(new float[] { 1.0f, 0.0f, 0.0f, 1.0f });	//zœ
				GL.Vertex3(-1.0f, -1.0f, 0.0f);
				GL.Color4(0.0f, 1.0f, 0.0f, 1.0f);					//4̈float^œ
				GL.Vertex3(1.0f, -1.0f, 0.0f);
				GL.Color4((byte)0, (byte)0, (byte)255, (byte)255);  //byte^œ
				GL.Vertex3(1.0f, 1.0f, 0.0f);
			GL.End();
			//obt@[ϊ
			SwapBuffers();
		}

		private void SetProjection()
		{
			//Ԃ̐ݒ
			GL.MatrixMode(MatrixMode.Projection);
			//e
			Matrix4 projection = Matrix4.CreatePerspectiveFieldOfView((float)Math.PI / 4, (float)Width / (float)Height, 0.1f, 64.0f);	//glPerspective(fov, aspect, near, far);
			GL.LoadMatrix(ref projection);
		}

		void SetModelView(float x = 0.0f, float y = 0.0f, float z = 5.0f)
		{
			GL.MatrixMode(MatrixMode.Modelview);	//fr[I
			//_ݒ肵Č_(0, 0, 0)
			Vector3 eye = new Vector3(x, y, z);
			Matrix4 modelview = Matrix4.LookAt(eye, Vector3.Zero, Vector3.UnitY);	//gluLookAt(0, 0, 5, 0, 0, 0, 0, 1, 0);
			GL.LoadMatrix(ref modelview);			//݂̕ϊ}gbNXɐݒ
		}

		void SetLight(float x = 50.0f, float y = 50.0f, float z = 10.0f)
		{
			//̎gp
			GL.Enable(EnableCap.Lighting);
			//Cg0̐ݒ
			GL.Enable(EnableCap.Light0);
			float[] pos = new float[] {x, y, z, 0.0f };
			GL.Light(LightName.Light0, LightParameter.Position, pos);
		}
	}
}
