///////////////////////////////////////
// ResWriter.cs - Resource File Writer
// Copyright (c) 2022 by Ysama
///////////////////////////////////////

using System;
using System.Collections;
using System.Drawing;
using System.Windows.Forms;
using System.Reflection;		//Assemblyg
using System.Drawing.Imaging;	//ImageIuWFNĝ
using System.Resources;			//\[X֌WNX̎gp̈
using System.IO;				//Stream֌WNX̎gp̈
using System.Text;				//Encodinggp̈

class ResWriter : Form
{
	//o̓t@C
	string Res_FileName = "";	//*.resourcet@C
	string ResX_FileName = "";	//*.resxt@C
	//tH[֘ANXo[ϐ
	Button Btn_Add;				//\[Xǉ{^
	Button Btn_Del;				//\[X폜{^
	Button Btn_Edit;			//\[XҏW{^
	Button Btn_Gen;				//\[Xt@C쐬{^
	Button Btn_Init;			//{^
	Button Btn_Exit;			//I{^
	ListView listView;			//Xgr[

	[STAThread]
	public static void Main()
	{
		Application.Run(new ResWriter());
	}

	//RXgN^[
	public ResWriter()
	{
		Assembly myOwn = Assembly.GetEntryAssembly();
		Icon = Icon.ExtractAssociatedIcon(myOwn.Location);	//vOACRtH[ɂ
		Load += new EventHandler(Form_Load);
		Text = "ResWriter";
		ClientSize = new Size(724, 262);
		MinimumSize = new Size(362, 294);
		BackColor = SystemColors.Window;
		AllowDrop = true;
	}

	//WM_CREATE
	protected void Form_Load(object sender, EventArgs e)
	{
		Btn_Add = new Button();
		Btn_Add.Text = "\[X̒ǉ";
		Btn_Add.TextAlign = ContentAlignment.MiddleCenter;
		Btn_Add.Font = new Font("lr ", 8);
		Btn_Add.ForeColor = Color.Black;
		Btn_Add.Size = new Size(100, 32);
		Btn_Add.BackColor = SystemColors.Control;
		Btn_Add.Location = new Point(ClientSize.Width - Btn_Add.Width - 10, 10);
		Btn_Add.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
		Btn_Add.Click += new EventHandler(OnClick_Add);

		Btn_Del = new Button();
		Btn_Del.Text = "\[X̍폜";
		Btn_Del.TextAlign = ContentAlignment.MiddleCenter;
		Btn_Del.Font = new Font("lr ", 8);
		Btn_Del.ForeColor = Color.Black;
		Btn_Del.Size = new Size(100, 32);
		Btn_Del.BackColor = SystemColors.Control;
		Btn_Del.Location = new Point(ClientSize.Width - Btn_Del.Width - 10, 20 + Btn_Add.Height);
		Btn_Del.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
		Btn_Del.Click += new EventHandler(OnClick_Del);

		Btn_Edit = new Button();
		Btn_Edit.Text = "\[X̕ҏW";
		Btn_Edit.TextAlign = ContentAlignment.MiddleCenter;
		Btn_Edit.Font = new Font("lr ", 8);
		Btn_Edit.ForeColor = Color.Black;
		Btn_Edit.Size = new Size(100, 32);
		Btn_Edit.BackColor = SystemColors.Control;
		Btn_Edit.Location = new Point(ClientSize.Width - Btn_Edit.Width - 10, 30 + Btn_Add.Height + Btn_Del.Height);
		Btn_Edit.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
		Btn_Edit.Click += new EventHandler(OnClick_Edit);

		Btn_Gen = new Button();
		Btn_Gen.Text = "\[Xt@C̍쐬";
		Btn_Gen.TextAlign = ContentAlignment.MiddleCenter;
		Btn_Gen.Font = new Font("lr ", 8);
		Btn_Gen.ForeColor = Color.Black;
		Btn_Gen.Size = new Size(100, 32);
		Btn_Gen.BackColor = SystemColors.Control;
		Btn_Gen.Location = new Point(ClientSize.Width - Btn_Gen.Width - 10, 40 + Btn_Add.Height + Btn_Del.Height + Btn_Edit.Height);
		Btn_Gen.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
		Btn_Gen.Click += new EventHandler(OnClick_Gen);

		Btn_Init = new Button();
		Btn_Init.Text = "f[^";
		Btn_Init.TextAlign = ContentAlignment.MiddleCenter;
		Btn_Init.Font = new Font("lr ", 8);
		Btn_Init.ForeColor = Color.Black;
		Btn_Init.Size = new Size(100, 32);
		Btn_Init.BackColor = SystemColors.Control;
		Btn_Init.Location = new Point(ClientSize.Width - Btn_Init.Width - 10, 50 + Btn_Add.Height + Btn_Del.Height + Btn_Edit.Height + Btn_Gen.Height);
		Btn_Init.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
		Btn_Init.Click += new EventHandler(OnClick_Init);

		Btn_Exit = new Button();
		Btn_Exit.Text = "I";
		Btn_Exit.TextAlign = ContentAlignment.MiddleCenter;
		Btn_Exit.Font = new Font("lr ", 8);
		Btn_Exit.ForeColor = Color.Black;
		Btn_Exit.Size = new Size(100, 32);
		Btn_Exit.BackColor = SystemColors.Control;
		Btn_Exit.Location = new Point(ClientSize.Width - Btn_Exit.Width - 10, 60 + Btn_Add.Height + Btn_Del.Height + Btn_Edit.Height + Btn_Gen.Height + Btn_Init.Height);
		Btn_Exit.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
		Btn_Exit.Click += new EventHandler(OnClick_Exit);

		this.Controls.Add(Btn_Add);
		this.Controls.Add(Btn_Del);
		this.Controls.Add(Btn_Edit);
		this.Controls.Add(Btn_Gen);
		this.Controls.Add(Btn_Init);
		this.Controls.Add(Btn_Exit);

		//Xgr[
		listView = new ListView();
		listView.BorderStyle = BorderStyle.Fixed3D;					//E
		listView.Location = new Point(10, 10);						//ʒu
		listView.Width = ClientSize.Width - Btn_Add.Width - 30;	//TCY
		listView.Height = ClientSize.Height - 20;
		listView.Anchor = (AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right);	//AJ[Œ
		listView.FullRowSelect = true;								//sI
		listView.MultiSelect = true;								//I
		listView.GridLines = true;									//ObhC̕\
		listView.HoverSelection = false;							//|CgőIł悤ɂ
		listView.Activation = ItemActivation.OneClick;				//VONbNI;
		listView.CheckBoxes = false;								//`FbN{bNX
		listView.View = View.Details;								//Xgr[̕\@
		listView.AllowDrop = true;									//listViewւ̃hbv󂯓
		//Cxgnh̒ǉ
		listView.ColumnClick += new ColumnClickEventHandler(ListView_ColumnClick);
		//Drag and Drop̃Cxgnh̒ǉ
		listView.DragEnter += new DragEventHandler(ListView_DragEnter);
		listView.DragDrop += new DragEventHandler(ListView_DragDrop);
		//wb_[`
		ColumnHeader columnNo = new ColumnHeader{Text = "O", Width = 100};
		ColumnHeader columnType = new ColumnHeader{Text = "", Width = 60};
		ColumnHeader columnData = new ColumnHeader{Text = "f[^", Width = 430};
		ColumnHeader[] colHeaderRegValue = {columnNo, columnType, columnData};	//wb_[ݒ
		listView.Columns.AddRange(colHeaderRegValue);	//wb_[ǉ
		//FormListViewǉ
		this.Controls.Add(listView);
	}

	//I
	protected override void OnFormClosing(FormClosingEventArgs e)
	{
		base.OnFormClosing(e);
		DialogResult dr = MessageBox.Show("I܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
		if(dr == DialogResult.No)
		{
			e.Cancel = true;
		}
	}

	protected void OnClick_Add(object sender, EventArgs e)
	{
		//\[X̓_CAOɂ
		InputDlg inpDlg = new InputDlg();
		inpDlg.ShowDialog();
		ListViewItem added_item;
		if(!String.IsNullOrEmpty(inpDlg.ResName))	//͂ꂽꍇ
		{
			if(inpDlg.ResType == "StrResCollection")	//t@Cɂ镶񃊃\[X͂̏ꍇ
			{
				//t@CeLXgǂݍ
				StreamReader sr = new StreamReader(inpDlg.ResData, Encoding.GetEncoding("Shift_JIS"));
 				string str = sr.ReadToEnd();
 				sr.Close();
 				//eLXgsɕiz񉻁j
				string[] lines = str.Split('\n');
				string[] sept = new string[]{"="};
				foreach(string line in lines)
				{	//es"key=value"keytovalueɕ
					if(String.IsNullOrEmpty(line))	//ŏIssƁuCfbNXz̋EOłvG[ɂȂ
						break;
					string[] key_vals = line.Split(sept, StringSplitOptions.RemoveEmptyEntries);	//RemoveEmptyEntries܂None
					added_item = listView.Items.Add(key_vals[0]);
					added_item.SubItems.Add("String");
					added_item.SubItems.Add(key_vals[1]);
				}
			}
			else
			{
				added_item = listView.Items.Add(inpDlg.ResName);
				added_item.SubItems.Add(inpDlg.ResType);
				added_item.SubItems.Add(inpDlg.ResData);
			}
		}
		inpDlg.Dispose();
	}

	protected void OnClick_Del(object sender, EventArgs e)
	{
		//IꂽsmF
		if(listView.SelectedItems.Count == 0)
			MessageBox.Show("f[^IĂ܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
		else
		{
			//IꂽACe폜
			foreach(ListViewItem item in listView.SelectedItems)
			{
				listView.Items.Remove(listView.SelectedItems[0]);
			}
		}
	}

	protected void OnClick_Edit(object sender, EventArgs e)
	{
		//IꂽsmF
		if(listView.SelectedItems.Count == 0)
			MessageBox.Show("f[^IĂ܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
		else
		{
			//IꂽACeҏW
			foreach(ListViewItem item in listView.SelectedItems)
			{
				//ꂼɂĕҏW_CAOg
				EditDlg editDlg = new EditDlg(item.Text, item.SubItems[1].Text, item.SubItems[2].Text);
				editDlg.ShowDialog();
				item.Text = editDlg.ResName;
				item.SubItems[1].Text = editDlg.ResType;
				item.SubItems[2].Text = editDlg.ResData;
				editDlg.Dispose();
			}
		}

	}

	protected void OnClick_Gen(object sender, EventArgs e)
	{
		//smF
		if(listView.Items.Count == 0)
		{
			MessageBox.Show("f[^܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			return;
		}
		//t@Cۑ_CAOɂt@C擾
		SaveFileDialog sfDlg = new SaveFileDialog();
		sfDlg.Filter = "\[Xt@C(*.resources)|*.resources|XML\[Xt@C(*.resx)|*.resx";	//t@CtB^[w
		sfDlg.FilterIndex = 1;			//t@CtB^[CfbNXw
		sfDlg.RestoreDirectory = true;	//fBNg
		sfDlg.CheckPathExists = true;	//݂ȂpX̎wx
		sfDlg.InitialDirectory = ".";	//ftHg̃tH_w
		sfDlg.Title = "\[Xt@Cۑ";	//_CAO^Cgw
		//t@Cۑ_CAO̕\
		if(sfDlg.ShowDialog() == DialogResult.OK)
		{
			if(Path.GetExtension(sfDlg.FileName) == ".resources")
			{
				Res_FileName = sfDlg.FileName;
				ResX_FileName = Path.GetDirectoryName(sfDlg.FileName) +  "\\" + Path.GetFileNameWithoutExtension(sfDlg.FileName) + ".resx";
			}
			else if(Path.GetExtension(sfDlg.FileName) == ".resx")
			{
				Res_FileName = Path.GetDirectoryName(sfDlg.FileName) + "\\" + Path.GetFileNameWithoutExtension(sfDlg.FileName) + ".resources";
				ResX_FileName = sfDlg.FileName;
			}
			else
			{
				MessageBox.Show("t@C@ł", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
		}
		else
		{
			MessageBox.Show("LZ܂B", "LZ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			return;
		}
		//sfDlgCX^X̔j
		sfDlg.Dispose();
		/////////////////////////////
		//\[Xt@C̏
		/////////////////////////////
		//*.rest@C쐬
		ResourceWriter res_writer = new ResourceWriter(Res_FileName);
		//*.resxt@C쐬
		ResXResourceWriter resx_writer = new ResXResourceWriter(ResX_FileName);
		foreach(ListViewItem item in listView.Items)
		{
			switch(item.SubItems[1].Text)
			{
				case "Image":
					//Image\[X̏
					try
					{
						Image img = Image.FromFile(item.SubItems[2].Text);
						//C[W̃t@C`𒲂ׂ
						if(img.RawFormat.Equals(ImageFormat.Bmp))
						{
							res_writer.AddResource(item.SubItems[0].Text, img);
							resx_writer.AddResource(item.SubItems[0].Text, img);
						}
						else if(img.RawFormat.Equals(ImageFormat.Icon))
						{
							Icon ico = new Icon(item.SubItems[2].Text);
							try
							{
								res_writer.AddResource(item.SubItems[0].Text, ico);
							}
							catch
							{
								MessageBox.Show("\[Xt@C߂܂", "G[iIconj", MessageBoxButtons.OK, MessageBoxIcon.Error);
							}
							try
							{
								resx_writer.AddResource(item.SubItems[0].Text, ico);
							}
							catch
							{
								MessageBox.Show("\[Xt@C߂܂", "G[iIconj", MessageBoxButtons.OK, MessageBoxIcon.Error);
							}
						}
						else if(img.RawFormat.Equals(ImageFormat.Wmf))
						{
							Metafile meta = new Metafile(item.SubItems[2].Text);
							try
							{
								res_writer.AddResource(item.SubItems[0].Text, meta);
							}
							catch
							{
								MessageBox.Show("\[Xt@C߂܂", "G[iIconj", MessageBoxButtons.OK, MessageBoxIcon.Error);
							}
							try
							{
								resx_writer.AddResource(item.SubItems[0].Text, meta);
							}
							catch
							{
								MessageBox.Show("\[Xt@C߂܂", "G[iIconj", MessageBoxButtons.OK, MessageBoxIcon.Error);
							}
						}
						else
						{
							MemoryStream imgStream = new MemoryStream();	//Image stream̍쐬
							img.Save(imgStream, img.RawFormat);
							try
							{
								res_writer.AddResource(item.SubItems[0].Text, imgStream);
							}
							catch
							{
								MessageBox.Show("\[Xt@C߂܂", "G[ȋC[Wj", MessageBoxButtons.OK, MessageBoxIcon.Error);
							}
							try
							{
								resx_writer.AddResource(item.SubItems[0].Text, imgStream);
							}
							catch
							{
								MessageBox.Show("\[Xt@C߂܂", "G[ȋC[Wj", MessageBoxButtons.OK, MessageBoxIcon.Error);
							}
						}
					}
					catch(OutOfMemoryException)
					{
						MessageBox.Show(item.SubItems[2].Text + " ͑ΏۊỎ摜f[^ł", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
						continue;
					}
					catch(FileNotFoundException)
					{
						MessageBox.Show(item.SubItems[2].Text + " ܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
						continue;
					}
					break;
				case "File":
					//File\[XVACYď
					try
					{
						FileStream fs = new System.IO.FileStream(item.SubItems[2].Text, FileMode.Open, FileAccess.Read);
						byte[] bs = new byte[fs.Length];
						fs.Read(bs, 0, bs.Length);
						res_writer.AddResource(item.SubItems[0].Text, bs);
						resx_writer.AddResource(item.SubItems[0].Text, bs);
						fs.Close();
					}
					catch
					{
						MessageBox.Show(item.SubItems[2].Text + "ǂ߂܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
						continue;
					}
					break;
				case "String":
					//񃊃\[X̏
					res_writer.AddResource(item.SubItems[0].Text, item.SubItems[2].Text);
					resx_writer.AddResource(item.SubItems[0].Text, item.SubItems[2].Text);
					break;
			}
		}
		//ResXResourceWriter
		res_writer.Close();
		//ResXResourceWriter
		resx_writer.Close();
	}

	protected void OnClick_Init(object sender, EventArgs e)
	{
		listView.Items.Clear();
	}

	protected void OnClick_Exit(object sender, EventArgs e)
	{
		Close();
	}

	private void ListView_ColumnClick(object sender, ColumnClickEventArgs e)
	{
		//ListViewItemSorterw肷
		listView.ListViewItemSorter = new ListViewItemComparer(e.Column);
		//ёւiListViewItemSorterݒ肷SortIɌĂяoj
	}

	//listViewɃhbOꂽ
	private void ListView_DragEnter(object sender, DragEventArgs e)
	{
		if(e.Data.GetDataPresent(DataFormats.FileDrop))
			e.Effect = DragDropEffects.Copy;
		else
			e.Effect = DragDropEffects.None;
	}

	//listViewɃhbvꂽƂ
	private void ListView_DragDrop(object sender, DragEventArgs e)
	{
		//hbvꂽt@CpX擾
		string[] srclist =  (string[])e.Data.GetData(DataFormats.FileDrop, false);
		//hbvꂽf[^Xgr[ɒǉ
		foreach(string item in srclist)
		{
			//ꂼɂă\[XƃC[Wt@CۂmFKv
			EditDlg editDlg = new EditDlg(Path.GetFileNameWithoutExtension(item), "", item);
			editDlg.ShowDialog();
			ListViewItem added_item;
			if(!String.IsNullOrEmpty(editDlg.ResName))
			{
				if(editDlg.ResType == "StrResCollection")	//t@Cɂ镶񃊃\[X͂̏ꍇ
				{
					//t@CeLXgǂݍ
					StreamReader sr = new StreamReader(editDlg.ResData, Encoding.GetEncoding("Shift_JIS"));
					string str = sr.ReadToEnd();
					sr.Close();
					//eLXgsɕiz񉻁j
					string[] lines = str.Split('\n');
					string[] sept = new string[]{"="};
					foreach(string line in lines)
					{	//es"key=value"keytovalueɕ
						if(String.IsNullOrEmpty(line))	//ŏIssƁuCfbNXz̋EOłvG[ɂȂ
							break;
						string[] key_vals = line.Split(sept, StringSplitOptions.RemoveEmptyEntries);	//RemoveEmptyEntries܂None
						added_item = listView.Items.Add(key_vals[0]);
						added_item.SubItems.Add("String");
						added_item.SubItems.Add(key_vals[1]);
					}
				}
				else
				{
					added_item = listView.Items.Add(editDlg.ResName);
					added_item.SubItems.Add(editDlg.ResType);
					added_item.SubItems.Add(editDlg.ResData);
				}
			}
			editDlg.Dispose();
		}
	}
}

///////////////////////////////////////////
//ListView̍ڂ̕ёւɎgpNX
///////////////////////////////////////////
public class ListViewItemComparer : IComparer
{
	private int m_column;

	// ListViewItemComparerNX̃RXgN^
	public ListViewItemComparer(int col)
	{
		m_column = col;
	}

	//xy菬Ƃ̓}CiX̐A傫Ƃ̓vX̐AƂ0Ԃ
	public int Compare(object x, object y)
	{
		//ListViewItem̎擾
		ListViewItem itemx = (ListViewItem) x;
		ListViewItem itemy = (ListViewItem) y;
		//xy𕶎ƂĔr
		return string.Compare(itemx.SubItems[m_column].Text, itemy.SubItems[m_column].Text);
	}
}

/////////////////////////
//\[X̓_CAO
/////////////////////////
class InputDlg : Form
{
	//vpeB
	string m_Name = "";
	public string ResName
	{
		get
		{
			return m_Name;
		}
		set
		{
			m_Name = value;
		}
	}

	protected string m_Type = "";
	public string ResType
	{
		get
		{
			return m_Type;
		}
		set
		{
			m_Type = value;
		}
	}

	protected string m_Data = "";
	public string ResData
	{
		get
		{
			return m_Data;
		}
		set
		{
			m_Data = value;
		}
	}

	//_CAÕRg[
	Button BtnOK;
	Button BtnCancel;
	Label labelName;
	TextBox txbName;
	GroupBox gBox;
	Label labelChoice;
	RadioButton rdBtnImg;
	RadioButton rdBtnFile;
	Button BtnSelFile;
	RadioButton rdBtnStr;
	TextBox txbStr;

	public InputDlg()
	{
		//NXtB[h̏
		m_Name = "";
		m_Type = "";
		m_Data = "";
		//_CAȎݒ
		this.Text = "\[X̓_CAO";
		this.ClientSize = new Size(320, 180);
		this.MaximizeBox = false;		// ő剻{^
		this.MinimizeBox = false;		// ŏ{^
		this.ShowInTaskbar = false;		//^XNo[\
		this.FormBorderStyle = FormBorderStyle.FixedDialog;		// ẼX^C
		this.StartPosition = FormStartPosition.CenterScreen;	//ʒɔzu
		//Rg[̑ݒ
		BtnOK = new Button();
		BtnOK.Location = new Point(20, ClientSize.Height - BtnOK.Height - 10);
		BtnOK.Text = "OK";
		BtnOK.AutoSize = true;
		BtnOK.Click += new EventHandler(OnOK_Click);

		BtnCancel = new Button();
		BtnCancel.Location = new Point(ClientSize.Width - BtnCancel.Width - 20, ClientSize.Height - BtnCancel.Height - 10);
		BtnCancel.Text = "Cancel";
		BtnCancel.AutoSize = true;
		BtnCancel.Click += new EventHandler(OnCancel_Click);

		gBox = new GroupBox();
		gBox.Text = "\[XƐݒ";
		gBox.Size = new Size(ClientSize.Width - 20, ClientSize.Height - BtnOK.Height - 20);
		gBox.Location = new Point(10, 0);

		labelName = new Label();
		labelName.Text = "\[X";
		labelName.Location = new Point(10, 15);
		labelName.AutoSize = true;

		txbName = new TextBox();
		txbName.BorderStyle = BorderStyle.Fixed3D;
		txbName.Location = new Point(105, 15);
		txbName.Size = new Size(ClientSize.Width - 135, 16);

		labelChoice = new Label();
		labelChoice.Text = "A܂̓C[Wt@CIĂ";
		labelChoice.Location = new Point(10, 40);
		labelChoice.AutoSize = true;

		rdBtnImg = new RadioButton();
		rdBtnImg.Location = new Point(20, 35 + labelChoice.Height);
		rdBtnImg.Size = new Size(80, 16);
		rdBtnImg.Text = "C[W";
		rdBtnImg.CheckedChanged += new EventHandler(rdBtnImg_CheckedChanged);

		rdBtnFile = new RadioButton();
		rdBtnFile.Location = new Point(20, 45 + labelChoice.Height + rdBtnImg.Height);
		rdBtnFile.Size = new Size(80, 16);
		rdBtnFile.Text = "t@C";
		rdBtnFile.CheckedChanged += new EventHandler(rdBtnFile_CheckedChanged);

		BtnSelFile = new Button();
		BtnSelFile.Visible = false;
		BtnSelFile.Text = "t@CI";
		BtnSelFile.AutoSize = true;
		BtnSelFile.Click += new EventHandler(OnSelFile_Click);

		rdBtnStr = new RadioButton();
		rdBtnStr.Location = new Point(20, 55 + labelChoice.Height + rdBtnImg.Height + rdBtnFile.Height);
		rdBtnStr.Size = new Size(80, 16);
		rdBtnStr.Text = "";
		rdBtnStr.CheckedChanged += new EventHandler(rdBtnStr_CheckedChanged);

		txbStr = new TextBox();
		txbStr.Visible = false;
		txbStr.BorderStyle = BorderStyle.Fixed3D;
		txbStr.Location = new Point(105, 55 + labelChoice.Height + rdBtnImg.Height + rdBtnFile.Height);
		txbStr.Size = new Size(ClientSize.Width - 135, 16);

		gBox.Controls.Add(labelName);
		gBox.Controls.Add(txbName);
		gBox.Controls.Add(labelChoice);
		gBox.Controls.Add(rdBtnImg);
		gBox.Controls.Add(rdBtnFile);
		gBox.Controls.Add(BtnSelFile);
		gBox.Controls.Add(rdBtnStr);
		gBox.Controls.Add(txbStr);
		this.Controls.Add(BtnOK);
		this.Controls.Add(BtnCancel);
		this.Controls.Add(gBox);
	}

	void rdBtnImg_CheckedChanged(object sender, EventArgs e)
	{
		txbStr.Visible = false;
		BtnSelFile.Visible = true;
		m_Type = "Image";
		BtnSelFile.Location = new Point(145, 35 + labelChoice.Height);
	}

	void rdBtnFile_CheckedChanged(object sender, EventArgs e)
	{
		txbStr.Visible = false;
		BtnSelFile.Visible = true;
		m_Type = "File";
		BtnSelFile.Location = new Point(145, 45 + labelChoice.Height + rdBtnImg.Height);
	}

	void rdBtnStr_CheckedChanged(object sender, EventArgs e)
	{
		txbStr.Visible = true;
		BtnSelFile.Visible = false;
		m_Type = "String";
	}

	protected void OnSelFile_Click(object sender, EventArgs e)
	{
		OpenFileDialog ofDlg = new OpenFileDialog();
		//t@CtB^[̎w
		ofDlg.Filter = "C[Wt@C|*.bmp;*.ico;*.wmf;*.jpeg;*.jpg;*.png;*.gif;*.tiff;*.emf;*.exif|Ẵt@C(*.*)|*.*";
		//t@CtB^[CfbNX̎w
		if(m_Type == "Image")
			ofDlg.FilterIndex = 1;
		else
			ofDlg.FilterIndex = 2;
		//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
		ofDlg.RestoreDirectory = true;
		// ftHg̃tH_w肷
		ofDlg.InitialDirectory = @".";
		//_CAÕ^Cgw肷
		ofDlg.Title = "t@CJ";
		//_CAO\
		if(ofDlg.ShowDialog() == DialogResult.OK)
		{
			m_Data = ofDlg.FileName;
			txbName.Text = Path.GetFileNameWithoutExtension(ofDlg.FileName);
			string ext = Path.GetExtension(ofDlg.FileName);
			if(ext == ".restext")
			{
				m_Type = "StrResCollection";
			}
			else if(ext == ".txt")
			{
				DialogResult dr = MessageBox.Show("eLXgt@C𕶎񃊃\[XƂĎg܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
				if(dr == DialogResult.Yes)
				{
					m_Name = m_Type = "StrResCollection";
					//IuWFNgj
					ofDlg.Dispose();
					Close();
				}
			}
		}
		else
		{
			MessageBox.Show("LZ܂B", "LZ", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
		}
		//IuWFNgj
		ofDlg.Dispose();
		//ut@CIv{^
		BtnSelFile.Visible = false;
	}

	protected void OnOK_Click(object sender, EventArgs e)
	{
		m_Name = txbName.Text;
		if(m_Type == "String")
			m_Data = txbStr.Text;
		if(String.IsNullOrEmpty(m_Name))
		{
			MessageBox.Show("\[X܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}
		else
		{
			if(String.IsNullOrEmpty(m_Type) || String.IsNullOrEmpty(m_Data))
			{
				MessageBox.Show("\[Xw܂̓\[X̃f[^܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			else
			{
				Close();
			}
		}
	}

	protected void OnCancel_Click(object sender, EventArgs e)
	{
		m_Name = "";
		m_Type = "";
		m_Data = "";
		Close();
	}
}

/////////////////////////
//\[XҏW_CAO
/////////////////////////
class EditDlg : Form
{
	//vpeB
	string m_Name = "";
	public string ResName
	{
		get
		{
			return m_Name;
		}
		set
		{
			m_Name = value;
		}
	}

	protected string m_Type = "";
	public string ResType
	{
		get
		{
			return m_Type;
		}
		set
		{
			m_Type = value;
		}
	}

	protected string m_Data = "";
	public string ResData
	{
		get
		{
			return m_Data;
		}
		set
		{
			m_Data = value;
		}
	}

	//_CAÕRg[
	Button BtnOK;
	Button BtnCancel;
	Label labelName;
	TextBox txbName;
	GroupBox gBox;
	RadioButton rdBtnImg;
	RadioButton rdBtnFile;
	RadioButton rdBtnStr;
	Label labelData;
	TextBox txbData;

	public EditDlg(string arg_name, string arg_type, string arg_data)
	{
		//̋L^
		m_Name = arg_name;
		m_Type = arg_type;
		m_Data = arg_data;
		//_CAȎݒ
		this.Text = "\[XҏW_CAO";
		this.ClientSize = new Size(320, 220);
		this.MaximizeBox = false;		// ő剻{^
		this.MinimizeBox = false;		// ŏ{^
		this.ShowInTaskbar = false;		//^XNo[\
		this.FormBorderStyle = FormBorderStyle.FixedDialog;		// ẼX^C
		this.StartPosition = FormStartPosition.CenterScreen;	//ʒɔzu

		//Rg[̑ݒ
		BtnOK = new Button();
		BtnOK.TabIndex = 1;
		BtnOK.Location = new Point(20, ClientSize.Height - BtnOK.Height - 10);
		BtnOK.Text = "OK";
		BtnOK.AutoSize = true;
		BtnOK.Click += new EventHandler(OnOK_Click);

		BtnCancel = new Button();
		BtnCancel.TabIndex = 2;
		BtnCancel.Location = new Point(ClientSize.Width - BtnCancel.Width - 20, ClientSize.Height - BtnCancel.Height - 10);
		BtnCancel.Text = "Cancel";
		BtnCancel.AutoSize = true;
		BtnCancel.Click += new EventHandler(OnCancel_Click);

		labelName = new Label();
		labelName.Text = "\[X";
		labelName.Location = new Point(10, 10);
		labelName.AutoSize = true;

		txbName = new TextBox();
		txbName.TabIndex = 0;
		txbName.Text = m_Name;
		txbName.BorderStyle = BorderStyle.Fixed3D;
		txbName.Location = new Point(20 + labelName.Width, 10);
		txbName.Size = new Size(ClientSize.Width - labelName.Width - 30, 16);

		gBox = new GroupBox();
		gBox.Text = "\[X敪";
		gBox.Location = new Point(5, labelName.Height + 10);
		gBox.Size = new Size(ClientSize.Width - 10, 40);

		rdBtnImg = new RadioButton();
		rdBtnImg.Location = new Point(10, 15);
		rdBtnImg.Size = new Size(80, 16);
		rdBtnImg.Text = "C[W";
		rdBtnImg.CheckedChanged += new EventHandler(rdBtnImg_CheckedChanged);
		if(m_Type == "Image")
			rdBtnImg.Checked = true;

		rdBtnFile = new RadioButton();
		rdBtnFile.Location = new Point(gBox.Width / 3 + 10, 15);
		rdBtnFile.Size = new Size(80, 16);
		rdBtnFile.Text = "t@C";
		rdBtnFile.CheckedChanged += new EventHandler(rdBtnFile_CheckedChanged);
		if(m_Type == "File")
			rdBtnFile.Checked = true;

		rdBtnStr = new RadioButton();
		rdBtnStr.Location = new Point(gBox.Width * 2 / 3 + 20, 15);
		rdBtnStr.Size = new Size(80, 16);
		rdBtnStr.Text = "";
		rdBtnStr.CheckedChanged += new EventHandler(rdBtnStr_CheckedChanged);
		if(m_Type == "String")
			rdBtnStr.Checked = true;

		labelData = new Label();
		labelData.Text = "\[Xf[^";
		labelData.Location = new Point(10, labelName.Height + gBox.Height + 20);
		labelData.AutoSize = true;

		txbData = new TextBox();
		txbData.Multiline = true;
		txbData.Text = m_Data;
		if(m_Type == "String")
			txbData.ReadOnly = false;
		else
			txbData.ReadOnly = true;
		txbData.BorderStyle = BorderStyle.Fixed3D;
		txbData.Location = new Point(10, labelName.Height + gBox.Height + labelData.Height + 20);
		txbData.Size = new Size(ClientSize.Width - 20, 72);

		this.Controls.Add(labelName);
		this.Controls.Add(txbName);
		this.Controls.Add(gBox);
		gBox.Controls.Add(rdBtnImg);
		gBox.Controls.Add(rdBtnFile);
		gBox.Controls.Add(rdBtnStr);
		this.Controls.Add(labelData);
		this.Controls.Add(txbData);
		this.Controls.Add(BtnOK);
		this.Controls.Add(BtnCancel);
	}

	void rdBtnImg_CheckedChanged(object sender, EventArgs e)
	{
		m_Type = "Image";
	}

	void rdBtnFile_CheckedChanged(object sender, EventArgs e)
	{
		m_Type = "File";
		//t@C當擾O[u
		string ext = Path.GetExtension(m_Data);
		if(ext == ".txt" || ext == ".restext")
		{
			DialogResult dr = MessageBox.Show("eLXgt@C𕶎񃊃\[XƂĎg܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if(dr == DialogResult.Yes)
			{
				m_Name = m_Type = "StrResCollection";
				Close();
			}
		}
	}

	void rdBtnStr_CheckedChanged(object sender, EventArgs e)
	{
		m_Type = "String";
	}

	protected void OnOK_Click(object sender, EventArgs e)
	{
		m_Name = txbName.Text;
		m_Data = txbData.Text;
		if(String.IsNullOrEmpty(m_Name))
		{
			MessageBox.Show("\[X܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}
		else if(String.IsNullOrEmpty(m_Type))
		{
			MessageBox.Show("\[X^Cvw肳Ă܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}
		else if(String.IsNullOrEmpty(m_Data))
		{
			MessageBox.Show("f[^܂", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
		}
		else
		{
			Close();
		}
	}

	protected void OnCancel_Click(object sender, EventArgs e)
	{
		Close();
	}
}
