///////////////////////////////////////
//MessageBox.cs - MessageBox Sample
///////////////////////////////////////
using System;
using System.Windows;

namespace MsgBox
{
	///////////////////////////
	//エントリーポイントクラス
	///////////////////////////
	class MainApp
	{
		[STAThread]
		public static void Main()
		{
			string msgText = "終了しますか？";
			string caption = "MessageBoxテスト";
			MessageBoxButton button = MessageBoxButton.YesNoCancel;
			MessageBoxImage icon = MessageBoxImage.Warning;
			MessageBoxResult result = MessageBoxResult.Cancel;
			while(result != MessageBoxResult.Yes)
			{
				result = MessageBox.Show(msgText, caption, button, icon);
			}
			MessageBox.Show("とうとう終了することにしましたね！", "おめでとう！", MessageBoxButton.OK, MessageBoxImage.Information);	//MessageBoxButtonsではない。またMessageBoxIconではない。
		}
	}
}
