/****************************
	Maze - Digging Method
*****************************/

/* 萔 */
// ʘHEǏ
#define	MAX_SIZE	99		// ύX|99ȏłȂ
#define	MIN_SIZE 	5		// Œł5ȏ͕Kv
#define Path 		0
#define Wall 		1
// 
const int Up		= 0;
const int Right		= 1;
const int Down		= 2;
const int Left		= 3;
const int Direction = 4;

/* NX` */
// 2ix, yjWϐ^
class CELL {
public:
    int x;  // x W
    int y;  // y W
	CELL() {x = y = 0;}
	CELL(int X, int Y) {x = X; y = Y;}
	void Set(int X, int Y) {x = X; y = Y;}
	void operator = (CELL i) {this->x = i.x; this->y = i.y;}
	bool operator == (CELL c) {return (this->x == c.x && this->y == c.y);}
	bool operator != (CELL c) {return (this->x != c.x || this->y != c.y);}
};

// CELLΏۂƂX^bNǗϐ^
class CELLSTACK {
private:
	unsigned int stacklevel;
	CELL *cellptr[MAX_SIZE * MAX_SIZE];
public:
	// RXgN^[
	CELLSTACK() {stacklevel = 0;}
	// fRXgN^[
	~CELLSTACK(){
		while(stacklevel > 0) {
			stacklevel--;
			delete cellptr[stacklevel];
		}	// stacklevel = 0;͕sv
	}
	// X^bNɐς
	void Push(CELL cel) {
		if(stacklevel < MAX_SIZE * MAX_SIZE) {
			cellptr[stacklevel] = new CELL;
			*cellptr[stacklevel] = cel;
			stacklevel++;
		}
		else {
			MessageBox(0, "Stack overflow!", "Error!", MB_OK | MB_ICONERROR);
			exit(0);
		}
	}
	// FILOx[XŃX^bNo
	CELL Pop() {
		CELL cel;
		stacklevel--;
		cel = *cellptr[stacklevel];
		delete cellptr[stacklevel];
		return cel;
	}
	// CӂiԖځi0`j̃X^bNf[^o
	CELL Pop(int i) {
		CELL cel = *cellptr[i];
		for(int j = i; j < stacklevel - 1; j++)
			*cellptr[j] = *cellptr[j + 1];
		stacklevel--;
		delete cellptr[stacklevel];
		return cel;
	}
	// X^bNTCYԂ
	unsigned int Size() {return stacklevel;}
	// CELLf[^i΂̈ʒui1`jAȂ0Ԃj
	unsigned int Find(CELL cel) {
		for(int i = 0; i < stacklevel; i++) {
			if(*cellptr[i] == cel)
				return i + 1;
		}
		return 0;
	}
	// 
	void Clear() {
		while(stacklevel > 0) {
			stacklevel--;
			delete cellptr[stacklevel];
		}	// stacklevel = 0;͕sv
	}
};

// HNX
class MAZE {
private:
	/* ϐ */
	// H
	int *m_Mazedata;		// 2z̖Hf[^ւ̃|C^[
	int m_Width;			// H
	int m_Height;     		// H
	// @JnWL^pϐ
	CELLSTACK m_StartPoints;

	/* vCx[g֐ */
	// x, yn_ƂČ@
	void Dig(int x, int y) {
		// @i߂Xg쐬
		while (TRUE) {
		// @i߂L^
			int i = 0, dirs[Direction] = {-1};
			if(y > 1 && m_Mazedata[x + m_Width * (y - 1)] == Wall && m_Mazedata[x + m_Width * (y - 2)] == Wall) {
				dirs[i]= Up;
				i++;
			}				
			if(x < m_Width - 1 && m_Mazedata[x + 1 + m_Width * y] == Wall && m_Mazedata[x + 2 + m_Width * y] == Wall) {
				dirs[i]= Right;
				i++;
			}
			if(y < m_Height - 1 && m_Mazedata[x + m_Width * (y + 1)] == Wall && m_Mazedata[x + m_Width * (y + 2)] == Wall) {
				dirs[i]= Down;
				i++;
			}
			if(x > 1 && m_Mazedata[x - 1 + m_Width * y] == Wall && m_Mazedata[x - 2 + m_Width * y] == Wall) {
				dirs[i]= Left;
				i++;
			}
			// @i߂ȂꍇA[v𔲂
			if(!i) {
				break;
			}
			// wWʘHƂA@Wo^
			SetPath(x, y);
			// i߂_ɑIA2ubNʘHƂ
			switch(dirs[rand() % i]) {
				case Up:
					SetPath(x, --y);
					SetPath(x, --y);
					break;
				case Right:
					SetPath(++x, y);
					SetPath(++x, y);
					break;
				case Down:
					SetPath(x, ++y);
					SetPath(x, ++y);
					break;
				case Left:
					SetPath(--x, y);
					SetPath(--x, y);
					break;
			}
		}
		// ǂɂ@i߂ȂꍇǍ@JnW擾
		CELL pt;
		if(GetStartPoint(&pt)) {	// Jn₪
			Dig(pt.x, pt.y);		// ċAĂяo
		}
		// W݂ȂƂA@芮
	}

	// WʘHƂAx, yɊ́u@JnWvXgɋL^
	void SetPath(int x, int y) {
		m_Mazedata[x + m_Width * y] = Path;
		if (x % 2 == 1 && y % 2 == 1) {
			// @W̋L^
			CELL pt(x, y);
			m_StartPoints.Push(pt);
		}
	}

	// @Jnʒu_Ɏ擾iCELLϐ|C^[nj
	bool GetStartPoint(CELL* pt) {
		int num = m_StartPoints.Size();
		// Jnʒu₪Ȃꍇ
		if(!num)
			return FALSE;
		// Jnʒu₪ꍇA_Ɍ擾č폜
		else {
			*pt = m_StartPoints.Pop(rand() % num);
			return TRUE;
		}
	}

public:
	// HK͖wRXgN^[
	MAZE() {
		//irand()j̏
		srand((unsigned int)time(NULL));
		// HK͂̎w肪ȂꍇAMAX_SIZEŎIɖHK͂
		m_Width = rand() % MAX_SIZE;
		m_Height = rand() % MAX_SIZE;
		if (m_Width % 2 == 0)					// łꍇ
			m_Width++;
		if (m_Height % 2 == 0)				// łꍇ
			m_Height++;
		m_Mazedata = new int[m_Width * m_Height];	// 񎟌zꎟŊm
	}

	// MAZE()RXgN^̏ꍇAHK͊mF̂߂Ɏg
	int GetW() {return m_Width;}
	int GetH() {return m_Height;}
	// Hf[^̎擾̂߂Ɏg
	int* GetMaze() {return m_Mazedata;}

	// HK͎wRXgN^[
	MAZE(int w, int h) {	//HK͂w肵RXgN^[
		//irand()j̏
		srand((unsigned int)time(NULL));
		// MIN_SIZẼTCYł͐łȂ
		if (w < MIN_SIZE) {
			//MessageBox(hMainWnd, "Too narrow! Width is now 5.", "Error", MB_OK | MB_ICONERROR);
			MessageBox(0, "Too narrow! Width is now 5.", "Error", MB_OK | MB_ICONERROR);
			w = MIN_SIZE;
		}
		if (h < MIN_SIZE) {
			//MessageBox(hMainWnd, "Too low! Height is now 5.", "Error", MB_OK | MB_ICONERROR);
			MessageBox(0, "Too low! Height is now 5.", "Error", MB_OK | MB_ICONERROR);
			h = MIN_SIZE;
		}
		if (w % 2 == 0) {	//łꍇ
			//MessageBox(hMainWnd, "As the given width is even, it is made +1.", "Caveat", MB_OK | MB_ICONERROR);
			MessageBox(0, "As the given width is even, it is made +1.", "Caveat", MB_OK | MB_ICONERROR);
			w++;
		}
		if (h % 2 == 0) {	//łꍇ
			//MessageBox(hMainWnd, "As the given height is even, it is made +1.", "Caveat", MB_OK | MB_ICONERROR);
			MessageBox(0, "As the given height is even, it is made +1.", "Caveat", MB_OK | MB_ICONERROR);
			h++;
		}
		// H
		m_Width = w;
		m_Height = h;
		m_Mazedata = new int[m_Width * m_Height];	// 񎟌zꎟŊm
	}

	// fXgN^
	~MAZE() {
		// Mazedata̔z񃁃iĂяoŖHf[^mۂKvj
		delete [] m_Mazedata;			// z̊J
	}

	// H쐬
	int* CreateMaze() {
		// HǂŖ߂
		for(int y = 0; y < m_Height; y++) {
			for(int x = 0; x < m_Width; x++) {
				if(x == 0 || y == 0 || x == m_Width - 1 || y == m_Height - 1)
					// Oǂׁ͔̈AUʘHiPath = 0jɂ
					m_Mazedata[x + m_Width * y] = Path;
				else
					m_Mazedata[x + m_Width * y] = Wall;
			}
		}
		// Wi1, 1j猊@Jn|H̎͂͒ʘHɂȂĂ
		Dig(1, 1);
		// OǂǁiWall = 1j߂
		for(int y = 0; y < m_Height; y++) {
			for(int x = 0; x < m_Width; x++) {
				if(x == 0 || y == 0 || x == m_Width - 1 || y == m_Height - 1)
					m_Mazedata[x + m_Width * y] = Wall;
			}
		}
		return m_Mazedata;	// Hf[^i񎟌zj|C^[Ԃ
	}

	// Of[^ɂ镝AAHf[^̐ݒ
	void Set(int w, int h, int* data) {

		m_Width = w;		// 
		m_Height = h;		// 
		if(m_Mazedata)
			delete [] m_Mazedata;
		m_Mazedata = new int[m_Width * m_Height];
		for(int y = 0; y < m_Height; y++) {
			for(int x = 0; x < m_Width; x++) {
				m_Mazedata[x + m_Width * y] = data[x + m_Width * y];	//Hf[^
			}
		}
	}
};
