///////////////////////////////////
// Class of CNIM for playing "nim"
// Copyright (c) by Ysama, 2021
///////////////////////////////////
/*
y[z
iPj55A4A3A2A1̃RCQe[uɒuA
iQjA肪ɁA̗񂩂A1ȏ̃RCĂ䂫A
iRjŌ̃RC邱ƂɂȂ
nim̑o΃Q[ihttps://ja.wikipedia.org/wiki/%E3%83%8B%E3%83%A0j
*/

#include	<vector>
using namespace std;

//CCOINSNXwb_[
#include	"CCOINSW.h"

////////////////////////
//CNIMNXwb_[
////////////////////////
class CNIM : public CCOINS {
private:
	//o[ϐ
	vector <unsigned int> m_GameProcess;	//ΐ했̎̐ڂL^
	vector <unsigned int> m_CoinsDB;		//ΐԂ̋L^pDB
	vector <unsigned int>::iterator m_Itr;	//m_CoinsDBpCe[^[
	unsigned int m_Record;				//ΐԂ̋L^pϐ
	//m_Record = 0000:0000i16i4oCgj
	//			 @A@B
	//@]tOi1oCgj0|A1|̗pA2|
	//A񐔁i4bitsj0000:0000RC5̗񐔁i2i2oCg|16bitsj
	//BRC敪ɂ񐔓	0000:0000:0000:0000i2i2oCg|16bitsj
	//(2oCg)					4@3@2@1
public:
	//o[֐
	CNIM();						//RXgN^[
	~CNIM();					//fXgN^[
	void InitGame();			//Q[̏
	bool IsGameOver();			//s̕]ыL^
	bool CheckCoins(unsigned int);	//unsigned intf[^̃`FbNiTRUE|K`AFALSE|Ks`j
	bool EvalTake();			//]Ďł
	bool Eval();				//RC󋵂ɊÂs]iTRUE|K`AFALSE|Ks`jj
	bool ExpTake();				//oł
	void SetRecord(int);		//m_Coins̏Ԃm_RecordɋL^
	void Register(unsigned int, bool);	//̓o^iFo^f[^ATRUE|AFALSE|̗pj
	bool Search(unsigned int, int&);	//̌iTRUEňɕ]AȂFALSEj
	int CoinsCmp();				//̔r
	int DBSize();				//DB̃f[^Ԃ
	bool CoinsWrite(char*);		//DBf[^̏
	bool CoinsRead(char*);		//DBf[^̓ǂݍ
};

//RXgN^[
CNIM::CNIM() {

	//m_CoinsDB̓ǂݍ݁it@CiŒjF"Nim.dat"j
	//CoinsRead("Nim.dat");
	CoinsRead("Nim.dat");
}

//fXgN^[
CNIM::~CNIM() {

	//m_CoinsDB̏݁it@CiŒjF"Nim.dat"j
	//CoinsWrite("Nim.dat");
	CoinsWrite("Nim.dat");
}

//Q[̏
void CNIM::InitGame() {

	//CCOINS̏
	Init();
	//Vectorϐ
	m_GameProcess.clear();
}

//s̕]ыL^
bool CNIM::IsGameOver() {

	int result = IsOver();					//s֐IsOveri-0܂͔s1A2j
	if(result) {							//sȂ
	//1񂾂̏ꍇ2ň1̕K`̏ꍇ͓o^svȂ̂
	//̊mFsÄO̎iK`ɓ̂ō̗p(1)j擾
		int dmy;
		m_Itr = m_GameProcess.end() - 1;
		auto last = *m_Itr;
		//1sȂ
		while((last & 0x00F00000) == 0x00100000) {
			//XɂЂƂO̓o^L^֑k
			last = *(--m_Itr);
		}
		//2s
		while((last & 0x00F00000) == 0x00200000) {
			//ȂƂ1Ȃ
			if((last & 0x0000000F) > 0) {
				//ЂƂO̓o^L^֑k
				last = *(--m_Itr);
			}
			else
				break;						//1ΐɐi
		}
		if(!Search(last, dmy)) {			//RC󋵂
			Register(last, CheckCoins(last));	//ÕRC󋵂o^
		}
		return TRUE;
	}
	else {									//sȂ΁A(0)ŋL^
		SetRecord(0);						//m_RecordɍŐVXV
		m_GameProcess.push_back(m_Record);	//m_GameProcess֋L^
		return FALSE;
	}
}

//̕]iK`|TRUEAKs`|FALSEj
//iEval֐ƕ킹j
bool CNIM::CheckCoins(unsigned int data) {

	//5̃RC̔rI_a
	//AARCׂ1̏ꍇ͋ťʂƂȂ
	int d = ((data & 0x000F0000) >> 16) * 5;				//5̗
	int flag = (data & 0x000F0000) >> 16;
	for(int i = 0; i < ((data & 0x0000F000) >> 12); i++)	//4̗
		d ^= 4;
	flag += (data & 0x0000F000) >> 12;
	for(int i = 0; i < ((data & 0x00000F00) >> 8); i++)		//3̗
		d ^= 3;
	flag += (data & 0x00000F00) >> 8;
	for(int i = 0; i < ((data & 0x000000F0) >> 4); i++)		//2̗
		d ^= 2;
	flag += (data & 0x000000F0) >> 4;
	for(int i = 0; i < (data & 0x0000000F); i++)			//1̗
		d ^= 1;
	if(flag > 0)	//2ȏ̗񐔂ł
		return d;	//K`|TRUEAKs`|FALSE
	else			//f[^ׂ1܂0ł
		return !d;	//K`|FALSEAKs`|TRUE
}

//]Ďł
bool CNIM::EvalTake() {

	int col[5], i, j;
	for(i = 0, j = 0; i < 5; i++) {		//z0ȊO̗
		if(m_Coins[i])
			col[j++] = i;
	}
	//ȉcase 1case 2̖炩ȏ͕]ȑOɊm
	switch(j) {
	case 1:								//1񂾂̏ꍇ
		if(m_Coins[col[0]] == 1)		//1ȂɕiłĂȂj
			break;
		else {
			m_Coins[col[0]] = 1;		//1cĂׂĎ
			m_Player = 3 - m_Player;	//Ǎ
			return TRUE;				//łĂ
		}
	case 2:								//2̏ꍇ
		if(m_Coins[col[0]] == 1) {		//1Ȃ΁A
			m_Coins[col[1]] = 0;		//ׂ̂ẴRC
			m_Player = 3 - m_Player;	//Ǎ
			return TRUE;				//łĂ
		}
		else if(m_Coins[col[1]] == 1) {	//1Ȃ΁A
			m_Coins[col[0]] = 0;		//̂xẴRC
			m_Player = 3 - m_Player;	//Ǎ
			return TRUE;				//łĂ
		}								//1łȂꍇdefault
	default:							//ȊȌꍇ
		int coins;						//f[^ꎞۑpϐ
		for(i = 0; i < j; i++) {
			coins = m_Coins[col[i]];	//m_Coins[col[i]̒lۑ
			for(int k = 1; k <= coins; k++) {	//1玩̃RC
				m_Coins[col[i]] = coins - k;	//RCzsA
				if(!Eval()) {					//ɕsłΊm肷
					m_Player = 3 - m_Player;	//Ǎ
					return TRUE;		//łĂ
				}
			}
			m_Coins[col[i]] = coins;	//ɖ߂
		}
		break;
	}
	return FALSE;						//m_PlayerijłĂȂij
}

//RC󋵂ɊÂs]iTRUE|K`AFALSE|Ks`j
//iCheckCoins֐ƕ킹j
//ׂĂ̗ɂĔrI_a
//F0, 0, 2, 2, 0  rI_a0iKs`j
//AA0łȂ1̏ꍇ͗OƂȂ
//F0, 0, 1, 1, 0  rI_a0AK`ƂȂĂ
bool CNIM::Eval() {

	int d;
	bool flag = FALSE;
	for(int i = 0; i < 5; i++) {
		if(!i)					//i == 0ŃRC
			d = m_Coins[i];
		else					//ȍ~͔rI_a
			d ^= m_Coins[i];
		if(m_Coins[i] > 1)		//RC1ȏł
			flag = TRUE;		//flag͐^
	}
	if(flag)					//ꂩ̗̃RC1ȏゾ
		return d;				//rI_a
	else						//̃RCׂĂ1܂0
		return !d;				//rI_a̋t
}

//oł
bool CNIM::ExpTake() {

	//z0ȊO̗
	int col[5], i, j;
	for(i = 0, j = 0; i < 5; i++) {
		if(m_Coins[i])
			col[j++] = i;
	}
	//CoinsDB'2'i֊jɊYe[u
	char TabooTable[5][5] = {0};		//[][][
	int TTCounter = 0;					//TabooTableo^
	//ȉcase 1case 2̖炩ȏ͕]ȑOɊm
	switch(j) {
	case 1:								//1񂾂̏ꍇ
		if(m_Coins[col[0]] == 1)		//1ȂɕiłĂȂj
			break;
		else {
			m_Coins[col[0]] = 1;		//1cĂׂĎ
			m_Player = 3 - m_Player;	//Ǎ
			return TRUE;				//łĂ
		}
	case 2:								//2̏ꍇ
		if(m_Coins[col[0]] == 1) {		//1Ȃ΁A
			m_Coins[col[1]] = 0;		//ׂ̂ẴRC
			m_Player = 3 - m_Player;	//Ǎ
			return TRUE;				//łĂ
		}
		else if(m_Coins[col[1]] == 1) {	//1Ȃ΁A
			m_Coins[col[0]] = 0;		//̂xẴRC
			m_Player = 3 - m_Player;	//Ǎ
			return TRUE;				//łĂ
		}								//1łȂꍇdefault
	default:							//ȊȌꍇ
		int coins, v;					//f[^ꎞۑѕ]pϐ
		for(i = 0; i < j; i++) {
			coins = m_Coins[col[i]];		//m_Coins[col[i]̒lۑ
			for(int k = 1; k <= coins; k++) {	//1玩̃RC
				m_Coins[col[i]]= coins - k;		//RCzsA
				SetRecord(0);					//SearcḧׁAm_RecordɃRC󋵂L^
				if(Search(m_Record, v)) {		//肪A̕]u̗pi1jvł
					if(v == 1) {				//̕]u̗pi1jvł
						m_Player = 3 - m_Player;	//Ǎ
						return TRUE;			//łĂ
					}
					else if(v == 2) {			//̕]ui2jvł
						TabooTable[col[i]][coins - k] = 1;	//֊e[uɓo^
						TTCounter++;						//֊e[uo^
					}
				}						//Ȃ΂̂܂܂ɂ
			}
			m_Coins[col[i]] = coins;	//ɖ߂
		}
		/* ӁFׂĂ̌₪TabooTableɊYƖ[vɂȂ̂ŁA
		   Sׁ̈Aɂ茈߂e[uo^ + 1ȏɂȂꍇA
		   ܂ */
		do {
			i = rand() % j;			//l𗐐Œo
			//m_Coins[col[i]]̃RCAŒ߂li1`̃RCj
			v = m_Coins[col[i]] - ((rand() % m_Coins[col[i]]) + 1);
			--TTCounter;
			if(TTCounter < 0)		//io^ + 1jȂ̂łȏĂSĊ̔
				break;
		} while(TabooTable[i][v]);	//֊e[uɈΗ蒼
		m_Coins[col[i]] = v;
		m_Player = 3 - m_Player;	//Ǎ
		return TRUE;				//łĂ
	}
	return FALSE;					//ł肪ȂAuv
}

void CNIM::SetRecord(int result) {	//m_Coins̏Ԃm_RecordɋL^

	int ln = 0, coins5 = 0, coins4 = 0, coins3 = 0, coins2 = 0, coin1 = 0;
	for(int i = 0; i < 5; i++) {
		if(m_Coins[i]) {
			ln++;
			switch(m_Coins[i]) {
			case 5:
				coins5++;
				break;
			case 4:
				coins4++;
				break;
			case 3:
				coins3++;
				break;
			case 2:
				coins2++;
				break;
			case 1:
				coin1++;
				break;
			default:
				break;
			}
		}
	}
	m_Record = result;			//擪0|A1|̗pA2|
	m_Record <<= 4;				//4 bitsʂփVtg
	m_Record |= ln;				//0ȊO̐l
	m_Record <<= 4;				//8 bitsʂփVtg
	m_Record |= (char)coins5;	//5̃RC̗
	m_Record <<= 4;				//8 bitsʂփVtg
	m_Record |= (char)coins4;	//4̃RC̗
	m_Record <<= 4;				//4 bitsʂփVtg
	m_Record |= (char)coins3;	//3̃RC̗
	m_Record <<= 4;				//4 bitsʂփVtg
	m_Record |= (char)coins2;	//2̃RC̗
	m_Record <<= 4;				//4 bitsʂփVtg
	m_Record |= (char)coin1;	//1̃RC̗
}

//̓o^
void CNIM::Register(unsigned int data, bool flag) {

	//ɓn̕]Ȃ̂
	if(flag)		//uviflagTRUEj
		data |= 0x02000000;
	else			//u̗pviflagFALSEj
		data |= 0x01000000;
	m_CoinsDB.push_back(data);
}

//̌
bool CNIM::Search(unsigned int data, int& value) {

	unsigned int cmp;	//rpϐidata & 0x0000FFFFƔrj
	for(m_Itr = m_CoinsDB.begin(); m_Itr != m_CoinsDB.end(); m_Itr++) {
		cmp = *m_Itr & 0x000FFFFF;					//2oCg̃RC󋵂
		if(cmp == (data & 0x000FFFFF)) {			//dataƔr
			value = (*m_Itr & 0xFF000000) >> 24;	//ł΂̕]擾
			return TRUE;
		}
	}
	return FALSE;
}

//DB̃f[^Ԃ
int CNIM::DBSize() {

	return m_CoinsDB.size();
}

bool CNIM::CoinsWrite(char* fn) {

	int num = DBSize();
	unsigned int data;
	HANDLE hFile = CreateFile(fn, GENERIC_WRITE,
				FILE_SHARE_WRITE, NULL,
				OPEN_ALWAYS, NULL, NULL);	//t@CŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		DWORD dwWrite;
		//悸intŃf[^
		WriteFile(hFile, &num, sizeof(int), &dwWrite, NULL);
		m_Itr = m_CoinsDB.begin();
		//m_Coins̔z
		for(int i = 0; i < num; i++, m_Itr++) {
			data = *m_Itr;
			WriteFile(hFile, &data, sizeof(data), &dwWrite, NULL);
		}
		CloseHandle(hFile);					//t@C̃N[Y
		return TRUE;
	}
	else
		return FALSE;
}

bool CNIM::CoinsRead(char* fn) {

	int num;
	unsigned int data;
	HANDLE hFile = CreateFile(fn, GENERIC_READ,
				FILE_SHARE_READ, NULL,
				OPEN_EXISTING, NULL, NULL);	//t@CǍŃI[v
	if(hFile != INVALID_HANDLE_VALUE) {		//I[vł
		m_CoinsDB.clear();					//m_CoinsDB̃f[^ɂ
		DWORD dwRead;
		//悸int numɃf[^ǂݍ
		ReadFile(hFile, &num, sizeof(int), &dwRead, NULL);
		for(int i = 0; i < num; i++) {
			ReadFile(hFile, &data, sizeof(data), &dwRead, NULL);
			m_CoinsDB.push_back(data);
		}
		CloseHandle(hFile);					//t@C̃N[Y
		return TRUE;
	}
	else
		return FALSE;
}
