//////////////////////////////////////////
// ResourceListProc.h
// Copyright (c) 08/11/2024 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnCreate(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	TBar.Init(m_hWnd, m_hInstance, TOOLBAR);
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TOOLBAR), 4);
	//c[o[{^ǉ
	TBBUTTON tbb[6];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_OPEN;
	tbb[1].iBitmap = TBar.m_id + 1;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_SAVE;
	tbb[2].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[3].iBitmap = TBar.m_id + 2;
	tbb[3].fsState = TBSTATE_ENABLED;
	tbb[3].fsStyle = TBSTYLE_BUTTON;
	tbb[3].idCommand = IDM_EXIT;
	tbb[4].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[5].iBitmap = TBar.m_id + 3;
	tbb[5].fsState = TBSTATE_ENABLED;
	tbb[5].fsStyle = TBSTYLE_BUTTON;
	tbb[5].idCommand = IDM_VERSION;
	TBar.AddButtons(6, tbb);

	//Xe[^Xo[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	SBar.Init(m_hWnd, m_hInstance, STATUSBAR);
	//Xe[^Xo[ݒ
	int sec[2] = {120, -1};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "ResourceList Ver 1.0");
	SBar.SetText(1, "it@Cj");

	//hbOAhhbv̎tJn
	DragAcceptFiles(m_hWnd, TRUE);

	//GfBbgRg[̍쐬
	Edit.Init("EDIT", m_hInstance);
	Edit.Create("i\[Xf[^\܂j",
					WS_CHILD | WS_VISIBLE | WS_BORDER | WS_HSCROLL | WS_VSCROLL |
					ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_MULTILINE | ES_READONLY,
					WS_EX_CLIENTEDGE, m_hWnd, IDC_EDIT, 0, 0, 0, 0);
	Edit.SetFont(11, "lr ");

	//f[^t@CŋNꂽꍇAt@CI[v
	if(g_ByFile) {
		g_FileName = Arg.v(1);	//Pp[^[̃t@Cî݁j
		g_ByFile =TRUE;
		OnOpen();
	}
	return TRUE;
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	//c[o[̃c[`bv擾
	if(((LPNMHDR)lParam)->code == TTN_NEEDTEXT) {
		static LPTOOLTIPTEXT lptip;
		lptip = (LPTOOLTIPTEXT)lParam;
		switch (lptip->hdr.idFrom) {
		case IDM_OPEN:
			lptip->lpszText = "s\t@CJ";
			break;
		case IDM_SAVE:
			lptip->lpszText = "\[Xt@C̕ۑ";
			break;
		case IDM_EXIT:
			lptip->lpszText = "I";
			break;
		case IDM_VERSION:
			lptip->lpszText = "o[W";
			break;
		default:
			return FALSE;
		}
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	//c[o[Đݒ
	TBar.AutoSize();
	//Xe[^Xo[Đݒ
	SBar.AutoSize();
	//EDITRg[NCAgGAɐݒ
	RECT rec;
	GetWindowRect(TBar.GetHandle(), &rec);	//c[o[擾
	int top = (rec.bottom - rec.top);
	int height = HIWORD(lParam) - top;
	GetWindowRect(SBar.GetHandle(), &rec);	//Xe[^Xo[擾
	height -= (rec.bottom - rec.top);
	MoveWindow(GetDlgItem(m_hWnd, IDC_EDIT), 0, top, LOWORD(lParam), height, TRUE);
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES)
		//DestroyWindowAPostQuitMessageĂ΂
		return TRUE;
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

bool CMyWnd::OnDropFiles(WPARAM wParam, LPARAM lParam) {

	//T^IȃhbOAhhbv
	static char lpszFn[MAX_PATH];				//t@Cpobt@
	HDROP hDrop = (HDROP)wParam; 				//HDROP擾
	DragQueryFile(hDrop, 0, lpszFn, MAX_PATH);	//ŏ̃t@C擾
	g_FileName =lpszFn;							//g_FileNameŃt@CpXAî݁jn
	g_ByFile = TRUE;
	OnOpen();
	DragFinish(hDrop);							//I
	return TRUE;
}

bool CMyWnd::OnMinMax(WPARAM wParam, LPARAM lParam) {

	//T^IȃEBhẼTCY
	MINMAXINFO *pmmi;
	pmmi = (MINMAXINFO*)lParam;
	pmmi->ptMinTrackSize.x = 496;	//NCAgGA480 + 16
	pmmi->ptMinTrackSize.y = 381;	//NCAgGA320 + 61

	return FALSE;					//DefWndProcɔC
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnOpen() {

	//t@CAtB^[pϐ
	char* ptFile;
	char* ptFilter = "W[t@Ciexe, dllj\0*.exe;*.dll\0ׂẴt@C\0*.*\0\0";
    //t@C̎擾
	if(g_ByFile)		//t@CtNADrag and Drop܂̓j[̏ꍇ
		g_ByFile = FALSE;		//Ԃɖ߂
	else {				//j[Rg[̏ꍇ
		//IĂACe̕擾AŃtB^[쐬
		ptFile = cmndlg.GetFileName(m_hWnd, ptFilter, TRUE);
		if(!ptFile) {
			MessageBox(m_hWnd, "t@CI܂ł", "G[", MB_OK | MB_ICONSTOP);
			return FALSE;
		}
		else {
			g_FileName = ptFile;
		}
	}
	SBar.SetText(1, g_FileName.ToChar());
	SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_FileName.ToChar());	//ToolTip
	//\[XXg̐ݒƕ\
	ResList.BeginResList(g_FileName.ToChar());		//Vs\t@CēxJ
	SendMessage(Edit.GetHandle(), WM_SETTEXT, 0, (LPARAM)ResList.GetData());
	//u\[Xt@C̕ۑvLɂ
	HMENU hMenu = GetMenu(ResourceList.GetHandle());	//j[nh̎擾
	HMENU hFileMenu = GetSubMenu(hMenu, 0);
	EnableMenuItem(hFileMenu, IDM_SAVE, MF_BYCOMMAND | MF_ENABLED);
	//EnableMenuItem(hFileMenu, IDM_SAVE, MF_BYCOMMAND | (EnableFlag ? MF_ENABLED : MF_GRAYED));
	//c[o[{^Lɂ
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_SAVE, MAKELONG(TRUE, 0));
	return TRUE;
}

bool CMyWnd::OnSave() {

	ResList.SaveList();
	return TRUE;
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnVersion() {

	//IDD_VERSION_CAO̕\
	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

/////////////////////////////////
//VERSIONDLG_CAO̊֐`
//Rg[֐
/////////////////////////////////
bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}
