////////////////////////////////////
//ImageListTv|ToolBar Editor
////////////////////////////////////
//c[o[rbg}bṽTCY萔
#define NAME		"ToolBar Editor"
#define CX_IMAGE	16
#define CY_IMAGE	15
#define CW			16
#define NONE		0
#define DRAG1		1
#define DRAG2		2
#define DRAW		3

//O[oϐ(2003N12BaseDirǉj
char BaseDir[MAX_PATH];		//TBEditor̂tH[[̉SampleBMPtH[_[
CBMP cvsbmp;				//Canvas̃rbg}bv捞pCBMPNXϐ
char* g_FileName;			//Ōɓǂ݂񂾃t@C
bool g_FileGiven = FALSE;	//Ñt@Cp[^[̗L
int g_x, g_y;				//NCAg̈̕`L͈
int g_Width, g_Height;		//`L͈̓TCY
RECT g_DispArea;			//c[o[\`
RECT g_DrawArea;			//`̈
RECT g_SampArea;			//`̈̃Tv\̈
RECT g_ColArea;				//`FI̕\̈
RECT g_SampColArea;			//I`F̕\̈
int g_Busy = NONE;					//ƒtbO
int g_Drawx;				//`JnW
int g_Drawy;				//`JnW
int g_Color = 0;			//`F
int g_Selected = IDM_DOT;	//Iꂽ`}`j[ID

//TCY֌W̃O[oϐ擾
void GetSize(LPARAM lParam) {

	RECT Trec, Srec;
	GetWindowRect(TBar.m_hWnd, &Trec);
	GetWindowRect(SBar.m_hWnd, &Srec);
	g_x = 0;
	g_y = Trec.bottom - Trec.top;
	g_Width = LOWORD(lParam);
	g_Height = HIWORD(lParam) - Trec.bottom + Trec.top - Srec.bottom + Srec.top;
	//c[o[rbg}bv\̈̈ʒuݒ
	g_DispArea.left = g_x + 1;
	g_DispArea.top = g_y + 1;
	g_DispArea.right = g_DispArea.left + CX_IMAGE * 32;
	g_DispArea.bottom = g_DispArea.top + CY_IMAGE;
	//`̈̈ʒuݒ
	g_DrawArea.left = g_x + 1;
	g_DrawArea.top = g_DispArea.bottom + 1;
	g_DrawArea.right = g_DrawArea.left + CW * 16;
	g_DrawArea.bottom = g_DrawArea.top + CW * 15;
	//`̈̃Tv\̈
	g_SampArea.left = (g_Width + g_DrawArea.right - CX_IMAGE) / 2;
	g_SampArea.top = g_y + (g_Height + g_DispArea.bottom - CY_IMAGE) / 2;
	g_SampArea.right = g_SampArea.left + CX_IMAGE;
	g_SampArea.bottom = g_SampArea.top + CY_IMAGE;
	//`FI̕\̈
	g_ColArea.left = (g_Width + g_DrawArea.right - CX_IMAGE * 8) / 2;
	g_ColArea.top = g_SampArea.bottom + CW * 3;
	g_ColArea.right = g_ColArea.left + CW * 8;
	g_ColArea.bottom = g_ColArea.top + CW * 2;
	//I`F̕\̈
	g_SampColArea.left = (g_ColArea.left + g_DrawArea.right - CW) / 2;
	g_SampColArea.top = g_ColArea.top + CW / 2;
	g_SampColArea.right = g_SampColArea.left + CW;
	g_SampColArea.bottom = g_SampColArea.top + CW;
}

//C[WXg̏Ə\
void InitClientArea() {

	COLORREF c = cvs.m_Color;	//`FޔAۑ
	ImgList.DeleteImage(-1);	//SẴC[W
	cvs.Color(15);
	cvs.Clear();
	cvs.Color(0);
	//c[o[rbg}bv\̈̕\
	cvs.Box(g_DispArea.left - 1, g_DispArea.top - 1, g_DispArea.right + 1, g_DispArea.bottom + 1, 0);
	//̑̈̕\
	cvs.Color(7);
	cvs.Box(g_DrawArea.right + 1, g_DrawArea.top, g_x + g_Width, g_y + g_Height, 1);
	//`̈̃Tv\̈̕\
	cvs.Color(15);
	cvs.Box(g_SampArea.left - 1, g_SampArea.top - 1, g_SampArea.right + 1, g_SampArea.bottom + 1, 1);
	cvs.Color(0);
	cvs.Box(g_SampArea.left - 1, g_SampArea.top - 1, g_SampArea.right + 1, g_SampArea.bottom + 1, 0);
	//`̈̕\
	cvs.Box(g_DrawArea.left - 1, g_DrawArea.top - 1, g_DrawArea.right + 1, g_DrawArea.bottom + 1, 0);
	for(int i = 1; i < CX_IMAGE; i++)
		cvs.Line(g_DrawArea.left + i * CW, g_DrawArea.top, g_DrawArea.left + i * CW, g_DrawArea.bottom);
	for(int i = 1; i < CY_IMAGE; i++)
		cvs.Line(g_DrawArea.left, g_DrawArea.top + i * CW, g_DrawArea.right, g_DrawArea.top + i * CW);
	//`FI̕\̈̕\
	for(int i = 0; i < 8; i++) {
		cvs.Color(i);
		cvs.Box(g_ColArea.left + i * CW, g_ColArea.top, g_ColArea.left + (i + 1) * CW, g_ColArea.top + CW, 1);
	}
	for(int i = 0; i < 8; i++) {
		cvs.Color(i + 8);
		cvs.Box(g_ColArea.left + i * CW, g_ColArea.top + CW, g_ColArea.left + (i + 1) * CW, g_ColArea.top + CW * 2, 1);
	}
	cvs.Color(0);
	cvs.Box(g_ColArea.left - 1, g_ColArea.top - 1, g_ColArea.right + 1, g_ColArea.bottom + 1, 0);
	//I`F̕\̈
	cvs.m_Color = c;
	cvs.Box(g_SampColArea.left, g_SampColArea.top, g_SampColArea.right, g_SampColArea.bottom, 1);
	cvs.Color(0);
	cvs.Box(g_SampColArea.left - 1, g_SampColArea.top - 1, g_SampColArea.right + 1, g_SampColArea.bottom + 1, 0);
	cvs.m_Color = c;
}

////////////////////////////////////////
//XLCV[htBASY
//ghׂ[`| Fuzzy
////////////////////////////////////////
#define MAXSIZE	1024				//obt@TCY1024
#define MINX	g_SampArea.left		//ʃTCY
#define MINY	g_SampArea.top
#define MAXX	g_SampArea.right - 1
#define MAXY	g_SampArea.bottom - 1

struct BUFSTR {
	int buf_lx;	//̈捶[XW
	int buf_rx;	//̈E[XW
	int buf_y;	//̈YW
	int buf_oy;	//eCYW
};
struct BUFSTR Buffer[MAXSIZE];
struct BUFSTR *Start_Idx, *End_Idx;

void Scan_Line(int lx, int rx, int y, int oy, COLORREF col) {

	while (lx <= rx) {
		//̈F΂
		for (; lx < rx ; lx++)
			if(GetPixel(cvs.hDC(), lx, y) == col) break;
		if(GetPixel(cvs.hDC(), lx, y) != col) break;
		End_Idx->buf_lx = lx;
		//̈F΂
		for(; lx <= rx ; lx++)
			if(GetPixel(cvs.hDC(), lx, y) != col) break;
		End_Idx->buf_rx = lx - 1;
		End_Idx->buf_y = y;
		End_Idx->buf_oy = oy;
		if(++End_Idx == &Buffer[MAXSIZE]) End_Idx = Buffer;
	}
}

void Paint(int x, int y, COLORREF paint_color) {

	int lx, rx, uy, dy, oy;
	int lxsav, rxsav;
	int i;
	COLORREF col;

	Start_Idx = Buffer;
	End_Idx = Buffer + 1;
	Start_Idx->buf_lx = Start_Idx->buf_rx = x;
	Start_Idx->buf_y = Start_Idx->buf_oy = y;
	col = GetPixel(cvs.hDC(), x, y);

	do {
		lx = Start_Idx->buf_lx;
		rx = Start_Idx->buf_rx;
		uy = Start_Idx->buf_y;
		dy = Start_Idx->buf_y;
		oy = Start_Idx->buf_oy;
		lxsav = lx - 1;
		rxsav = rx + 1;
		if(++Start_Idx == &Buffer[MAXSIZE]) Start_Idx = Buffer;
		//ς̃V[hȂ疳
		if (GetPixel(cvs.hDC(), lx, uy) == paint_color) continue;
		//E̋ET
		while(rx < MAXX) {
			if(GetPixel(cvs.hDC(), rx + 1, uy) != col) break;
			rx++;
		}
		//̋ET
		while(lx > MINX) {
			if(GetPixel(cvs.hDC(), lx - 1, uy) != col ) break;
			lx--;
		}
		//lx-rx̐`
//		cvs.m_Color = paint_color;	//ɂȂĂ
		for (i = lx; i <= rx; i++)	cvs.Dot(i, uy);
		//^̃XLC𑖍
		if(--uy >= MINY) {
			if(uy == oy) {
				Scan_Line(lx, lxsav, uy, uy + 1, col);
				Scan_Line(rxsav, rx, uy, uy + 1, col);
			}
			else {
				Scan_Line(lx, rx, uy, uy + 1, col);
			}
		}
		//^̃XLC𑖍
		if(++dy <= MAXY) {
			if(dy == oy) {
				Scan_Line(lx, lxsav, dy, dy - 1, col);
				Scan_Line(rxsav, rx, dy, dy - 1, col);
			}
			else {
				Scan_Line(lx, rx, dy, dy - 1, col);
			}
		}
	} while(Start_Idx != End_Idx);
}

//Tv\̈`֐
void DrawSample(int x, int y) {

	//n_W(sx, sy)ƏI_W(ex, ey)߂
	int sx = g_SampArea.left + g_Drawx;
	int sy = g_SampArea.top + g_Drawy;
	int ex = g_SampArea.left + x;
	int ey = g_SampArea.top + y;

	//F̌
	if(g_Color < 16)				cvs.Color(g_Color);
	//_ł
	if(g_Selected == IDM_DOT)		cvs.Dot(ex, ey);
	//
	if(g_Selected == IDM_LINE) {	cvs.Line(sx, sy, ex, ey);
									cvs.Dot(ex, ey);}
	if(g_Selected == IDM_PAINT)		Paint(ex, ey, cvs.m_Color);
	//IʒȕC
	if(sx < ex)			ex++;
	else if(sx > ex)	sx++;
	if(sy < ey)			ey++;
	else if(sy > ey)	sy++;
	//``
	if(g_Selected == IDM_BOX)		cvs.Box(sx, sy, ex, ey, 0);
	//ȉ~`
	if(g_Selected == IDM_ELLIPSE)	cvs.Ellipsed(sx, sy, ex, ey, 0);
	//h׋``
	if(g_Selected == IDM_BOXF)		cvs.Box(sx, sy, ex, ey, 1);
	//hבȉ~`
	if(g_Selected == IDM_ELLIPSEF)	cvs.Ellipsed(sx, sy, ex, ey, 1);
}

//Tv\̈`̈֊g]
void SampToDraw() {

	cvs.GetBMP(g_SampArea.left, g_SampArea.top, CX_IMAGE, CY_IMAGE);
	cvs.FitBMP(g_DrawArea.left, g_DrawArea.top, g_DrawArea.right - g_DrawArea.left, g_DrawArea.bottom -  g_DrawArea.top, 0);
	//Obh`
	COLORREF c = cvs.m_Color;	//`FޔAۑ
	cvs.Color(0);
	for(int i = 1; i < CX_IMAGE; i++)
		cvs.Line(g_DrawArea.left + i * CW, g_DrawArea.top, g_DrawArea.left + i * CW, g_DrawArea.bottom);
	for(int i = 1; i < CY_IMAGE; i++)
		cvs.Line(g_DrawArea.left, g_DrawArea.top + i * CW, g_DrawArea.right, g_DrawArea.top + i * CW);
	cvs.m_Color = c;
}

//}`j[ƃc[o[̃`FbNύX
void CheckChange(HWND hWnd, WORD Sel) {

	SendMessage(TBar.GetHandle(), TB_SETSTATE, g_Selected,
				(LPARAM)MAKELONG(TBSTATE_ENABLED, 0));
	CheckMenuItem(GetSubMenu(GetSubMenu(GetMenu(hWnd), 1), 2), g_Selected,
				MF_UNCHECKED | MF_BYCOMMAND);
	g_Selected = Sel;
	SendMessage(TBar.GetHandle(), TB_SETSTATE, Sel,
				(LPARAM)MAKELONG(TBSTATE_ENABLED | TBSTATE_PRESSED, 0));
	CheckMenuItem(GetSubMenu(GetSubMenu(GetMenu(hWnd), 1), 2), g_Selected,
				MF_CHECKED | MF_BYCOMMAND);
}

//Fj[̃`FbNύX
void CheckColor(HWND hWnd, int Col) {
	CheckMenuItem(GetSubMenu(GetSubMenu(GetMenu(hWnd), 1), 4), g_Color,
				MF_UNCHECKED | MF_BYPOSITION);
	g_Color = Col;
	cvs.Color(g_Color);
	cvs.Box(g_SampColArea.left, g_SampColArea.top, g_SampColArea.right, g_SampColArea.bottom, 1);
	CheckMenuItem(GetSubMenu(GetSubMenu(GetMenu(hWnd), 1), 4), g_Color,
				MF_CHECKED | MF_BYPOSITION);
}

//j[Arbg}bv{^̏Ԃς
void ChangeStatus(bool flag) {

	UINT state = flag ? MF_ENABLED : MF_DISABLED;
	//t@C̕ۑj[ύXɂ
	EnableMenuItem(GetSubMenu(GetMenu(TBEditor.m_hWnd), 0), 2, MF_BYPOSITION | state);
	EnableMenuItem(GetSubMenu(GetMenu(TBEditor.m_hWnd), 0), 3, MF_BYPOSITION | state);
	//rbg}bv̕ҏWj[ύXɂ
	EnableMenuItem(GetMenu(TBEditor.m_hWnd), 1, MF_BYPOSITION | state);
	DrawMenuBar(TBEditor.m_hWnd);
	//rbg}bṽ{^ԂύXɂ
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_SAVE, MAKELONG(flag, 0));
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_ADDBMP, MAKELONG(flag, 0));
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_DOT, MAKELONG(flag, 0));
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_LINE, MAKELONG(flag, 0));
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_BOX, MAKELONG(flag, 0));
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_ELLIPSE, MAKELONG(flag, 0));
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_BOXF, MAKELONG(flag, 0));
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_ELLIPSEF, MAKELONG(flag, 0));
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_PAINT, MAKELONG(flag, 0));
	SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_SELEC, MAKELONG(flag, 0));
}