///////////////////////////////
// CCLIPBOARDNX`t@C
///////////////////////////////

class CCLIPBOARD {
private:
	//ϐ
	HWND m_hWnd;		//Nbv{[hgpEBhEnh
	char* m_Text;		//eLXgp
	HBITMAP m_hBitmap;	//rbg}bvp
public:
	//֐
	CCLIPBOARD();		//RXgN^[
	CCLIPBOARD(HWND);	//RXgN^[
	~CCLIPBOARD();		//fXgN^[
	void SetWnd(HWND);
	char* GetText();
	bool SetText(char*);
	HBITMAP GetBitmap();
	bool SetBitmap(HBITMAP);
};

CCLIPBOARD::CCLIPBOARD() {
	m_hWnd = NULL;
	m_Text = NULL;
	m_hBitmap = NULL;
}

CCLIPBOARD::CCLIPBOARD(HWND hWnd) {
	m_hWnd = hWnd;
	m_Text = NULL;
	m_hBitmap = NULL;
}

CCLIPBOARD::~CCLIPBOARD() {
	if(!m_Text) delete [] m_Text;
}

void CCLIPBOARD::SetWnd(HWND hWnd){
	m_hWnd = hWnd;
}

char* CCLIPBOARD::GetText() {

	//Nbv{[hɃeLXgf[^邩ۂ
	if(!IsClipboardFormatAvailable(CF_TEXT))
		return NULL;
	//Nbv{[hJ
	if(!OpenClipboard(m_hWnd))
		return NULL;
	//Nbv{[hf[^|C^[擾
	HGLOBAL hGlobal = (HGLOBAL)GetClipboardData(CF_TEXT);
	if(!hGlobal) {
		CloseClipboard();
		return NULL;
	}
	//[bN
	char *str = (char*)GlobalLock(hGlobal);
	//m_TextɕKvȒ̃[iɎgĂΉĂjm
	if(m_Text) delete [] m_Text;
    m_Text = new char [lstrlen(str) + 1];
	lstrcpy(m_Text, str);
    GlobalUnlock(hGlobal);
    CloseClipboard();
	return m_Text;
}

bool CCLIPBOARD::SetText(char* str) {

	//eLXg̒+1̃O[o[m
	HGLOBAL hGlobal = GlobalAlloc(GHND, lstrlen(str) + 1);
	//eLXgf[^̃O[o[փRs[
	char* pt = (char*)GlobalLock(hGlobal);
	lstrcpy(pt, str);
	GlobalUnlock(hGlobal);
	//O[o[Nv{[hɓn
	OpenClipboard(m_hWnd);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, hGlobal);
	return CloseClipboard();
}

HBITMAP CCLIPBOARD::GetBitmap() {

	//Nbv{[hɃeLXgf[^邩ۂ
	if(!IsClipboardFormatAvailable(CF_BITMAP))
		return NULL;
	//Nbv{[hJ
	if(!OpenClipboard(m_hWnd))
		return NULL;
	//Nbv{[hf[^|C^[擾
	m_hBitmap = (HBITMAP)GetClipboardData(CF_BITMAP);
	CloseClipboard();
	return m_hBitmap;
}

bool CCLIPBOARD::SetBitmap(HBITMAP hBitmap) {

	//rbg}bvnhNv{[hɓn
	OpenClipboard(m_hWnd);
	EmptyClipboard();
	SetClipboardData(CF_BITMAP, hBitmap);
	return CloseClipboard();
}
