///////////////////////////////////////
// MDIEBhENXCMDI`t@C
///////////////////////////////////////

class CMDI : public CWND
{
protected:
	HANDLE	m_hMutex;
	char	m_UniqName[MAX_PATH];

public:		//o[ϐ
	HWND		m_hMDIClient;	//MDINCGg̃nh
	HWND		m_hFocusedChild;//tH[JX̂MDIqEBhẼnh
	HWND		m_hDlg;			//IsDIalogMessage()gpɎg
	MSG			m_Msg;			//EBhEbZ[W
	HACCEL		m_Accel;		//Accelerator̗L

public:		//o[֐
	CMDI();		//CMDĨRXgN^[iPj
	CMDI(char*);		//CMDĨRXgN^[iQj
	~CMDI();
	bool CreateMDIClient(int);
	bool CreateMDIChild(LPCTSTR, LPCTSTR, int, int);
	HWND FocusedChild() {return m_hFocusedChild;}
	void MDIClientAutoSize(HWND, HWND);
	void MDIChildControlAutoSize(int, WPARAM, LPARAM);
	bool InclAccel(LPCTSTR);
	UINT Loop();
	virtual bool OnMDIFrameCreate(WPARAM, LPARAM);
	virtual bool OnMDIChildCreate(WPARAM, LPARAM);
	virtual bool OnMDIActivate(WPARAM, LPARAM);
	bool IsOnlyOne();			//QdNh~֐
};

//CMDĨRXgN^[iPj
CMDI::CMDI() {

	m_hMDIClient = 0;
	m_UniqName[0] = 0;
}

//CMDĨRXgN^[iQj
CMDI::CMDI(char* UName) {

	m_hMDIClient = 0;
	wsprintf(m_UniqName, "%d", UName);
}

//CMDĨfXgN^[
CMDI::~CMDI() {

	if(m_hMutex)
		CloseHandle(m_hMutex);
}

//MDIClientEBhE̍쐬
bool CMDI::CreateMDIClient(int WindowMenu) {

	//MDIqEBhȄ\
	CLIENTCREATESTRUCT ccs;
	//MDIqEBhE\郁j[nh
	ccs.hWindowMenu  = GetSubMenu(GetMenu(m_hWnd), WindowMenu);
	//OSݒ肷MDIqEBhE̍ŏ̃nhi͎IɌ܂j
	ccs.idFirstChild = ID_MDI_FIRSTCHILD;
	m_hMDIClient = CreateWindowEx(WS_EX_CLIENTEDGE, "MDICLIENT", NULL,
					WS_CHILD | WS_CLIPCHILDREN | WS_VSCROLL | WS_HSCROLL,
					0, 0, 0, 0,
					m_hWnd, (HMENU)ID_MDI_CLIENT, m_hInstance, (LPVOID)&ccs);
	if (m_hMDIClient == NULL) {
		MessageBox(0, "MDIClientEBhE쐬ł܂ł", "G[",
					MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return FALSE;
	}
	ShowWindow(m_hMDIClient, SW_SHOW);
	return TRUE;
}

//MDIChild̍쐬
bool CMDI::CreateMDIChild(LPCTSTR Class, LPCTSTR Name,
				int w = CW_USEDEFAULT, int h = CW_USEDEFAULT) {

	HWND hMDIChild = CreateMDIWindow(Class, Name, MDIS_ALLCHILDSTYLES,
								CW_USEDEFAULT, CW_USEDEFAULT, w, h,
								m_hMDIClient, m_hInstance, NULL);
	if(!hMDIChild) {
		MessageBox(m_hWnd, "MDIqEBhE܂ł",
					"G[", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}
	ShowWindow(hMDIChild, SW_SHOW);
	return TRUE;
}

//MDIClient̃TCYMDIFrameWindowɍ킹
void CMDI::MDIClientAutoSize(HWND hStatusBar = 0, HWND hToolBar = 0) {

	RECT rectFrameClient, rectStatus, rectTool;
	UINT uToolHeight, uStatusHeight, uClientAreaHeight;
	//MainFrameEBhẼTCY擾
	GetClientRect(m_hWnd, &rectFrameClient);
	uClientAreaHeight = rectFrameClient.bottom;
	//c[o[̍擾
	if(hToolBar) {
		GetWindowRect(hToolBar, &rectTool);
		uToolHeight = rectTool.bottom - rectTool.top;
	}
	else
		uToolHeight = 0;
	//Xe[^Xo[̍擾
	if(hStatusBar) {
		GetWindowRect(hStatusBar, &rectStatus);
		uStatusHeight = rectStatus.bottom - rectStatus.top;
	}
	else
		uStatusHeight = 0;
	//MDIClient̃TCY킹
	MoveWindow(m_hMDIClient, 0, uToolHeight, rectFrameClient.right, uClientAreaHeight - uStatusHeight - uToolHeight, TRUE);
}

//MDIChild̃Rg[̃TCYMDIChildɍ킹
void CMDI::MDIChildControlAutoSize(int Item, WPARAM wParam, LPARAM lParam) {

	//ŏȊOARg[MDIChild̃NCAgGAɍ킹
	if(wParam != SIZE_MINIMIZED)
		//LOWORD(lParam)=, HIWORD(lParam)=
		MoveWindow(GetDlgItem((HWND)SendMessage(m_hMDIClient, WM_MDIGETACTIVE, 0, 0), Item),
					0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
}

//ANZ[^[
bool CMDI::InclAccel(LPCTSTR Name) {

	if(!(m_Accel = LoadAccelerators(m_hInstance, Name))) {
		MessageBox(NULL, "ANZ[^[̓ǍɎs܂",
					"G[", MB_OK);
		return FALSE;
	}
	return TRUE;
}

//bZ[W[v
UINT CMDI::Loop() {

	while(GetMessage(&m_Msg, NULL, 0, 0) > 0) {	//G[-1Ԃ
		//[hX_CAOꍇ
		if(!IsDialogMessage(m_hDlg, &m_Msg) &&
			//MDĨVXej[ANZ[^
			!TranslateMDISysAccel(m_hMDIClient, &m_Msg) &&
			//ANZ[^[
			!TranslateAccelerator(m_hWnd, m_Accel, &m_Msg)) {
			TranslateMessage(&m_Msg);
			DispatchMessage(&m_Msg);
		}
	}
	return m_Msg.wParam;
}

////////////////////////////
// bZ[WΉ֐(zj
////////////////////////////
//WM_CREATEbZ[W|eiMDIFrameWindowjƎqiMDIChildWindowjňقȂ
bool CMDI::OnMDIFrameCreate(WPARAM wParam, LPARAM lParam) {
	return TRUE;	//G[̏ꍇFALSEɂƃEBhEꂸAI
}

bool CMDI::OnMDIChildCreate(WPARAM wParam, LPARAM lParam) {
	return TRUE;	//G[̏ꍇFALSEɂƃEBhEꂸAI
}

bool CMDI::OnMDIActivate(WPARAM wParam, LPARAM lParam) {
	return TRUE;
}

bool CMDI::IsOnlyOne() {

	m_hMutex = CreateMutex(NULL, TRUE, m_UniqName);
	if (!m_hMutex) 	return FALSE;
	// GetLastError()AERROR_ALREADY_EXISTSȂA
	// łɃAvP[VNĂ
	if (GetLastError() == ERROR_ALREADY_EXISTS) {
    //dN̏
    	return FALSE;
	}
	return TRUE;
}
