//////////////////////////
// CTABNX`t@C
//////////////////////////

#define	MAX_PAGE	64				//^uy[W̍ő吔

class CTAB : public CCTRL
{
public:		//o[ϐ
	RECT m_rectParent;				//ẽNCAg̈
	RECT m_rectTab;					//^u̕\̈
	HIMAGELIST m_hIList;			//C[WXgnh
	int m_CtrlID[MAX_PAGE];			//e^uy[Wɐݒ肷eEBhẼRg[ID

public:		//o[֐
	CTAB();							//RXgN^[iPj
	CTAB(int, int, int);			//RXgN^[iQj
	~CTAB();						//fXgN^[
	bool Create(HWND, HINSTANCE, int, int, int, int, int);	//CTABRg[쐬֐
	int TabCount() {return TabCtrl_GetItemCount(m_hWnd);}	//^u̐擾
	void MoveTab(int, int, int, int);						//^uړ
	void FitParent(HWND, HWND);								//ẽNCAg̈ɍ킹
	void FitSiblings(WPARAM);								//^uRg[TCY
	bool AddPage(int, int, LPSTR);	//^uy[Wƕ\ẽRg[o^֐
	bool DeletePage();				//Jg^uƐe̕\Rg[폜
	HWND GetCtrl();					//Jg^uŕ\ẽRg[̃nhԂ
	int GetPage();					//Jgy[Wԍ擾
	bool SetPage(int);				//Jgy[Wݒ肷
	char* GetTitle();				//Jgy[W̃^Cg擾
	char* GetTitle(int);			//wy[W̃^Cg擾
};

//////////////////////
// o[֐̎
//////////////////////
//RXgN^[(̂݁iPjj
CTAB::CTAB() {

	m_hWnd			= 0;
	m_dwExStyle		= 0;
	m_lpClassName	= "SYSTABCONTROL32";
	m_lpWindowName	= NULL;
	m_dwStyle		= WS_CHILD | WS_CLIPSIBLINGS | WS_VISIBLE;
	m_x				= 0;
	m_y				= 0;
	m_Width			= 0;
	m_Height		= 0;
	m_hParent		= NULL;
	m_hMenu			= NULL;
	m_hInstance		= 0;
	m_lpParam		= NULL;
	//C[WXg̏il16 x 16|16Fj
	m_hIList = ImageList_Create(16, 16, ILC_COLOR4, MAX_PAGE, 0);
	if(!m_hIList)
		MessageBox(m_hWnd, "C[WXg̏Ɏs܂",
					"x", MB_OK | MB_ICONSTOP);
}

//RXgN^[(̂݁jiQj
CTAB::CTAB(int w, int h, int c) {

	m_hWnd			= 0;
	m_dwExStyle		= 0;
	m_lpClassName	= "SYSTABCONTROL32";
	m_lpWindowName	= NULL;
	m_dwStyle		= WS_CHILD | WS_CLIPSIBLINGS | WS_VISIBLE;
	m_x				= 0;
	m_y				= 0;
	m_Width			= 0;
	m_Height		= 0;
	m_hParent		= NULL;
	m_hMenu			= NULL;
	m_hInstance		= 0;
	m_lpParam		= NULL;
	//C[WXg̏
	m_hIList = ImageList_Create(w, h, c, MAX_PAGE, 0);
	if(!m_hIList)
		MessageBox(m_hWnd, "C[WXg̏Ɏs܂",
					"x", MB_OK | MB_ICONSTOP);
}

//fXgN^[
CTAB::~CTAB() {

	ImageList_Destroy(m_hIList);
	DestroyWindow(m_hWnd);
}

//CTABRg[쐬֐
bool CTAB::Create(HWND hParent, HINSTANCE hInstance, int ID, int x = 0, int y = 0, int w = 0, int h = 0) {

	//ẽNCAg̈擾
	GetClientRect(m_hParent = hParent, &m_rectParent);
	if(!x) x = m_rectParent.left;
	if(!y) y = m_rectParent.top;
	if(!w) w = m_rectParent.right - m_rectParent.left;
	if(!h) h = m_rectParent.bottom - m_rectParent.top;
	m_hInstance = hInstance;
	m_hMenu = (HMENU)ID;
	CCTRL::Create("", m_dwStyle, 0, m_hParent, ID, x, y, w, h);
	return TRUE;
}

//^uړ
void CTAB::MoveTab(int x, int y, int w , int h) {

	int focus = TabCtrl_GetCurSel(m_hWnd);
	if(focus != -1)
		ShowWindow(GetDlgItem(m_hParent, m_CtrlID[focus]), SW_HIDE);
	m_x = x;
	m_y = y;
	m_Width = w;
	m_Height = h;
	MoveWindow(m_hWnd, x, y, w, h, TRUE);
	ShowWindow(GetDlgItem(m_hParent, m_CtrlID[focus]), SW_SHOWNORMAL);
}

//^ũTCYeEBhEɍ킹
void CTAB::FitParent(HWND hStatusBar = 0, HWND hToolBar = 0) {

	RECT rectStatus, rectTool;
	//eEBhẼTCY擾
	GetClientRect(m_hParent, &m_rectParent);
	//c[o[̍擾
	if(hToolBar) {
		GetWindowRect(hToolBar, &rectTool);
		m_rectParent.top += (rectTool.bottom - rectTool.top);
	}
	//Xe[^Xo[̍擾
	if(hStatusBar) {
		GetWindowRect(hStatusBar, &rectStatus);
		m_rectParent.bottom -= (rectStatus.bottom - rectStatus.top);
	}
	//^ũTCY킹
	MoveWindow(m_hWnd, m_x = m_rectParent.left, m_y = m_rectParent.top,
				m_Width = (m_rectParent.right - m_rectParent.left),
				m_Height = (m_rectParent.bottom - m_rectParent.top), TRUE);
	FitSiblings((WPARAM)m_hMenu);
}

//^u̕\TCYɐẽRg[TCY킹
void CTAB::FitSiblings(WPARAM wParam) {

	if(wParam != (WPARAM)m_hMenu)	return;	//^uRg[łȂ΋A
	int focus = TabCtrl_GetCurSel(m_hWnd);
	if(focus == -1)					return;	//IĂȂ΋A
	//eWM_SIZEbZ[WFitParent֐sۂɎs邽m_ẍʒu͍ŐV
	m_rectTab.left = m_x;
	m_rectTab.right = m_x + m_Width;
	m_rectTab.top = m_y;
	m_rectTab.bottom = m_y + m_Height;
	TabCtrl_AdjustRect(m_hWnd, FALSE, &m_rectTab);
	//Jg^uȊÕ^ũRg[BATCY𒲐
	for(int i = 0, j = TabCount(); i < j; i++) {
		if(i != focus)		//Jg^uȊÕ^ũRg[B
			ShowWindow(GetDlgItem(m_hParent, m_CtrlID[i]), SW_HIDE);
		MoveWindow(GetDlgItem(m_hParent, m_CtrlID[i]),
							m_rectTab.left, m_rectTab.top,
							m_rectTab.right - m_rectTab.left,
							m_rectTab.bottom - m_rectTab.top, TRUE);
	}
	//ŌɃJg^uRg[ĕ\ătH[JX𓖂Ă
	ShowWindow(GetDlgItem(m_hParent, m_CtrlID[focus]), SW_SHOWNORMAL);
	SetFocus(GetDlgItem(m_hParent, m_CtrlID[focus]));
}

//^uy[Wƕ\ẽRg[o^֐
bool CTAB::AddPage(int ID, int BitmapID, LPSTR Title) {

	int item = TabCount();
	//ɂ̃^uy[WɐẽRg[쐬Ă邩AMAX_PAGEł
	if(m_CtrlID[item] || item >= MAX_PAGE)
		return FALSE;	//G[ƂĉȂ
	//C[Wƃ^Cg^uɐݒ
	HBITMAP hBitmap = LoadBitmap(m_hInstance, MAKEINTRESOURCE(BitmapID));
	if(!hBitmap)
		MessageBox(m_hWnd, "rbg}bvǂݍ߂܂ł",
					"x", MB_OK | MB_ICONSTOP);
	TC_ITEM tcItem;		//^uRg[\
	tcItem.mask = TCIF_TEXT | TCIF_IMAGE;
	tcItem.pszText = Title;
	tcItem.iImage = ImageList_Add(m_hIList, hBitmap, NULL);
	if(tcItem.iImage == -1)
		MessageBox(m_hWnd, "rbg}bvo^ł܂ł",
					"x", MB_OK | MB_ICONSTOP);
	SendMessage(m_hWnd, TCM_INSERTITEM, item, (LPARAM)&tcItem);
	SendMessage(m_hWnd, TCM_SETIMAGELIST, 0, (LPARAM)m_hIList);
	DeleteObject(hBitmap);
	//VK^uy[Wɕ\ẽRg[ID̓o^
	m_CtrlID[item] = ID;
	//VK^uy[W\y[WɂĐẽRg[\
	TabCtrl_SetCurSel(m_hWnd, item);
	FitSiblings((WPARAM)m_hMenu);
	return TRUE;
}

//Jg^uƐe̕\Rg[폜
bool CTAB::DeletePage() {

	int item = TabCtrl_GetCurSel(m_hWnd);
	if(item == -1)	return FALSE;	//IĂȂ
	char Buff[MAX_PATH];			//xeobt@
	TC_ITEM tcItem;					//^uRg[\
	//݂̕\^uy[Wŕ\ĂẽRg[j
	DestroyWindow(GetDlgItem(m_hParent, m_CtrlID[item]));
	//^ũxrbg}bvj
	ImageList_Remove(m_hIList, item);
	//^uy[Wj
	TabCtrl_DeleteItem(m_hWnd, item);
	//󂢂^uy[Wɏʃ^uy[WÂJ艺
	for(int i = item, j = TabCount(); i < j; i++) {
		m_CtrlID[i] = m_CtrlID[i + 1];
		tcItem.mask = TCIF_TEXT | TCIF_IMAGE;
		tcItem.cchTextMax = MAX_PATH;
		tcItem.pszText = Buff;
		TabCtrl_GetItem(m_hWnd, i, &tcItem);
		tcItem.iImage--;
		TabCtrl_SetItem(m_hWnd, i, &tcItem);
	}
	m_CtrlID[TabCount()] = 0;
	TabCtrl_SetCurSel(m_hWnd, item);
	FitSiblings((WPARAM)m_hMenu);
	return TRUE;
}

//Jg^uŕ\ẽRg[̃nhԂ
HWND CTAB::GetCtrl() {

	int item = TabCtrl_GetCurSel(m_hWnd);
	if(item != -1)
		return GetDlgItem(m_hParent, m_CtrlID[item]);
	else
		return 0;
}

//Jgy[Wԍ擾
int CTAB::GetPage() {

	return SendMessage(m_hWnd, TCM_GETCURSEL, 0, 0);	//^uIĂȂꍇ-1
}

//Jgy[Wݒ肷
bool CTAB::SetPage(int cur) {

	int ret = SendMessage(m_hWnd, TCM_SETCURSEL, cur, 0);
	if(ret == -1)
		return FALSE;
	else
		return TRUE;
}

//Jgy[W̃^Cg擾
char* CTAB::GetTitle() {

	int item = TabCtrl_GetCurSel(m_hWnd);
	if(item == -1)
		return 0;
	static char Buff[MAX_PATH];		//xeobt@
	TC_ITEM tcItem;					//^uRg[\
	tcItem.mask = TCIF_TEXT;
	tcItem.cchTextMax = MAX_PATH;
	tcItem.pszText = Buff;
	TabCtrl_GetItem(m_hWnd, item, &tcItem);
	return Buff;
}

//wy[W̃^Cg擾
char* CTAB::GetTitle(int item) {

	if(item >= TabCount())
		return 0;
	static char Buff[MAX_PATH];		//xeobt@
	TCITEM tcItem;					//^uRg[\
	tcItem.mask = TCIF_TEXT;
	tcItem.cchTextMax = MAX_PATH;
	tcItem.pszText = Buff;
	TabCtrl_GetItem(m_hWnd, item, &tcItem);
	return Buff;
}
