/////////////////////////////
// CVSPLITNX`t@C
/////////////////////////////

#define	_SPLITBORDER	2

class CVSPLIT : public CCTRL
{
public:		//o[ϐ
	int m_VBorder;							//؂̏cʒu
	int m_HBorder1;							//؂̉ʒu
	int m_HBorder2;							//؂̉ʒu
	int m_ClientWidth;						//̃NCAg̈̕
	int m_ClientHeight;						//̃NCAg̈̍
	HCURSOR m_NormCrs;						//WJ[\
	HCURSOR m_HCursor;						//J[\
	HCURSOR m_VCursor;						//J[\
	bool m_VSwitch;							//cEړtO
	bool m_HSwitch1;						//EPړtO
	bool m_HSwitch2;						//EQړtO
	int m_CtrlID[4];						//eRg[ID(0-UL, 1-UR, 2LL, 3-LR)
	CTAB* m_Tab[4];							//Tabgꍇ̃|C^[(0-UL, 1-UR, 2LL, 3-LR)

public:		//o[֐
	CVSPLIT();									//RXgN^[iPj
	CVSPLIT(int, int, int);							//RXgN^[iQj
	~CVSPLIT();										//fRXgN^[
	bool Create(HWND, HINSTANCE, int);				//CVSPLITEBhE쐬֐
	void AutoSize(HWND, HWND);						//TCY
	static LRESULT CALLBACK DummyProc(HWND, UINT, WPARAM, LPARAM);	//_~[̃R[obN֐
	virtual LRESULT CALLBACK SplitProc(HWND, UINT, WPARAM, LPARAM);	//{̃R[obN֐
	void SetBorders(int, int, int);					//Ëʒuݒ肷
	void MoveCtrl();								//Rg[ړ
	HWND SetCtrl(int, int);							//Rg[zu
	HWND GetCtrl(int);								//Rg[̃nhԂ
	void DeleteCtrl(int);							//Rg[폜
	CTAB* SetTab(int, int, int, int, int);			//Tabzu
	CTAB* GetTab(int);								//Tab̃|C^[Ԃ
	void DeleteTab(int);							//Tab폜
};

//////////////////////
// o[֐̎
//////////////////////
//RXgN^[(Pj
CVSPLIT::CVSPLIT() {

	m_hWnd			= 0;
	m_dwExStyle		= 0;
	m_lpClassName	= "VSPLITTER";
	m_lpWindowName	= NULL;
	m_dwStyle		= WS_CHILD | WS_CLIPCHILDREN;
	m_x				= 0;
	m_y				= 0;
	m_Width			= 0;
	m_Height		= 0;
	m_hParent		= NULL;
	m_hMenu			= NULL;
	m_hInstance		= 0;
	m_lpParam		= NULL;
	//J[\`
	m_NormCrs = LoadCursor(NULL, IDC_ARROW);	//WJ[\
	m_HCursor = LoadCursor(NULL, IDC_SIZEWE);	//J[\
	m_VCursor = LoadCursor(NULL, IDC_SIZENS);	//J[\
	m_VSwitch = m_HSwitch1 = m_HSwitch2 = FALSE;
	//Eʒȕ
	m_VBorder		= 150;
	m_HBorder1		= 300;
	m_HBorder2		= 300;
}

//RXgN^[(Qj
CVSPLIT::CVSPLIT(int v, int h1, int h2) {

	m_hWnd			= 0;
	m_dwExStyle		= 0;
	m_lpClassName	= "VSPLITTER";
	m_lpWindowName	= NULL;
	m_dwStyle		= WS_CHILD | WS_CLIPCHILDREN;
	m_x				= 0;
	m_y				= 0;
	m_Width			= 0;
	m_Height		= 0;
	m_hParent		= NULL;
	m_hMenu			= NULL;
	m_hInstance		= 0;
	m_lpParam		= NULL;
	//J[\`
	m_NormCrs = LoadCursor(NULL, IDC_ARROW);	//WJ[\
	m_HCursor = LoadCursor(NULL, IDC_SIZEWE);	//J[\
	m_VCursor = LoadCursor(NULL, IDC_SIZENS);	//J[\
	m_VSwitch = m_HSwitch1 = m_HSwitch2 = FALSE;
	//Eʒȕ
	m_VBorder		= v;
	m_HBorder1		= h1;
	m_HBorder2		= h2;
}

//fXgN^[
CVSPLIT::~CVSPLIT() {

	//Tabj󂷂
	for(int i = 0; i < 4; i++)
		if(m_Tab[i])	delete m_Tab[i];
	DestroyWindow(m_hWnd);
}

//EBhE쐬֐
bool CVSPLIT::Create(HWND hParent, HINSTANCE hInstance, int ID) {

	//EBhENX̓o^
	WNDCLASSEX WndClass;
	WndClass.cbSize		= sizeof(WNDCLASSEX);			//̍\̂̃TCY
	WndClass.style		= CS_HREDRAW | CS_VREDRAW;		//cړATCYύXĕ`
	WndClass.lpfnWndProc= DummyProc;					//_~[R[obN֐|C^[
	WndClass.cbClsExtra	= 0;							//̍\̈ȍ~ɒuoCg
	WndClass.cbWndExtra	= 0;							//CX^Xȍ~ɒuoCg
	WndClass.hInstance	= m_hInstance = hInstance;		//̃EBhẼCX^X
	WndClass.hIcon			= NULL;						//̃EBhENX̃ACR
	WndClass.hCursor		= m_NormCrs;				//̃EBhENX̃J[\
	WndClass.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);//̃EBhENX̔wiF
	WndClass.lpszMenuName	= NULL;						//̃EBhENX̃j[
	WndClass.lpszClassName	= m_lpClassName;			//̃EBhENX̖
	WndClass.hIconSm		= NULL;						//ŏ̏ACR
	if(!RegisterClassEx(&WndClass)) {
		MessageBox(0, "EBhEo^ł܂łB", "G[",
				MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return FALSE;
	}
	CCTRL::Create("", WS_CHILD | WS_CLIPCHILDREN, 0, m_hParent = hParent, ID);
	//vpeBɏ
 	SetProp(m_hWnd, "CVSPLIT", (HANDLE)this);
	return TRUE;
}

//Xvb^[̃TCYeEBhEɍ킹
void CVSPLIT::AutoSize(HWND hStatusBar = 0, HWND hToolBar = 0) {

	RECT rect;
	UINT x, y, w, h;
	//eEBhẼTCY擾
	GetClientRect(m_hParent, &rect);
	x = rect.left;
	y = rect.top;
	w = rect.right - rect.left;
	h = rect.bottom - rect.top;
	//c[o[̍擾
	if(hToolBar) {
		GetWindowRect(hToolBar, &rect);
		y += rect.bottom - rect.top;
		h -= rect.bottom - rect.top;
	}
	//Xe[^Xo[̍擾
	if(hStatusBar) {
		GetWindowRect(hStatusBar, &rect);
		h -= rect.bottom - rect.top;
	}
	//Xvb^[̃TCY킹
	MoveWindow(m_hWnd, x, y, w, h, TRUE);
	//CVSPLITEBhËʒuATCYۑ
	GetClientRect(m_hWnd, &rect);
	m_ClientWidth = rect.right - rect.left;
	m_ClientHeight = rect.bottom - rect.top;
}

//_~[R[obN֐
LRESULT CALLBACK CVSPLIT::DummyProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam) {

	//Inito[֐񂾂̃NX̃CX^Xւ̃|C^[ǂ
	CVSPLIT* pSplit = (CVSPLIT*)GetProp(hWnd, "CVSPLIT");
	//ꂪǂݍ߂
	if(pSplit) {
		//{̃R[obN֐iSplitProcjĂ
		LRESULT lResult = pSplit->SplitProc(hWnd, Message, wParam, lParam);
		//WM_DESTROYbZ[WiKŃEBhEvpeBp
		if (Message == WM_DESTROY)
			RemoveProp(hWnd, "CVSPLIT");
		return lResult;
	}
	else
		//EBhEY̏ɔC
		return DefWindowProc(hWnd, Message, wParam, lParam);
}

//{̃R[obN֐iz֐j
LRESULT CALLBACK CVSPLIT::SplitProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam) {

	switch(Message) {
		case WM_CREATE:
			//ẽNCAg̈ɂ킹
			RECT rec;
			GetClientRect(m_hParent, &rec);
			SendMessage(m_hParent, WM_SIZE, SIZE_RESTORED,
						MAKELONG(rec.right - rec.left, rec.bottom - rec.top));
			return 0;
		case WM_NOTIFY:
			//eɃbZ[W݉B
			SendMessage(m_hParent, WM_NOTIFY, (int)m_hMenu, lParam);
			//TabRg[
			for(int i = 0; i < 4; i++)
				if(m_Tab[i])	m_Tab[i]->FitSiblings(wParam);
			break;
		case WM_LBUTTONDOWN:
			//J[\`ωĐEP̈ړ
			if(LOWORD(lParam) < m_VBorder - _SPLITBORDER) {
				if(HIWORD(lParam) >= m_HBorder1 - _SPLITBORDER &&
					HIWORD(lParam) <= m_HBorder1 + _SPLITBORDER) {
					SetCursor(m_VCursor);
					m_HSwitch1 = TRUE;
					SetCapture(hWnd);
				}
			}
			//J[\`ωĐEQ̈ړ
			else if(LOWORD(lParam) > m_VBorder + _SPLITBORDER) {
				if(HIWORD(lParam) >= m_HBorder2 - _SPLITBORDER &&
					HIWORD(lParam) <= m_HBorder2 + _SPLITBORDER) {
					SetCursor(m_VCursor);
					m_HSwitch2 = TRUE;
					SetCapture(hWnd);
				}
			}
			//J[\`ωĐËړ
			else {
				SetCursor(m_HCursor);
				m_VSwitch = TRUE;
				SetCapture(hWnd);
			}
			break;
		case WM_MOUSEMOVE:
			//{^Ă΁AJ[\`ωċEړsȂ
			if(wParam & MK_LBUTTON) {
				POINTS pt = MAKEPOINTS(lParam);
				if(m_VSwitch) {
					SetCursor(m_HCursor);
					m_VBorder = pt.x;
					if(m_VBorder < _SPLITBORDER)
						m_VBorder = _SPLITBORDER;
					else if(m_VBorder > m_ClientWidth - _SPLITBORDER)
						m_VBorder = m_ClientWidth - _SPLITBORDER;
					MoveCtrl();
				}
				if(m_HSwitch1) {
					SetCursor(m_VCursor);
					m_HBorder1 = pt.y;
					if(m_HBorder1 < _SPLITBORDER)
						m_HBorder1 = _SPLITBORDER;
					else if(m_HBorder1 > m_ClientHeight - _SPLITBORDER)
						m_HBorder1 = m_ClientHeight - _SPLITBORDER;
					MoveCtrl();
				}
				if(m_HSwitch2) {
					SetCursor(m_VCursor);
					m_HBorder2 = pt.y;
					if(m_HBorder2 < _SPLITBORDER)
						m_HBorder2 = _SPLITBORDER;
					else if(m_HBorder2 > m_ClientHeight - _SPLITBORDER)
						m_HBorder2 = m_ClientHeight - _SPLITBORDER;
					MoveCtrl();
				}
			}
			//{^ĂȂ΃J[\`ω邾
			else {
				if(LOWORD(lParam) < m_VBorder - _SPLITBORDER) {
					if(HIWORD(lParam) >= m_HBorder1 - _SPLITBORDER &&
						HIWORD(lParam) <= m_HBorder1 + _SPLITBORDER) {
						SetCursor(m_VCursor);
					}
				}
				else if(LOWORD(lParam) > m_VBorder + _SPLITBORDER) {
					if(HIWORD(lParam) >= m_HBorder2 - _SPLITBORDER &&
						HIWORD(lParam) <= m_HBorder2 + _SPLITBORDER) {
						SetCursor(m_VCursor);
					}
				}
				else
					SetCursor(m_HCursor);
			}
			break;
		case WM_LBUTTONUP:
			//J[\`ɖ߂AEړ֎~
			m_VSwitch = FALSE;
			m_HSwitch1 = FALSE;
			m_HSwitch2 = FALSE;
			SetCursor(m_NormCrs);
			ReleaseCapture();
			for(int i = 0; i < 4; i++)
				if(m_Tab[i])	m_Tab[i]->FitSiblings(m_CtrlID[i]);
			break;
		case WM_SIZE:
			//CVSPLITEBhẼTCYۑ
			m_ClientWidth = LOWORD(lParam);
			m_ClientHeight = HIWORD(lParam);
			//Rg[̃TCY|m_CtrlID[2/3]ɍ킹m_CtrlID[0/1]𓮂
			//̓CHSPLITNXƈقȂ܂i𒲍ĉ͓Ȃj
			if(!m_CtrlID[1] && !m_CtrlID[3])
				m_VBorder = m_ClientWidth;
			RECT rect;
			if(!m_CtrlID[2])
				m_HBorder1 = m_ClientHeight;
			else {
				GetWindowRect(GetDlgItem(m_hWnd, m_CtrlID[2]), &rect);
				m_HBorder1 = m_ClientHeight - rect.bottom + rect.top - _SPLITBORDER * 2;
			}
			if(!m_CtrlID[3])
				m_HBorder2 = m_ClientHeight;
			else {
				GetWindowRect(GetDlgItem(m_hWnd, m_CtrlID[3]), &rect);
				m_HBorder2 = m_ClientHeight - rect.bottom + rect.top - _SPLITBORDER * 2;
			}
			MoveCtrl();
			break;
		default:
			return DefWindowProc(hWnd, Message, wParam, lParam);
	}
	return 0;
}

//Ëʒuݒ肷
void CVSPLIT::SetBorders(int v, int h1, int h2) {

	m_VBorder = v;
	m_HBorder1 = h1;
	m_HBorder2 = h2;
	MoveCtrl();
}

//Rg[ړ
void CVSPLIT::MoveCtrl() {

	//h~̂߂ɁAEChE̍XVꎞXgbv
	LockWindowUpdate(m_hWnd);
	if(m_CtrlID[0])
		if(m_Tab[0])
			m_Tab[0]->MoveTab(0, 0, m_VBorder - _SPLITBORDER * 2, m_HBorder1 - _SPLITBORDER);
		else
			MoveWindow(GetCtrl(0), 0, 0, m_VBorder - _SPLITBORDER * 2, m_HBorder1 - _SPLITBORDER, TRUE);
	if(m_CtrlID[1])
		if(m_Tab[1])
			m_Tab[1]->MoveTab(m_VBorder + _SPLITBORDER, 0, m_ClientWidth - m_VBorder - _SPLITBORDER * 2, m_HBorder2 - _SPLITBORDER);
		else
			MoveWindow(GetCtrl(1), m_VBorder + _SPLITBORDER, 0, m_ClientWidth - m_VBorder - _SPLITBORDER * 2, m_HBorder2 - _SPLITBORDER, TRUE);
	if(m_CtrlID[2])
		if(m_Tab[2])
			m_Tab[2]->MoveTab(0, m_HBorder1 + _SPLITBORDER, m_VBorder - _SPLITBORDER * 2, m_ClientHeight - m_HBorder1 - _SPLITBORDER);
		else
			MoveWindow(GetCtrl(2), 0, m_HBorder1 + _SPLITBORDER, m_VBorder - _SPLITBORDER * 2, m_ClientHeight - m_HBorder1 - _SPLITBORDER, TRUE);
	if(m_CtrlID[3])
		if(m_Tab[3])
			m_Tab[3]->MoveTab(m_VBorder + _SPLITBORDER, m_HBorder2 + _SPLITBORDER, m_ClientWidth - m_VBorder - _SPLITBORDER * 2, m_ClientHeight - m_HBorder2 - _SPLITBORDER);
		else
			MoveWindow(GetCtrl(3), m_VBorder + _SPLITBORDER, m_HBorder2 + _SPLITBORDER, m_ClientWidth - m_VBorder - _SPLITBORDER * 2, m_ClientHeight - m_HBorder2 - _SPLITBORDER, TRUE);
	LockWindowUpdate(NULL);
	//ĊJł͏Ȃ̂ŁAĕ`
	UpdateWindow(m_hWnd);
}

//Rg[zu
HWND CVSPLIT::SetCtrl(int pos, int ID) {

	//ɍ쐬ĂΉȂŋA
	if(m_CtrlID[pos])	return FALSE;
	//Rg[ID̓o^
	m_CtrlID[pos] = ID;
	//SplitterRg[̐eɂ
	SetParent(GetDlgItem(m_hParent, m_CtrlID[pos]), m_hWnd);
	//Rg[̈ړ
	MoveCtrl();
	return GetDlgItem(m_hWnd, m_CtrlID[pos]);
}

//Rg[̃nhԂ
HWND CVSPLIT::GetCtrl(int pos) {

	return GetDlgItem(m_hWnd, m_CtrlID[pos]);
}

//Rg[폜
void CVSPLIT::DeleteCtrl(int pos) {

	//EBhEj󂷂
	DestroyWindow(GetDlgItem(m_hWnd, m_CtrlID[pos]));
	m_CtrlID[pos] = 0;	//s݂̏
}

//Tabzu
CTAB* CVSPLIT::SetTab(int pos, int ID, int w = 16, int h  = 16, int c = ILC_COLOR4) {

	//ɍ쐬ĂΉȂŋA
	if(m_CtrlID[pos])	return FALSE;
	//Rg[ID̓o^
	m_CtrlID[pos] = ID;
	//CTABNX̃IuWFNg𐶐
	m_Tab[pos] = new CTAB(w, h, c);
	m_Tab[pos]->Create(m_hWnd, m_hInstance, ID);
	//Rg[̈ړ
	MoveCtrl();
	return m_Tab[pos];
}

//Tab̃|C^[Ԃ
CTAB* CVSPLIT::GetTab(int pos) {

	return m_Tab[pos];
}

//Tab폜
void CVSPLIT::DeleteTab(int pos) {

	//Tab̃y[Wj󂷂
	for(int i = 0, j = m_Tab[pos]->TabCount(); i < j; i++) {
		TabCtrl_SetCurSel(m_Tab[pos]->m_hWnd, i);
		m_Tab[pos]->DeletePage();
	}
	//Tabj󂷂
	DestroyWindow(GetDlgItem(m_hWnd, m_CtrlID[pos]));
	delete m_Tab[pos];
	m_Tab[pos] = 0;
	m_CtrlID[pos] = 0;	//s݂̏
}
