//////////////////////////////////////////
// ECCSkelton
// rbg}bvExNXCBMPEX`t@C
// Copyright (c) August, 2022
//        By Ysama
//////////////////////////////////////////
/////////////
//ǉ\
/////////////
//ICONDIRENTRY\̐錾@|@16oCg
typedef struct tagICONDIRENTRY {
	BYTE	bWidth;				//摜iPʁFsNZj
	BYTE	bHeight;			//摜iPʁFsNZj
	BYTE	bColorCount;		//摜̐Fi256Fȏ0j
	BYTE	bReserved;			//\ς݁i0j
	WORD	wPlanes;			//J[v[iJ[\AXzbgX|bgj
	WORD	wBitCount;	  		//sNZ̃rbg[xiJ[\AYzbgX|bgj
	DWORD   dwBytesInRes;   	//sNZf[^̃oCg
	DWORD   dwImageOffset;  	//t@C擪sNZf[^܂ł̃ItZbg
}ICONDIRENTRY, *LPICONDIRENTRY;

//ICONDIR\̐錾@|@6oCg
typedef struct tagICONDIR {
	WORD	idReserved;			//\ς݁i0j
	WORD	idType;				//\[X^Cv:ACRF1AJ[\F2
	WORD	idCount;			//ACR̐
}ICONDIR, *LPICONDIR;

//---------------------------------------
// CBMPEX Class - rbg}bvNX
//---------------------------------------
class CBMPEX : public CBMP {

public:
	//ACRnh
	HICON m_hIcon;
	//ACR\
	ICONINFO m_iconinfo;
	//fXgN^[
	~CBMPEX();
	//t@CACR܂̓J[\荞ށiIcon-1ACursor-2j
	bool LoadIconFromBMP(HWND, LPCWSTR, UINT, bool, int);
	//t@CփACR܂̓J[\ށiIcon-1ACursor-2j
	bool SaveAsIcon(LPWSTR, int, UINT, int, int);
	//ʂ㉺(flag - FALSE)E(flag - TRUE)]摜̃rbg}bv擾
	bool FlipImage(HWND, int, int, int, int, bool);
};

//fXgN^[
CBMPEX::~CBMPEX() {
	if(m_hIcon)
		DestroyIcon(m_hIcon);
}

//////////////////////////////////////////////////////////////
//ACR܂̓J[\荞
//iType	: Icon = 1ACursor = 2
//flag	: t@C = TRUEiKljA\[X = FALSE
//num	: Ԗڂ̃rbg}bvǂނi"0"x[XAKl|0j
//////////////////////////////////////////////////////////////
bool CBMPEX::LoadIconFromBMP(HWND hWnd, LPCWSTR FileName, UINT iType,
								bool flag = TRUE, int num = 0) {

	//C[W^Cv`FbNiIMAGE_ICON, IMAGE_CURSORȊO̓G[j
	if(iType != 1 && iType != 2)
		return FALSE;
	//VKAύX̏
	m_hWnd = hWnd;
	CheckandInit();	//PBmfPBmi̓ACRAJ[\łNULL̂܂܂ƂȂ
	//[hIvViftHg̓t@Ćj
	UINT fLoad;
	if(flag)
		fLoad = LR_DEFAULTCOLOR | LR_LOADFROMFILE;
	else
		fLoad = LR_DEFAULTCOLOR;
	//ACRAJ[\̃[hî͔̂jj
	if(m_hIcon)
		DestroyIcon(m_hIcon);
 	m_hIcon = (HICON)LoadImageW((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
				FileName, iType, 0, 0, fLoad);
	if(!m_hIcon)	//ACR܂̓J[\̓ǂݍ݂ɎsꍇG[
		return FALSE;
	//ACR擾
	GetIconInfo(m_hIcon, &m_iconinfo);
	//ACR܂̓J[\̃J[rbg}bvo^
	if(!(m_hBMP = m_iconinfo.hbmColor)) {
		//J[rbg}bvnh0̏ꍇAmNrbg}bvƂȂ
		/* If this structure defines a black and white icon,
		this bitmask is formatted so that the upper half is
		the icon AND bitmask and the lower half is the icon XOR bitmask.
		*/
		m_hBMP =  m_iconinfo.hbmMask;
	}
	//Uǂݍ񂾃J[rbg}bvDDB擾
	GetObject(m_hBMP, sizeof(BITMAP), (LPVOID)&m_Bmp);
	//KTCYł͂ȂꍇAG[Ƃď
	if(m_Bmp.bmWidth != 32 && m_Bmp.bmWidth != 16) {
		MessageBoxW(m_hWnd, L"TCYKi16 x 16A32 x 32jOł", L"G[", MB_OK | MB_ICONSTOP);
		DestroyIcon(m_hIcon);
		return FALSE;
	}
	//t@CACR܂̓J[\̃TCYAF擾ďC
	ICONDIR icondir;
	ICONDIRENTRY icondirentry;
	DWORD dwResult;
	//t@CI[v
	HANDLE hFile = CreateFileW(FileName, GENERIC_READ, 0, NULL, OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;
	//t@CICONDIRǂݍ
	ReadFile(hFile, (ICONDIR*)&icondir, sizeof(ICONDIR), &dwResult, NULL);
	//擾Ώہinumjrbg}bvo^iicondir.idCountjȏ̏ꍇG[
	if(num >= icondir.idCount) {
		CloseHandle(hFile);
		return FALSE;
	}
	//擪numԖڂICONDIRENTRYփt@C|C^[ړ
	SetFilePointer(hFile, sizeof(ICONDIR) + sizeof(ICONDIRENTRY) * num,
					NULL, FILE_BEGIN);
	//t@CnumԖڂICONDIRENTRYǂݍ
	ReadFile(hFile, (ICONDIRENTRY*)&icondirentry, sizeof(ICONDIRENTRY),
				&dwResult, NULL);
	//擪numԖڂ̃C[Wփt@C|C^[ړ
	SetFilePointer(hFile, icondirentry.dwImageOffset, NULL, FILE_BEGIN);
	//PBITMAPINFO(m_PBmi)̃[RGBQUADŊm
	m_PBmi = (PBITMAPINFO)LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER));
	if(!m_PBmi) {	//[mێs
		MessageBoxW(NULL, L"PBmĩ[J[mۂɎs܂",
					L"G[!", MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return FALSE;
	}
	//numԖڂ̃rbg}bvǂݍށi芸RGBQUAD͕KvȂj
	ReadFile(hFile, m_PBmi, sizeof(BITMAPINFOHEADER), &dwResult, NULL);
	m_Bmp.bmWidth = m_Bmp.bmHeight = m_PBmi->bmiHeader.biWidth;
	m_ClrBits = m_Bmp.bmBitsPixel = m_PBmi->bmiHeader.biBitCount;
	//Icont@CN[Y
	if(!CloseHandle(hFile))
		MessageBoxW(NULL, L"t@CN[Ył܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
	return TRUE;
}

///////////////////////////////////////////////////////
//t@Cփrbg}bv
//FileName	: t@CpXƃt@C
//CBit		: F[i1, 4, 8, 16, 24, 32bitj
//iType		: Icon = 1ACursor = 2
//hsx, hsy	: J[\̏ꍇAzbgX|bgx, yW
///////////////////////////////////////////////////////
bool CBMPEX::SaveAsIcon(LPWSTR FileName, int CBit = 0,
						UINT iType = 1, int hsx = 0, int hsy = 0) {

	//[Jϐ
	HANDLE hFile;			//tBnh
	LPBYTE lpBits;			//[ւ̃|C^[
	DWORD dwTotal;			//oCg
	DWORD dwTmp;			//WriteFile()֐̏oCgp
	DWORD BMPSize;			//rbg}bvTCYvZp
	int nSuccess;			//GetDIBits֐̐tO
	HDC hDC, hMem;			//fXNgbvDCƃRp`rbg}bvDC
	PBITMAPINFO PBmi;		//ݗp
	DWORD bmpSize;			//rbg}bbvoCgTCY
	int BkCol;				//wiFpbgԍiCbit == 1, 4, 8̏ꍇj
	char BkC[4];			//wiFpbgԍiCbit == 24̏ꍇj
	ICONDIR IconDir;		//ICONDIR\
	ICONDIRENTRY IconEntry;	//ICONDIRENTRY\
	LPBYTE mskBits;			//}XNrbg[ւ̃|C^[
	DWORD mskSize;			//}XNrbgoCgTCY
	//iTypẽ`FbN
	if(iType != 1 && iType != 2)
		return FALSE;
	//C[WTCY`FbNi16 x 1632 x 32󂯕tȂj
	if(m_Bmp.bmWidth != 32 && m_Bmp.bmWidth != 16)
		return FALSE;
	//CBit̃`FbNi1, 4, 8, 16, 24, 32ȊO͎󂯕tȂj
	switch(CBit) {
	case 1:
	case 4:
	case 8:
	case 16:
	case 24:
	case 32:
		break;
	default:
		return FALSE;
	}
	//PBITMAPINFO PBmïׂ̃[mہiŒ胁[E[ŏj
	if (CBit <= 8)
		PBmi = (PBITMAPINFO)LocalAlloc(LPTR,
				sizeof(BITMAPINFOHEADER) +
				sizeof(RGBQUAD) * (1 << CBit));
	//24bittH[}bgBI_RGB̏ꍇRGBQUADȂ
	else
		PBmi = (PBITMAPINFO)LocalAlloc(LPTR,
				sizeof(BITMAPINFOHEADER));
	if(!PBmi) {	//[mێs
			MessageBoxW(NULL, L"PBmĩ[J[mۂɎs܂",
						L"G[!", MB_OK | MB_ICONSTOP);
			return FALSE;
	}
	//rbg}bvf[^TCYZo
	BMPSize = ((CBit * m_Bmp.bmWidth + 31) / 32) * 4
				* abs(m_Bmp.bmHeight);
	//BITMAPINFȌ
	PBmi->bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	PBmi->bmiHeader.biWidth			= m_Bmp.bmWidth;
	PBmi->bmiHeader.biHeight		= m_Bmp.bmHeight;
	PBmi->bmiHeader.biPlanes		= 1;
	PBmi->bmiHeader.biBitCount		= CBit;
	PBmi->bmiHeader.biCompression	= BI_RGB;	//0x0
	PBmi->bmiHeader.biSizeImage		= BMPSize;
	PBmi->bmiHeader.biXPelsPerMeter	= 0;
	PBmi->bmiHeader.biYPelsPerMeter	= 0;
	PBmi->bmiHeader.biClrUsed		= 0;
	PBmi->bmiHeader.biClrImportant	= 0;
	//rbgp^[f[^̏
	lpBits = (LPBYTE)LocalAlloc(LPTR, BMPSize);
	if(!lpBits) {
		MessageBoxW(NULL, L"O[o[mۂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		return FALSE;
	}
	//ŐFύX
	hDC = GetDC(0);					//fXNgbṽfoCXReLXg
	hMem = CreateCompatibleDC(hDC);	//̃Rp`DC
	SelectObject(hMem, m_hBMP);		//rbg}bvǂ܂
	//rbgzGetDIBits֐ŃO[o[Ɏo
	nSuccess = GetDIBits(hMem, m_hBMP, 0, m_Bmp.bmHeight,
							lpBits, PBmi, DIB_RGB_COLORS);
	DeleteDC(hMem) ;				//Rp`DC폜
	ReleaseDC(0, hDC);				//fXNgbṽfoCXReLXgJ
	if(!nSuccess) {	//FύXs
		MessageBoxW(NULL, L"FύXrbg}bṽrbgz擾Ɏs܂",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree((HGLOBAL)lpBits);
		return FALSE;
	}
	//@Ql@
	
	//W x H̃{gAbviH̏ꍇ)rbg}bv̏ꍇ
	// H
	//
	//31܂					yz
	//15 * * * * * * * *     *	u*vsNZ\fPʂƂ
	//`						yCBit == 1̏ꍇz
	// 7 * * * * * * * *     *	 2i16j܂4i32joCg̊erbg
	// 6 * * * * * * * *     *	yCBit == 4̏ꍇz
	// 5 * * * * * * * *     *	 8i16j܂16i32joCg̏㉺e4rbg
	// 4 * * * * * * * *     * 	yCBit == 8̏ꍇz
	// 3 * * * * * * * *     *	 16܂32oCg̊e8rbgi1oCgj
	// 2 * * * * * * * *     *	yCBit == 24̏ꍇz
	// 1 * * * * * * * *     *	 16 x 3܂32 x 3oCg̊e3oCgiBGȐj
	// 0 * * * * * * * *     *	yCBit == 16܂32̏ꍇze2܂4oCg
	//   0 1 2 3 4 5 6 7 ` 15܂31
	//
	//C[WŉE[sNZ̐FwiFɐݒ肵A1oCgo
	if(PBmi->bmiHeader.biHeight > 0) {	//{gAbv
		switch(CBit) {
		case 1:		//mN̏ꍇ́u / 8voCg̑1rbgl
			BkCol = lpBits[m_Bmp.bmWidth / 8 - 1] & 1;	//01ƂȂ
			break;
		case 4:		//16F̏ꍇu / 2voCĝ͉4rbgl
			BkCol = lpBits[m_Bmp.bmWidth / 2 - 1] & 0xF;
			break;
		case 8:		//256F̏ꍇ8rbgl
			BkCol = lpBits[m_Bmp.bmWidth - 1];
			break;
		case 16:	//16bit̏ꍇ2byte(RGB555 or 565̏)l
			BkC[0] = lpBits[m_Bmp.bmWidth * 2 - 2];	//RGB555܂
			BkC[1] = lpBits[m_Bmp.bmWidth * 2 - 1];	//RGB565z
			break;
		case 24:	//24bit̏ꍇ3byte(BRG̏)l
			BkC[0] = lpBits[m_Bmp.bmWidth * 3 - 3];	//B
			BkC[1] = lpBits[m_Bmp.bmWidth * 3 - 2];	//G
			BkC[2] = lpBits[m_Bmp.bmWidth * 3 - 1];	//R
			break;
		case 32:	//32bit̏ꍇ4byte(BRGRsvd̏)l
			BkC[0] = lpBits[m_Bmp.bmWidth * 4 - 4];	//B
			BkC[1] = lpBits[m_Bmp.bmWidth * 4 - 3];	//G
			BkC[2] = lpBits[m_Bmp.bmWidth * 4 - 2];	//R
			BkC[3] = lpBits[m_Bmp.bmWidth * 4 - 1];	//Rsvd
			break;
		}
    }
	else {								//{g_E
		switch(CBit) {
		case 1:		//mN̏ꍇ͍ŏIoCg̑1rbgl
			BkCol = lpBits[BMPSize - 1] & 1;	//01ƂȂ
			break;
		case 4:		//16F̏ꍇ͍ŏIoCg̉4rbgl
			BkCol = lpBits[BMPSize - 1] & 0xf;
			break;
		case 8:		//256F̏ꍇŏIoCgl
			BkCol = lpBits[BMPSize - 1];
			break;
		case 16:	//16bit̏ꍇ͂2byte(RGB555 or 565̏)l
			BkC[0] = lpBits[BMPSize - 2];		//RGB555܂
			BkC[1] = lpBits[BMPSize - 1];		//RGB565z
			break;
		case 24:	//24bit̏ꍇ3byte(BRG̏)l
			BkC[0] = lpBits[BMPSize - 3];		//B
			BkC[1] = lpBits[BMPSize - 2];		//G
			BkC[2] = lpBits[BMPSize - 1];		//R
			break;
		case 32:	//32bit̏ꍇ4byte(BRGRsvd̏)l
			BkC[0] = lpBits[BMPSize - 4];		//B
			BkC[1] = lpBits[BMPSize - 3];		//G
			BkC[2] = lpBits[BMPSize - 2];		//R
			BkC[3] = lpBits[BMPSize - 1];		//Rsvd
			break;
		}
	}
	//}XNrbg̃TCYZoi4̔{Ŗ΂ȂȂj
	mskSize = ((m_Bmp.bmWidth + 31) / 32) * 4 * abs(m_Bmp.bmHeight);
	//}XNrbgL̈쐬
	mskBits = (LPBYTE)LocalAlloc(LPTR, mskSize);
	if(!mskBits) {
		MessageBoxW(NULL, L"O[o[mۂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree((HGLOBAL)lpBits);
		return FALSE;
	}
	//}XNrbgp^[̍쐬
	char Bit, tmp;	//eoCg̑lZopϐitmp1|߂ORĂ䂭j
	int Dat;		//4bitrbg}bvpFf[^pϐ
	for(int i = 0; i < mskSize; i++) {
		Bit = 0;					//oCg0ɏ
		for(int j = 7; j >= 0; j--) {	//E֌čs
			switch(CBit) {
			case 1:
				tmp = 1 << j;
				if(lpBits[i] & tmp) {	//?0000000'1'ۂ̃`FbN
					if(BkCol)			//wiF'1'̏ꍇ
						Bit |= tmp;		//rbg'1'ɂē
				}
				else {					//OiF'0'̏ꍇł
					if(!BkCol)			//wiF'0'ł
						Bit |= tmp;		//rbg'1'ɂē
				}
				break;
			case 4:
				if(j % 2)
					Dat = lpBits[i * 4 + (7 - j) / 2] >> 4;
				else
					Dat = lpBits[i * 4 + (7 - j) / 2] & 0xF;
				if(Dat == BkCol) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			case 8:
				if(lpBits[i * 8 + 7 - j] == BkCol) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			case 16:
				if(lpBits[(i * 8 + 7 - j) * 2] == BkC[0] &&
				   lpBits[(i * 8 + 7 - j) * 2 + 1] == BkC[1]) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			case 24:
				if(lpBits[(i * 8 + 7 - j) * 3] == BkC[0] &&
				   lpBits[(i * 8 + 7 - j) * 3 + 1] == BkC[1] &&
				   lpBits[(i * 8 + 7 - j) * 3 + 2] == BkC[2]) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			case 32:
				if(lpBits[(i * 8 + 7 - j) * 4] == BkC[0] &&
				   lpBits[(i * 8 + 7 - j) * 4 + 1] == BkC[1] &&
				   lpBits[(i * 8 + 7 - j) * 4 + 2] == BkC[2] &&
				   lpBits[(i * 8 + 7 - j) * 4 + 3] == BkC[3]) {
					tmp = 1 << j;
					Bit |= tmp;
				}
				break;
			}
    	}
		mskBits[i] = Bit;
	}
	// 16̎ɂ2oCg0̂ŏCiȉ̓{gAbvj
	//@@@@̃f[^[̏ԁ@@@@@@@@@@@f[^@@@]0iǉj
	//											  00000000 00000000 00000000 00000000
	//											  00000000 00000000 00000000 00000000
	//											  00000000 00000000 00000000 00000000
	//											  00000000 00000000 00000000 00000000
	// 00000000 00000000 00000000 00000000 || 11111111 11111111 00000000 00000000
	// 00000000 00000000 00000000 00000000 || 10000000 00000001 00000000 00000000
	// 10000000 00000001 11111111 11111111 || 10000000 00000001 00000000 00000000
	// 11111111 11111111 10000000 00000001 || 11111111 11111111 00000000 00000000
	// -------------------------------------------------------------------------------
	// 01234567 89ABCDEF 01234567 89ABCDEF		   01234567 89ABCDEF 01234567 89ABCDEF
	if(m_Bmp.bmWidth == 16) {
		LPBYTE temp = (LPBYTE)LocalAlloc(LPTR, mskSize);
		if(!temp) {
			MessageBoxW(NULL, L"O[o[mۂł܂ł",
						L"G[", MB_OK | MB_ICONSTOP);
			LocalFree(PBmi);
			LocalFree(lpBits);
			LocalFree(mskBits);
			return FALSE;
		}
		int j = 0;
		for(int i = 0; i < mskSize / 2; i += 2, j += 4) {
			temp[j] = mskBits[i];
			temp[j + 1] = mskBits[i + 1];
			temp[j + 2] = 0;
			temp[j + 3] = 0;
		}
		memcpy(mskBits, temp, mskSize);
		LocalFree(temp);
	}
	//ICONDIR\̂̏
	IconDir.idReserved = 0;						//K0
	IconDir.idType = iType;						//ACȐꍇ1AJ[\̏ꍇ2
	IconDir.idCount = 1;						//Gg[̐
	//ICONDIRENTRY\̂̏
	IconEntry.bWidth = m_Bmp.bmWidth;			//ACR̕
	IconEntry.bHeight = m_Bmp.bmHeight;			//ACR̍
	switch(CBit) {								//FibColorCount  = 1 << (wBitCount * wPlanes)j
	case 1:
	case 4:
		IconEntry.bColorCount	= 1 << (1 * CBit);
		break;
	case 8:										//A256Fȏ̓[
	case 16:
	case 24:
	case 32:
		IconEntry.bColorCount	= 0;
		break;
	}
	IconEntry.bReserved			= 0;			//K0
	if(iType == 1) {							//ACȐꍇ
		IconEntry.wPlanes		= 1;			//v[
		IconEntry.wBitCount		= CBit;			//rbgJEg
	}
	else if(iType == 2) {						//J[\̏ꍇ
		IconEntry.wPlanes		= hsx;			//xzbgX|bg
		IconEntry.wBitCount		= hsy;			//yzbgX|bg
	}
	//摜f[^̃oCg-BITMAPINFO(40) + (Color Pallette) + BMPSize + MaskBit size
	//1, 4, 8bittH[}bgBI_RGB̏ꍇRGBQUAD
	if (CBit <= 8)
		IconEntry.dwBytesInRes	= 40 + 4 * (1 << CBit) + BMPSize + mskSize;
	//24bittH[}bgBI_RGB̏ꍇRGBQUADȂ
	else
		IconEntry.dwBytesInRes	= 40 + BMPSize + mskSize;
	//摜f[^܂ł̃ItZbgICONDIR( = 6) + ICONDIRENTRY( = 16)
	IconEntry.dwImageOffset			= sizeof(ICONDIR) + sizeof(ICONDIRENTRY);
	//BITMAPINFO\̂̏C
	PBmi->bmiHeader.biHeight		= m_Bmp.bmHeight * 2;	//ʏ̃rbg}bvƈقȂ
	PBmi->bmiHeader.biCompression	= 0;					//͏0
	PBmi->bmiHeader.biSizeImage		= BMPSize + mskSize;	//\f[^ƃ}XNf[^̍vTCY
	PBmi->bmiHeader.biXPelsPerMeter	= 0;
	PBmi->bmiHeader.biYPelsPerMeter	= 0;
	PBmi->bmiHeader.biClrUsed		= 0;
	PBmi->bmiHeader.biClrImportant	= 0;
	//------------
	//t@C쐬
	//------------
	//ݗpt@CJ
	hFile = CreateFileW(FileName,		//t@C
					GENERIC_WRITE,
					(DWORD)0,
					(LPSECURITY_ATTRIBUTES)NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL,
					(HANDLE)NULL);
	if(hFile == INVALID_HANDLE_VALUE) {
		MessageBoxW(NULL, L"t@CJƂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		GlobalFree((HGLOBAL)lpBits);
		GlobalFree((HGLOBAL)mskBits);
		return FALSE;
	}
	//ICONDIR\̂t@C֏
	if(!WriteFile(hFile, &IconDir, sizeof(ICONDIR), (LPDWORD)&dwTmp, (LPOVERLAPPED)NULL)) {
		MessageBoxW(NULL, L"ACRt@Cwb_[ނƂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree((HGLOBAL)lpBits);
		LocalFree((HGLOBAL)mskBits);
		CloseHandle(hFile);
		return FALSE;
	}
	//ICONDIRENTRY\̂t@C֏
	if(!WriteFile(hFile, &IconEntry, sizeof(ICONDIRENTRY), (LPDWORD)&dwTmp, (LPOVERLAPPED)NULL)) {
		MessageBoxW(NULL, L"ACRwb_[ނƂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree(lpBits);
		LocalFree(mskBits);
		CloseHandle(hFile);
		return FALSE;
	}
	//BITMAPINFOHEADERRGBQUADt@C֏
	if (CBit <= 8) {
		if(!WriteFile(hFile, PBmi, 40 + 4 * (1 << CBit), (LPDWORD)&dwTmp, (LPOVERLAPPED) NULL)) {
			MessageBoxW(NULL, L"rbg}bvƃJ[e[uނƂł܂ł",
						L"G[", MB_OK | MB_ICONSTOP);
			LocalFree(PBmi);
			LocalFree(lpBits);
			LocalFree(mskBits);
			CloseHandle(hFile);
			return FALSE;
		}
	}
	//24bittH[}bgBI_RGB̏ꍇRGBQUADȂ
	else {
		if(!WriteFile(hFile, PBmi, 40, (LPDWORD)&dwTmp, (LPOVERLAPPED) NULL)) {
			MessageBoxW(NULL, L"rbg}bvƃJ[e[uނƂł܂ł",
						L"G[", MB_OK | MB_ICONSTOP);
			LocalFree(PBmi);
			LocalFree(lpBits);
			LocalFree(mskBits);
			CloseHandle(hFile);
			return FALSE;
		}
	}
	//Colorrbg}bvrbgzt@C֏
	if(!WriteFile(hFile, lpBits, BMPSize, (LPDWORD)&dwTmp, (LPOVERLAPPED)NULL)) {
		MessageBoxW(NULL, L"J[rbgzނƂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree(lpBits);
		LocalFree(mskBits);
		CloseHandle(hFile);
		return FALSE;
	}
	//Maskrbg}bvrbgzt@C֏
	if(!WriteFile(hFile, mskBits, mskSize, (LPDWORD)&dwTmp, (LPOVERLAPPED)NULL)) {
		MessageBoxW(NULL, L"}XNrbgzނƂł܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
		LocalFree(PBmi);
		LocalFree(lpBits);
		LocalFree(mskBits);
		CloseHandle(hFile);
		return FALSE;
	}
	//Icont@CN[Y
	if(!CloseHandle(hFile))
		MessageBoxW(NULL, L"t@CN[Ył܂ł",
					L"G[", MB_OK | MB_ICONSTOP);
	//[
	LocalFree(PBmi);
	LocalFree(lpBits);
	LocalFree(mskBits);
	return TRUE;
}

//ʂ㉺(flag - FALSE)E(flag - TRUE)]摜̃rbg}bv擾
bool CBMPEX::FlipImage(HWND hWnd, int x, int y, int w, int h, bool flag = TRUE) {

	//
	CheckandInit();
	//Rp`rbg}bvɔ]摜ǂݎ
	m_hWnd = hWnd;
	HDC hDC = GetDC(hWnd);						//EBhEDC擾
	HDC memDC = CreateCompatibleDC(hDC);		//Rp`DC쐬
	m_hBMP = CreateCompatibleBitmap(hDC, w, h);	//Rp`rbg}bv쐬
	SelectObject(memDC, m_hBMP);				//rbg}bvI
	if(flag)
		StretchBlt(memDC, w - 1, 0, -w, h, hDC, x, y, w, h, SRCCOPY);
	else
		StretchBlt(memDC, 0, h - 1, w, -h, hDC, x, y, w, h, SRCCOPY);
	ReleaseDC(hWnd, hDC);						//EBhEDCJ
	DeleteObject(memDC);						//Rp`DC폜
	return GetDDBInfo();						//Vrbg}bv̏擾
}
