/////////////////////////////
// ECCSkelton
// CCMDEDITNX`t@C
// Copyright (c) August, 2022
//        By Ysama
/////////////////////////////

class CCMDEDIT : public CCTRL
{
public:
	int m_BuffSize;								//vZXo͗pobt@[
	HANDLE m_hRead;								//ǍppCvnh
	HANDLE m_hProcess;							//qvZX̃nh
	WCHAR* m_Pre;								//\擪
	WCHAR* m_Post;								//\

public:
	CCMDEDIT();									//RXgN^[
	CCMDEDIT(int);								//tRXgN^[
	void SetSize(int);							//vZXo͕̍ő吔̐ݒ
	bool Create(HWND, HINSTANCE, HMENU, int,
				int, int, int);					//CCMDEDITRg[쐬֐
	WCHAR* GetLine(WCHAR*, WPARAM, LPARAM);		//J[\̂1s擾
	void Move(int, int, int, int);				//GfCbgRg[̈ړ
	bool Exec(WCHAR*, WCHAR*, WCHAR*);			//exet@C̎s
	static DWORD WINAPI WaitThreadProc(LPVOID);	//vZXI҃vVW[
};

//RXgN^[
CCMDEDIT::CCMDEDIT() {

	m_hWnd			= 0;
	m_dwExStyle		= WS_EX_CLIENTEDGE;
	m_lpClassName	= L"EDIT";
	m_dwStyle		= WS_CHILD | WS_VISIBLE |
						WS_VSCROLL | ES_AUTOVSCROLL |
						WS_HSCROLL | ES_AUTOHSCROLL |
						ES_MULTILINE | ES_NOHIDESEL | ES_READONLY;
	SetSize(2);		//o̓obt@[̋Kl2K byte
	m_Pre = 0;
	m_Post = 0;
}

//tRXgN^[
CCMDEDIT::CCMDEDIT(int i) {

	m_hWnd			= 0;
	m_dwExStyle		= WS_EX_CLIENTEDGE;
	m_lpClassName	= L"EDIT";
	m_dwStyle		= WS_CHILD | WS_VISIBLE |
						WS_VSCROLL | ES_AUTOVSCROLL |
						WS_HSCROLL | ES_AUTOHSCROLL |
						ES_MULTILINE | ES_NOHIDESEL | ES_READONLY;
	SetSize(i);
	m_Pre = 0;
	m_Post = 0;
}

//vZXo͕̍ő吔̐ݒ
void CCMDEDIT::SetSize(int i) {

	if(i < 1 || i > 64) {
		MessageBoxW(NULL, L"TCY1KoCgPʂ1-64Ŏw肵ĉB",
					L"G[", MB_OK | MB_ICONSTOP);
		return;
	}
	m_BuffSize = i * 1024 - 1;
}

//CCMDEDITEBhE쐬֐
bool CCMDEDIT::Create(HWND hWnd, HINSTANCE hInstance, HMENU ID,
						int x = 0, int y = 0, int w = 0, int h = 0) {

	m_hInstance = hInstance;
	return CCTRL::Create(L"", m_dwStyle, m_dwExStyle, hWnd, ID, x, y, w, h);
}

//EDITRg[͐eWM_COMMANDbZ[WŒʒmŝ
//LOWORD(wParam)ID𒲂ׂāÃRg[ȂA
//tH[JX̃J[\̂1s̕擾
WCHAR* CCMDEDIT::GetLine(WCHAR* Buffer, WPARAM wParam, LPARAM lParam) {

	DWORD cp1, cp2, ln;
	switch(HIWORD(wParam)) {			//bZ[W𒲂ׂ
	case EN_SETFOCUS:					//tH[JX
		//J[\̃LN^[CfbNX擾
		SendMessageW(m_hWnd, EM_GETSEL, (WPARAM)&cp1, (LPARAM)&cp2);
		//̍s̍ŏƍŌ̕LN^[CfbNX擾
		ln = SendMessageW(m_hWnd, EM_LINEFROMCHAR, cp1, 0);
		cp1 = SendMessageW(m_hWnd, EM_LINEINDEX, ln, 0);
		cp2 = SendMessageW(m_hWnd, EM_LINEINDEX, ln + 1, 0);
		//̍sIƋɂPs̕擾
		SendMessageW(m_hWnd, EM_SETSEL, cp1, cp2);
		ln = SendMessageW(m_hWnd, EM_GETLINE, ln, (LPARAM)Buffer);
		Buffer[ln] = NULL;				//擾NULLI[
		SetFocus(m_hParent);			//tH[JXOieɈڂj
		break;
	default:
		return NULL;
	}
	return Buffer;
}

//GfCbgRg[̈ړ
void CCMDEDIT::Move(int x, int y, int w, int h) {

	MoveWindow(m_hWnd, x, y, w, h, TRUE);
}

//exet@C̎s
bool CCMDEDIT::Exec(WCHAR* FileName, WCHAR* Pre = 0, WCHAR* Post = 0) {

	//擪A̐̕ݒ
	if(Pre)
		m_Pre = Pre;
	if(Post)
		m_Post = Post;
	//[Jϐ
	HANDLE hWrite;
	SECURITY_ATTRIBUTES sa;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	//Security_Attribute̐ݒ
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.lpSecurityDescriptor = NULL;
	sa.bInheritHandle = TRUE;
	//evZX̃pCv
	if (!CreatePipe(&m_hRead, &hWrite, &sa, 0)) {
		MessageBoxW(m_hWnd, L"pCv̍쐬Ɏs܂", L"G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	//e̓ǍpCvpȂ
	if (!DuplicateHandle(GetCurrentProcess(),	//\[XvZX
			m_hRead,							//duplicatenh(IWinh)
			GetCurrentProcess(),				//^[QbgvZX(s)
			NULL,								//nhւ̃|C^(Rs[nh)
			0,									//ANZX
			FALSE,								//qnhp邩ǂ
			DUPLICATE_SAME_ACCESS)) {			//IvV
				MessageBoxW(m_hWnd, L"DuplicateHandleɎs܂",
							L"G[", MB_OK | MB_ICONSTOP);
				CloseHandle(hWrite);
				CloseHandle(m_hRead);
				m_hRead = NULL;
				return FALSE;
	}
	//X^[gAbv̐ݒipj
	ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	si.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_HIDE;	//Ďs
	si.hStdInput = GetStdHandle(STD_INPUT_HANDLE);
	si.hStdOutput = hWrite;
	si.hStdError = GetStdHandle(STD_ERROR_HANDLE );
	if(!CreateProcess(NULL, FileName, NULL, NULL, TRUE, 0, NULL, NULL, &si, &pi)) {
		MessageBoxW(m_hWnd, L"CreateProcessɎs܂", L"G[", MB_OK);
		CloseHandle(m_hRead);
		m_hRead = NULL;
		return FALSE;
	} 
	m_hProcess = pi.hProcess;
	CloseHandle(hWrite);
	CloseHandle(pi.hThread);

	DWORD dwThreadID;
	HANDLE hThread;
	hThread = CreateThread(NULL, 0,
							(LPTHREAD_START_ROUTINE)WaitThreadProc,
							(LPVOID)this, 0, &dwThreadID);
	return TRUE;
}

//vZXI҃vVW[
DWORD WINAPI CCMDEDIT::WaitThreadProc(LPVOID lpV) {

	CCMDEDIT* lpThis = (CCMDEDIT*)lpV;
	DWORD dwResult = 0;
	BOOL bSuccess;
	WCHAR* Buffer = new WCHAR [lpThis->m_BuffSize];
	lstrcpyW(Buffer, lpThis->m_Pre);		//擪̐ݒ
	WCHAR* cp = Buffer + lstrlenW(lpThis->m_Pre);
	while(TRUE) {
		bSuccess = ReadFile(lpThis->m_hRead, cp += dwResult, sizeof(lpThis->m_BuffSize), &dwResult, NULL);
		if(!bSuccess) {
			break;
		}
	}
	Buffer[cp - Buffer] = NULL;
	lstrcatW(Buffer, lpThis->m_Post);	//̐ݒ
	SendMessageW(lpThis->m_hWnd, WM_SETTEXT, 0, (LPARAM)Buffer);
	CloseHandle(lpThis->m_hRead);
	CloseHandle(lpThis->m_hProcess);
	delete [] Buffer;
	return dwResult;
}
