///////////////////////////////////////
// ECCSkelton
// Rg[NXCCTRL`t@C
// Copyright (c) August, 2022
//        By Ysama
///////////////////////////////////////

class CCTRL : public CWND
{
public:
	CFONT m_hFont;							//Rg[Ŝ̃tHg
public:		//o[֐
	bool Assign(LPWSTR, HWND, HMENU);		//Rg[t^֐
	bool Init(LPWSTR, HINSTANCE, LPWSTR,
				LPWSTR, LPWSTR, HBRUSH);	//Rg[쐬̂߂̏֐
	bool Create(LPWSTR, DWORD, DWORD, HWND, HMENU,
				int, int, int, int);		//Rg[쐬֐
	void SetInstance(HINSTANCE hInst)
					{m_hInstance = hInst;}	//CX^Xݒ
	virtual void SetFont(int, WCHAR*);		//tHgݒ(ڎwj
};

//Rg[t^֐
bool CCTRL::Assign(LPWSTR ClassName, HWND hParent, HMENU hMenu) {

	m_lpClassName = ClassName;										//̃Rg[NX̃EBhENX
	m_hParent = hParent;											//̃Rg[̐ẽnh
	m_hMenu = (HMENU)hMenu;											//̃Rg[ID
	m_hWnd = GetDlgItem(m_hParent, (int)m_hMenu);					//̃Rg[̃EBhEnh
	m_hInstance = (HINSTANCE)GetWindowLongW(m_hWnd, GWL_HINSTANCE);	//̃Rg[̃CX^X
	m_dwStyle = GetWindowLongW(m_hWnd, GWL_STYLE);
	m_dwExStyle = GetWindowLongW(m_hWnd, GWL_EXSTYLE);
	return TRUE;
}

//Rg[쐬̂߂̏֐
//iEBhENXo^͍sȂACWND̏z֐[ׂ̈Ɉ킹j
bool CCTRL::Init(LPWSTR ClassName, HINSTANCE hInstance,
				LPWSTR Menu = L"\0",
				LPWSTR Icon = L"\0", LPWSTR cur = L"\0",
				HBRUSH brush = (HBRUSH)0) {

	m_lpClassName = ClassName;		//̃Rg[NX̃EBhENX
	m_hInstance = hInstance;		//̃Rg[̃CX^X
	return TRUE;
}

//Rg[쐬֐
bool CCTRL::Create(LPWSTR WindowName, DWORD Style, DWORD ExStyle,
				HWND hParent, HMENU hMenu,
				int x = CW_USEDEFAULT, int y = CW_USEDEFAULT,
				int w = CW_USEDEFAULT, int h = CW_USEDEFAULT) {

	m_hWnd = CreateWindowExW(m_dwExStyle = ExStyle,
					    	m_lpClassName,
							m_lpWindowName = WindowName,
							m_dwStyle = Style,
							m_x = x,
							m_y = y,
							m_Width = w,
							m_Height = h,
							m_hParent = hParent,
							m_hMenu = hMenu,
							m_hInstance,
							m_lpParam
	);
	if(m_hWnd == NULL) {
		MessageBoxW(0, L"Rg[܂ł!", L"G[",
				MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
		return FALSE;
	}
	//Rg[̕\ƍĕ`
	ShowWindow(m_hWnd, SW_SHOWNORMAL);
	UpdateWindow(m_hWnd);
	return TRUE;
}

//------------------------
// tHgݒ(ڎwj
//------------------------
void CCTRL::SetFont(int size, WCHAR* FontName) {

	m_hFont.SetFont(m_hWnd, size, FontName);
}
