//////////////////////////////////////////
// FileHandler.cpp
//Copyright (c) 8/10/2022 by ECCSkelton
//////////////////////////////////////////
#include	"FileHandler.h"
#include	"CSPLIT.h"
#include	"User.h"
#include	"FileHandlerProc.h"

////////////////
// WinMain֐
////////////////
int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPWSTR lpCmdLine, int nCmdShow) {

	//QdNh~
	if(!FileHandler.IsOnlyOne()) {
		HWND hWnd = FindWindowW(L"MainWnd", L"FileHandler");
		if(IsIconic(hWnd))
			ShowWindow(hWnd, SW_RESTORE);
		SetForegroundWindow(hWnd);
		return 0L;
	}

	//EBhEo^ | Init(ClassName, hInstance, L"IDM_MAIN",
	//						iȉȗjMAKEINTRESOURCE(IDI_ICON), IDC_ARROW, Brush)
	FileHandler.Init(L"MainWnd", hInstance, L"IDM_MAINMENU", MAKEINTRESOURCE(IDI_ICON));

	//EBhE쐬ƕ\|Create(WindowTitle, (ȉȗjStyle,
	//						ExStyle, hParent, hMenu, x, y, w, h)
	if(!FileHandler.Create(L"FileHandler"))
		return 0L;

	//ANZ[^[o^|InclAccel("(Accelerator ID)")
	FileHandler.InclAccel(L"IDA_ACCEL");

	//bZ[W[vɓ
	return FileHandler.Loop();
}
