///////////////////////////////
//CALBUMNXibased on GDI+j
//Copyright (c) 2022 by Ysama
//GDI+gC[Wt@C
//̊Ǘ[eBeB
//ӁFAo̎gpɂGDI+A
//tHgNX̃wb_[捞
//KvłB
///////////////////////////////
//C[Wt@C̃tB^[
#define		IMGFILTER	"C[Wt@C\0*.bmp;*.jpeg;*.jpg;*.gif;*.tiff;*.png;*.wmf;*.emf;*.ico\0\0"
//GR[_[Xg
const WCHAR* g_EncoderList[5] = {L"image/bmp", L"image/jpeg", L"image/gif", L"image/tiff", L"image/png"};
//GDI+̃CN[hAl[Xy[X̎gp
#include	<gdiplus.h>
using namespace Gdiplus;

//Chgp̈"wchar.h"CN[h
#include <wchar.h>
//CPHOTONXwb_[
#include	"CPHOTO.h"

//C[Wt@C̍ő吔
#define	MAXIMG	0x200						//512̎ʐ^|[U[ύX

class CALBUM
{
private:
	//GDI+֌Wo[ϐ
	GdiplusStartupInput m_gdiSI;			//GDI+̃X^[gAbvCvbg
	ULONG_PTR m_gdiToken;					//GDI+̃g[N
	Graphics* m_pGraphics = 0;				//GraphicsIuWFNg|C^[
	Color m_Col = 0;						//ColorIuWFNg
	Pen* m_pPen = 0;						//``ׂ̈̃yIuWFNg|C^[
	CPHOTO* m_Photo[MAXIMG] = {0};			//CPHOTONXCX^X|C^[z
	Image* m_Image = 0;						//ImageNXIuWFNg|C^[
	RotateFlipType m_RFType = RotateNoneFlipNone;	//o͗p]A]^Cv(]A]Ȃ)
	//o͐EBhE֌Wo[ϐ
	HWND m_hWnd;							//o͐EBhẼnh
	int m_X = 0;							//o͐EBhELNCAgGAXW
	int m_Y = 0;							//o͐EBhELNCAgGAYW
	int m_Width;							//o͐EBhELNCAgGA
	int m_Height;							//o͐EBhELNCAgGA
	//o͐扼zEBhE֌Wo[ϐ
	HDC m_hDC;								//o͐EBhẼRp`uDC
	HBITMAP m_hCanvas;						//zEBhEłrbg}bv
	int m_Left;								//zEBhEitXN[jW
	int m_Top;								//zEBhEW
	int m_Right;							//zEBhEEW
	int m_Bottom;							//zEBhEW
	//TlCpϐ
	int m_Page = 0;							//ʐ^\y[Wi1`x[Xj
	int m_Column = 0;						//ʐ^̗񐔁i1`x[Xj
	int m_Row = 0;							//ʐ^̗񐔁i1`x[Xj
public:
	//\ʐ^֌Wo[ϐ
	char m_FileName[MAX_PATH];				//tpXʐ^t@CpiMBSj
	WCHAR m_WFName[MAX_PATH];				//tpXʐ^t@Cp(WCSj
	int m_NoI = 0;							//ǂݍݎʐ^
	int m_Selected = 0;						//IĂʐ^̔zԍ
	int m_CurPage = 0;						//TlC\ŌݑIĂy[Wi0`x[Xj
	//o[֐
	CALBUM();								//RXgN^[
	~CALBUM();								//fXgN^[
	bool Init(HWND);						//GraphicsNXƏo͉zEBhȄ
	void GetSize(LPARAM, HWND, HWND);		//o͐EBhEWM_SIZEbZ[WɎs
	void OnPaint(HDC, int, int);			//o͐EBhEWM_PAINTbZ[WɎs
	void SetCol(int, int, int, int);		//`FݒiAlpha, R, G, Bj
	bool Cls();								//ʏiOSetCol֐ŏFݒ肷j
	void SetPen(int);						//yݒiOSetCol֐ŏFݒ肷j
	bool Rect(int, int, int, int);			//wix, y, w, hj̋``iFAyݒsj
	bool Add(char*, char*, char*);			//ʐ^ǉ(t@CNULLƁut@CJv_CAOJ)
	bool Delete(int);						//ʐ^̍폜
	void DeleteAll();						//Sʐ^̍폜
	RotateFlipType GetRotateFlip()			//݂̉]A]ԂԂ
		{return m_RFType;}
	void SetRotateFlip(RotateFlipType type)	//ʐ^]A]\w
		{m_RFType = type;}
	int GetCount() {return m_NoI;}			//o^ʐ^Ԃ
	int GetSelected()						//Iʐ^̔zԍ擾i0`x[Xj
		{return m_Selected;}
	void Select(int);						//ʐ^̑Ii0`x[Xj
	DWORD GetImgSize();						//IC[W(LOWORD)A(HIWORD)̎擾
	char* GetFileName();					//m_Selected̃t@C̃tpXt@C(MBS)Ԃ
	char* GetComment();						//IC[W̃Rg̎擾
	void SetComment(char*);					//IC[W̃Rg̐ݒ
	bool ShowImg(int, int, int, int);		//ʐ^̕\(x, y畝wAhɌcΔŒɕ\)
	bool ShowImg(bool, bool);				//C[W̕\(1TRUEAFALSEA2TRUEAFALSETCY)
	bool ShowThumbnail(int, int);			//TlC\(̓TlC̕EAy[W)
	int GetPage() {return m_CurPage;}		//݂̃y[WԂ
	int HowManyThumb(int);					//TlC\̃y[W\ʐ^
	int GetWhichThumb(int, int, int);		//o͐EBhEx, yWTlC̔ԍ𓾂
};

//RXgN^[
CALBUM::CALBUM() {

	//Chgp̂߃P[̏i{j
	setlocale(LC_CTYPE, "JPN");
	//GDI+̊Jn
	GdiplusStartup(&m_gdiToken, &m_gdiSI, NULL);
}

//fXgN^[
CALBUM::~CALBUM() {

	//XN[rbg}bv̍폜
	DeleteObject(m_hCanvas);
	//Rp`DC̍폜
	DeleteDC(m_hDC);
	//CPHOTOIuWFNg̍폜iCPHOTÕo[͂̃fXgN^[ŉj
	for(int i = m_NoI - 1; i >= 0; i--)
		delete m_Photo[i];
	//PenIuWFNg̏I
	if(m_pPen)
		delete m_pPen;
	//GraphicsIuWFNg̏I
	if(m_pGraphics)
		delete m_pGraphics;
	//GDI+̏I
	GdiplusShutdown(m_gdiToken);
}

//Album(Graphics)̏i1DC1񂾂{j
bool CALBUM::Init(HWND hWnd) {

	//EBhE֌W
	m_hWnd = hWnd;									//EBhEnhL^
	HDC hDC = GetDC(hWnd);							//ΏۃEBhEDC擾
	m_hDC = CreateCompatibleDC(hDC);				//Rp`DC쐬
	m_Left = m_Top = 0;								//tXN[Ɋg債
	m_Right = GetSystemMetrics(SM_CXFULLSCREEN);	//̃L@XTCY
	m_Bottom = GetSystemMetrics(SM_CYFULLSCREEN);	//L^Ă
	m_hCanvas = CreateCompatibleBitmap(hDC,			//m_hDCł͂Ȃ̂Œ
				m_Right, m_Bottom);					//m_hDCɂƃmNƂȂ
	SelectObject(m_hDC, m_hCanvas);					//LoX̎
	PatBlt(m_hDC, m_Left, m_Top, m_Right, m_Bottom, PATCOPY);	//`
	ReleaseDC(hWnd, hDC);							//hDCJ
	if(m_pGraphics = new Graphics(m_hDC))
		return TRUE;
	else
		return FALSE;
}

//o͐EBhEWM_SIZEŎs
void CALBUM::GetSize(LPARAM lParam, HWND TBar, HWND SBar) {

	m_Width = LOWORD(lParam);
	m_Height = HIWORD(lParam);
	RECT rec;
	if(TBar) {
		GetWindowRect(TBar, &rec);
		m_Y = rec.bottom - rec.top;
		m_Height -= m_Y;
	}
	if(SBar) {
		GetWindowRect(SBar, &rec);
		m_Height -= rec.bottom - rec.top;
	}
}

//m_hWndEBhEWM_PAINTbZ[WŎs
void CALBUM::OnPaint(HDC hDC, int x = 0, int y = 0) {
	//EBhEzEBhEiBitmapjŕ`
	BitBlt(hDC, m_Left, m_Top, m_Right, m_Bottom, m_hDC, x, y, SRCCOPY);
}

//`FݒiAlpha, R, G, Bj
void CALBUM::SetCol(int Alpha, int R, int G, int B) {

	m_Col = Color(Alpha, R, G, B);		//Alpha, R, G, B
}

//ʏiOSetCol֐ŏFݒ肷j
bool CALBUM::Cls() {

	if(!m_pGraphics)
		return FALSE;
	m_pGraphics->Clear(m_Col);
	//ĕ`v
	InvalidateRect(m_hWnd, NULL, TRUE);
	return TRUE;
}

//yݒiOSetCol֐ŏFݒ肷j
void CALBUM::SetPen(int width) {

	if(m_pPen)
		delete m_pPen;
	m_pPen = new Pen(m_Col, width);
}

//wix, y, w, hj̋``ivFAyݒj
bool CALBUM::Rect(int x, int y, int w, int h) {

	if(!m_pGraphics)
		return FALSE;
	m_pGraphics->DrawRectangle(m_pPen, x, y, w, h);
	//ĕ`v
	InvalidateRect(m_hWnd, NULL, TRUE);
	return TRUE;
}

//tHgǉ(t@CNULLƁut@CJv_CAOJ)
bool CALBUM::Add(char* fn, char* ftr = IMGFILTER, char* cmt = "") {

	if(*fn)	//t@C^ꂽꍇ
		lstrcpy(m_FileName, fn);
	else {
		//C[Wt@CI
		OPENFILENAME ofn;				//I[vt@C_CAO\
		ZeroMemory(&ofn, sizeof(ofn));	//[
		ofn.lStructSize		= sizeof(ofn);
		ofn.hwndOwner		= m_hWnd;
		ofn.lpstrFilter		= ftr;		//ŃtB^O
		ofn.nFilterIndex	= 1;
		ofn.lpstrFile		= m_FileName;
		ofn.nMaxFile		= MAX_PATH;
		ofn.lpstrTitle		= "C[Wt@C̑I";
		ofn.lpstrInitialDir = ".";
		ofn.Flags			= OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
		ofn.lpstrDefExt		= NULL;
		if(!GetOpenFileName(&ofn)) {
			return FALSE;
		}
	}
	//ʐ^ǉ
	m_Photo[m_NoI] = new (CPHOTO);	//ʐ^iCPH0TOCX^Xj̍쐬
	m_Photo[m_NoI]->SetPhoto(m_FileName, cmt);
	//ʐ^𑝂₷
	m_NoI++;
	if(m_NoI > MAXIMG) {
		MessageBox(m_hWnd, "ȏ̃C[Wǂݍ݂͂ł܂", "x", MB_OK | MB_ICONERROR);
		m_NoI--;
		return FALSE;
	}
	return TRUE;
}

//tHg̍폜
bool CALBUM::Delete(int n) {

	if(n >= m_NoI || n < 0)	//@Ȉ
		return FALSE;
	m_Photo[n]->Delete();
	for(int i = n; i < m_NoI - 1; i++) {
		m_Photo[i] = m_Photo[i + 1];
	}
	if(m_NoI > 0) {
		--m_NoI;
		m_Photo[m_NoI] = 0;
	}
	if(m_Selected && m_Selected >= n)
		--m_Selected;
	return TRUE;
}

//StHg̍폜
void CALBUM::DeleteAll() {

	for(int i = m_NoI - 1; i >= 0; i--)
		delete m_Photo[i];
	m_NoI = 0;					//ǂݍImage
	m_Selected = 0;				//IĂC[W̔zԍ
	m_CurPage = 0;				//TlC\ŌݑIĂy[W
	m_RFType = RotateNoneFlipNone;	//]A]Ȃ
}

//IC[W̐ݒi0`x[Xj
void CALBUM::Select(int n) {

	if(n < 0)
		m_Selected = 0;
	else {
		if(n < m_NoI)
			m_Selected = n;
		else
			m_Selected = m_NoI - 1;
	}
}

//IC[W(LOWORD)A(HIWORD)̎擾
DWORD CALBUM::GetImgSize() {

	//G[Ή
	if(!m_Photo[m_Selected])
		return 0;
	//ݑIĂʐ^̃t@CChɂ
	mbstowcs(m_WFName, m_Photo[m_Selected]->m_FName, MAX_PATH);
	//ݑIĂʐ^̃t@CŃC[WNXCX^X𐶐
	m_Image = new (Image)(m_WFName);
	//m_ImageCX^X̐Ɏsꍇ
	if(!m_Image)
		return 0;
    //C[W(LOWORD)A(HIWORD)擾
	DWORD size = MAKELONG((WORD)m_Image->GetWidth(), (WORD)m_Image->GetHeight());
	//m_ImageCX^XA|C^[[
	delete m_Image;
	m_Image = 0;
	return size;
}

//m_Selected̃t@C̃tpXt@CԂ
char* CALBUM::GetFileName() {

	return m_Photo[m_Selected]->m_FName;
}

//IC[W̃Rg̎擾
char* CALBUM::GetComment() {

	return m_Photo[m_Selected]->m_Comment;
}

//IC[W̃Rg̐ݒ
void CALBUM::SetComment(char* cmt) {

	m_Photo[m_Selected]->SetComment(cmt);
}

//C[W̕\(x, ywAh̋`Ɍ\䗦ŕ\)
bool CALBUM::ShowImg(int x, int y, int w, int h) {

	//G[Ή
	if(!m_Photo[m_Selected])
		return FALSE;
	//ݑIĂʐ^̃t@CChɂ
	mbstowcs(m_WFName, m_Photo[m_Selected]->m_FName, MAX_PATH);
	//ݑIĂʐ^̃t@CŃC[WNXCX^X𐶐
	m_Image = new (Image)(m_WFName, FALSE);
	//摜]|RotateFlipTypeFRotate<A>Flip<B> <A:None, 90, 180, 270>, <B:X, Y, XY>
	m_Image->RotateFlip(m_RFType);
	//C[W̌擾
	int imgw = m_Image->GetWidth();
	int imgh = m_Image->GetHeight();
	//m_ImageCX^X̐ɎsꍇimgwAimgh̓[ɂȂ
	if(!imgw || !imgh) {
		MessageBox(m_hWnd, "t@Cǂݍ߂܂łB\nt@CpXĂB",
					"G[", MB_OK | MB_ICONERROR);
		//m_ImageCX^X
		delete m_Image;
		m_Image = 0;
		return FALSE;
	}
	//wAhŌ̏cΔ̃C[W𒆉ɔzu
	double asp1, asp2;
	asp1 = (double)imgh / (double)imgw;
	asp2 = (double)h / (double)w;
	if(asp1 > asp2) {
		imgh = h;
		imgw = h / asp1;
	}
	else {
		imgw = w;
		imgh = w * asp1;
	}
	x += (w - imgw) / 2;
	y += (h - imgh) / 2;
	//m_ImageCX^X\
	m_pGraphics->DrawImage(m_Image, x, y, imgw, imgh);
	//m_ImageCX^X
	delete m_Image;
	m_Image = 0;
	//ĕ`v
	InvalidateRect(m_hWnd, NULL, TRUE);
	return TRUE;
}

//C[W̕\(1TRUEAFALSEA2TRUEAFALSETCY)
bool CALBUM::ShowImg(bool lefttop, bool asis) {

	//G[Ή
	if(!m_Photo[m_Selected])
		return FALSE;
	//ݑIĂʐ^̃t@CChɂ
	mbstowcs(m_WFName, m_Photo[m_Selected]->m_FName, MAX_PATH);
	//ݑIĂʐ^̃t@CŃC[WNXCX^X𐶐
	m_Image = new (Image)(m_WFName);
	//摜]|RotateFlipTypeFRotate<A>Flip<B> <A:None, 90, 180, 270>, <B:X, Y, XY>
	m_Image->RotateFlip(m_RFType);
	//C[W̌擾
	int imgw = m_Image->GetWidth();
	int imgh = m_Image->GetHeight();
	//m_ImageCX^X̐ɎsꍇimgwAimgh̓[ɂȂ
	if(!imgw || !imgh) {
		MessageBox(m_hWnd, "t@Cǂݍ߂܂łB\nt@CpXĂB",
					"G[", MB_OK | MB_ICONERROR);
		//m_ImageCX^X
		delete m_Image;
		m_Image = 0;
		return FALSE;
	}
	//TCY̏ꍇ͔䗦ɉĒ
	if(!asis) {
		double asp1, asp2;
		asp1 = (double)imgh / (double)imgw;
		asp2 = (double)m_Height / (double)m_Width;
		if(asp1 > asp2) {
			imgh = m_Height;
			imgw = m_Height / asp1;
		}
		else {
			imgw = m_Width;
			imgh = m_Width * asp1;
		}
	}
	//ɕ\
	int x = m_X;
	int y = m_Y;
	//ɕ\
	if(!lefttop) {
		x += (m_Width - imgw) / 2;
		y += (m_Height - imgh) / 2;
	}
	//m_ImageCX^X\
	m_pGraphics->DrawImage(m_Image, x, y, imgw, imgh);
	//m_ImageCX^X
	delete m_Image;
	m_Image = 0;
	//ĕ`v
	InvalidateRect(m_hWnd, NULL, TRUE);
	return TRUE;
}

//TlC\(̓TlC̕EAy[W)
bool CALBUM::ShowThumbnail(int size, int page = -1) {

	//G[Ή
	if(!m_NoI)
		return FALSE;
	//C[W\ׂ̈̉ʐA\Ac\ݒ
	int sel = m_Selected;						//m_Selectedޔۑ
	m_Column = m_Width / size;					//񐔁i1`x[Xj
	m_Row = m_Height / size;					//si1`x[Xj
	if(!(m_Column * m_Row)) {
		MessageBox(m_hWnd, "EBhETCY܂",
					"x", MB_OK | MB_ICONERROR);
		return FALSE;							//"Div. by zero" error
	}
	m_Page = m_NoI / (m_Column * m_Row);		//y[Wi1`x[Xj
	if(page == -1)								//ݑIĂʐ^̃y[W
		m_CurPage = page = m_Selected / (m_Column * m_Row);
	else
		m_CurPage = page;
	if(page > m_Page)							//page傫ĕ\łȂ
		return FALSE;
	for(int i = 0; i < m_Row; i++) {
		for(int j = 0; j < m_Column; j++) {
			int n = page * (m_Column * m_Row) + i * m_Column + j;
			if(n < m_NoI) {
				Select(n);
				ShowImg(size * j, size * i + m_Y, size, size);
				if(n == sel) {
					Rect(size * j, size * i + m_Y, size, size);
				}
			}
			else {
				m_Selected = sel;
				return TRUE;
			}
		}
	}
	m_Selected = sel;
	return TRUE;
}

//TlC\̃y[W\ʐ^
int CALBUM::HowManyThumb(int size) {

	m_Column = m_Width / size;	//񐔁i1`x[Xj
	m_Row = m_Height / size;	//si1`x[Xj
	return (m_Column * m_Row);
}

//o͐EBhEx, yWTlC̔ԍ𓾂
int CALBUM::GetWhichThumb(int size, int x, int y) {

	int col = x / size;
	int row = y / size;
	return (m_CurPage * (m_Column * m_Row) + row * m_Column + col);
}
