//////////////////////////////////////////
// DirectShowProc.h
// Copyright (c) 01/31/2022 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnCreate(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	TBar.Init(m_hWnd, m_hInstance, TOOLBAR);
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TOOLBAR), 9);
	//c[o[{^ǉ
	TBBUTTON tbb[13];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_OPEN;
	tbb[1].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[2].iBitmap = TBar.m_id + 1;
	tbb[2].fsState = TBSTATE_ENABLED;
	tbb[2].fsStyle = TBSTYLE_BUTTON;
	tbb[2].idCommand = IDM_EXIT;
	tbb[3].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[4].iBitmap = TBar.m_id + 2;
	tbb[4].fsStyle = TBSTYLE_BUTTON;
	tbb[4].idCommand = IDM_SHOW;
	tbb[5].iBitmap = TBar.m_id + 3;
	tbb[5].fsStyle = TBSTYLE_BUTTON;
	tbb[5].idCommand = IDM_PAUSE;
	tbb[6].iBitmap = TBar.m_id + 4;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_STOP;
	tbb[7].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[8].iBitmap = TBar.m_id + 5;
	tbb[8].fsState = TBSTATE_ENABLED;
	tbb[8].fsStyle = TBSTYLE_BUTTON;
	tbb[8].idCommand = IDM_MAKELIST;
	tbb[9].iBitmap = TBar.m_id + 6;
	tbb[9].fsStyle = TBSTYLE_BUTTON;
	tbb[9].idCommand = IDM_AUTOPLAY;
	tbb[10].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[11].iBitmap = TBar.m_id + 7;
	tbb[11].fsState = TBSTATE_ENABLED;
	tbb[11].fsStyle = TBSTYLE_BUTTON;
	tbb[11].idCommand = IDM_ABOUT;
	tbb[12].iBitmap = TBar.m_id + 8;
	tbb[12].fsState = TBSTATE_ENABLED;
	tbb[12].fsStyle = TBSTYLE_BUTTON;
	tbb[12].idCommand = IDM_VERSION;
	TBar.AddButtons(13, tbb);

	//Xe[^Xo[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	SBar.Init(m_hWnd, m_hInstance, STATUSBAR);
	//Xe[^Xo[ݒ
	int sec[3] = {120, 240, -1};
	SBar.SetSection(3, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "DirectShow Ver 1.1");
	SBar.SetText(1, "Đ");
	SBar.SetText(2, "t@C");

	//j[Ac[o[{^
	ChangeMenuStatus(0);	//uĐvAuꎞ~vAu~v
	AllowtoOpen(TRUE);		//ut@CJvAuURLJv
	AutoPlay(TRUE, FALSE);	//uvCXg̍쐬EIvAuvCXg̍Đv

	//wvt@Co^
	g_HelpFile = arg.Path();
	g_HelpFile = g_HelpFile + "\\DirectShowHelp.chm";

	//t@CXgfBNg[̍쐬
	g_FileListDir = arg.Path();
	g_FileListDir = g_FileListDir + "\\FileList";
	if(!PathFileExists(g_FileListDir.ToChar()))
		CreateDirectory(g_FileListDir.ToChar(), NULL);

	//ĐpXC_[Rg[̍쐬
	g_Slider.Create(TBar.GetHandle(), IDC_SLIDER, 340, 0, 300, 24);
	ShowWindow(g_Slider.GetHandle(), SW_HIDE);	//XC_[Rg[B
	//XC_[̐ełc[o[WM_HSCROLLsׂ̃TuNX
	g_TBProc = (WNDPROC)GetWindowLongPtr(GetDlgItem(m_hWnd, TOOLBAR), GWLP_WNDPROC);
	SetWindowLongPtr(GetDlgItem(m_hWnd, TOOLBAR), GWLP_WNDPROC, (LONG_PTR)TOOLBARProc);

	//hbOAhhbv̎tJn
	DragAcceptFiles(m_hWnd, TRUE);

	//t@CN̏
	if(arg.c() > 1) {
		if(g_ExtChk.CheckExt(arg.v(1), FILTER)) {
			g_ByFile = TRUE;
			g_dshow.SetFileName(arg.v(1));
			OnOpen();
		}
		else
			MessageBox(m_hWnd, "ĐΏۊÕt@Cł", "G[", MB_OK | MB_ICONERROR);
	}

	return TRUE;
}

bool CMyWnd::OnTimer(WPARAM wParam, LPARAM lParam) {

	int cp = (int)g_dshow.GetCurrentPos();
	char* tm = GetTimeStr(g_Mtm - cp);
	//XC_[Rg[̕\
	g_Slider.SetPosition(cp);
	//Xe[^Xo[ݒ
	SBar.SetText(1, tm);
	return TRUE;
}

bool CMyWnd::OnLButtonDown(WPARAM wParam, LPARAM lParam) {

	//ꎞ~i1j܂͍Đi2ji^CO10/1000bj
	if(g_dshow.GetState(10) == 1 || g_dshow.GetState(10) == 2) {
		OnPause();
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnRButtonDown(WPARAM wParam, LPARAM lParam) {

	//|bvAbvj[ǂ݂
	HMENU hPopupMenu = GetSubMenu(GetMenu(m_hWnd), 1);
	//|bvAbvj[̕\
	POINT pt;
	GetCursorPos(&pt);
	TrackPopupMenu(hPopupMenu, TPM_LEFTALIGN | TPM_LEFTBUTTON,
				  pt.x, pt.y, 0, m_hWnd, NULL);
	return TRUE;
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	//c[o[̃c[`bv擾
	if(((LPNMHDR)lParam)->code == TTN_NEEDTEXT) {
		static LPTOOLTIPTEXT lptip;
		lptip = (LPTOOLTIPTEXT)lParam;
		switch (lptip->hdr.idFrom) {
			case IDM_OPEN:
				lptip->lpszText = "t@CJ";
				break;
			case IDM_EXIT:
				lptip->lpszText = "I";
				break;
			case IDM_SHOW:
				lptip->lpszText = "Đ";
				break;
			case IDM_PAUSE:
				lptip->lpszText = "ꎞ~";
				break;
			case IDM_STOP:
				lptip->lpszText = "~";
				break;
			case IDM_MAKELIST:
				lptip->lpszText = "vCXg̍쐬EI";
				break;
			case IDM_AUTOPLAY:
				lptip->lpszText = "vCXg̍Đ";
				break;
			case IDM_ABOUT:
				lptip->lpszText = "DirectShowɂ";
				break;
			case IDM_VERSION:
				lptip->lpszText = "o[W";
				break;
		}
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	TBar.AutoSize();
	SBar.AutoSize();
	//XC_[Rg[̎ʒu
	g_Slider.AutoSize(1);		//Emarginx0Amarginy2ŕ\
	//NCAgGATCY
	int w = LOWORD(lParam);		//EChE
	int h = HIWORD(lParam);		//EChE
	//TBarSBar̍T
	RECT rec;
	GetWindowRect(SBar.GetHandle(), &rec);
	h -= rec.bottom - rec.top;
	GetWindowRect(TBar.GetHandle(), &rec);
	int barh = rec.bottom - rec.top;
	h -= barh;
	g_dshow.Move(0, barh, w, h);
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES)
		//DestroyWindowAPostQuitMessageĂ΂
		return TRUE;
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

bool CMyWnd::OnMinMax(WPARAM wParam, LPARAM lParam) {

	//T^IȃEBhẼTCY
	MINMAXINFO *pmmi;
	pmmi = (MINMAXINFO*)lParam;
	pmmi->ptMinTrackSize.x = 656;	//NCAgGA640 + 16
	pmmi->ptMinTrackSize.y = 541;	//NCAgGA480 + 61
	return FALSE;					//DefWndProcɔC
}

bool CMyWnd::OnGraphNotify(WPARAM wParam, LPARAM lParam) {

	long evnt;					//EC_COMPLETE - ĐIAEC_USERABORT - Đ~AEC_ERRORABORT - G[
	if(!g_dshow.IsOver(evnt))	//ĐJnOĐ͉Ȃ
		return FALSE;
	//I
	WhenComplete();
	//vCXgĐ
	if(g_AutoPlay) {
		if(*m_FileList.ToChar())	//܂ĂȂꍇ
			OnAutoPlay();
		else {						//ꍇ
			g_AutoPlay = FALSE;
			AutoPlay(TRUE, FALSE);	//vCXg̍쐬EIAĐ
		}
	}	
	return TRUE;
}

bool CMyWnd::OnDropFiles(WPARAM wParam) {

	//hbOAhhbvꂽt@C擾Ə
	char FileName[MAX_PATH];
	DragQueryFile((HDROP)wParam, 0, FileName, MAX_PATH);
	if(g_ExtChk.CheckExt(FileName, FILTER)) {
		g_ByFile = TRUE;
		g_dshow.SetFileName(FileName);
		OnOpen();
		DragFinish((HDROP)wParam);
		return TRUE;
	}
	MessageBox(m_hWnd, "ĐΏۊÕt@Cł", "G[", MB_OK | MB_ICONERROR);
	return FALSE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnOpen() {

	if(g_ByFile)
		g_ByFile = FALSE;
	else {
		//t@Cǂ
		if(!g_dshow.SetFileName(""))
			return FALSE;
	}
	//j[A{^̏ԕύX
	ChangeMenuStatus(1);
	//Xe[^Xo[ݒ
	SBar.SetText(2, g_dshow.m_FileName);
	SBar.SendMsg(SB_SETTIPTEXT, 2, (LPARAM)g_dshow.m_FileName);	//ToolTip
	return TRUE;
}

bool CMyWnd::OnUrl() {

	urldlg.DoModal(m_hWnd, "IDD_URL", urldlgProc, m_hInstance);
	//j[A{^̏ԕύX
	ChangeMenuStatus(1);
	//Xe[^Xo[ݒ
	SBar.SetText(2, g_dshow.m_FileName);
	SBar.SendMsg(SB_SETTIPTEXT, 2, (LPARAM)g_dshow.m_FileName);	//ToolTip
	return TRUE;
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnShow() {

	//ĐJn
	if(g_dshow.Show(m_hWnd)) {
		g_Mtm = (int)g_dshow.GetDuration();
		char* tm = GetTimeStr(g_Mtm);
		//Xe[^Xo[ݒ
		SBar.SetText(1, tm);
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)tm);	//ToolTip
		//j[A{^̏ԕύX
		ChangeMenuStatus(2);
		AllowtoOpen(FALSE);		//t@Cǂݍ݂s\ɂ
		//ĐpXC_[Rg[̐ݒ
		g_Slider.SetRange(0, g_Mtm);
		g_Slider.SetPosition(0);
		//XC_[Rg[\
		ShowWindow(g_Slider.GetHandle(), SW_SHOW);
		//^C}[Jni1bj
		g_tmr.Begin(m_hWnd, 1, 1000);
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnPause() {

	static bool toggle = FALSE;
	if(toggle) {
		//ĐĊJiRun()\bhj
		g_dshow.Continue();
		//j[A{^̏ԕύX
		ChangeMenuStatus(2);
		g_tmr.Begin(m_hWnd, 1, 1000);	//^C}[Jni1bj
	}
	else {
		//Đꎞ~
		g_dshow.Pause();
		//j[A{^̏ԕύX
		ChangeMenuStatus(3);
		g_tmr.Stop();					//^C}[~
	}
	toggle = !toggle;
	return TRUE;
}

bool CMyWnd::OnStop() {

	//Đ~
	g_dshow.Stop();
	//I
	WhenComplete();
	//vCXgĐ
	if(g_AutoPlay) {
		if(*m_FileList.ToChar()) {		//܂ĂȂꍇ
			if(MessageBox(m_hWnd, "vCXgĐ𑱂܂H", "vCXgĐmF",
						MB_YESNO | MB_ICONQUESTION) == IDYES)
				OnAutoPlay();
			else {						//vCXgĐ̒~
				m_FileList = "";
				g_AutoPlay = FALSE;
				AutoPlay(TRUE, FALSE);	//vCXg̍쐬EIAĐ
			}
		}
		else {							//ꍇ
			g_AutoPlay = FALSE;
			AutoPlay(TRUE, FALSE);		//vCXg̍쐬EIAĐ
		}
	}	
	return TRUE;
}

bool CMyWnd::OnMakelist() {

	//FileList.dll_CAOĂ
	char* fn = GetFileList("vCXgt@C(*.plf)\0*.plf\0\0", FILTER, g_FileListDir.ToChar(), "plf");
	if(!*fn) {
		MessageBox(m_hWnd, "plft@CI܂ł", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	m_FileList.FromFile(fn);
	//vCXg̍Đj[ƃc[{^L
	AutoPlay(FALSE, TRUE);
	return TRUE;
}

bool CMyWnd::OnAutoPlay() {

	CSTR fn, comment;
	if(!m_FileList.Next(fn)) {		//t@CXgĐt@C̃tpX؂o
		g_AutoPlay = FALSE;
		AutoPlay(TRUE, FALSE);
		MessageBox(m_hWnd, "vCXgĐ܂", "vCXgĐ", MB_OK | MB_ICONINFORMATION);
	}
	else {							//t@CXgɍĐt@CȂ
		m_FileList.Next(comment);	//t@CXgsvȁulv؂o
		//DirectShowɍĐt@Co^
		g_dshow.SetFileName(fn.ToChar());
		//Xe[^Xo[ݒ
		SBar.SetText(2, g_dshow.m_FileName);
		SBar.SendMsg(SB_SETTIPTEXT, 2, (LPARAM)g_dshow.m_FileName);	//ToolTip
		//vCXg̍쐬EIAĐj[𖳌
		AutoPlay(FALSE, FALSE);
		//vCXgĐ
		g_AutoPlay = TRUE;
		//Đ
		if(!OnShow())					//vCXg̍ĐɎsꍇ
			OnStop();
	}
	return TRUE;
}

bool CMyWnd::OnPlayList() {

	CSTR List, FileList, FileName;
	CARG arg;
	FileList = m_FileList;
	while(FileList.Next(FileName)) {
		arg = FileName.ToChar();
		List = List + arg.FileName();
		List = List + "\r\n";
		FileList.Next(FileName);		//lXLbv
	}
	MessageBox(m_hWnd, List.ToChar(), "vCXg", MB_OK | MB_ICONINFORMATION);
	return TRUE;
}

bool CMyWnd::OnAbout() {

	CSTR cmd = "hh ";
	cmd = cmd + g_HelpFile;
	WinExec(cmd.ToChar(), SW_SHOWNORMAL);
	return TRUE;
}

bool CMyWnd::OnVersion() {

	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc, m_hInstance);
	return TRUE;
}

////////////////////////////////////////////////////////
//[U[`֐
//XC_[\ƃ^C}[AĐԃj[̏
////////////////////////////////////////////////////////
void CMyWnd::WhenComplete() {

	//^C}[~
	g_tmr.Stop();
	//ĐԂ̏
	g_Mtm = 0;
	//XC_[Rg[B
	ShowWindow(g_Slider.GetHandle(), SW_HIDE);
	//ĐIAt@Cǂݍ݌ԂɂiĐj
	ChangeMenuStatus(1);
	//t@Cǂݍ݂\ɂ
	AllowtoOpen(TRUE);
}

///////////////////////////////////////////////////
//[U[`֐
//ԁEI0
//t@CǍݎ1AĐ2Aꎞ~3igOj
///////////////////////////////////////////////////
void CMyWnd::ChangeMenuStatus(int flag) {

	HMENU hMenu = GetSubMenu(GetMenu(m_hWnd), 1);	//j[nh̎擾
	switch(flag) {
	case 0:		//SĖ
		//j[ACe
		EnableMenuItem(hMenu, 0, MF_BYPOSITION | MF_GRAYED);
		EnableMenuItem(hMenu, 1, MF_BYPOSITION | MF_GRAYED);
		EnableMenuItem(hMenu, 2, MF_BYPOSITION | MF_GRAYED);
		//c[o[{^
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_SHOW, MAKELONG(FALSE, 0));
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_PAUSE, MAKELONG(FALSE, 0));
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_STOP, MAKELONG(FALSE, 0));
		break;
	case 1:		//Đ̂ݗL
		//j[ACe
		EnableMenuItem(hMenu, 0, MF_BYPOSITION | MF_ENABLED);
		EnableMenuItem(hMenu, 1, MF_BYPOSITION | MF_GRAYED);
		EnableMenuItem(hMenu, 2, MF_BYPOSITION | MF_GRAYED);
		//c[o[{^
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_SHOW, MAKELONG(TRUE, 0));
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_PAUSE, MAKELONG(FALSE, 0));
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_STOP, MAKELONG(FALSE, 0));
		break;
	case 2:		//Đ𖳌Aꎞ~A~L
		//j[ACe
		EnableMenuItem(hMenu, 0, MF_BYPOSITION | MF_GRAYED);
		EnableMenuItem(hMenu, 1, MF_BYPOSITION | MF_ENABLED);
		EnableMenuItem(hMenu, 2, MF_BYPOSITION | MF_ENABLED);
		//c[o[{^
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_SHOW, MAKELONG(FALSE, 0));
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_PAUSE, MAKELONG(TRUE, 0));
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_STOP, MAKELONG(TRUE, 0));
		break;
	case 3:		//ĐA~ɖ
		//j[ACe
		EnableMenuItem(hMenu, 0, MF_BYPOSITION | MF_GRAYED);
		EnableMenuItem(hMenu, 2, MF_BYPOSITION | MF_GRAYED);
		//c[o[{^
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_SHOW, MAKELONG(FALSE, 0));
		SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_STOP, MAKELONG(FALSE, 0));
		break;
	default:
		return;
	}
	DrawMenuBar(m_hWnd);	//Re-draw
}

/////////////////////////////////////////////////////
//[U[`֐
//ut@CJvƁuURLJv̏ԂύX
/////////////////////////////////////////////////////
void CMyWnd::AllowtoOpen(bool flag) {

	HMENU hMenu = GetSubMenu(GetMenu(m_hWnd), 0);	//j[nh̎擾
	//j[ACe
	EnableMenuItem(hMenu, 0, MF_BYPOSITION | (flag ? MF_ENABLED : MF_GRAYED));
	EnableMenuItem(hMenu, 1, MF_BYPOSITION | (flag ? MF_ENABLED : MF_GRAYED));
	//c[o[{^
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_OPEN, MAKELONG(flag, 0));
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_URL, MAKELONG(flag, 0));
}

//////////////////////////////////////////////////////////////////////
//[U[`֐
//uvCXg̍쐬EIvƁuvCXg̍Đv̏ԂύX
//////////////////////////////////////////////////////////////////////
void CMyWnd::AutoPlay(bool flag1, bool flag2) {

	HMENU hMenu = GetSubMenu(GetMenu(m_hWnd), 2);	//j[nh̎擾
	//j[ACe
	EnableMenuItem(hMenu, 0, MF_BYPOSITION | (flag1 ? MF_ENABLED : MF_GRAYED));
	EnableMenuItem(hMenu, 1, MF_BYPOSITION | (flag2 ? MF_ENABLED : MF_GRAYED));
	//c[o[{^
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_MAKELIST, MAKELONG(flag1, 0));
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_AUTOPLAY, MAKELONG(flag2, 0));
}

////////////////////////////////////////////
//[U[`֐
//̕buԕbv̕ɂĕԂ
////////////////////////////////////////////
char* CMyWnd::GetTimeStr(int tm) {

	static CSTR tmstr;
	int hour, min, sec;
	hour = tm / 3600;
	min = sec = tm % 3600;
	min /= 60;
	sec %= 60;
	tmstr = "c";
	if(hour) {
		tmstr = tmstr + hour;
		tmstr = tmstr + "";
	}
	tmstr = tmstr + min + "";
	tmstr = tmstr + sec + "b";
	return tmstr.ToChar();
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool URLDLG::OnIdok() {

	char buff[MAX_PATH];
	SendItemMsg(IDC_URL, WM_GETTEXT, MAX_PATH, (LPARAM)buff);
	if(g_dshow.SetFileName(buff)) {
		EndModal(TRUE);
		return TRUE;
	}
	else {
		EndModal(FALSE);
		return FALSE;
	}
}

bool URLDLG::OnCancel() {

	EndModal(FALSE);
	return FALSE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}
