//--------------------------------------------
// CHISTORY Class - File History[eBeB
// 쐬iSetPathŁjinit@Cݒ肵A
// InitŉߋǂݍłAddŒǉB
// i[U[͌A폜sgpBj
// Copyright (c) 2020, K. Yoshida
/*
typedef struct tagMENUITEMINFO {
    UINT    cbSize; 
    UINT    fMask; 
    UINT    fType; 
    UINT    fState; 
    UINT    wID; 
    HMENU   hSubMenu;
    HBITMAP hbmpChecked; 
    HBITMAP hbmpUnchecked; 
    DWORD   dwItemData; 
    LPTSTR  dwTypeData; 
    UINT    cch; 
} MENUITEMINFO, FAR *LPMENUITEMINFO;
*/
//--------------------------------------------

#define	ITEM_MAX	32

class CHISTORY
{
private:
	//ϐ
	char m_InitPath[MAX_PATH];	//init@CpX
	int	 m_ItemNum;				//
	char *m_Item[ITEM_MAX];		//f[^ij
	HMENU m_hMenu;				//\p|bvAbvj[nh
	//֐
	int DelItem(int num);		//ڍ폜
	int SrchItem(char* item);	//ڌiFound|numAFailed|-1j
public:
	//֐
	CHISTORY(char* InitName);	//RXgN^[iinit@CftHgj
	~CHISTORY();				//fRXgN^[ij
	SetPath(char* path);		//init@CpX̐ݒ
	SetMenu(HMENU menu);		//m_hMenu̐ݒ
	int Init();					//ߋ
	int AddItem(char* item);	//ڒǉ
	void WriteIni();			//init@C
};

//RXgN^[iInitt@CftHg".\Init.ini"j
CHISTORY::CHISTORY(char* InitName = ".\Init.ini") {

	lstrcpy(m_InitPath, InitName);	//init@CpXۑ
	m_ItemNum = 0;
	m_Item[0] = 0;
	m_hMenu = 0;
}

//fXgN^[ij
CHISTORY::~CHISTORY() {

	for(int i = m_ItemNum - 1; i >= 0; i--)
		delete [] m_Item[i];
}

//init@CpX̐ݒ
CHISTORY::SetPath(char* path) {

	lstrcpy(m_InitPath, path);	//init@CpXݒ
}

//m_hMenu̐ݒ
CHISTORY::SetMenu(HMENU menu) {

	m_hMenu = menu;
}

//ߋ
int CHISTORY::Init() {

	char buff[MAX_PATH];
	wsprintf(buff, "Item%d", m_ItemNum);
	//t@C̓ǂݍ
	while(GetPrivateProfileString("History", buff, "", buff, MAX_PATH, m_InitPath)) {
		m_Item[m_ItemNum] = new char[lstrlen(buff) + 1];
		lstrcpy(m_Item[m_ItemNum], buff);
		if(m_hMenu) {		//j[ݒ肪itemڂǉ
			if(!m_ItemNum)	//m_ItemNum0łΊ"iNonej"폜
				DeleteMenu(m_hMenu, 0, MF_BYPOSITION);
			MENUITEMINFO mii = {0};
			mii.cbSize		= sizeof(MENUITEMINFO);
			mii.fMask		= MIIM_ID | MIIM_STRING;
			mii.wID			= IDM_HISTORY + m_ItemNum;
			mii.dwTypeData	= m_Item[m_ItemNum];
			InsertMenuItem(m_hMenu, m_ItemNum, TRUE, &mii);
		}
		m_ItemNum++;
		wsprintf(buff, "Item%d", m_ItemNum);
	}
	return m_ItemNum;
}

//ڒǉ
int CHISTORY::AddItem(char* item) {

	if(m_ItemNum == ITEM_MAX)		//ڐx𒴂
		DelItem(0);					//ԋ̂폜
	int i;
	if((i = SrchItem(item)) > -1)	//ɗ鍀ڂ
		DelItem(i);					//폜
	m_Item[m_ItemNum] = new char[lstrlen(item) + 1];
	lstrcpy(m_Item[m_ItemNum], item);
	if(m_hMenu) {		//j[ݒ肪itemڂǉ
		if(!m_ItemNum)	//m_ItemNum0łΊ́iNonej폜
			DeleteMenu(m_hMenu, 0, MF_BYPOSITION);
		MENUITEMINFO mii = {0};
		mii.cbSize		= sizeof(MENUITEMINFO);
		mii.fMask		= MIIM_ID | MIIM_STRING;
		mii.wID			= IDM_HISTORY + m_ItemNum;
		mii.dwTypeData	= m_Item[m_ItemNum];
		InsertMenuItem(m_hMenu, m_ItemNum, TRUE, &mii);
	}
	return m_ItemNum++;
}

//ڍ폜iDone|New m_ItemNumAFailed|-1j
int CHISTORY::DelItem(int num) {

	if(!m_ItemNum) return -1;		//ڐ0ȂFailedŖ߂
	if(num >= m_ItemNum) return -1;	//ڐ𒴂ڂ̍폜ȂFailedŖ߂
	delete [] m_Item[num];
	if(m_hMenu)		//j[ݒ肪numԖڂ̍ڂ폜
		DeleteMenu(m_hMenu, num, MF_BYPOSITION);
	m_ItemNum--;
	for(int i = num; i < m_ItemNum; i++) {
		m_Item[i] = m_Item[i + 1];
		MENUITEMINFO mii = {0};
		mii.cbSize	= sizeof(MENUITEMINFO);
		mii.fMask	= MIIM_ID;
		mii.wID	= IDM_HISTORY + i;
		SetMenuItemInfo(m_hMenu, i, TRUE, &mii);
	}
	m_Item[m_ItemNum] = NULL;
	return m_ItemNum;
}

//ڌiFound|numAFailed|-1j
int CHISTORY::SrchItem(char* item) {

	for(int i = 0; i < m_ItemNum; i++) {
		if(!lstrcmp(m_Item[i], item))
			return i;
	}
	return -1;
}

//init@C
void CHISTORY::WriteIni() {

	char buff[MAX_PATH];
	for(int i = 0; i < m_ItemNum; i++) {
			//t@C̏
			wsprintf(buff, "Item%d", i);
			WritePrivateProfileString("History", buff, m_Item[i], m_InitPath);
	}
}
