////////////////////////////////////
// CGLUT.h for BCC Skelton
// GLUTiOpenGLjNX`t@C
// Copyright (c) May, 2024
//		By Ysama
////////////////////////////////////
#include	<GL\freeglut.h>				//freeglutCuWindowsŎg
#pragma comment(lib, "freeglut.lib")

class CGLUT
{
private:
	//EBhE֘Ao[
	HWND m_hWnd = NULL;								//\EBhEnh
	int m_win_no;									//EBhEԍ
	int m_x = 100;									//\EBhExʒu
	int m_y = 100;									//\EBhEyʒu
	int m_w = 640;									//\EBhE
	int m_h = 480;									//\EBhE
	unsigned int m_mode = GLUT_SINGLE | GLUT_RGBA;	//\EBhE[h GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE)
	char m_title[MAX_PATH] = {0};					//\EBhE^Cg
public:
	//`IuWFNg֘A
	int m_Obj = 0;									//`IuWFNgԍi0 - 8j
	bool m_sw = FALSE;								//CA[A\bh̃tO(Solid - TRUE, Wire - FALSE)
	//gluLookAt֐֘A
	GLdouble m_LA[9] = {0.0, 0.0, 2.0,				//_ʒu(GLdouble) eyex, eyey, eyez,
						0.0, 0.0, 0.0,				//Nbvʂ̒S_(GLdouble) centerx, centery, centerz,
						0.0, 1.0, 0.0};				//AvxN^[(GLdouble) upx, upy, upz
	//e@I
	int m_proj = 0;									//lgluPerspective֐
	//gluPerspective֐֘A
	GLdouble m_fov = 90.0;							//iFiield of viewjŒPʂ͓x
	GLdouble m_aspect = m_w / m_h;					//ci / j
	GLdouble m_near = 1.0;							//_߃Nbvʂ܂ł̋ij
	GLdouble m_far = 20.0;							//_牓Nbvʂ܂ł̋ij
	//glFrustum֐֘A
	//ӁFm_nearm_far͋p
	GLdouble m_left = -1.0;							//NbvʍW
	GLdouble m_right = 1.0;							//NbvʉEW
	GLdouble m_bottom = -1.0;						//NbvʉW
	GLdouble m_top = 1.0;							//NbvʏW
	//glOrtho֐֘Aî̍E㉺O̒Ssej
	//ӁFm_leftAm_rightAm_bottomm_top͋p
	GLdouble m_front = 1.0;							//ONbvʍW
	GLdouble m_back = -1.0;							//NbvʍW
public:
	CGLUT();										//RXgN^[
	~CGLUT();										//fXgN^[
	HWND GethWnd() {return m_hWnd;}
	void SetPos(int x, int y) {m_x = x; m_y = y;}
	void SetSize(int w, int h) {m_w = w; m_h = h;}
	void SetTitle(char* name) {lstrcpy(m_title, name);}
	void SetMode(unsigned int mode) {m_mode = mode;}
	void Enable(GLenum cap) {glEnable(cap);}
	void Disable(GLenum cap) {glDisable(cap);}
	int Create(char*);
	void Display(void(*func)()) {glutDisplayFunc(func);} 
	void ReDisp() {glutPostRedisplay();}
	void SetLA(GLdouble, GLdouble, GLdouble,		//glLookAtƓ
				GLdouble, GLdouble , GLdouble,		//lm_LAzɕۑA
				GLdouble, GLdouble, GLdouble);		//LookAt(gluLookAt)Ă
	void LookAt();
	void Color(GLint r, GLint g, GLint b, GLint a = 1) {glColor4i(r, g, b, a);}						//I[o[[hij
	void Color(GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1.0) {glColor4f(r, g, b, a);}			//I[o[[hiPxj
	void Color(GLdouble r, GLdouble g, GLdouble b, GLdouble a = 1.0) {glColor4d(r, g, b, a);}		//I[o[[hi{xj
	void Clear(GLbitfield mask) {glClear(mask);}	//GL_COLOR_BUFFER_BIT, GL_DEPTH_BUFFER_BIT, GL_ACCUM_BUFFER_BIT, GL_STENCIL_BUFFER_BIT
	void ClearCol(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha) {glClearColor(red, green, blue, alpha);}
	void Transfer(GLdouble x, GLdouble y, GLdouble z) {glTranslated(x, y, z);}
	void Rotate(GLfloat angle, GLfloat x, GLfloat y, GLfloat z) {glRotatef(angle, x, y, z);}		//I[o[[hiPxj
	void Rotate(GLdouble angle, GLdouble x, GLdouble y, GLdouble z) {glRotated(angle, x, y, z);}	//I[o[[hi{xj
	void Scale(GLfloat x, GLfloat y, GLfloat z) {glScalef(x, y, z);}								//I[o[[hiPxj
	void Scale(GLdouble x, GLdouble y, GLdouble z) {glScaled(x, y, z);}								//I[o[[hi{xj
	void Reshape(void(*func)(int, int)) {glutReshapeFunc(func);}
	void Resize(int, int);
	void Refresh();																					//I[o[[hiȂj
	void Idle(void(*func)()) {glutIdleFunc(func);}
	void Mouse(void(*func)(int button, int state, int x, int y)) {glutMouseFunc(func);} 
	void Keyboard(void(*func)(unsigned char key, int x, int y)) {glutKeyboardFunc(func);}
	void Loop() {glutMainLoop();}
	void DrawObject();		//3DIuWFNg`֐
};

//RXgN^[
CGLUT::CGLUT() {

	glutInit(&__argc, __argv);			//void glutInit(int* &argc, char** argv);
	glutInitWindowPosition(m_x, m_y);	//void glutInitWindowPosition(int x, int y);
	glutInitWindowSize(m_w, m_h);		//void glutInitWindowSize(intw, int h);
	glutInitDisplayMode(m_mode);		//void glutInitDisplayMode(unsigned int mode);
}

//fXgN^[
CGLUT::~CGLUT() {

}

//\EBhE
int CGLUT::Create(char* name = NULL) {

	m_win_no = glutCreateWindow("");	//int glutCreateWindow(char * title)	//߂l̓EBhEԍ
	//GL̃foCXReLXgnh擾
	HDC glDc = wglGetCurrentDC();
	//EBhEnh擾
	m_hWnd = WindowFromDC(glDc);
	if(!name)
		if(!m_title)
			SendMessage(m_hWnd, WM_SETTEXT, NULL, (LPARAM)__argv[0]);
		else
			SendMessage(m_hWnd, WM_SETTEXT, NULL, (LPARAM)m_title);
	else {
		lstrcpy(m_title, name);
		SendMessage(m_hWnd, WM_SETTEXT, NULL, (LPARAM)m_title);
	}
}

void CGLUT::SetLA(GLdouble eye_x, GLdouble eye_y, GLdouble eye_z,
					GLdouble center_x, GLdouble center_y, GLdouble center_z,
					GLdouble up_x, GLdouble up_y, GLdouble up_z) {
	m_LA[0] = eye_x; m_LA[1] = eye_y; m_LA[2] = eye_z;
	m_LA[3] = center_x; m_LA[4] = center_y; m_LA[5] = center_z;
	m_LA[6] = up_x; m_LA[7] = up_y; m_LA[8] = up_z;
	LookAt();
}

void CGLUT::LookAt() {
	gluLookAt(m_LA[0], m_LA[1], m_LA[2],
			m_LA[3], m_LA[4], m_LA[5],
			m_LA[6], m_LA[7], m_LA[8]);
}

void CGLUT::Resize(int width, int height) {

	glViewport(0, 0, width, height);	//EChEŜɕ\
	glMatrixMode(GL_PROJECTION);		//eϊ[h
	glLoadIdentity();					//eϊ̕ϊsPʍsŏ
	switch(m_proj) {
	case 0:	//@e@P
		gluPerspective(m_fov, m_aspect, m_near, m_far);	//pxAcA߃Nbvʂ܂ł̋ANbvʂ܂ł̋
		LookAt();
		break;
	case 1:	//Ae@Q
		glFrustum(m_left, m_right, m_bottom, m_top, m_near, m_far);	//NbvʍW(left, right, bottom, top)A߃Nbvʂ܂ł̋ANbvʂ܂ł̋
		LookAt();
		break;
	case 2:	//Be@iߖ@܂܂Ȃej
		glOrtho(m_left, m_right, m_bottom, m_top, m_front, m_back);	//m_left, m_right, m_bottom, m_top, m_front, m_backň͂܂闧̂se
		break;
	}
	glMatrixMode(GL_MODELVIEW);			//ϊEfOϊ[h
	glLoadIdentity();					//ϊEfOϊ̕ϊsPʍsŏ
}

void CGLUT::Refresh() {

	Resize(m_w, m_h);
}

//3DIuWFNg`֐
void CGLUT::DrawObject() {

	switch(m_Obj) {
	default:	//1 - 8ȊO0ƂȂ
	case 0:		//eB[|bg
		if(m_sw)
			glutSolidTeapot(0.5);
		else
			glutWireTeapot(0.5);
		break;
	case 1:		//Cubeíj
		if(m_sw)
			glutSolidCube(0.5);
		else
			glutWireCube(0.5);
		break;
	case 2:		//Sphereij
		if(m_sw)
			glutSolidSphere(0.5, 20, 20);
		else
			glutWireSphere(0.5, 20, 20);
		break;
	case 3:		//Conei~j
		if(m_sw)
			glutSolidCone(0.5, 0.8, 20, 20);
		else
			glutWireCone(0.5, 0.8, 20, 20);
		break;
	case 4:		//Torus (h[ibcj
		if(m_sw)
			glutSolidTorus(0.1, 0.4, 20, 20);
		else
			glutWireTorus(0.1, 0.4, 20, 20);
		break;
	case 5:		//Tetrahedron(4ʑ́j
		if(m_sw)
			glutSolidTetrahedron();
		else
			glutWireTetrahedron();
		break;
	case 6:		//Octahedron(8ʑ́j
		if(m_sw)
			glutSolidOctahedron();
		else
			glutWireOctahedron();
		break;
	case 7:		//Dodecahedron(12ʑ́j
		if(m_sw)
			glutSolidDodecahedron();
		else
			glutWireDodecahedron();
		break;
	case 8:		//Icosahedron(20ʑ́j
		if(m_sw)
			glutSolidIcosahedron();
		else
			glutWireIcosahedron();
		break;
	}
}
