//////////////////////////////////////////
// Glut_BCCProc.h
// Copyright (c) 10/26/2021 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnInit(WPARAM wParam, LPARAM lParam) {

	//IDC_SELOBJ̏
	for(int i = 0; i < 18; i++)
		SendItemMsg(IDC_SELOBJ, CB_ADDSTRING, 0, (LPARAM)g_ObjName[i]);
	SendItemMsg(IDC_SELOBJ, CB_SETCURSEL, 0, (LPARAM)0);
	//IDC_SELPROJ̏
	for(int i = 0; i < 3; i++)
		SendItemMsg(IDC_SELPROJ, CB_ADDSTRING, 0, (LPARAM)g_ProjName[i]);
	SendItemMsg(IDC_SELPROJ, CB_SETCURSEL, 0, (LPARAM)0);
	//IDC_SELLIGHT̏
	for(int i = 0; i < 3; i++)
		SendItemMsg(IDC_SELLIGHT, CB_ADDSTRING, 0, (LPARAM)g_LightName[i]);
	SendItemMsg(IDC_SELLIGHT, CB_SETCURSEL, 0, (LPARAM)0);
	//`FbN{bNX̏ݒ
	SendItemMsg(IDC_ROTATE, BM_SETCHECK, BST_CHECKED, (LPARAM)0);
	//XC_[͈̔͐ݒ
	SendItemMsg(IDC_ANGLE, TBM_SETRANGE, TRUE, (LPARAM)MAKELONG(0, 360));
	//y[WTCYi}EXNbN̈ړʁjݒ
	SendItemMsg(IDC_ANGLE, TBM_SETPAGESIZE, 0, (LPARAM)30);
	//CTCYiL[ɂړʁjݒ
	SendItemMsg(IDC_ANGLE, TBM_SETLINESIZE, 0, (LPARAM)10);
	//|WV̐ݒ
	SendItemMsg(IDC_ANGLE, TBM_SETPOS, TRUE, (LPARAM)0);
	//ڐTCY̐ݒ
	SendItemMsg(IDC_ANGLE, TBM_SETTICFREQ, 10, 0);
	return TRUE;
}

bool CMyWnd::OnHScroll(WPARAM wParam, LPARAM lParam) {

	if(!g_rotate && (HWND)lParam == GetDlgItem(m_hWnd, IDC_ANGLE)) {	//펞]̏ꍇAȂ
		if(LOWORD(wParam) == TB_THUMBPOSITION || LOWORD(wParam) == TB_THUMBTRACK)
			g_r = (GLdouble)HIWORD(wParam);
		else
			g_r = (GLdouble)SendItemMsg(IDC_ANGLE, TBM_GETPOS, 0, (LPARAM)0);
	}
	return FALSE;	//AvP[Vł̃bZ[Wꍇ́A0 ԂKv܂B(MSDN)
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES)
		//DestroyWindowAPostQuitMessageĂ΂
		return TRUE;
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

//_CAOx[X̏ꍇ͂ꂪKv
bool CMyWnd::OnDestroy(WPARAM wPram, LPARAM lParam) {

	PostQuitMessage(0);
	return TRUE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnSelected(WPARAM wParam) {

	if(HIWORD(wParam) == CBN_SELCHANGE) {	//ACeIꂽꍇ
		//IDC_SELOBJ̑IemFAglɃZbg
		int sel = SendItemMsg(IDC_SELOBJ, CB_GETCURSEL, 0, (LPARAM)0);
		gl.m_Obj = sel / 2;
		gl.m_sw = (sel % 2 == 1);	//SolidiTRUEjۂiWireFALSEj
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnSelCol() {

	CMNDLG cmndlg;
	COLORREF col = cmndlg.GetColor(m_hWnd);
	if(col) {
		g_Red = (GLdouble)GetRValue(col) / 255.0;
		g_Green = (GLdouble)GetGValue(col) / 255.0;
		g_Blue = (GLdouble)GetBValue(col) / 255.0;
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnCreate() {

	//eLXg{bNX̏ԂύX
	for(int i = 0; i < 9; i++)
		EnableWindow(GetDlgItem(m_hWnd, IDC_EYEX + i), TRUE);
	for(int i = 0; i < 4; i++)
		EnableWindow(GetDlgItem(m_hWnd, IDC_FOV + i), TRUE);
	//R{{bNX̏ԂύX
	EnableWindow(GetDlgItem(m_hWnd, IDC_SELPROJ), TRUE);
	//WI{^̏ԂύX
	EnableWindow(GetDlgItem(m_hWnd, IDC_ROTATE), TRUE);
	EnableWindow(GetDlgItem(m_hWnd, IDC_LIGHT), TRUE);
	//vbV{^̏ԂύX
	EnableWindow(GetDlgItem(m_hWnd, IDC_CREATE), FALSE);
	EnableWindow(GetDlgItem(m_hWnd, IDC_SETLA), TRUE);
	EnableWindow(GetDlgItem(m_hWnd, IDC_SETPROJ), TRUE);
	//CGLUTNXCX^X̏ݒ
	gl.SetPos(100, 100);					//CGLUT̏l
	gl.SetSize(640, 480);					//CGLUT̏l
	gl.SetTitle("Glut Window");				//GLUTEBhE^Cg
	//CGLUTNXCX^X̐
	gl.Create();							//ŃEBhE^Cgݒ
 	glClearColor(0.0, 0.0, 0.0, 0.0);		//ŉʃNA
	glShadeModel(GL_SMOOTH);				//l̊炩ȖԂȋIƂătbgVF[fBO|GL_FLATj
	glEnable(GL_DEPTH_TEST);				//`IuWFNg̉Aʏsׂ̐[x
	gl.SetMode(GLUT_DOUBLE | GLUT_RGBA);	//CGLUT̏li_uobt@O vs. GLUT_SINGLEj
  	//CGLUTR[obN֐̐ݒ
	gl.Idle(gl_Idle);
	gl.Display(gl_Display);
	gl.Reshape(gl_Resize);
	gl.Loop();
	return TRUE;
}

bool CMyWnd::OnSetLA() {

	GLdouble val[9];
	for(int i = 0; i < 9; i++)
		val[i] = GetDouble(IDC_EYEX + i);
	gl.SetLA(	val[0], val[1], val[2],		//_̃|Cg			(GLdouble) eyex, eyey, eyez,
				val[3], val[4], val[5],		//NbvV[̒S_	(GLdouble) centerx, centery, centerz,
				val[6], val[7], val[8]);	//AbvxN^[			(GLdouble) upx, upy, upz
	gl.Refresh();
	return TRUE;
}

bool CMyWnd::OnSelProj(WPARAM wParam) {

	if(HIWORD(wParam) == CBN_SELCHANGE) {	//ACeIꂽꍇ
		//IDC_SELPROJ̑IemFAglɃZbg
		gl.m_proj = SendItemMsg(IDC_SELPROJ, CB_GETCURSEL, 0, (LPARAM)0);	//e@ύX
		SetControlState(gl.m_proj);			//e@ɍ킹Rg[L
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnSetProj() {

	switch(gl.m_proj) {
	default:
	case 0:
		//gluPerspective֐
		gl.m_fov = GetDouble(IDC_FOV);			//iFiield of viewjŒPʂ͓x
		gl.m_aspect = GetDouble(IDC_ASPECT);	//ci / j
		gl.m_near = GetDouble(IDC_NEAR);		//_߃Nbvʂ܂ł̋ij
		gl.m_far = GetDouble(IDC_FAR);			//_牓Nbvʂ܂ł̋ij
		break;
	case 1:
		//glFrustum֐
		gl.m_left = GetDouble(IDC_LEFT);		//NbvʍW
		gl.m_right = GetDouble(IDC_RIGHT);		//NbvʉEW
		gl.m_bottom = GetDouble(IDC_BOTTOM);	//NbvʉW
		gl.m_top = GetDouble(IDC_TOP);			//NbvʏW
		gl.m_near = GetDouble(IDC_NEAR);		//_߃Nbvʂ܂ł̋ij
		gl.m_far = GetDouble(IDC_FAR);			//_牓Nbvʂ܂ł̋ij
		break;
	case 2:
		//glOrtho֐
		gl.m_left = GetDouble(IDC_LEFT);		//NbvʍW
		gl.m_right = GetDouble(IDC_RIGHT);		//NbvʉEW
		gl.m_bottom = GetDouble(IDC_BOTTOM);	//NbvʉW
		gl.m_top = GetDouble(IDC_TOP);			//NbvʏW
		gl.m_front = GetDouble(IDC_BACK);		//ONbvʍW
		gl.m_back = GetDouble(IDC_FRONT);		//NbvʍW
		break;
	}
	gl.Refresh();
	return TRUE;
}

bool CMyWnd::OnRotate() {

	if(SendItemMsg(IDC_ROTATE, BM_GETCHECK, 0, (LPARAM)0) == BST_CHECKED) {	//`FbN{bNX̏ԊmF
		SendItemMsg(IDC_ROTATE, BM_SETCHECK, BST_UNCHECKED, (LPARAM)0);
		g_rotate = FALSE;
		//eLXg{bNXL
		EnableWindow(GetDlgItem(m_hWnd, IDC_ENDX), TRUE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_ENDY), TRUE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_ENDZ), TRUE);
		//XC_[L
		EnableWindow(GetDlgItem(m_hWnd, IDC_ANGLE), TRUE);
	}
	else {
		SendItemMsg(IDC_ROTATE, BM_SETCHECK, BST_CHECKED, (LPARAM)0);
		g_rotate = TRUE;
		//eLXg{bNX𖳌
		EnableWindow(GetDlgItem(m_hWnd, IDC_ENDX), FALSE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_ENDY), FALSE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_ENDZ), FALSE);
		//XC_[𖳌
		EnableWindow(GetDlgItem(m_hWnd, IDC_ANGLE), FALSE);
	}
	return TRUE;
}

bool CMyWnd::OnEndXChanged(WPARAM wParam) {

	if(!g_rotate && HIWORD(wParam) == EN_CHANGE) {	//펞]ȊOŁAf[^ύXꂽꍇ
		g_x = GetDouble(IDC_ENDX);
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnEndYChanged(WPARAM wParam) {

	if(!g_rotate && HIWORD(wParam) == EN_CHANGE) {	//펞]ȊOŁAf[^ύXꂽꍇ
		g_y = GetDouble(IDC_ENDY);
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnEndZChanged(WPARAM wParam) {

	if(!g_rotate && HIWORD(wParam) == EN_CHANGE) {	//펞]ȊOŁAf[^ύXꂽꍇ
		g_z = GetDouble(IDC_ENDZ);
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnLight() {

	if(SendItemMsg(IDC_LIGHT, BM_GETCHECK, 0, (LPARAM)0) == BST_UNCHECKED) {	//`FbN{bNX̏ԊmF
		SendItemMsg(IDC_LIGHT, BM_SETCHECK, BST_CHECKED, (LPARAM)0);
		g_light = TRUE;
		//uFv{^𖳌
		EnableWindow(GetDlgItem(m_hWnd, IDC_COLOR), FALSE);
		//eLXg{bNXL
		EnableWindow(GetDlgItem(m_hWnd, IDC_LIGHTX), TRUE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_LIGHTY), TRUE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_LIGHTZ), TRUE);
		//R{{bNXL
		EnableWindow(GetDlgItem(m_hWnd, IDC_SELLIGHT), TRUE);
		//Lɂ
		gl.Enable(GL_LIGHTING);
		//Iꂽ(8܂Őݒ\)Lɂ
		gl.Enable(g_lightno[g_selected]);
		//̂̎Lɂݒ
		gl.Disable(GL_COLOR_MATERIAL);
	}
	else {
		SendItemMsg(IDC_LIGHT, BM_SETCHECK, BST_UNCHECKED, (LPARAM)0);
		g_light = FALSE;
		//uFv{^L
		EnableWindow(GetDlgItem(m_hWnd, IDC_COLOR), TRUE);
		//eLXg{bNX𖳌
		EnableWindow(GetDlgItem(m_hWnd, IDC_LIGHTX), FALSE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_LIGHTY), FALSE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_LIGHTZ), FALSE);
		//R{{bNX𖳌
		EnableWindow(GetDlgItem(m_hWnd, IDC_SELLIGHT), FALSE);
		//𖳌ɂ
		gl.Disable(GL_LIGHTING);
		//ݑIĂ𖳌ɂ
		gl.Disable(g_lightno[g_selected]);
		//̂̎Lɂݒ
		gl.Enable(GL_COLOR_MATERIAL);
	}
	return TRUE;
}

bool CMyWnd::OnLightXChanged(WPARAM wParam) {

	if(g_light && HIWORD(wParam) == EN_CHANGE) {	//ƌʂLŁAf[^ύXꂽꍇ
		g_lightpos[0] = GetDouble(IDC_LIGHTX);
		gl_Display();
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnLightYChanged(WPARAM wParam) {

	if(g_light && HIWORD(wParam) == EN_CHANGE) {	//ƌʂLŁAf[^ύXꂽꍇ
		g_lightpos[1] = GetDouble(IDC_LIGHTY);
		gl_Display();
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnLightZChanged(WPARAM wParam) {

	if(g_light && HIWORD(wParam) == EN_CHANGE) {	//ƌʂLŁAf[^ύXꂽꍇ
		g_lightpos[2] = GetDouble(IDC_LIGHTZ);
		gl_Display();
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnSelLight(WPARAM wParam) {

	if(HIWORD(wParam) == CBN_SELCHANGE) {	//ACeIꂽꍇ
		//ݑIĂ𖳌ɂ
		gl.Disable(g_lightno[g_selected]);
		//IDC_SELLIGHT̑IemFAglɃZbg
		g_selected = SendItemMsg(IDC_SELLIGHT, CB_GETCURSEL, 0, (LPARAM)0);	//e@ύX
		//IꂽLɂ
		gl.Enable(g_lightno[g_selected]);
		gl_Display();
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnIdok() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

///////////////////
//[U[`֐
///////////////////
//eLXg{bNXGLDoublel擾
GLdouble CMyWnd::GetDouble(UINT id) {

	char buff[MAX_PATH];
	SendItemMsg(id, WM_GETTEXT, MAX_PATH, (LPARAM)buff);
	double res = strtod(buff, NULL);	//ϊɎsꍇ0.0Ԃ
	return (GLdouble)res;
}

void CMyWnd::SetControlState(int pattern = 0) {

	bool tof[10] = {FALSE};
	switch(pattern) {
	case 0:
		tof[0] = tof[1] = tof[2] = tof[3] = TRUE;
		break;
	case 1:
		tof[2] = tof[3] = tof[4] = tof[5] = tof[6] = tof[7] = TRUE;
		break;
	case 2:
		tof[4] = tof[5] = tof[6] = tof[7] = tof[8] = tof[9] = TRUE;
		break;
	default:
		break;
	}
	EnableWindow(GetDlgItem(m_hWnd, IDC_FOV), tof[0]);
	EnableWindow(GetDlgItem(m_hWnd, IDC_ASPECT), tof[1]);
	EnableWindow(GetDlgItem(m_hWnd, IDC_NEAR), tof[2]);
	EnableWindow(GetDlgItem(m_hWnd, IDC_FAR), tof[3]);
	EnableWindow(GetDlgItem(m_hWnd, IDC_LEFT), tof[4]);
	EnableWindow(GetDlgItem(m_hWnd, IDC_RIGHT), tof[5]);
	EnableWindow(GetDlgItem(m_hWnd, IDC_BOTTOM), tof[6]);
	EnableWindow(GetDlgItem(m_hWnd, IDC_TOP), tof[7]);
	EnableWindow(GetDlgItem(m_hWnd, IDC_BACK), tof[8]);
	EnableWindow(GetDlgItem(m_hWnd, IDC_FRONT), tof[9]);
}
