//////////////////////////////////////////
// IconView_DLL.h
// Copyright (c) 03/01/2021 by BCCSkelton
//////////////////////////////////////////
//BCCSkeltoñwb_[|ɕKvȃwb_[Ă
#include	"BCCSkelton.h"
#include	"CICON.h"
//\[XID̃wb_[
#include	"ResIconView_DLL.h"


///////////////////////////////////////////
// CDLGNXICONVIEW_DLGNXh
///////////////////////////////////////////
class ICONVIEW_DLG : public CDLG {
public:
	//o[ϐ
	HINSTANCE 	m_hInstance;
	CICON m_Icon;
	char m_FileName[MAX_PATH];
	int m_ImageType;
	//EBhEbZ[W֐
	bool OnInit(WPARAM, LPARAM);
	bool OnNotify(WPARAM, LPARAM);
	//Rg[֘A֐
	bool OnIdok();
	//[U[`֐
	bool SetListView();
	bool ShowIconData(int);
};

////////////////////////////////////////////////////////////////////////////////
// ICONVIEW_DLGNX_CAOϐ̐Ƃ̃R[obN֐i}Nj`
// NX̃_CAO쐬邱Ƃ\ăR[obN֐𖾋L
////////////////////////////////////////////////////////////////////////////////
//ICONVIEW_DLGNX̃CX^X
ICONVIEW_DLG iconview_dlg;
//R[obN֐}N
BEGIN_MODALDLGMSG(iconview_dlgProc, iconview_dlg)	//1R[obN֐̖O
	ON_COMMAND(iconview_dlg, IDOK, OnIdok())
END_DLGMSG

///////////////////////////////////////////
// ICONVIEW_DLGNX̊֐`
///////////////////////////////////////////
//Rg[֐
bool ICONVIEW_DLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();
	//Xgr[gX^C̐ݒ
	INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(ic);
	ic.dwICC = ICC_LISTVIEW_CLASSES;
	InitCommonControlsEx(&ic);
	DWORD lvStyle = SendItemMsg(IDC_LISTVIEW, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0);
	lvStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
	SendItemMsg(IDC_LISTVIEW, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES, lvStyle);
	//Xgr[̏
	char* column[11] = {"bWidth", "bHeight", "bColorCount", "dwBitCount",
						"dwBytesInRes", "dwImageOffset", "biWidth",
						"biHeight", "biPlanes", "biBitCount", "biSizeImage"};
	int w[11] = {60, 60, 80, 80, 90, 100, 60, 60, 60, 80, 80};
	LV_COLUMN lvcol;
	lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvcol.fmt = LVCFMT_LEFT;
	for(int i = 0; i < 11; i++) {
		lvcol.cx = w[i];
		lvcol.pszText = column[i];
		lvcol.iSubItem = i;
		SendItemMsg(IDC_LISTVIEW, LVM_INSERTCOLUMN, i, (LPARAM)&lvcol);
	}
	//CICONCX^X̏
	m_Icon.Init();
	m_Icon.Clear();
	m_Icon.SetWindow(m_hWnd);
	//t@CǍ
	char* errmsg;
	if(!m_Icon.Load_Icon(m_FileName, m_ImageType, TRUE)) {
		if(m_ImageType == IMAGE_ICON)			//Icont@C
			errmsg = "ACRt@Cǂݍ߂܂ł";
		else if(m_ImageType == IMAGE_CURSOR)	//Cursort@C
			errmsg = "J[\t@Cǂݍ߂܂ł";
		MessageBox(m_hWnd, errmsg, "G[", MB_OK | MB_ICONSTOP);
		return FALSE;
	}
	//ACR\
	SendItemMsg(IDC_ICONVIEW, STM_SETIMAGE, IMAGE_ICON, (LPARAM)m_Icon.GetIcon());
	//Xgr[ɓo^rbg}bv\
	SetListView();
 
	return TRUE;
}

bool ICONVIEW_DLG::OnNotify(WPARAM wParam, LPARAM lParam) {

	if((int)wParam == IDC_LISTVIEW) {	//Xgr[̃bZ[W
		if(((LPNMLISTVIEW)lParam)->hdr.code == NM_CLICK){
			int n = ListView_GetNextItem(GetDlgItem(m_hWnd, IDC_LISTVIEW), -1,
										LVNI_ALL | LVIS_SELECTED);
			if(n== -1) {
				MessageBox(m_hWnd, "IĂ܂", "G[", MB_OK | MB_ICONERROR);
				return FALSE;
			}
			//rbg}bv\
			SendItemMsg(IDC_BMPVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)m_Icon.GetColBmp(n));
			SendItemMsg(IDC_MSKVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)m_Icon.GetMaskBmp(n));
			//GfBbg{bNX̕\
			ShowIconData(n);
		}
		return TRUE;
	}
	return FALSE;
}

bool ICONVIEW_DLG::OnIdok() {

	int n = ListView_GetNextItem(GetDlgItem(m_hWnd, IDC_LISTVIEW), -1,
								LVNI_ALL | LVIS_SELECTED);
	if(n== -1) {
		MessageBox(m_hWnd, "rbg}bvIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
    else {
		//rbg}bvt@Cj󂵂Ȃ悤x
		char str[MAX_PATH];
		wsprintf(str, "\rbg}bv%d̂A%dԖڂI܂B\r\n"\
				"̂܂܂ŏ㏑⓯t@CŕۑƁÃrbg}bv"\
				"Ă܂܂̂ŕKʃt@CŕۑĂB",
				m_Icon.GetCount(), n + 1);
		MessageBox(m_hWnd, str, "x", MB_OK | MB_ICONEXCLAMATION);
		EndModal(n);
		return TRUE;
	}
}

///////////////////
//[U[`֐
///////////////////
bool ICONVIEW_DLG::SetListView() {

	//Xgr[ւ̃f[^o^
	HWND hLV = GetDlgItem(m_hWnd, IDC_LISTVIEW);
	SendMessage(hLV, LVM_DELETEALLITEMS, 0, 0);	//Xgr[̑Sf[^
	int IconNum = m_Icon.GetCount();
	LPICONDIRENTRY lpIde;
	PBITMAPINFOHEADER pBmi;
	LV_ITEM item;
	CSTR str;
	for(int i = 0; i < IconNum; i++) {
		//ICONDIRENTRY̏擾
		m_Icon.GetIDEntry(i, &lpIde);
		//Xg擪̐ݒij
		item.mask = LVIF_TEXT;
		str = lpIde->bWidth;
		item.pszText = str.ToChar();
		item.iItem = i;
		item.iSubItem = 0;
		SendMessage(hLV, LVM_INSERTITEM, 0, (LPARAM)&item);
		//Q̐ݒij
		str = lpIde->bHeight;
		item.pszText = str.ToChar();
		item.iSubItem = 1;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//R̐ݒiFj0=256F
		str = lpIde->bColorCount;
		item.pszText = str.ToChar();
		item.iSubItem = 2;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//S̐ݒiFjBitCount
		str = lpIde->wBitCount;
		item.pszText = str.ToChar();
		item.iSubItem = 3;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//T̐ݒi摜f[^̑傫j
		str = lpIde->dwBytesInRes;
		item.pszText = str.ToChar();
		item.iSubItem = 4;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//U̐ݒit@C擪摜f[^܂ł̃ItZbgj
		str = lpIde->dwImageOffset;
		item.pszText = str.ToChar();
		item.iSubItem = 5;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//BITMAPINFOHEADEȐ擾
		m_Icon.GetBmpInfo(i, &pBmi);
		//V̐ݒi摜̕j
		str = pBmi->biWidth;
		item.pszText = str.ToChar();
		item.iSubItem = 6;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//W̐ݒi摜̍~2 ̒lj
		str = pBmi->biHeight;
		item.pszText = str.ToChar();
		item.iSubItem = 7;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//X̐ݒiv[̐j
		str = pBmi->biPlanes;
		item.pszText = str.ToChar();
		item.iSubItem = 8;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//10̐ݒisNZ̐FE1, 4, 8(, 16), 24(, 32)̂ꂩj
		str = pBmi->biBitCount;
		item.pszText = str.ToChar();
		item.iSubItem = 9;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//11̐ݒi\f[^ƃ}XNf[^̍vTCYj
		str = pBmi->biSizeImage;
		item.pszText = str.ToChar();
		item.iSubItem = 10;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
	}
}

bool ICONVIEW_DLG::ShowIconData(int i) {

	PBITMAPINFOHEADER Bmi;
	LPICONDIRENTRY IDE;
	m_Icon.GetBmpInfo(i, &Bmi);
	m_Icon.GetIDEntry(i, &IDE);
	CSTR IconInfo = "yICONDIRz		F 6bytes\r\n";
	//ACR{̕\
	if(m_ImageType == IMAGE_ICON)
		IconInfo = IconInfo + "t@C		F ICON\r\n";
	else if(m_ImageType == IMAGE_CURSOR)
		IconInfo = IconInfo + "t@C		F CURSOR\r\n";
	else
		return FALSE;
	IconInfo = IconInfo + "摜			F ";
	IconInfo = IconInfo + m_Icon.GetCount();
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "yICONDIRENTRYz		F 16bytes\r\n";
	IconInfo = IconInfo + "C[W			F ";
	IconInfo = IconInfo + IDE->bWidth;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "C[W			F ";
	IconInfo = IconInfo + IDE->bHeight;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "F			F ";
	IconInfo = IconInfo + IDE->bColorCount;
	IconInfo = IconInfo + " (wBitCount = ";
	IconInfo = IconInfo + IDE->wBitCount;
	IconInfo = IconInfo + ")\r\n";
	IconInfo = IconInfo + "t@C擪̃ItZbg	F ";
	IconInfo = IconInfo + IDE->dwImageOffset;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "摜f[^TCY (Bytes)	F ";
	IconInfo = IconInfo + IDE->dwBytesInRes;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "yBIMAPINFOHEADERz	F 40bytes\r\n";
	IconInfo = IconInfo + "Pf̃rbg		F ";
	IconInfo = IconInfo + Bmi->biBitCount;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "(qfapt`ce[u)	F ";
	if(Bmi->biBitCount > 8)
		IconInfo = IconInfo + "0";
	else
		IconInfo = IconInfo + 4 * (1 << Bmi->biBitCount);
	IconInfo = IconInfo	 + "bytes (4 x 2 ^";
	IconInfo = IconInfo + Bmi->biBitCount;
	IconInfo = IconInfo	 + ")\r\n";
	IconInfo = IconInfo + "(J[rbg hbmColor)	F ";
	IconInfo = IconInfo + ((Bmi->biBitCount * Bmi->biWidth + 31) / 32) * 4 * abs(Bmi->biHeight / 2);
	IconInfo = IconInfo + "bytes\r\n";
	IconInfo = IconInfo + "(}XNrbg hbmMask)	F ";
	IconInfo = IconInfo + ((Bmi->biWidth + 31) / 32) * 4 * abs(Bmi->biHeight / 2);
	IconInfo = IconInfo + "bytes\r\n";

	IconInfo = IconInfo + "vC[WTCY		F ";
	IconInfo = IconInfo + Bmi->biSizeImage;
	IconInfo = IconInfo + "bytes\r\n";
	//}XNrbg̃C[Wvg
	IconInfo = IconInfo + "---------- }XNrbgC[W ----------\r\n";
	IconInfo = IconInfo + "No 01234567 01234567 01234567 01234567\r\n";
	IconInfo = IconInfo + "--------------------------------------\r\n";
	int j, k, l;
	char Dat[4];
	if(Bmi->biHeight > 0) {	//{gAbv
		for(j = 31; j >= 0; j--) {
			wsprintf(Dat, "%02d ", j);
			IconInfo = IconInfo + Dat;
			for(k = 0; k < 4; k++) {
				for(l = 0; l < 8; l++) {
					if(m_Icon.m_AND[i][j * 4 + k] & (1 << (7 - l)))
						IconInfo = IconInfo + "1";
					else
						IconInfo = IconInfo + "0";
				}
				IconInfo = IconInfo + " ";
			}
			IconInfo = IconInfo + "\r\n";
		}
	}
	else {					//gbv_E
		for(j = 0; j < 32; j++) {
			wsprintf(Dat, "%02d", j);
			IconInfo = IconInfo + Dat;
			for(k = 0; k < 4; k++) {
				for(l = 0; l < 8; l++) {
					if(m_Icon.m_AND[i][j * 4 + k] & (1 << (7 - l)))
						IconInfo = IconInfo + "1";
					else
						IconInfo = IconInfo + "0";
				}
				IconInfo = IconInfo + " ";
			}
			IconInfo = IconInfo + "\r\n";
		}
	}
	return SendItemMsg(IDC_EDIT, WM_SETTEXT, 0, (LPARAM)IconInfo.ToChar());
}
