//////////////////////////////////////////
// IconViewerProc.h
// Copyright (c) 04/09/2021 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhEICONVIEWER̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool ICONVIEWER::OnInit(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();
	//c[o[o^|SetHandle(hWnd))
	TBar.SetHandle(GetDlgItem(m_hWnd, IDC_TOOLBAR));
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TBAR), 9);
	//c[o[{^ǉ
	TBBUTTON tbb[13];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_OPEN;
	tbb[1].iBitmap = TBar.m_id + 1;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_SAVE;
	tbb[2].iBitmap = TBar.m_id + 2;
	tbb[2].fsState = TBSTATE_ENABLED;
	tbb[2].fsStyle = TBSTYLE_BUTTON;
	tbb[2].idCommand = IDM_BMPSAVE;
	tbb[3].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[4].iBitmap = TBar.m_id + 3;
	tbb[4].fsState = TBSTATE_ENABLED;
	tbb[4].fsStyle = TBSTYLE_BUTTON;
	tbb[4].idCommand = IDM_EXIT;
	tbb[5].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[6].iBitmap = TBar.m_id + 4;
	tbb[6].fsState = TBSTATE_ENABLED;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_ADD;
	tbb[7].iBitmap = TBar.m_id + 5;
	tbb[7].fsState = TBSTATE_ENABLED;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_DELETE;
	tbb[8].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[9].iBitmap = TBar.m_id + 6;
	tbb[9].fsState = TBSTATE_ENABLED;
	tbb[9].fsStyle = TBSTYLE_BUTTON;
	tbb[9].idCommand = IDM_DISPLAY;
	tbb[10].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[11].iBitmap = TBar.m_id + 7;
	tbb[11].fsState = TBSTATE_ENABLED;
	tbb[11].fsStyle = TBSTYLE_BUTTON;
	tbb[11].idCommand = IDM_HELP;
	tbb[12].iBitmap = TBar.m_id + 8;
	tbb[12].fsState = TBSTATE_ENABLED;
	tbb[12].fsStyle = TBSTYLE_BUTTON;
	tbb[12].idCommand = IDM_VERSION;
	TBar.AddButtons(13, tbb);
	//Xe[^Xo[o^|SetHandle(hWnd))
	SBar.SetHandle(GetDlgItem(m_hWnd, IDC_STATUSBAR));
	//Xe[^Xo[ݒ
	int sec[2] = {120, -1};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "IconViewer Ver2.0");
	//t@CpX̐ݒ
	g_HelpFile = Arg.Path();
	g_HelpFile = g_HelpFile + "\\IconViewerHelp.chm";
	//CICONCX^X̏
	g_Icon.SetWindow(m_hWnd);
	//Xgr[gX^C̐ݒ
	INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(ic);
	ic.dwICC = ICC_LISTVIEW_CLASSES;
	InitCommonControlsEx(&ic);
	DWORD lvStyle = SendItemMsg(IDC_LISTVIEW, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0);
	lvStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
	SendItemMsg(IDC_LISTVIEW, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES, lvStyle);
	//Xgr[̏
	char* column[11] = {"bWidth", "bHeight", "bColorCount", "dwBitCount",
						"dwBytesInRes", "dwImageOffset", "biWidth",
						"biHeight", "biPlanes", "biBitCount", "biSizeImage"};
	int w[11] = {60, 60, 80, 80, 90, 100, 60, 60, 60, 80, 80};
	LV_COLUMN lvcol;
	lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvcol.fmt = LVCFMT_LEFT;
	for(int i = 0; i < 11; i++) {
		lvcol.cx = w[i];
		lvcol.pszText = column[i];
		lvcol.iSubItem = i;
		SendItemMsg(IDC_LISTVIEW, LVM_INSERTCOLUMN, i, (LPARAM)&lvcol);
	}
 	//|bvAbvj[̐ݒ
	g_hPopup = GetSubMenu(GetMenu(m_hWnd), 1);
	//f[^t@CŋNꂽꍇAt@CI[v
	if(g_ByFile) {
		g_FileName = Arg.v(1);
		OnOpen();
	}
	//hbOAhhbvJn
	DragAcceptFiles(m_hWnd, TRUE);
	return TRUE;
}

bool ICONVIEWER::OnNotify(WPARAM wParam, LPARAM lParam) {

	//c[o[̃c[`bv
	if(((LPNMHDR)lParam)->code == TTN_NEEDTEXT) {
		switch(((LPTOOLTIPTEXT)lParam)->hdr.idFrom) {
		case IDM_OPEN:
			((LPTOOLTIPTEXT)lParam)->lpszText = "ACRJ";
			break;
		case IDM_SAVE:
			((LPTOOLTIPTEXT)lParam)->lpszText = "ACR̕ۑ";
			break;
		case IDM_BMPSAVE:
			((LPTOOLTIPTEXT)lParam)->lpszText = "\rbg}bv̕ۑ";
			break;
		case IDM_EXIT:
			((LPTOOLTIPTEXT)lParam)->lpszText = "I";
			break;
		case IDM_ADD:
			((LPTOOLTIPTEXT)lParam)->lpszText = "C[W̒ǉ";
			break;
		case IDM_DELETE:
			((LPTOOLTIPTEXT)lParam)->lpszText = "C[W̍폜";
			break;
		case IDM_DISPLAY:
			((LPTOOLTIPTEXT)lParam)->lpszText = "rbg}bv̕\";
			break;
		case IDM_HELP:
			((LPTOOLTIPTEXT)lParam)->lpszText = "wv";
			break;
		case IDM_VERSION:
			((LPTOOLTIPTEXT)lParam)->lpszText = "o[W";
			break;
		}
		return TRUE;
	}
	else if((int)wParam == IDC_LISTVIEW) {	//Xgr[̃bZ[W
		if(((LPNMLISTVIEW)lParam)->hdr.code == NM_CLICK){
			int n = ListView_GetNextItem(GetDlgItem(m_hWnd, IDC_LISTVIEW), -1,
										LVNI_ALL | LVIS_SELECTED);
			if(n== -1) {
				MessageBox(m_hWnd, "IĂ܂", "G[", MB_OK | MB_ICONERROR);
				return FALSE;
			}
			//rbg}bv\
			SendItemMsg(IDC_BMPVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_Icon.GetColBmp(n));
			SendItemMsg(IDC_MSKVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_Icon.GetMaskBmp(n));
			//GfBbg{bNX̕\
			ShowIconData(n);
		}
		else if(((LPNMLISTVIEW)lParam)->hdr.code == NM_RCLICK) {
			//EChËʒu擾
			RECT rec;
			GetWindowRect(m_hWnd, &rec);
			//|bvAbvj[̕\ꏊݒ
			POINT pt;
			GetCursorPos(&pt);
			//|bvAbvj[̕\
			TrackPopupMenu(g_hPopup, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON, pt.x, pt.y, 0, m_hWnd, &rec);
		}
		return TRUE;
	}
	return FALSE;
}

bool ICONVIEWER::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES) {
		//DestroyWindowAPostQuitMessageĂ΂
		EndModal(TRUE);
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

bool ICONVIEWER::OnDropFiles(WPARAM wParam, LPARAM lParam) {

	//T^IȃhbOAhhbv
	char FileName[MAX_PATH];
	HDROP hDrop = (HDROP)wParam; 					//HDROP擾
	DragQueryFile(hDrop, 0, FileName, MAX_PATH);	//t@C擾
	g_FileName = FileName;
	g_ByFile = TRUE;
	OnOpen();
	DragFinish(hDrop);								//I

	return TRUE;
}

//_CAOx[X̏ꍇ͂ꂪKv
bool ICONVIEWER::OnDestroy(WPARAM wPram, LPARAM lParam) {

	PostQuitMessage(0);
	return TRUE;
}

/////////////////////////////////
//EBhEICONVIEWER̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool ICONVIEWER::OnOpen() {

	if(g_ByFile)
		g_ByFile = FALSE;
	else {
		char* cp = cmndlg.GetFileName(m_hWnd, "ACRt@C(*.ico)\0*.ico\0J[\t@C(*.cur)\0*.cur\0\0", TRUE);
		if(cp)
			g_FileName = cp;	//cpNULLłȂ΃t@Cg_FileNameփRs[
		else {
			MessageBox(m_hWnd, "̓LZ܂", "bZ[W", MB_OK | MB_ICONERROR);
			return FALSE;
		}
	}
	//t@CǍ
	if(strstr(g_FileName.ToChar(), ".ico") || strstr(g_FileName.ToChar(), ".ICO")) {	//Icont@C
		g_ImageType = IMAGE_ICON;
		if(!g_Icon.Load_Icon(g_FileName.ToChar(), IMAGE_ICON, TRUE)) {
			MessageBox(m_hWnd, "ACRt@Cǂݍ߂܂ł", "G[", MB_OK | MB_ICONSTOP);
			return FALSE;
		}
	}
	else if(strstr(g_FileName.ToChar(), ".cur") || strstr(g_FileName.ToChar(), ".CUR")) {	//Cursort@C
		g_ImageType = IMAGE_CURSOR;
		if(!g_Icon.Load_Icon(g_FileName.ToChar(), IMAGE_CURSOR, TRUE)) {
			MessageBox(m_hWnd, "J[\t@Cǂݍ߂܂ł", "G[", MB_OK | MB_ICONSTOP);
			return FALSE;
		}
	}
	//ACR\
	SendItemMsg(IDC_ICONVIEW, STM_SETIMAGE, IMAGE_ICON, (LPARAM)g_Icon.GetIcon());
	//Xgr[ɓo^rbg}bv\
	SetListView();
	//t@CXe[^Xo[ɕ\
	SBar.SetText(1, g_FileName.ToChar());
	SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_FileName.ToChar());	//ToolTip
	return TRUE;
}

bool ICONVIEWER::OnSave() {

	if(!*g_FileName.ToChar())
		OnSaveas();
	else
		g_Icon.Save_Icon(g_FileName.ToChar(), g_ImageType);
	return TRUE;
}

bool ICONVIEWER::OnSaveas() {

	char *flt, *ext;
	//IDD_SAVE_CAO̕\
	savedlg.DoModal(m_hWnd, "IDD_SAVE", savedlgProc);
	if(g_ImageType == IMAGE_ICON) {
		flt = "ACRt@C(*.ico)\0*.ico\0\0";
		ext = "ico";
	}
	else {
		flt = "J[\t@C(*.cur)\0*.cur\0\0";
		ext = "cur";
		int num = g_Icon.GetCount();
		for(int i = 0; i < num; i++) {
			//rbg}bv\
			SendItemMsg(IDC_BMPVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_Icon.GetColBmp(i));
			SendItemMsg(IDC_MSKVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_Icon.GetMaskBmp(i));
			//zbgX|bg̐ݒ
			g_Num = i;
			hotspotdlg.DoModal(m_hWnd, "IDD_HOTSPOT", hotspotdlgProc);
		}
	}
	char* cp = cmndlg.GetFileName(m_hWnd, flt, FALSE, ext);
	if(cp)
		g_FileName = cp;	//cpNULLłȂ΃t@Cg_FileNameփRs[
	else {
		MessageBox(m_hWnd, "̓LZ܂", "bZ[W", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	g_Icon.Save_Icon(g_FileName.ToChar(), g_ImageType);
	//t@CXe[^Xo[ɕ\
	SBar.SetText(1, g_FileName.ToChar());
	SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_FileName.ToChar());	//ToolTip
	return TRUE;
}

bool ICONVIEWER::OnBmpsave() {

	int n = ListView_GetNextItem(GetDlgItem(m_hWnd, IDC_LISTVIEW), -1,
								LVNI_ALL | LVIS_SELECTED);
	if(n == -1) {	//IȂ牽Ȃ
		MessageBox(m_hWnd, "rbg}bvIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {			//IĂꍇ
		char* flt = "rbg}bvt@C(*.bmp)\0*.bmp\0\0";
		char* ext = "bmp";
		char* cp = cmndlg.GetFileName(m_hWnd, flt, FALSE, ext);
		if(!cp) {
			MessageBox(m_hWnd, "LZ܂", "G[", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		CBMP bmp(g_Icon.GetColBmp(n));
		bmp.SaveBMP(cp);
	}
 	return TRUE;
}

bool ICONVIEWER::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool ICONVIEWER::OnAdd() {

	char* flt = "rbg}bvt@C(*.bmp)\0*.bmp\0\0";
	char* cp = cmndlg.GetFileName(m_hWnd, flt, TRUE);
	if(!cp) {
		MessageBox(m_hWnd, "LZ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	int n = g_Icon.GetCount();		//͎̃rbg}bvJE^[Ɠ
	if(!g_Icon.Add_Bitmap(cp))		//rbg}bvǉ
		return FALSE;
	//rbg}bv\
	SendItemMsg(IDC_BMPVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_Icon.GetColBmp(n));
	SendItemMsg(IDC_MSKVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_Icon.GetMaskBmp(n));
	//GfBbg{bNX̕\
	ShowIconData(n);
	//Xgr[ɓo^rbg}bv\
	SetListView();
	return TRUE;
}

bool ICONVIEWER::OnDelete() {

	int n = ListView_GetNextItem(GetDlgItem(m_hWnd, IDC_LISTVIEW), -1,
								LVNI_ALL | LVIS_SELECTED);
	if(n == -1) {
		MessageBox(m_hWnd, "rbg}bvIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	g_Icon.Del_Bitmap(n);
	//\p̃rbg}bv
	HDC hDC = GetDC(m_hWnd);
	HBITMAP hNull = CreateCompatibleBitmap(hDC, 32, 32);
	ReleaseDC(m_hWnd, hDC);
	//prbg}bv\
	SendItemMsg(IDC_BMPVIEW, STM_SETIMAGE, 0, (LPARAM)hNull);
	SendItemMsg(IDC_MSKVIEW, STM_SETIMAGE, 0, (LPARAM)hNull);
	DeleteObject(hNull);
	//GfBbg{bNX̕\
	SendItemMsg(IDC_EDIT, WM_SETTEXT, 0, (LPARAM)0);
	//Xgr[ɓo^rbg}bv\
	SetListView();
	return TRUE;
}

bool ICONVIEWER::OnDisplay() {

	int n = ListView_GetNextItem(GetDlgItem(m_hWnd, IDC_LISTVIEW), -1,
								LVNI_ALL | LVIS_SELECTED);
	if(n== -1) {
		MessageBox(m_hWnd, "rbg}bvIĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//rbg}bv\
	SendItemMsg(IDC_BMPVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_Icon.GetColBmp(n));
	SendItemMsg(IDC_MSKVIEW, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_Icon.GetMaskBmp(n));
	//GfBbg{bNX̕\
	ShowIconData(n);
 	return TRUE;
}

bool ICONVIEWER::OnHelp() {

	CSTR cmd = "hh \"";
	cmd = cmd + g_HelpFile + "\"";
	WinExec(cmd.ToChar(), SW_SHOWNORMAL);
	return TRUE;
}

bool ICONVIEWER::OnVersion() {

	//IDD_VERSION_CAO̕\
	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

///////////////////
//[U[`֐
///////////////////
bool ICONVIEWER::SetListView() {

	//Xgr[ւ̃f[^o^
	HWND hLV = GetDlgItem(m_hWnd, IDC_LISTVIEW);
	SendMessage(hLV, LVM_DELETEALLITEMS, 0, 0);	//Xgr[̑Sf[^
	int IconNum = g_Icon.GetCount();
	LPICONDIRENTRY lpIde;
	PBITMAPINFOHEADER pBmi;
	LV_ITEM item;
	CSTR str;
	for(int i = 0; i < IconNum; i++) {
		//ICONDIRENTRY̏擾
		g_Icon.GetIDEntry(i, &lpIde);
		//Xg擪̐ݒij
		item.mask = LVIF_TEXT;
		str = lpIde->bWidth;
		item.pszText = str.ToChar();
		item.iItem = i;
		item.iSubItem = 0;
		SendMessage(hLV, LVM_INSERTITEM, 0, (LPARAM)&item);
		//Q̐ݒij
		str = lpIde->bHeight;
		item.pszText = str.ToChar();
		item.iSubItem = 1;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//R̐ݒiFj0=256F
		str = lpIde->bColorCount;
		item.pszText = str.ToChar();
		item.iSubItem = 2;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//S̐ݒiFjBitCount
		str = lpIde->wBitCount;
		item.pszText = str.ToChar();
		item.iSubItem = 3;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//T̐ݒi摜f[^̑傫j
		str = lpIde->dwBytesInRes;
		item.pszText = str.ToChar();
		item.iSubItem = 4;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//U̐ݒit@C擪摜f[^܂ł̃ItZbgj
		str = lpIde->dwImageOffset;
		item.pszText = str.ToChar();
		item.iSubItem = 5;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//BITMAPINFOHEADEȐ擾
		g_Icon.GetBmpInfo(i, &pBmi);
		//V̐ݒi摜̕j
		str = pBmi->biWidth;
		item.pszText = str.ToChar();
		item.iSubItem = 6;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//W̐ݒi摜̍~2 ̒lj
		str = pBmi->biHeight;
		item.pszText = str.ToChar();
		item.iSubItem = 7;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//X̐ݒiv[̐j
		str = pBmi->biPlanes;
		item.pszText = str.ToChar();
		item.iSubItem = 8;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//10̐ݒisNZ̐FE1, 4, 8(, 16), 24(, 32)̂ꂩj
		str = pBmi->biBitCount;
		item.pszText = str.ToChar();
		item.iSubItem = 9;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
		//11̐ݒi\f[^ƃ}XNf[^̍vTCYj
		str = pBmi->biSizeImage;
		item.pszText = str.ToChar();
		item.iSubItem = 10;
		SendMessage(hLV, LVM_SETITEM, 0, (LPARAM)&item);
	}
}

bool ICONVIEWER::ShowIconData(int i) {

	PBITMAPINFOHEADER Bmi;
	LPICONDIRENTRY IDE;
	g_Icon.GetBmpInfo(i, &Bmi);
	g_Icon.GetIDEntry(i, &IDE);
	CSTR IconInfo = "yICONDIRz		F 6bytes\r\n";
	//ACR{̕\
	if(g_ImageType == IMAGE_ICON)
		IconInfo = IconInfo + "t@C		F ICON\r\n";
	else if(g_ImageType == IMAGE_CURSOR)
		IconInfo = IconInfo + "t@C		F CURSOR\r\n";
	else
		return FALSE;
	IconInfo = IconInfo + "摜			F ";
	IconInfo = IconInfo + g_Icon.GetCount();
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "yICONDIRENTRYz		F 16bytes\r\n";
	IconInfo = IconInfo + "C[W			F ";
	IconInfo = IconInfo + IDE->bWidth;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "C[W			F ";
	IconInfo = IconInfo + IDE->bHeight;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "F			F ";
	IconInfo = IconInfo + IDE->bColorCount;
	IconInfo = IconInfo + " (wBitCount = ";
	IconInfo = IconInfo + IDE->wBitCount;
	IconInfo = IconInfo + ")\r\n";
	IconInfo = IconInfo + "t@C擪̃ItZbg	F ";
	IconInfo = IconInfo + IDE->dwImageOffset;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "摜f[^TCY (Bytes)	F ";
	IconInfo = IconInfo + IDE->dwBytesInRes;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "yBIMAPINFOHEADERz	F 40bytes\r\n";
	IconInfo = IconInfo + "Pf̃rbg		F ";
	IconInfo = IconInfo + Bmi->biBitCount;
	IconInfo = IconInfo + "\r\n";
	IconInfo = IconInfo + "(qfapt`ce[u)	F ";
	if(Bmi->biBitCount > 8)
		IconInfo = IconInfo + "0";
	else
		IconInfo = IconInfo + 4 * (1 << Bmi->biBitCount);
	IconInfo = IconInfo	 + "bytes (4 x 2 ^";
	IconInfo = IconInfo + Bmi->biBitCount;
	IconInfo = IconInfo	 + ")\r\n";
	IconInfo = IconInfo + "(J[rbg hbmColor)	F ";
	IconInfo = IconInfo + ((Bmi->biBitCount * Bmi->biWidth + 31) / 32) * 4 * abs(Bmi->biHeight / 2);
	IconInfo = IconInfo + "bytes\r\n";
	IconInfo = IconInfo + "(}XNrbg hbmMask)	F ";
	IconInfo = IconInfo + ((Bmi->biWidth + 31) / 32) * 4 * abs(Bmi->biHeight / 2);
	IconInfo = IconInfo + "bytes\r\n";

	IconInfo = IconInfo + "vC[WTCY		F ";
	IconInfo = IconInfo + Bmi->biSizeImage;
	IconInfo = IconInfo + "bytes\r\n";
	//}XNrbg̃C[Wvg
	IconInfo = IconInfo + "---------- }XNrbgC[W ----------\r\n";
	IconInfo = IconInfo + "No 01234567 01234567 01234567 01234567\r\n";
	IconInfo = IconInfo + "--------------------------------------\r\n";
	int j, k, l;
	char Dat[4];
	if(Bmi->biHeight > 0) {	//{gAbv
		for(j = 31; j >= 0; j--) {
			wsprintf(Dat, "%02d ", j);
			IconInfo = IconInfo + Dat;
			for(k = 0; k < 4; k++) {
				for(l = 0; l < 8; l++) {
					if(g_Icon.m_AND[i][j * 4 + k] & (1 << (7 - l)))
						IconInfo = IconInfo + "1";
					else
						IconInfo = IconInfo + "0";
				}
				IconInfo = IconInfo + " ";
			}
			IconInfo = IconInfo + "\r\n";
		}
	}
	else {					//gbv_E
		for(j = 0; j < 32; j++) {
			wsprintf(Dat, "%02d", j);
			IconInfo = IconInfo + Dat;
			for(k = 0; k < 4; k++) {
				for(l = 0; l < 8; l++) {
					if(g_Icon.m_AND[i][j * 4 + k] & (1 << (7 - l)))
						IconInfo = IconInfo + "1";
					else
						IconInfo = IconInfo + "0";
				}
				IconInfo = IconInfo + " ";
			}
			IconInfo = IconInfo + "\r\n";
		}
	}
	return SendItemMsg(IDC_EDIT, WM_SETTEXT, 0, (LPARAM)IconInfo.ToChar());
}

///////////////////////////////
//SAVEDLG_CAO̊֐`
///////////////////////////////
bool SAVEDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//WI{bNXƃzbgX|bgGfBbg{bNX̏ݒ
	switch(g_ImageType) {
	case IMAGE_ICON:	//ACR
		SendItemMsg(IDC_RBICON, BM_SETCHECK, BST_CHECKED, 0);
		break;
	case IMAGE_CURSOR:	//J[\
		SendItemMsg(IDC_RBCUR, BM_SETCHECK, BST_CHECKED, 0);
		break;
	}
	return TRUE;
}

bool SAVEDLG::OnIdok() {

	if(SendItemMsg(IDC_RBICON, BM_GETCHECK, 0, 0) == BST_CHECKED)
		g_ImageType = IMAGE_ICON;
	else
		g_ImageType = IMAGE_CURSOR;
	EndModal(TRUE);
	return TRUE;
}

/////////////////////////////////
//HOTSPOTDLG_CAO̊֐`
/////////////////////////////////
bool HOTSPOTDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//͕3ɐ
	SendItemMsg(IDC_HOTSPOTX, EM_SETLIMITTEXT, 2, 0);
	SendItemMsg(IDC_HOTSPOTY, EM_SETLIMITTEXT, 2, 0);
	char num[3];
	wsprintf(num, "%d", g_Icon.GetHsX(g_Num));
	SendItemMsg(IDC_HOTSPOTX, WM_SETTEXT, 0, (LPARAM)num);
	wsprintf(num, "%d", g_Icon.GetHsY(g_Num));
	SendItemMsg(IDC_HOTSPOTY, WM_SETTEXT, 0, (LPARAM)num);
	return TRUE;
}

bool HOTSPOTDLG::OnIdok() {

	int n;
	char num[3];
	SendItemMsg(IDC_HOTSPOTX, WM_GETTEXT, 3, (LPARAM)num);
	n = atoi(num);
	if(n < 0 || n > 32) {
		MessageBox(m_hWnd, "ُli܂32jɂȂĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else
		g_Icon.SetHsX(g_Num, n);
	SendItemMsg(IDC_HOTSPOTY, WM_GETTEXT, 3, (LPARAM)num);
	n = atoi(num);
	if(n < 0 || n > 32) {
		 MessageBox(m_hWnd, "ُli܂32jɂȂĂ܂", "G[", MB_OK | MB_ICONERROR);
		 return FALSE;
	}
	else
		g_Icon.SetHsY(g_Num, n);
	EndModal(TRUE);
	return TRUE;
}

/////////////////////////////////
//VERSIONDLG_CAO̊֐`
//Rg[֐
/////////////////////////////////
bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}
