//////////////////////////////////////////
// LightCycleProc.h
// Copyright (c) 10/30/2021 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnCreate(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	TBar.Init(m_hWnd, m_hInstance, TOOLBAR);
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_BITMAP), 7);
	//c[o[{^ǉ
	TBBUTTON tbb[10];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_ADD;
	tbb[1].iBitmap = TBar.m_id + 1;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_OPEN;
	tbb[2].iBitmap = TBar.m_id + 2;
	tbb[2].fsState = TBSTATE_ENABLED;
	tbb[2].fsStyle = TBSTYLE_BUTTON;
	tbb[2].idCommand = IDM_SAVE;
	tbb[3].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[4].iBitmap = TBar.m_id + 3;
	tbb[4].fsState = TBSTATE_ENABLED;
	tbb[4].fsStyle = TBSTYLE_BUTTON;
	tbb[4].idCommand = IDM_EXIT;
	tbb[5].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[6].iBitmap = TBar.m_id + 4;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_GO;
	tbb[7].iBitmap = TBar.m_id + 5;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_STOP;
	tbb[8].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[9].iBitmap = TBar.m_id + 6;
	tbb[9].fsState = TBSTATE_ENABLED;
	tbb[9].fsStyle = TBSTYLE_BUTTON;
	tbb[9].idCommand = IDM_VERSION;
	TBar.AddButtons(10, tbb);

	//Xe[^Xo[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	SBar.Init(m_hWnd, m_hInstance, STATUSBAR);
	//Xe[^Xo[ݒ
	int sec[3] = {100, 300, -1};
	SBar.SetSection(3, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "LightCycle Ver 1.0");
	SBar.SetText(2, "}EXNbNŃP[sAENbNŃQ[~");

	//zEBhȄ
	m_cvs.SetCanvas(m_hWnd);
	//wi̓hׂuVŕ`
	m_cvs.Color(0);
	m_cvs.BrSelection(1);
	m_cvs.Clear();

	//LightCyclẽfoCXReLXg̐ݒ
	//m_LC[0].SetDC(m_cvs.hDC());ł悢
	CLIGHTCYCLE::m_hDC = m_cvs.hDC();

	//uQ[j[vƃXe[^Xo[sɂ
	ChangeMenuStatus(FALSE, FALSE);  

	//LightCycleo^̏
	m_NoLC = 0;

	return TRUE;
}

bool CMyWnd::OnTimer(WPARAM wParam, LPARAM lParam) {

	int no;
	switch(wParam) {
	case IDT_TIMER0:
		no = 0;
		break;
	case IDT_TIMER1:
		no = 1;
		break;
	case IDT_TIMER2:
		no = 2;
		break;
	case IDT_TIMER3:
		no = 3;
		break;
	default:
		return FALSE;
	}
	if(m_LC[no].CanGo()) {
		m_cvs.Color(m_LC[no].m_Color);			//ZԗF
		m_cvs.Dot(m_LC[no].m_x, m_LC[no].m_y);	//shbgł
	}
	else {
		//^C}[荞݂~
		m_tm[no].Stop();
		//Xe[^Xo[3敪̕擾
		char str[MAX_PATH];
		SBar.GetText(2, str);
		CSTR Msg1 = str;
	 	CSTR Msg2 = g_Col[m_LC[no].m_Color - 8];
		Msg2 = Msg2 + "";
		Msg2 = Msg2 + m_LC[no].Dead();
		Msg1 = Msg1 + Msg2;
		SBar.SetText(2, Msg1.ToChar());
	}
	//Q[I
	if(!m_LC[0].m_Alive && !m_LC[1].m_Alive &&
		!m_LC[2].m_Alive && !m_LC[3].m_Alive) {
		MessageBox(m_hWnd, "Sԗ~܂", "ZI",
					MB_OK | MB_ICONEXCLAMATION);
		g_On = FALSE;
		ChangeMenuStatus(TRUE, FALSE);
	}
	return TRUE;
}

bool CMyWnd::OnLButtonDown(WPARAM wParam, LPARAM lParam) {

	//j[ACeCtH\
	MENUITEMINFO mii;
	//j[nh̎擾
	HMENU hMenu = GetMenu(m_hWnd);
	HMENU hGameMenu = GetSubMenu(hMenu, 1);
	mii.cbSize = sizeof(mii);
	mii.fMask = MIIM_STATE;
	GetMenuItemInfo(hGameMenu, IDM_GO, FALSE, &mii);
	if(mii.fState & MFS_DISABLED) {
		MessageBox(m_hWnd, "ݍNbN͎gpł܂", "",
					MB_OK | MB_ICONWARNING);
		return FALSE;
	}
	else {
		OnGo();
		return TRUE;
	}
}

bool CMyWnd::OnRButtonDown(WPARAM wParam, LPARAM lParam) {

	//j[ACeCtH\
	MENUITEMINFO mii;
	//j[nh̎擾
	HMENU hMenu = GetMenu(m_hWnd);
	HMENU hGameMenu = GetSubMenu(hMenu, 1);
	mii.cbSize = sizeof(mii);
	mii.fMask = MIIM_STATE;
	GetMenuItemInfo(hGameMenu, IDM_STOP, FALSE, &mii);
	if(mii.fState & MFS_DISABLED) {
		MessageBox(m_hWnd, "݉ENbN͎gpł܂", "",
					MB_OK | MB_ICONWARNING);
		return FALSE;
	}
	else {
		OnStop();
		return TRUE;
	}
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	//c[o[c[`bv|݂ɂ̎idCtrl(wParam)̓j[ACeɂȂiFIDM_OPENj
	if(((LPNMHDR)lParam)->code == TTN_NEEDTEXT) {	//TTN_GETDISPINFOƓ
		((LPTOOLTIPTEXT)lParam)->hinst = m_hInstance;
		char* tag;
		switch(((LPTOOLTIPTEXT)lParam)->hdr.idFrom) {
		case IDM_ADD:
			tag = "ǉEҏW";
			break;
		case IDM_OPEN:
			tag = "f[^J";
			break;
		case IDM_SAVE:
			tag = "f[^̕ۑ";
			break;
		case IDM_EXIT:
			tag = "I";
			break;
		case IDM_GO:
			tag = "s";
			break;
		case IDM_STOP:
			tag = "~";
			break;
			break;
		case IDM_VERSION:
			tag = "o[W";
			break;
		}
		((LPTOOLTIPTEXT)lParam)->lpszText = tag;
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	TBar.AutoSize();
	SBar.AutoSize();
	//Q[JnɃQ[̈m肷
	if(!g_On) {
		CLIGHTCYCLE::m_MinX = 0;
		CLIGHTCYCLE::m_MaxX = LOWORD(lParam);
		RECT rec;
		GetWindowRect(TBar.m_hWnd, &rec);
		CLIGHTCYCLE::m_MinY = rec.bottom - rec.top;
		CLIGHTCYCLE::m_MaxY = HIWORD(lParam);	//u
		GetWindowRect(SBar.m_hWnd, &rec);
		CLIGHTCYCLE::m_MaxY -= (rec.bottom - rec.top);
		//Zg̕\
		m_cvs.Clear();
		m_cvs.Color(7);
		m_cvs.Box(CLIGHTCYCLE::m_MinX, CLIGHTCYCLE::m_MinY, CLIGHTCYCLE::m_MaxX, CLIGHTCYCLE::m_MaxY, 0);
		//ZW̕\
		char str[64];
		wsprintf(str, "Z (%d,%d)-(%d,%d)", CLIGHTCYCLE::m_MinX, CLIGHTCYCLE::m_MinY, CLIGHTCYCLE::m_MaxX, CLIGHTCYCLE::m_MaxY);
		SBar.SetText(1, str);
	}
	return TRUE;
}

bool CMyWnd::OnPaint(WPARAM wParam, LPARAM lParam) {

	PAINTSTRUCT paint;
	m_cvs.OnPaint(BeginPaint(m_hWnd, &paint));
	EndPaint(m_hWnd, &paint);
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES) {
		//^C}[p
		for(int i = 0; i < m_NoLC; i++)
			m_tm[i].Stop();
		//DestroyWindowAPostQuitMessageĂ΂
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

bool CMyWnd::OnMinMax(WPARAM wParam, LPARAM lParam) {

	//T^IȃEBhẼTCY
	MINMAXINFO *pmmi;
	pmmi = (MINMAXINFO*)lParam;
	pmmi->ptMinTrackSize.x = 656;	// ŏiZGA640j
	pmmi->ptMinTrackSize.y = 509;	// ŏiZGA400j

	return FALSE;					//DefWndProcɔC
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnAdd() {

	if(inputdlg.DoModal(m_hWnd, "IDD_INPUT", inputdlgProc)) {
		if(m_NoLC)	//m_NoLC0łȂȂQ[s\
			ChangeMenuStatus(TRUE, FALSE);
		return TRUE;
	}
	else {
		MessageBox(m_hWnd, "LZ܂B", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
}

bool CMyWnd::OnOpen() {

	char* fn = cmndlg.GetFileName(m_hWnd, "LightCyclef[^t@C(*.lcd)\0*.lcd\0\0", TRUE, "lcd", ".", "LightCyclef[^J");
	if(fn) {
		g_File.SetName(fn);	//t@CpXA̓o^
		m_NoLC = g_File.ReadInt("ԗ", "䐔");
		char str[16];		//ZNVpobt@
		int Color, StartDir, StartX, StartY, Speed, Caprice;	//eϐ
		for(int i = 0; i < m_NoLC; i++) {
			wsprintf(str, "ԗNo. %d", i);
			Color = g_File.ReadInt(str, "ԗF");
			StartDir = g_File.ReadInt(str, "");
			StartX = g_File.ReadInt(str, "XW");
			StartY = g_File.ReadInt(str, "YW");
			Speed = g_File.ReadInt(str, "x");
		    Caprice = g_File.ReadInt(str, "]px");
			//f[^Zbĝ݂Ȃ炸As\Ԃɂ
			m_LC[i].SetData(Color, StartDir, StartX, StartY, Speed, Caprice);
		}
		//m_NoLC0łȂȂȉsB
		if(m_NoLC)
			ChangeMenuStatus(TRUE, FALSE);
		return TRUE;
	}
	else {
		MessageBox(m_hWnd, "LZ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
}

bool CMyWnd::OnSave() {

	char* fn = cmndlg.GetFileName(m_hWnd, "LightCyclef[^t@C(*.lcd)\0*.lcd\0\0", FALSE, "lcd", ".", "LightCyclef[^ۑ");
	if(fn) {
		g_File.SetName(fn);	//t@CpXA̓o^
		g_File.WriteInt("ԗ", "䐔", m_NoLC);
		char str[16];		//ZNVpobt@
		for(int i = 0; i < m_NoLC; i++) {
			wsprintf(str, "ԗNo. %d", i);
		    g_File.WriteInt(str, "ԗF", m_LC[i].m_Color);
		    g_File.WriteInt(str, "", m_LC[i].m_StartDir);
		    g_File.WriteInt(str, "XW", m_LC[i].m_StartX);
		    g_File.WriteInt(str, "YW", m_LC[i].m_StartY);
		    g_File.WriteInt(str, "x", m_LC[i].m_Speed);
		    g_File.WriteInt(str, "]px", m_LC[i].m_Caprice);
		}
		return TRUE;
	}
	else {
		MessageBox(m_hWnd, "LZ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnGo() {

	//Q[I͉ʂNA
	if(!g_On) {
		m_cvs.Clear();
		//Zg̕\
		m_cvs.Color(7);
		m_cvs.Box(CLIGHTCYCLE::m_MinX, CLIGHTCYCLE::m_MinY, CLIGHTCYCLE::m_MaxX, CLIGHTCYCLE::m_MaxY, 0);
	}
 	//ZԂ̃f[^o^Ă Ȃꍇ̏u
	if(!m_NoLC) {
		MessageBox(m_hWnd, "ZԂ̃f[^o^Ă܂\nut@C"\
						"uVKv܂́uf[^JvŐݒ肵ĂB",
						"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
		//^C}[̐ݒi~bݒȂ̂0.001b^C}[ƂȂĂj
		for(int i = 0; i < m_NoLC; i++) {
			if(!g_On)					//Q[JnOȂ
				m_LC[i].GetReady();		//op
			if(!m_tm[i].Begin(m_hWnd, g_Timer[i], g_Velo[m_LC[i].m_Speed])) {
				MessageBox(m_hWnd, "^C}[ݒł܂ł", "G[",
					MB_OK | MB_ICONERROR);
				return FALSE;
			}
		}
		//Q[Jńusvj[ACeƃ{^𓀌B
		g_On = TRUE;
		//ut@Cvj[sɂ
		EnableMenuItem(GetMenu(m_hWnd), 0, MF_BYPOSITION | MF_GRAYED);
		//uQ[vj[̃ACȅԂύX
		ChangeMenuStatus(FALSE, TRUE);
		//Xe[^Xo[ɂ錋ʕ\̈
		SBar.SetText(2, "");
    	return TRUE;
	}
}

bool CMyWnd::OnStop() {

	int ret = MessageBox(m_hWnd, "Sɒ~܂iNo|ꎞ~j", "mF",
						MB_YESNOCANCEL | MB_ICONQUESTION);
	switch(ret) {
	case IDYES:
		//SԎSA^C}[p
		for(int i = 0; i < m_NoLC; i++)
			m_LC[i].Dead();
		g_On = FALSE;
	case IDNO:
		//^C}[p
		for(int i = 0; i < m_NoLC; i++) {
			m_tm[i].Stop();
		}
		//ut@Cvj[ɂ
		EnableMenuItem(GetMenu(m_hWnd), 0, MF_BYPOSITION | MF_ENABLED);
		//uQ[vj[̃ACȅԂύX
		ChangeMenuStatus(TRUE, FALSE);
		return TRUE;
	case IDCANCEL:
		return FALSE;
	}
}

bool CMyWnd::OnVersion() {

	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

//////////////////
//[U[`֐
//////////////////
///////////////////////////////////////////
//uQ[vj[Ac[o[Ԃ̕ύX
///////////////////////////////////////////
void CMyWnd::ChangeMenuStatus(bool Flag1, bool Flag2) {

	//j[nh̎擾
	HMENU hMenu = GetMenu(m_hWnd);
	//j[ACesɂ
	HMENU hGameMenu = GetSubMenu(hMenu, 1);
	EnableMenuItem(hGameMenu, IDM_GO, MF_BYCOMMAND | (Flag1 ? MF_ENABLED : MF_GRAYED));
	EnableMenuItem(hGameMenu, IDM_STOP, MF_BYCOMMAND | (Flag2 ? MF_ENABLED : MF_GRAYED));
	DrawMenuBar(LightCycle.GetHandle());	//Re-draw "&Game" menu

	//c[o[(MAKELONG}N16bit2unsigned 32bitɂ)
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_GO, MAKELONG(Flag1, 0));
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_STOP, MAKELONG(Flag2, 0));
}

///////////////////////////////
//[U[_CAO̊֐`
//Input_CAO
///////////////////////////////
bool INPUTDLG::OnInit(WPARAM, LPARAM) {

	char str[16];	//R{{bNXo^pϐ
	//ZԔԍ
	for(int i = 0; i < LightCycle.m_NoLC; i++) {
		wsprintf(str, "%d", i + 1);
		SendItemMsg(IDC_COMBOBOX0, CB_ADDSTRING, 0, (LPARAM)str);
	}
	//ZԐF
	for(int i = 0; i < 8; i++) {
		SendItemMsg(IDC_COMBOBOX1, CB_ADDSTRING, 0, (LPARAM)g_Col[i]);
	}
	//is
	for(int i = 0; i < 8; i++) {
		SendItemMsg(IDC_COMBOBOX2, CB_ADDSTRING, 0, (LPARAM)g_Dir[i]);
	}
	//x
	for(int i = 0; i < 3; i++) {
		SendItemMsg(IDC_COMBOBOX3, CB_ADDSTRING, 0, (LPARAM)g_Speed[i]);
    }
	//]px
	for(int i = 0; i < 4; i++) {
		SendItemMsg(IDC_COMBOBOX4, CB_ADDSTRING, 0, (LPARAM)g_Caprice[i]);
	}
	//o^ԗ0 - 3͎̖LC[i]A4̏ꍇ擪w
	if(LightCycle.m_NoLC < 4)
		SendItemMsg(IDC_COMBOBOX0, CB_SETCURSEL, LightCycle.m_NoLC, 0);
	else {
		SendItemMsg(IDC_COMBOBOX0, CB_SETCURSEL, 0, 0);
		SetData(0);
	}

	//ΏۃRg[̃nh擾
	HWND hCtrl = GetDlgItem(m_hWnd, IDC_IMAGE);
	//񃊃\[X̂eEBhEi_CAOj̃CX^X
	m_hInstance;
	//c[`bv̍쐬
	m_hTip = CreateWindowEx(NULL, TOOLTIPS_CLASS, NULL,
				WS_POPUP | TTS_ALWAYSTIP | TTS_BALLOON,
				CW_USEDEFAULT, CW_USEDEFAULT,
				CW_USEDEFAULT, CW_USEDEFAULT,
				m_hWnd, NULL, 
				m_hInstance, NULL);
	//IDC_IMAGEɃc[qgRg[t
	TOOLINFO toolInfo = { 0 };	//[NA[
	toolInfo.cbSize = sizeof(toolInfo);
	toolInfo.hwnd = m_hWnd;
	toolInfo.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
	toolInfo.uId = (UINT_PTR)GetDlgItem(m_hWnd, IDC_IMAGE);
	toolInfo.hinst = m_hInstance;
	toolInfo.lpszText = "ҏWԂłAo^4䖢ȂNbNƁuǉvɂȂ܂";
	SendMessage(m_hTip, TTM_ADDTOOL, 0, (LPARAM)&toolInfo);
	SetWindowPos(m_hTip, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
	return TRUE;
}

bool INPUTDLG::OnSelChange(WPARAM wParam) {

	//R{{bNX̑IύXȊO͉Ȃ
	if(HIWORD(wParam) != CBN_SELCHANGE)
		return FALSE;
	//VIACeCfbNX擾
	int i = SendItemMsg(IDC_COMBOBOX0, CB_GETCURSEL, 0, 0);
	SetData(i);
	return TRUE;
}

bool INPUTDLG::OnImage() {

	if(LightCycle.m_NoLC < 4) {
		SendMsg(WM_SETTEXT, 0, (LPARAM)"LightCyclef[^̒ǉ");
		SendItemMsg(IDC_COMBOBOX0, CB_SETCURSEL, (WPARAM)-1, 0);
		SendItemMsg(IDC_COMBOBOX1, CB_SETCURSEL, (WPARAM)-1, 0);
		SendItemMsg(IDC_COMBOBOX2, CB_SETCURSEL, (WPARAM)-1, 0);
		SendItemMsg(IDC_COMBOBOX3, CB_SETCURSEL, (WPARAM)-1, 0);
		SendItemMsg(IDC_COMBOBOX4, CB_SETCURSEL, (WPARAM)-1, 0);
		SendItemMsg(IDC_EDIT2, WM_SETTEXT, 0, (LPARAM)"");
		SendItemMsg(IDC_EDIT3, WM_SETTEXT, 0, (LPARAM)"");
	}
}

bool INPUTDLG::OnOk() {

	//IԗԍCfbNX(0-3)擾
	int i = SendItemMsg(IDC_COMBOBOX0, CB_GETCURSEL, 0, 0);
	if(i == CB_ERR)	//IΒǉo^
		i = LightCycle.m_NoLC;
	//ԗF(0-7)̎擾
	int j = SendItemMsg(IDC_COMBOBOX1, CB_GETCURSEL, 0, 0);
	if(j == CB_ERR) {
		MessageBox(m_hWnd, "FIĂ܂B", "G[", MB_OK | MB_ICONERROR);
		return FALSE;	//_CAOJ܂܏𖳌Ƃ
	}
	LightCycle.m_LC[i].m_Color = j + 8;	//CANVASNX̐FR[h(8-15)
	//ԗ̕(0-7)
	j = SendItemMsg(IDC_COMBOBOX2, CB_GETCURSEL, 0, 0);
	if(j == CB_ERR) {
		MessageBox(m_hWnd, "IĂ܂B", "G[", MB_OK | MB_ICONERROR);
		return FALSE;	//_CAOJ܂܏𖳌Ƃ
	}
	LightCycle.m_LC[i].m_StartDir = j;
	//ԗXW
	char str[16];		//GfBbg{bNXpϐ
	SendItemMsg(IDC_EDIT2, WM_GETTEXT, 16, (LPARAM)str);
	j = atoi(str);		//G[ǂ邩H
	if(j <= 0 || j > CLIGHTCYCLE::m_MaxX) {
		MessageBox(m_hWnd, "X̒lsłB", "G[", MB_OK | MB_ICONERROR);
		return FALSE;	//_CAOJ܂܏𖳌Ƃ
	}
	LightCycle.m_LC[i].m_StartX = j;
	//ԗYW
	SendItemMsg(IDC_EDIT3, WM_GETTEXT, 16, (LPARAM)str);
	j = atoi(str);		//G[ǂ邩H
	if(j <= 0 || j > CLIGHTCYCLE::m_MaxY) {
		MessageBox(m_hWnd, "X̒lsłB", "G[", MB_OK | MB_ICONERROR);
		return FALSE;	//_CAOJ܂܏𖳌Ƃ
	}
	LightCycle.m_LC[i].m_StartY = j;
	//ԗ̑x(0-2j
	j = SendItemMsg(IDC_COMBOBOX3, CB_GETCURSEL, 0, 0);
	if(j == CB_ERR) {
		MessageBox(m_hWnd, "xIĂ܂B", "G[", MB_OK | MB_ICONERROR);
		return FALSE;	//_CAOJ܂܏𖳌Ƃ
	}
	LightCycle.m_LC[i].m_Speed = j;
	//ԗ̓]px(0-3j
	j = SendItemMsg(IDC_COMBOBOX4, CB_GETCURSEL, 0, 0);
	if(j == CB_ERR) {
		MessageBox(m_hWnd, "]pxIĂ܂B", "G[", MB_OK | MB_ICONERROR);
		return FALSE;	//_CAOJ܂܏𖳌Ƃ
	}
	LightCycle.m_LC[i].m_Caprice = j;
	//s\Ԃɂ
	LightCycle.m_LC[i].GetReady();
	//ǉo^̏ꍇAԗ䐔𑝂₷
	if(i == LightCycle.m_NoLC)
		LightCycle.m_NoLC++;
	EndModal(TRUE);
	return TRUE;
}

bool INPUTDLG::OnCancel() {

	EndModal(FALSE);
	return TRUE;
}

void INPUTDLG::SetData(int i) {

	char str[16];	//GfBbg{bNXpϐ
	//f[^Iꂽ̂ŕҏWł邱Ƃ
	SendMsg(WM_SETTEXT, 0, (LPARAM)"LightCyclef[^̕ҏW");
	//CANVASNX̐FR[h8-15gpĂ
	SendItemMsg(IDC_COMBOBOX1, CB_SETCURSEL, (LightCycle.m_LC[i].m_Color - 8), 0);
	SendItemMsg(IDC_COMBOBOX2, CB_SETCURSEL, LightCycle.m_LC[i].m_StartDir, 0);
	wsprintf(str, "%d", LightCycle.m_LC[i].m_StartX);
	SendItemMsg(IDC_EDIT2, WM_SETTEXT, 0, (LPARAM)str);
	wsprintf(str, "%d", LightCycle.m_LC[i].m_StartY);
	SendItemMsg(IDC_EDIT3, WM_SETTEXT, 0, (LPARAM)str);
	SendItemMsg(IDC_COMBOBOX3, CB_SETCURSEL, (WPARAM)LightCycle.m_LC[i].m_Speed, 0);
	SendItemMsg(IDC_COMBOBOX4, CB_SETCURSEL, LightCycle.m_LC[i].m_Caprice, 0);
}

///////////////////////////////
//[U[_CAO̊֐`
//Version_CAO
///////////////////////////////
bool VERSIONDLG::OnOk() {

	EndModal(TRUE);
	return TRUE;
}

bool VERSIONDLG::OnCancel() {

	EndModal(FALSE);
	return TRUE;
}
