////////////////////////////////
// Class of CBOARD
// for use of MENACE
// Copyright (c) by Ysama, 2021
////////////////////////////////

//萔`i(1)A(2)A(0)j
#define		FIRST	1
#define		SECOND	2	//-1́A]1 x -1 x 1 = -1-1 x 1 x -1 = 1ƂȂ̂Ŏ~߂
#define		VACANT	0

////////////////////////////////////
//BOARD Structure for use of CBOARD
////////////////////////////////////
typedef struct _board {

	char m_Pos[9];
	//	-------		Ֆʂm_Pos[0]-[8]charzg
	//	|0|1|2|		ꂪMENACẼr[Yɑ
	//	-------
	//	|3|4|5|
	//	-------
	//	|6|7|8|
	//	-------
	int m_Outcome;	//DBo^p]f[^i菟(1, -1)A菟(2, -2)j
} BOARD, *PBOARD;

////////////////////////
//CMBOARDNXwb_[
//iՖʃf[^̃NXj
////////////////////////
class CBOARD {

protected:										//CBOARDƏpCMENACE͗pł
	//ϐ
	BOARD m_Board;								//p
	int m_LastMove;								//ŏIi0 - 8j
public:
	//֐
	CBOARD();									//RXgN^[î݁j
	void Init();								//iăQ[ɕKvj
	BOARD GetBoard() {return m_Board;}			//Ֆʃf[^im_Boardj̃f[^n
	bool MakeMove(int, char);					//ł
	int* CheckBoard();							//Ֆʂ𒲂ׂi߂l͋󂫈ʒu̔zƂ̐j
	bool RandomMove(char);						//Ŏł
	void RecMove(int m) {m_LastMove = m;}		//L^
	int IsOver();								//-0Ac΂߂3-1|2A-3
	int GetLastMove() {return m_LastMove;}		//ŏI擾
	int WhoWon() {return m_Board.m_Outcome;}	//ҁi1, 2jsҁi-1, -2jmFp
//	virtual void ShowBoard();					//Ֆʕ\̉z֐
};

//RXgN^[î݁j
CBOARD::CBOARD() {

	srand(time(NULL));				//̏
	Init();
}

//iăQ[ɕKvj
void CBOARD::Init() {

	for(int i = 0; i < 9; i++)
		m_Board.m_Pos[i] = 0;		//m_Board.m_Posz0
	m_Board.m_Outcome = 0;			//m_Outcomȅ
	m_LastMove = 0;					//m_LastMovȅ
}

//ł
bool CBOARD::MakeMove(int i, char hand) {

	if(m_Board.m_Pos[i] != VACANT)
		return false;
	else {
		m_Board.m_Pos[i] = hand;	//ł
		RecMove(i);					//ŎL^
		return true;
	}
}

//Ֆʂ𒲂ׂi߂l͋󂫈ʒu̔zƂ̐j
int* CBOARD::CheckBoard() {

	static int pos[10];
	pos[9] = 0;						//pos[9]Ɏc󂫈ʒu
	for(int j = 0; j < 9; j++) {
		if(m_Board.m_Pos[j] == VACANT) {
			pos[pos[9]] = j;
			pos[9]++;
		}
	}
	if(!pos[9])
		return NULL;				//łĂꏊ(posu9v== 0j
	else
		return pos;					//łĂꏊ̔z
}

//ŎłiłĂȂꍇAstOāAfalseԂj
bool CBOARD::RandomMove(char hand) {

	int* cp  = CheckBoard();
	if(!cp[9])						//cp[0] - cp[8]󂫈ʒu̓YAcp[9]c󂫈ʒu
		return false;
	else {
		int i = cp[rand() % cp[9]];
		MakeMove(i, hand);
		RecMove(i);					//ŎL^
		return true;
	}
}

int CBOARD::IsOver() {

	int res;			//̐isԂ\߂l
	if(!CheckBoard())	//c󂫈ʒuiSĖ܂ďs͏j
		res = 3;		//Ԃl
	else
		res = 0;		//󂫈ʒuΖԂl
	int chk;			//c΂3̎̐ρiȂ1AȂ8ɂȂj
	if((chk = m_Board.m_Pos[0] * m_Board.m_Pos[1] * m_Board.m_Pos[2]) == 1)	//1s
		res = FIRST;	//菟
	if(chk == 8)
		res = SECOND;	//菟
	if((chk = m_Board.m_Pos[3] * m_Board.m_Pos[4] * m_Board.m_Pos[5]) == 1)	//2s
		res = FIRST;	//菟
	if(chk == 8)
		res = SECOND;	//菟
	if((chk = m_Board.m_Pos[6] * m_Board.m_Pos[7] * m_Board.m_Pos[8]) == 1)	//3s
		res = FIRST;	//菟
	if(chk == 8)
		res = SECOND;	//菟
	if((chk = m_Board.m_Pos[0] * m_Board.m_Pos[3] * m_Board.m_Pos[6]) == 1)	//c1
		res = FIRST;	//菟
	if(chk == 8)
		res = SECOND;	//菟
	if((chk = m_Board.m_Pos[1] * m_Board.m_Pos[4] * m_Board.m_Pos[7]) == 1)	//c2
		res = FIRST;	//菟
	if(chk == 8)
		res = SECOND;	//菟
	if((chk = m_Board.m_Pos[2] * m_Board.m_Pos[5] * m_Board.m_Pos[8]) == 1)	//c3
		res = FIRST;	//菟
	if(chk == 8)
		res = SECOND;	//菟
	if((chk = m_Board.m_Pos[0] * m_Board.m_Pos[4] * m_Board.m_Pos[8]) == 1)	//΂ߑ1
		res = FIRST;	//菟
	if(chk == 8)
		res = SECOND;	//菟
	if((chk = m_Board.m_Pos[2] * m_Board.m_Pos[4] * m_Board.m_Pos[6]) == 1)	//΂ߑ2
		res = FIRST;	//菟
	if(chk == 8)
		res = SECOND;	//菟
	//AłȂΏ҂L^iDBo^pj
	if(res == FIRST || res == SECOND)
		m_Board.m_Outcome = res;	//҂͐̐
	return res;
}
/*
//Ֆʕ\֐iCUIŁ|z֐ŏpI[o[Ch\j
void CBOARD::ShowBoard() {

	char c;
	cout << "-------" << endl;
	for(int i = 0; i < 9; i++) {
		switch(m_Board.m_Pos[i]) {
		case FIRST:
			c = 'O';
			break;
		case SECOND:
			c = 'X';
			break;
		case VACANT:
			c = ' ';
			break;
		}
		cout << "|" << c;
		if((i % 3) == 2)
			cout << "|" << endl << "-------" << endl;
	}
}
*/
