//////////////////////////////////////////
// MENACEProc.h
// Copyright (c) 12/11/2021 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnInit(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|SetHandle(hWnd))
	TBar.SetHandle(GetDlgItem(m_hWnd, IDC_TOOLBAR));
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TOOLBAR), 8);
	//c[o[{^ǉ
	TBBUTTON tbb[11];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_OPEN;
	tbb[1].iBitmap = TBar.m_id + 1;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_SAVEAS;
	tbb[2].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[3].iBitmap = TBar.m_id + 2;
	tbb[3].fsState = TBSTATE_ENABLED;
	tbb[3].fsStyle = TBSTYLE_BUTTON;
	tbb[3].idCommand = IDM_EXIT;
	tbb[4].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[5].iBitmap = TBar.m_id + 3;
	tbb[5].fsState = TBSTATE_ENABLED;
	tbb[5].fsStyle = TBSTYLE_BUTTON;
	tbb[5].idCommand = IDM_FM;
	tbb[6].iBitmap = TBar.m_id + 4;
	tbb[6].fsState = TBSTATE_ENABLED;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_SM;
	tbb[7].iBitmap = TBar.m_id + 5;
	tbb[7].fsState = TBSTATE_ENABLED;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_AUTO;
	tbb[8].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[9].iBitmap = TBar.m_id + 6;
	tbb[9].fsState = TBSTATE_ENABLED;
	tbb[9].fsStyle = TBSTYLE_BUTTON;
	tbb[9].idCommand = IDM_ABOUT;
	tbb[10].iBitmap = TBar.m_id + 7;
	tbb[10].fsState = TBSTATE_ENABLED;
	tbb[10].fsStyle = TBSTYLE_BUTTON;
	tbb[10].idCommand = IDM_VERSION;
	TBar.AddButtons(11, tbb);

	//Xe[^Xo[o^|SetHandle(hWnd))
	SBar.SetHandle(GetDlgItem(m_hWnd, IDC_STATUSBAR));
	//Xe[^Xo[ݒ
	int sec[2] = {90, -1};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "MENACE Ver 1.0");
	//{^ɒtprbg}bv̓ǂݍ
	g_hNought = (HBITMAP)LoadImage(m_hInstance, MAKEINTRESOURCE(IDI_NOUGHT), IMAGE_BITMAP, 0, 0, LR_DEFAULTSIZE);
	g_hCross = (HBITMAP)LoadImage(m_hInstance, MAKEINTRESOURCE(IDI_CROSS), IMAGE_BITMAP, 0, 0, LR_DEFAULTSIZE);
	g_hVacant = (HBITMAP)LoadImage(m_hInstance, MAKEINTRESOURCE(IDI_VACANT), IMAGE_BITMAP, 0, 0, LR_DEFAULTSIZE);
	//o[ϐ̏
	m_Games = 0;		//A@Bΐ̃Q[
	m_1st = 0;			//̏
	m_2nd = 0;			//̏
	m_Draw = 0;			//
	//f[^t@C̐ݒƓǂݍ
	m_FileName = arg.Path();
	m_FileName = m_FileName + "\\MENACE.dat";
	m_Menace.BoardRead(m_FileName.ToChar());
	//j[Aj[{^LAZ~{^𖳌
	ChangeMenuStatus(TRUE);

	return TRUE;
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	//c[o[̃c[`bv擾
	switch (((LPNMHDR)lParam)->code) {
		case TTN_NEEDTEXT:
			static LPTOOLTIPTEXT lptip;
			lptip = (LPTOOLTIPTEXT)lParam;
			switch (lptip->hdr.idFrom) {
				case IDM_OPEN:
					lptip->lpszText = "f[^J";
					break;
				case IDM_SAVEAS:
					lptip->lpszText = "f[^Rs[ۑ";
					break;
				case IDM_EXIT:
					lptip->lpszText = "I";
					break;
				case IDM_FM:
					lptip->lpszText = "";
					break;
				case IDM_SM:
					lptip->lpszText = "";
					break;
				case IDM_AUTO:
					lptip->lpszText = "΋";
					break;
				case IDM_ABOUT:
					lptip->lpszText = "MENACEɂ";
					break;
				case IDM_VERSION:
					lptip->lpszText = "o[W";
					break;
			}
	}
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
	MB_YESNO | MB_ICONINFORMATION) == IDYES) {
		//f[^ۑ
		m_Menace.BoardWrite(m_FileName.ToChar());
		//rbg}bv̉
		DeleteObject((HGDIOBJ)g_hNought);
		DeleteObject((HGDIOBJ)g_hCross);
		DeleteObject((HGDIOBJ)g_hVacant);
		//DestroyWindowAPostQuitMessageĂ΂
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

//_CAOx[X̏ꍇ͂ꂪKv
bool CMyWnd::OnDestroy(WPARAM wPram, LPARAM lParam) {

	PostQuitMessage(0);
	return TRUE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::On0() {

	if(m_You == FIRST)
		SendItemMsg(IDC_0, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
	else if(m_You == SECOND)
		SendItemMsg(IDC_0, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
	Turn(0);
	return TRUE;
}

bool CMyWnd::On1() {

	if(m_You == FIRST)
		SendItemMsg(IDC_1, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
	else if(m_You == SECOND)
		SendItemMsg(IDC_1, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
	Turn(1);
	return TRUE;
}

bool CMyWnd::On2() {

	if(m_You == FIRST)
		SendItemMsg(IDC_2, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
	else if(m_You == SECOND)
		SendItemMsg(IDC_2, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
	Turn(2);
	return TRUE;
}

bool CMyWnd::On3() {

	if(m_You == FIRST)
		SendItemMsg(IDC_3, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
	else if(m_You == SECOND)
		SendItemMsg(IDC_3, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
	Turn(3);
	return TRUE;
}

bool CMyWnd::On4() {

	if(m_You == FIRST)
		SendItemMsg(IDC_4, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
	else if(m_You == SECOND)
		SendItemMsg(IDC_4, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
	Turn(4);
	return TRUE;
}

bool CMyWnd::On5() {

	if(m_You == FIRST)
		SendItemMsg(IDC_5, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
	else if(m_You == SECOND)
		SendItemMsg(IDC_5, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
	Turn(5);
	return TRUE;
}

bool CMyWnd::On6() {

	if(m_You == FIRST)
		SendItemMsg(IDC_6, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
	else if(m_You == SECOND)
		SendItemMsg(IDC_6, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
	Turn(6);
	return TRUE;
}

bool CMyWnd::On7() {

	if(m_You == FIRST)
		SendItemMsg(IDC_7, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
	else if(m_You == SECOND)
		SendItemMsg(IDC_7, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
	Turn(7);
	return TRUE;
}

bool CMyWnd::On8() {

	if(m_You == FIRST)
		SendItemMsg(IDC_8, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
	else if(m_You == SECOND)
		SendItemMsg(IDC_8, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
	Turn(8);
	return TRUE;
}

bool CMyWnd::OnOpen() {

	char* fn = cmndlg.GetFileName(m_hWnd, "DATt@C(*.dat)\0*.dat\0\0", TRUE, "dat", ".", "MENACEf[^t@CJ");
	if(!fn) {
		MessageBox(m_hWnd, "LZ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else
		m_Menace.BoardRead(fn);
	return TRUE;
}

bool CMyWnd::OnSave() {

	//f[^ۑ
	m_Menace.BoardWrite(m_FileName.ToChar());
	return TRUE;
}

bool CMyWnd::OnSaveas() {

	char* fn = cmndlg.GetFileName(m_hWnd, "DATt@C(*.dat)\0*.dat\0\0", FALSE, "dat", ".", "MENACEf[^t@CiRs[j̕ۑ");
	if(!fn) {
		MessageBox(m_hWnd, "LZ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
		//f[^ۑ
		m_Menace.BoardWrite(fn);
	}
	return TRUE;
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnFm() {

	m_You = FIRST;
	Init();
	ChangeMenuStatus(FALSE);
	return TRUE;
}

bool CMyWnd::OnSm() {

	m_You = SECOND;
	Init();
	ChangeMenuStatus(FALSE);
	Turn(0);
	return TRUE;
}

bool CMyWnd::OnAuto() {

	m_You = 3;
	int n = inputdlg.DoModal(m_hWnd, "IDD_INPUT", inputdlgProc);
	for(int i = 0; i < n; i++) {	//100A500A1000A10000A
		Init();
		ChangeMenuStatus(FALSE);
		while(!Turn(0));			//@BΐɈ͊֌WȂ
	}
	return TRUE;
}

bool CMyWnd::OnAbout() {

	infodlg.DoModal(m_hWnd, "IDD_INFO", infodlgProc);
	return TRUE;
}

bool CMyWnd::OnVersion() {

	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

///////////////////
//[U[`֐
///////////////////
//Q[֐
void CMyWnd::Init() {

	m_Menace.Init();
	m_Result = 0;		//Q[ʁi0A菟1A菟2A3j
	m_Times = 0;		//eΐ̎萔JE^[
	for(int i = 0; i < 9; i++)
		SendItemMsg(IDC_0 + i, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hVacant);

}

//Q[֐
int CMyWnd::Turn(int pos) {

	for(int i = 0; !m_Result && i < 2; i++) {	//ΐ햢ȂA肪Âł
		switch(m_You) {
		case FIRST:		//Player
			if(!(m_Times % 2))		//
				m_Menace.MakeMove(pos, FIRST);
			else {					//
				if(!m_Menace.AutoMove(SECOND)) {	//ł肪Ȃꍇ
					m_Result = m_Menace.WhoWon();	//̏
				}
				else {
					//AutoMove̍ۂ́Z~̕\
					int move = m_Menace.GetLastMove();	//m_Board.m_LastMove̍Ō̎̈ʒu擾
					SendItemMsg(IDC_0 + move, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
				}
			}
			break;
		case SECOND:	//Player
			if(m_Times % 2) {		//
				if(!m_Menace.AutoMove(FIRST)) {		//ł肪Ȃꍇ
					m_Result = m_Menace.WhoWon();	//̏
				}
				else {
					//AutoMove̍ۂ́Z~̕\
					int move = m_Menace.GetLastMove();	//m_Board.m_LastMove̍Ō̎̈ʒu擾
					SendItemMsg(IDC_0 + move, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
				}
			}
			else					//
				m_Menace.MakeMove(pos, SECOND);
			break;
		case 3:			//@Bΐ
			if(!(m_Times % 2)) {	//
				if(!m_Menace.AutoMove(FIRST)) {		//ł肪Ȃꍇ
					m_Result = m_Menace.WhoWon();	//̏
				}
				else {
					int move = m_Menace.GetLastMove();	//m_Board.m_LastMove̍Ō̎̈ʒu擾
					SendItemMsg(IDC_0 + move, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hNought);
				}
			}
			else {					//
				if(!m_Menace.AutoMove(SECOND)) {	//ł肪Ȃꍇ
					m_Result = m_Menace.WhoWon();	//̏
				}
				else {
					int move = m_Menace.GetLastMove();	//m_Board.m_LastMove̍Ō̎̈ʒu擾
					SendItemMsg(IDC_0 + move, BM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hCross);
				}
			}
			break;
		}
		m_Times++;
		//5ځivO̓[x[XȂ̂4ځjȍ~stĂȂȂ
		if(!m_Result && m_Times > 4)
			m_Result = m_Menace.IsOver();
	}
	if(m_Result)
		WhenOver();		//Q[I
	return m_Result;	//Q[ʂԂ
}

void CMyWnd::WhenOver() {
	
	m_Games++;
	switch(m_Result) {	//菟(-1)A菟(2)Ask(-1)Ask(-2)
	case FIRST:
		SBar.SetText(1, "̏");
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)"̏");	//ToolTip
		m_1st++;
		m_Menace.Register();		//IՖʂ̋L^
		m_Menace.PushBack();		//Ȏ̔Ֆʁiskjɖ߂
		m_Menace.Register();		//skՖʂ̋L^
		break;
	case SECOND:
		SBar.SetText(1, "̏");
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)"̏");	//ToolTip
		m_2nd++;
		m_Menace.Register();		//IՖʂ̋L^
		m_Menace.PushBack();		//Ȏ̔Ֆʁiskjɖ߂
		m_Menace.Register();		//skՖʂ̋L^
		break;
	case 3:
		SBar.SetText(1, "");
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)"");	//ToolTip
		m_Draw++;
		break;
	case -1:
		SBar.SetText(1, "̕");
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)"̕");	//ToolTip
		m_2nd++;
		m_Menace.Register();		//IOAՖʂ̋L^
		break;
	case -2:
		SBar.SetText(1, "̕");
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)"̕");	//ToolTip
		m_1st++;
		m_Menace.Register();		//IOAՖʂ̋L^
		break;
	}
	ChangeMenuStatus(TRUE);			//Q[j[ƐAA@Bΐ̃{^L
}

void CMyWnd::ChangeMenuStatus(bool EnableFlag) {

	HMENU hMenu = GetMenu(MENACE.GetHandle());	//j[nh̎擾
	//j[o[
	EnableMenuItem(hMenu, 1, MF_BYPOSITION | (EnableFlag ? MF_ENABLED : MF_GRAYED));
	DrawMenuBar(MENACE.GetHandle());	//Re-draw
	//c[o[(MAKELONG}N16bit2unsigned 32bitɂ)
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_FM, MAKELONG(EnableFlag, 0));
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_SM, MAKELONG(EnableFlag, 0));
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_AUTO, MAKELONG(EnableFlag, 0));
	//Z~{^̗LA
	for(int i = 0; i < 9; i++)
		EnableWindow(GetDlgItem(m_hWnd, IDC_0 + i), (EnableFlag ? FALSE : TRUE));
}

///////////////////////////////
//[U[_CAO̊֐`
//Input_CAO
///////////////////////////////
bool INPUTDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	SendItemMsg(IDC_GAMES, CB_INSERTSTRING, 0, (LPARAM)"100");
	SendItemMsg(IDC_GAMES, CB_INSERTSTRING, 1, (LPARAM)"500");
	SendItemMsg(IDC_GAMES, CB_INSERTSTRING, 2, (LPARAM)"1000");
	return TRUE;
}

bool INPUTDLG::OnOk() {

	int n = SendItemMsg(IDC_GAMES, CB_GETCURSEL, 0, 0);
	if(n == CB_ERR) {
		MessageBox(m_hWnd, "񐔂IĂ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	switch(n) {
	case 0:
		n = 100;
		break;
	case 1:
		n = 500;
		break;
	case 2:
		n = 1000;
		break;
	}
	EndModal(n);
	return TRUE;
}

bool INPUTDLG::OnCancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Info_CAO
///////////////////////////////
bool INFODLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//MENACEɂĂ̏J
	CSTR num(MENACE.m_Menace.DBSize());
	SendItemMsg(IDC_EDIT1, WM_SETTEXT, 0, (LPARAM)num.ToChar());
	num = MENACE.m_Games;
	SendItemMsg(IDC_EDIT2, WM_SETTEXT, 0, (LPARAM)num.ToChar());
	num = MENACE.m_1st;
	SendItemMsg(IDC_EDIT3, WM_SETTEXT, 0, (LPARAM)num.ToChar());
	num = MENACE.m_2nd;
	SendItemMsg(IDC_EDIT4, WM_SETTEXT, 0, (LPARAM)num.ToChar());
	num = MENACE.m_Draw;
	SendItemMsg(IDC_EDIT5, WM_SETTEXT, 0, (LPARAM)num.ToChar());
	return TRUE;
}

bool INFODLG::OnOk() {

	EndModal(TRUE);
	return TRUE;
}

bool INFODLG::OnCancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Version_CAO
///////////////////////////////
bool VERSIONDLG::OnOk() {

	EndModal(TRUE);
	return TRUE;
}

bool VERSIONDLG::OnCancel() {

	EndModal(FALSE);
	return TRUE;
}
