///////////////////////////////////
//C#̃t@CƃtH[_[̑I
///////////////////////////////////

using System;
using System.Drawing;
using System.Windows.Forms;
using System.IO;				//PathNXg

class Select_File_Folder
{
	[STAThread]
	public static void Main()
	{
		MainForm mf = new MainForm();
		Application.Run(mf);
	}
}

public partial class MainForm : Form
{
	public Label label;

	public MainForm()
	{
		Button btn1 = new Button();
		btn1.Location = new Point(10, 10);
		btn1.Text = "File Open Dialog";
		btn1.AutoSize = true;
		btn1.Click += new EventHandler(Button1_Click);
		Button btn2 = new Button();
		btn2.Location = new Point(10, 20 + btn1.Height);
		btn2.Text = "Folder Brouser Dialog";
		btn2.AutoSize = true;
		btn2.Click += new EventHandler(Button2_Click);
		Button btn3 = new Button();
		btn3.Location = new Point(this.ClientSize.Width - btn3.Width - 10, this.ClientSize.Height - btn3.Height - 10);
		btn3.Text = "Exit";
		btn3.AutoSize = true;
		btn3.Anchor = (AnchorStyles.Bottom | AnchorStyles.Right);
		btn3.Click += new EventHandler(Button3_Click);
		label = new Label();
		label.Location = new Point(10, 30 + btn1.Height + btn2.Height);
//		label.AutoSize = true;
		label.AutoSize = false;
		Size sz = new Size(this.ClientSize.Width - 20, this.ClientSize.Height - (40 + btn1.Height + btn2.Height));
		label.Size = sz;
		this.Controls.Add(btn1);
		this.Controls.Add(btn2);
		this.Controls.Add(btn3);
		this.Controls.Add(label);
	}

	private void Button1_Click(object sender, EventArgs e)
	{
		OpenFileDialog ofDlg = new OpenFileDialog();
		//t@C̎w
		ofDlg.FileName = "*.*";
		//t@CtB^[̎w
		ofDlg.Filter = "C#t@C(*.cs)|*.cs|ׂẴt@C(*.*)|*.*";
		//t@CtB^[CfbNX̎w
		ofDlg.FilterIndex = 2;
		//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
		ofDlg.RestoreDirectory = true;
		//݂Ȃt@C̖Ow肳ꂽƂx\
		ofDlg.CheckFileExists = true;
		//݂ȂpXw肳ꂽƂx\
		ofDlg.CheckPathExists = true;
		// ftHg̃tH_w肷
		ofDlg.InitialDirectory = @"C:\users\ysama\";
		//_CAÕ^Cgw肷
		ofDlg.Title = "t@CJ";
		//_CAO\
		if(ofDlg.ShowDialog() == DialogResult.OK)
		{
			label.Text = ofDlg.FileName + " I܂B";
			string oldPath = ofDlg.FileName;
			//gqύX
			string newPath = Path.ChangeExtension(oldPath, ".bak");
			MessageBox.Show(String.Format("Iꂽ{0}̃obNAbvt@CA{1}܂", oldPath, newPath), "obNAbv̍쐬", MessageBoxButtons.OK, MessageBoxIcon.Information);
			//obNAbvt@C쐬
			File.Copy(oldPath, newPath);
 		}
		else
		{
			label.Text = "LZ܂B";
		}
		// IuWFNgj
		ofDlg.Dispose();
	}

	private void Button2_Click(object sender, EventArgs e)
	{
		FolderBrowserDialog fbDlg = new FolderBrowserDialog();
		// _CAO̐
		fbDlg.Description = "tH_IĂB";
		// ftHg̃tH_
		fbDlg.SelectedPath = @"C:\";
		// uVtH_[̍쐬v{^\iftHgtruej
		fbDlg.ShowNewFolderButton = true;
		//tH_I_CAO\
		if(fbDlg.ShowDialog() == DialogResult.OK)
		{
			label.Text = fbDlg.SelectedPath + "I܂B";
		}
		else
		{
			label.Text = "LZ܂B";
		}
		// IuWFNgj
		fbDlg.Dispose();
	}

	private void Button3_Click(object sender, EventArgs e)
	{
		Close();
	}
}
