////////////////////
//C# PictureBox.cs
////////////////////
using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Reflection;				//Assemblyg
using Atelier;							//Atelier.dllg

namespace WindowsFormsApp
{
	public partial class AppForm : Form
	{
		Panel panel;						//sN`[i{bNXj̘gƂȂPanel
		PictureBox picBox;					//sN`[{bNXRg[
		Button btn1, btn2, btn3, extbtn;	//{^Rg[
		Easel easel;						//`sEaselIuWFNg

		[STAThread]
		public static void Main()
		{
			AppForm ap = new AppForm();
			Application.Run(ap);
		}

		public AppForm()
		{
			Assembly myOwn = Assembly.GetEntryAssembly();
			this.Icon = Icon.ExtractAssociatedIcon(myOwn.Location);	//vOACRtH[ɂ
			this.Size = new Size(640, 540);
			this.MinimumSize = new Size(320, 190);
			this.Text = "PictureBox";
			this.Load += AppForm_Load;
		}

		private void AppForm_Load(object sender, EventArgs e)
		{
			//{^1
			btn1 = new Button();
			btn1.Location = new Point(ClientSize.Width - btn1.Width - 10, 10);
			btn1.Text = "t͗l";
			btn1.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			btn1.Click += Button1_Click;
			this.Controls.Add(btn1);

			//{^2{^
			btn2 = new Button();
			btn2.Location = new Point(ClientSize.Width - btn2.Width - 10, btn1.Height + 20);
			btn2.Text = "lȋȐ";
			btn2.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			btn2.Click += Button2_Click;
			this.Controls.Add(btn2);

			//{^3{^
			btn3 = new Button();
			btn3.Location = new Point(ClientSize.Width - btn3.Width - 10, btn1.Height + btn2.Height + 30);
			btn3.Text = "xWGȐ";
			btn3.Anchor = (AnchorStyles.Top | AnchorStyles.Right);
			btn3.Click += Button3_Click;
			this.Controls.Add(btn3);

			//I{^
			extbtn = new Button();
			extbtn.Location = new Point(ClientSize.Width - extbtn.Width - 10, ClientSize.Height - extbtn.Height - 20);
			extbtn.Text = "I";
			extbtn.Anchor = (AnchorStyles.Bottom | AnchorStyles.Right);
			extbtn.Click += Button4_Click;
			this.Controls.Add(extbtn);

			//`ƂEaselIuWFNg쐬iGraphicsAPenABrushIuWFNg쐬j
			easel = new Easel();
			//sN`[{bNXRg[ in pl
			panel = new Panel();		//t[ƂȂPanelIuWFNg̍쐬
			panel.BorderStyle = BorderStyle.Fixed3D;
			panel.Location = new Point(10, 10);
			panel.Width = ClientSize.Width - btn1.Width - 30;
			panel.Height = ClientSize.Height - 20;
			panel.AutoScroll = true;	//XN[o[t
			panel.Anchor = (AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Bottom | AnchorStyles.Right);
			picBox = new PictureBox();	//g̒PictureIuWFNg̍쐬
			picBox.Location = new Point(0, 0);				//g̈ʒu
			picBox.SizeMode = PictureBoxSizeMode.AutoSize;	//摜TCYPictureBox̑傫ύX
			picBox.Image = easel.Canvas;					//easelCanvas\
			picBox.Click += Panel_Click;
			panel.Controls.Add(picBox);						//picBoxpanel̎qɂ
			//FormTPictureBoxPanelǉ
			this.Controls.Add(panel);

			MessageBox.Show("ʂɂ̓}EXŃNbNĂB", "ʏ");
		}

		//I
		protected override void OnFormClosing(FormClosingEventArgs e)
		{
			base.OnFormClosing(e);
			DialogResult dr = MessageBox.Show("I܂H", "mF", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
			if(dr == DialogResult.No)
			{
				e.Cancel = true;
			}
			else
				//PictureBox̃}l[Wh \[XƃA}l[Wh \[X
				picBox.Dispose();
		}

		private void Button1_Click(object sender, EventArgs e)
		{
			//{^1
			//_ȐF쐬
			Random r = new Random((int)DateTime.Now.Ticks & 0x0000FFFF);	//قȂV[hŗ𔭐
			double X = 0, Y = 0, Xp, Yp, xx, yy;
			int n, i;
			for(i = 1; i <= 100000; i++)
			{
				n = r.Next(0, 100);
				if(n < 1)
				{
					Xp = 0;
					Yp = 0.16 * Y;
				}
				else if(n >= 1 && n <= 8)
				{
					Xp = 0.2 * X - 0.26 * Y;
					Yp = 0.23 * X + 0.22 * Y + 1.6;
				}
				else if(n >= 8 && n <= 15)
				{
					Xp = -0.15 * X + 0.28 * Y;
					Yp = 0.26 * X + 0.24 * Y + 0.44;
				}
				else
				{
					Xp = 0.85 * X + 0.04 * Y;
					Yp = -0.04 * X + 0.85 * Y + 1.6;
				}
				X = Xp;
				Y = Yp;
				xx = X * 45;
				yy = Y * 45 -225;
				easel.gFtColor = Color.FromArgb(r.Next(0, 256), r.Next(0, 256), r.Next(0, 256));
				easel.Dot((int)(xx + 240), (int)(-yy + 240));
			}
			//PictureBoxɕ\
			picBox.Image = easel.Canvas;
		}

		private void Button2_Click(object sender, EventArgs e)
		{
			//{^2 - Phase 1
			//_4_쐬
			Random r = new Random((int)DateTime.Now.Ticks & 0x0000FFFF);	//قȂV[hŗ𔭐
			Point[] pts = {	new Point(0 + r.Next(0, picBox.ClientSize.Width / 4), 0 + r.Next(0, picBox.ClientSize.Height / 4)),
							new Point(100 + r.Next(0, picBox.ClientSize.Width / 4), 200 + r.Next(0, picBox.ClientSize.Height / 4)),
							new Point(200 + r.Next(0, picBox.ClientSize.Width / 4), 50 + r.Next(0, picBox.ClientSize.Height / 4)),
							new Point(300 + r.Next(0, picBox.ClientSize.Width / 4), 100 + r.Next(0, picBox.ClientSize.Height / 4)),
			};
			//y̍쐬
			Pen pen = new Pen(Color.Black, 1);
			//easel.gHandlegGDI+ɂȐ`
			easel.gHandle.DrawCurve(pen, pts, 0F);
			pen.Color = Color.Blue;
			easel.gHandle.DrawCurve(pen, pts, 0.5F);
			pen.Color = Color.Green;
			easel.gHandle.DrawCurve(pen, pts, 1F);
			pen.Color = Color.Red;
			easel.gHandle.DrawCurve(pen, pts, 2F);
			//ỷ
			pen.Dispose();
			//PictureBoxɕ\
			picBox.Image = easel.Canvas;
			//{^2 - Phase 2
			//Ȑʉ߂郉_5_̔z쐬iŒł3ȏKvj
			Point[] curvePoints = new Point[5];
			for(int i = 0; i < 5; i++)
			{
				curvePoints[i] = new Point(r.Next(0, panel.ClientSize.Width), r.Next(0, panel.ClientSize.Height));
			}
			//Ȑʉ߂_̔z쐬BŒł3ȏ̓_KvB
			//Point point1 = new Point(30, 20);
			//Point point2 = new Point(60, 150);
			//Point point3 = new Point(120, 30);
			//Point point4 = new Point(200, 140);
			//Point point5 = new Point(220, 100);
			//Point point6 = new Point(190, 60);
			//Point[] curvePoints = { point1, point2, point3, point4, point5, point6 };
			//3̐FPenIuWFNg쐬
			Pen bluePen = new Pen(Color.Blue, 3);
			//eV0.5ilj̃J[fBiXvC`
			easel.gHandle.DrawCurve(bluePen, curvePoints, 0.5F);
			//3̐ԐFPenIuWFNg쐬
			Pen redPen = new Pen(Color.Red, 3);
			//eV1̃J[fBiXvC`
			easel.gHandle.DrawCurve(redPen, curvePoints, 1);
			//3̗ΐFPenIuWFNg쐬
			Pen greenPen = new Pen(Color.Green, 3);
			//eV0̃J[fBiXvCiƂȂj`
			easel.gHandle.DrawCurve(greenPen, curvePoints, 0);
			//1̉FPenIuWFNg쐬
			Pen yellowPen = new Pen(Color.Yellow, 1);
			//2Ԗڂ̓_5Ԗڂ̓_܂łʉ߂J[fBiXvC`
			easel.gHandle.DrawCurve(yellowPen, curvePoints, 1, 3, 0.5F);
			//1̍FPenIuWFNg쐬
			Pen blackPen = new Pen(Color.Black, 1);
			//eV1̕J[fBiXvC`
			easel.gHandle.DrawClosedCurve(blackPen, curvePoints, 1, FillMode.Alternate);
			//\[X
			bluePen.Dispose();
			redPen.Dispose();
			greenPen.Dispose();
			yellowPen.Dispose();
			blackPen.Dispose();
			//PictureBoxɕ\
			picBox.Image = easel.Canvas;
		}

		private void Button3_Click(object sender, EventArgs e)
		{
			//{^3
			//Ȑʉ߂郉_5_̔z쐬iŒł3ȏKvj
			Random r = new Random((int)DateTime.Now.Ticks & 0x0000FFFF);	//قȂV[hŗ𔭐
			Point[] bezierPoints = new Point[7];
			for(int i = 0; i < 7; i++)
			{
				bezierPoints[i] = new Point(r.Next(0, panel.ClientSize.Width), r.Next(0, panel.ClientSize.Height));
			}
			//xWGȐ̌`肷_
			//Point start = new Point(10, 70);
			//Point control1 = new Point(50, 10);
			//Point control2 = new Point(80, 30);
			//Point end1 = new Point(130, 60);
			//Point control3 = new Point(190, 70);
			//Point control4 = new Point(200, 120);
			//Point end2 = new Point(170, 160);
			//Point[] bezierPoints = { start, control1, control2, end1, control3, control4, end2 };
			//1̍FPenIuWFNg쐬
			Pen blackPen = new Pen(Color.Black, 1);
			//
			blackPen.EndCap = LineCap.ArrowAnchor;
			//xWGȐɐڂ钼`
			easel.gHandle.DrawLine(blackPen, bezierPoints[0], bezierPoints[1]);
			easel.gHandle.DrawLine(blackPen, bezierPoints[2], bezierPoints[3]);
			easel.gHandle.DrawLine(blackPen, bezierPoints[3], bezierPoints[4]);
			easel.gHandle.DrawLine(blackPen, bezierPoints[5], bezierPoints[6]);
			//1̐FPenIuWFNg쐬
			Pen bluePen = new Pen(Color.Blue, 1);
			//xWGXvC`悷
			easel.gHandle.DrawBeziers(bluePen, bezierPoints);
			//\[X
			blackPen.Dispose();
			bluePen.Dispose();
			//PictureBoxɕ\
			picBox.Image = easel.Canvas;
		}

		private void Button4_Click(object sender, EventArgs e)
		{
			//I
			Close();
		}

		private void Panel_Click(object sender, EventArgs e)
		{
			MouseEventArgs mouseArgs = e as MouseEventArgs;
			Point p = panel.PointToClient(Cursor.Position);
			string str = String.Format("MouseClick at (x = {0}, y = {1})", p.X.ToString(), p.Y.ToString());
			string title = "";
			if(mouseArgs.Button == MouseButtons.Left)
				title = "Mouse Left Click Position in Client Area";
			else if(mouseArgs.Button == MouseButtons.Right)
				title = "Mouse Right Click Position in Client Area";
			else
				title = "Mouse Click Position in Client Area";
			MessageBox.Show(str, title);
			easel.Clear();
			//PictureBoxɕ\
			picBox.Image = easel.Canvas;
		}
	}
}
