/////////////////////////////////////////////
// GameWindow_Sample03.cpp
// Copyrignt (c) 2024 byYsama
/////////////////////////////////////////////
using System;
using OpenTK;						//OpenTKgpۂɕK{
using OpenTK.Graphics;				//OpenTK̃OtBbNgpۂɕK{
using OpenTK.Graphics.OpenGL;		//OpenGLgpۂɕKv
using OpenTK.Input;					//OpenTKœ͂sۂɕKviFKeyboiardj
using OpenTK_Primitives;			//OpenTK}`Cu[

namespace GameWindow_Sample03
{
	//AvP[VNX
	public class App
	{
		[STAThread]
		public static void Main()
		{
			gWindow gw = new gWindow();
			gw.Run();
		}
	}

	class gWindow : GameWindow	//GameWindowNX烆[U[EBhEh
	{
		OTKPrims pv = new OTKPrims();					//otkPrimitivesNXCX^X
		float RotateX = 0, RotateY = 0, RotateZ = 0;	//pCv̉]p
		bool SorW = true;								//SolidAWirẽtO
		bool drawStop = false;							//`~

		public gWindow() : base(640, 480, GraphicsMode.Default, "OpenTK GameWindow")	//
		{
			//Mouse
			this.MouseDown += gW_MouseDown;
			this.MouseMove += gW_MouseMove;
			//Key
			this.KeyUp += gW_KeyUp;
			this.KeyDown += gW_KeyDown;
			this.KeyPress += gW_KeyPress;
		}

		//EBhE̋NɎs
		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);								//菈
			GL.ClearColor(Color4.Black);				//ʏF̐ݒ
			GL.Enable(EnableCap.DepthTest);				//[x`FbNL
			//̎gp
			GL.Enable(EnableCap.Lighting);
			//Cg0̐ݒ
			GL.Enable(EnableCap.Light0);
			float[] pos = new float[] {50.0f, 50.0f, 10.0f, 0.0f };
			GL.Light(LightName.Light0, LightParameter.Position, pos);
		}

		//EBhẼTCYύXꂽꍇɎs
		protected override void OnResize(EventArgs e)
		{
			base.OnResize(e);							//菈
			//r[|[g̐ݒ
			GL.Viewport(ClientRectangle.X, ClientRectangle.Y, ClientRectangle.Width, ClientRectangle.Height);
			//̐ς̐ݒ
			GL.MatrixMode(MatrixMode.Projection);
			Matrix4 projection = Matrix4.CreatePerspectiveFieldOfView((float)Math.PI / 4, (float)Width / (float)Height, 1.0f, 64.0f);	//glPerspective(fov, aspect, near, far);
			GL.LoadMatrix(ref projection);
		}

		//EBhECxgXVꂽꍇɎsiOnRenderFramȇOɎsj
		protected override void OnUpdateFrame(FrameEventArgs e)
		{
			base.OnUpdateFrame(e);
			//ESCL[ꂽI
			if(Keyboard.GetState().IsKeyDown(Key.Escape))
			{
				Exit();
			}
		}

		//EBhE`悪XVꂽꍇɎs
		protected override void OnRenderFrame(FrameEventArgs e)
		{
			base.OnRenderFrame(e);						//菈
			if(drawStop)
				return;									//`~
			GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);
			GL.MatrixMode(MatrixMode.Modelview);		//fr[[hI
			//_ݒ肵Č_(0, 0, 0)
			Vector3 eye = new Vector3(0.0f, 0.0f, 5.0f);
			Matrix4 modelview = Matrix4.LookAt(eye, Vector3.Zero, Vector3.UnitY);	//gluLookAt(0, 0, 5, 0, 0, 0, 0, 1, 0);
			GL.LoadMatrix(ref modelview);				//݂̕ϊ}gbNXɐݒ
			//ȉɕ`揈s
			GL.PushMatrix();
			{
				GL.Rotate(RotateX, 1, 0, 0);
				GL.Rotate(RotateY, 0, 1, 0);
				GL.Rotate(RotateZ, 0, 0, 1);
				GL.Material(MaterialFace.Front, MaterialParameter.Ambient, Color4.Red);	//CgƂ̋pKv
				pv.Pipe(SorW, 0.35, 1.5);
				//DrawPipe2(0.35, 1.5, SorW);
				GL.PushMatrix();
					GL.Rotate(90, 0, 0, 1);
					GL.Material(MaterialFace.Front, MaterialParameter.Ambient, Color4.Cyan);	//CgƂ̋pKv
					pv.Cone(SorW, 0.5, 2);
					//DrawCone2(0.5, 2, SorW);
				GL.PopMatrix();
			}
			GL.PopMatrix();
			RotateX += 1.5f; 
			RotateY += 5.0f; 
			RotateZ += 1.0f; 
			this.SwapBuffers();
		}

		//Mouse
		private void gW_MouseDown(object sender, MouseButtonEventArgs e)
		{
			if(e.Button == MouseButton.Left)
				SorW = !SorW;
			else if(e.Button == MouseButton.Right)
				drawStop = !drawStop;
		}

		private void gW_MouseMove(object sender, MouseMoveEventArgs e)
		{
		}

		//Key
		private void gW_KeyUp(object sender, KeyboardKeyEventArgs e)
		{
		}

		private void gW_KeyDown(object sender, KeyboardKeyEventArgs e)
		{
		}

		private void gW_KeyPress(object sender, KeyPressEventArgs e)
		{
		}
	}
}
