/////////////////////////////////////////////
// GameWindow_Sample04.cpp
// Copyrignt (c) 2024 byYsama
/////////////////////////////////////////////
using System;
using OpenTK;						//OpenTKgpۂɕK{
using OpenTK.Graphics;				//OpenTK̃OtBbNgpۂɕK{
using OpenTK.Graphics.OpenGL;		//OpenGLgpۂɕKv
using OpenTK.Input;					//OpenTKœ͂sۂɕKviFKeyboiardj
using OpenTK_Primitives;			//OpenTK}`Cu[

namespace GameWindow_Sample04
{
	//AvP[VNX
	public class App
	{
		[STAThread]
		public static void Main()
		{
			gWindow gw = new gWindow();
			gw.Run();
		}
	}

	class gWindow : GameWindow	//GameWindowNX烆[U[EBhEh
	{
		OTKPrims pv = new OTKPrims();					//otkPrimitivesNXCX^X
		float Theta_Sun;								//z̎]p
		float Theta_Earth;								//n̎]p
		float Theta_Moon;								//̎]p
		bool SorW = true;								//SolidAWirẽtO
		bool drawStop = false;							//`~

		public gWindow() : base(640, 480, GraphicsMode.Default, "OpenTK GameWindow")	//
		{
			//Mouse
			this.MouseDown += gW_MouseDown;
			this.MouseMove += gW_MouseMove;
			//Key
			this.KeyUp += gW_KeyUp;
			this.KeyDown += gW_KeyDown;
			this.KeyPress += gW_KeyPress;
		}

		//EBhE̋NɎs
		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);								//菈
			GL.ClearColor(Color4.Black);				//ʏF̐ݒ
			GL.Enable(EnableCap.DepthTest);				//[x`FbNL
			GL.Enable(EnableCap.Normalize);				//@̐KLɂ
			//̎gp
			GL.Enable(EnableCap.Lighting);
			//Cg0̐ݒ
			GL.Enable(EnableCap.Light0);
			float[] pos0 = new float[] {50.0f, 50.0f, 50.0f, 1.0f };
			GL.Light(LightName.Light0, LightParameter.Position, pos0);
			//Cg1̐ݒ
			GL.Enable(EnableCap.Light1);
			float[] pos1 = new float[] {0.0f, -50.0f, 0.0f, 1.0f };
			GL.Light(LightName.Light1, LightParameter.Position, pos1);
			//Cg2̐ݒ
			GL.Enable(EnableCap.Light2);
			float[] pos2 = new float[] {100.0f, 100.0f, 100.0f, 1.0f };
			GL.Light(LightName.Light2, LightParameter.Position, pos2);
		}

		//EBhẼTCYύXꂽꍇɎs
		protected override void OnResize(EventArgs e)
		{
			base.OnResize(e);							//菈
			//r[|[g̐ݒ
			GL.Viewport(ClientRectangle.X, ClientRectangle.Y, ClientRectangle.Width, ClientRectangle.Height);
			//̐ς̐ݒ
			GL.MatrixMode(MatrixMode.Projection);
			Matrix4 projection = Matrix4.CreatePerspectiveFieldOfView((float)Math.PI / 4, (float)Width / (float)Height, 50.0f, 10000.0f);	//glPerspective(fov, aspect, near, far);
			GL.LoadMatrix(ref projection);
		}

		//EBhECxgXVꂽꍇɎsiOnRenderFramȇOɎsj
		protected override void OnUpdateFrame(FrameEventArgs e)
		{
			base.OnUpdateFrame(e);
			//ESCL[ꂽI
			if(Keyboard.GetState().IsKeyDown(Key.Escape))
			{
				Exit();
			}
		}

		//EBhE`悪XVꂽꍇɎs
		protected override void OnRenderFrame(FrameEventArgs e)
		{
			base.OnRenderFrame(e);						//菈
			if(drawStop)
				return;									//`~
			GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);
			GL.MatrixMode(MatrixMode.Modelview);		//fr[[hI
			//_ݒ肵Č_(0, 0, 0)
			Vector3 eye = new Vector3(0.0f, 200.0f, 60.0f);
			Matrix4 modelview = Matrix4.LookAt(eye, Vector3.Zero, Vector3.UnitY);	//gluLookAt(0.0, 100.0, 20.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
			GL.LoadMatrix(ref modelview);				//݂̕ϊ}gbNXɐݒ
			//ȉɕ`揈s
			//ʌ̃Zbg
			//float[] material_specular = new float[4] {0.2f, 0.2f, 0.2f, 1.0f};		//ʌ
			GL.Material(MaterialFace.Front, MaterialParameter.Specular, Color4.White);
			GL.Material(MaterialFace.Front, MaterialParameter.Shininess, 32.0f);
			GL.Material(MaterialFace.Front, MaterialParameter.Diffuse, Color4.OrangeRed);
			pv.Sphere(SorW,20.0);						//z/
			GL.PushMatrix();
			{
				GL.Rotate(Theta_Sun, 0.0f, 0.0f, 1.0f);	//zTheta_Sunx]
				GL.Translate(60.0f, 0.0f, 0.0f);		//x60sړ
				GL.Rotate(Theta_Earth, 0.0f, 0.0f, 1.0f);//zTheta_Earthx]
				GL.Material(MaterialFace.Front, MaterialParameter.Diffuse, Color4.SeaGreen);
				pv.Sphere(SorW, 10.0);					//n
				GL.Rotate(Theta_Moon, 0.0f, 0.0f, 1.0f);//zTheta_Moonx]
				GL.Translate(20.0f, 0.0f, 0.0f);		//x20sړ
				GL.Material(MaterialFace.Front, MaterialParameter.Diffuse, Color4.Yellow);
				pv.Sphere(SorW, 5.0);					//
			}
			GL.PopMatrix();
			Theta_Sun += 2.0f;
			Theta_Earth -= 10.0f;
			Theta_Moon += 6.0f;
			//_uobt@[
			this.SwapBuffers();
		}

		//Mouse
		private void gW_MouseDown(object sender, MouseButtonEventArgs e)
		{
			if(e.Button == MouseButton.Left)
				SorW = !SorW;
			else if(e.Button == MouseButton.Right)
				drawStop = !drawStop;
		}

		private void gW_MouseMove(object sender, MouseMoveEventArgs e)
		{
		}

		//Key
		private void gW_KeyUp(object sender, KeyboardKeyEventArgs e)
		{
		}

		private void gW_KeyDown(object sender, KeyboardKeyEventArgs e)
		{
		}

		private void gW_KeyPress(object sender, KeyPressEventArgs e)
		{
		}
	}
}
