//////////////////////////////////////////
// MazeProc.h
// Copyright (c) 06/21/2020 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnCreate(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//Xe[^Xo[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	SBar.Init(m_hWnd, m_hInstance, STATUSBAR);
	//Xe[^Xo[ݒ
	int sec[2] = {200, 400};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "Maze Ver1.0");
	SBar.SetText(1, "Maze size");

	//zEBhȄ
	cvs.SetCanvas(m_hWnd);
	cvs.BrSelection(1);		//hׂ

	//Orbg}bvǂ݂
	Brick.LoadBMP(m_hWnd, "IDI_BRICK");
	Ball.LoadBMP(m_hWnd, "IDI_BALL");
	Back.LoadBMP(m_hWnd, "IDI_BACK");
	Exit.LoadBMP(m_hWnd, "IDI_EXIT");

	//EBhETCY̏
	RECT w, c, s;
	GetWindowRect(m_hWnd, &w);	//EBhE̊O߂
	GetClientRect(m_hWnd, &c);	//EChE̓߂
	GetWindowRect(SBar.GetHandle(), &s);	//Xe[^Xo[̍
	SetWindowPos(m_hWnd, HWND_TOP, 0, 0,
	 	MSIZE *UNIT + (w. right - w.left - c.right + c.left),
		MSIZE *UNIT + (w. bottom - w.top - c.bottom + c.top + s.bottom - s.top),
		SWP_NOMOVE);	//KvȖHTCYɓOƃXe[^Xo[̍Z

	//EBhELvV̏
	FileName = " - Maze";
	SendMsg(WM_SETTEXT, 0, (LPARAM)FileName.ToChar());

	//j[nh̎擾
	g_hPopup = GetSubMenu(GetMenu(m_hWnd), 1);

	//H܂ł̓j[uۑvƁu\vs\ɂ
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 0), IDM_SAVE, MF_GRAYED | MF_BYCOMMAND);
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_TWOD, MF_GRAYED | MF_BYCOMMAND);
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_THREED, MF_GRAYED | MF_BYCOMMAND);

	//܂悤l̃S[ݒ
	man.SetGoal(MSIZE - 2, MSIZE - 2);

	return TRUE;
}

bool CMyWnd::OnTimer(WPARAM wParam, LPARAM lParam) {

	if(Mazedata) {
		if(ThreeD)
			Display3D();
		else
			Display2D();
	}
	else {
		KillTimer(m_hWnd, ID_TIMER);
		Show = FALSE;
		MessageBox(m_hWnd, "܂H쐬Ă܂", "Error", MB_OK | MB_ICONERROR);
	}
	return TRUE;
}

bool CMyWnd::OnLButtonDown(WPARAM wParam, LPARAM lParam)  {

	//^C}[̗L
	if(!Show) {
		if(!SetTimer(m_hWnd, ID_TIMER, 50, NULL)) {
				MessageBox(m_hWnd, "^C}[ݒɎs܂", "Error", MB_OK | MB_ICONERROR);
				return FALSE;
		}
	}
	//^C}[̖
	else {
		KillTimer(m_hWnd, ID_TIMER);
	}
	Show = !Show;

	return TRUE;
}

bool CMyWnd::OnRButtonDown(WPARAM wParam, LPARAM lParam) {

	//EChËʒu擾
	RECT rec;
	GetWindowRect(m_hWnd, &rec);
	//|bvAbvj[̕\ꏊݒ
	POINT pt;
	GetCursorPos(&pt);
	//|bvAbvj[̕\
	TrackPopupMenu(g_hPopup, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON, pt.x, pt.y, 0, m_hWnd, &rec);
	return TRUE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	SBar.AutoSize();
	return TRUE;
}

bool CMyWnd::OnPaint(WPARAM wParam, LPARAM lParam) {

	PAINTSTRUCT paint;
	cvs.OnPaint(BeginPaint(m_hWnd, &paint));
	EndPaint(m_hWnd, &paint);
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES) {
		//DestroyWindowAPostQuitMessageĂ΂
		if(Show) KillTimer(m_hWnd, ID_TIMER);	//^C}[I
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnNew() {

	if(Mazedata)
		if(MessageBox(m_hWnd, "݂̖H͔j󂳂܂낵ł傤H",
			"x", MB_YESNO | MB_ICONEXCLAMATION) == IDNO)
			return FALSE;
	Mazedata = mz.CreateMaze();	//Hf[^̃|C^[
	CSTR str = MSIZE;
	str = str + " x ";
	str = str + MSIZE;
	SBar.SetText(1, str.ToChar());
	//j[uۑvƁu\v\ɂ
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 0), IDM_SAVE, MF_ENABLED | MF_BYCOMMAND);
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_TWOD, MF_ENABLED | MF_BYCOMMAND);
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_THREED, MF_ENABLED | MF_BYCOMMAND);
	//ʕ\
	OnTwod();
	//TJnw\
	MessageBox(m_hWnd, "HTJnɂ̓EChEŃ}EXNbNĂ", "HTJn", MB_OK |MB_ICONINFORMATION);
	return TRUE;
}

bool CMyWnd::OnOpen() {

	//t@C擾
	char* fn = cmndlg.GetFileName(m_hWnd, "Hf[^t@C(*.maz)\0*.maz\0\0", TRUE, ".maz", ".", "Hf[^J");
	if(!fn) {
		MessageBox(m_hWnd, "ǂݍ݂̓LZ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	FileName = fn;
	//f[^ǂݍ
	int w, h, *data;
	CSTR str1, str2;
	str1.FromFile(FileName.ToChar());
	//Hf[^1sڂ͕, 
	str1.Next(str2);
	w = atoi(str2.ToChar());	//ǂݍ
	str1.Next(str2);
	h = atoi(str2.ToChar());	//ǂݍ
	if(w != MSIZE || h != MSIZE) {
		MessageBox(m_hWnd, "HTCYقȂ̂œǂݍ߂܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//2sڈȍ~̓J}؂̖Hf[^iʘH0ƕ1j
	data = mz.GetMaze();
	for(int y = 0; y < h; y++) {
		for(int x = 0; x < w; x++) {
			str1.Next(str2);
			data[x + w * y] = atoi(str2.ToChar());
		}
	}
	mz.Set(w, h, data);			//ǂݍ񂾃f[^Zbg
	Mazedata = mz.GetMaze();	//Hf[^̃|C^[
	//EBhELvVύX
	str1 = FileName;
	str1 = str1 + " - Maze";
	SendMsg(WM_SETTEXT, 0, (LPARAM)str1.ToChar());
	//Xe[^Xo[ύX
	str1 = w;
	str1 = str1 + " x ";
	str1 = str1 + h;
	SBar.SetText(1, str1.ToChar());
	//j[uۑvƁu\v\ɂ
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 0), IDM_SAVE, MF_ENABLED | MF_BYCOMMAND);
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_TWOD, MF_ENABLED | MF_BYCOMMAND);
	EnableMenuItem(GetSubMenu(GetMenu(m_hWnd), 1), IDM_THREED, MF_ENABLED | MF_BYCOMMAND);
	//ʕ\
	OnTwod();
	//TJnw\
	MessageBox(m_hWnd, "HTJnɂ̓EChEŃ}EXNbNĂ", "HTJn", MB_OK |MB_ICONINFORMATION);
	return TRUE;
}

bool CMyWnd::OnSave() {

    char* fn = cmndlg.GetFileName(m_hWnd, "Hf[^t@C(*.maz)\0*.maz\0\0", FALSE, ".maz", ".", "Hf[^̕ۑ");
	if(!fn) {
		MessageBox(m_hWnd, "LZ܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	FileName = fn;
	//Hf[^̕ۑ
	CSTR str;
	//1sځ@, 
	int Width = mz.GetW();
	int Height = mz.GetH();
    str = Width;
	str = str + ",";
	str = str + Height;
	str = str + "\n";
	//2sڈȍ~̓J}؂̖Hf[^iʘH0ƕ1j
	for(int y = 0; y < Height; y++) {		// 
		for(int x = 0; x < Width; x++) {	// 
			str = str + Mazedata[x + Width * y];
			if(x == Width - 1)
				str = str + "\n";
			else
				str = str + ",";
		}
	}
	str.ToFile(FileName.ToChar());
	//EBhELvV̏
	str = FileName;
	str = str + " - Maze";
	SendMsg(WM_SETTEXT, 0, (LPARAM)str.ToChar());
	return TRUE;
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnTwod() {

	//3D\Itɂ
	ThreeD = FALSE;
	//H̕ʕ\
	int Width = mz.GetW();
	int Height = mz.GetH();
	cvs.Box(0, 0, Width * UNIT, Height * UNIT, 1);	//Ō1͓hׂuV
	for(int y = 0; y < Height; y++) {		// 
		for(int x = 0; x < Width; x++) {	// 
			if(Mazedata[x + Width * y])
				cvs.PutBMP(Brick.Handle(), x * UNIT, y * UNIT, 0);	// 0 = PSET
		}
	}
	cvs.PutBMP(Ball.Handle(), man.GetX() * UNIT, man.GetY() * UNIT, 0);	// 0 = PSET
	cvs.PutBMP(Exit.Handle(), man.GetGoalX() * UNIT, man.GetGoalY() * UNIT, 0);	// 0 = PSET
	return TRUE;
}

bool CMyWnd::OnThreed() {

	//3D\Iɂ
	ThreeD = TRUE;
	return TRUE;
}

bool CMyWnd::OnVersion() {

	MessageBox(m_hWnd, "Maze Version 1.0\nCpoyright by YSAAM", "o[W", MB_OK | MB_ICONEXCLAMATION);
	return TRUE;
}

///////////////////////////////
//[U֐`
///////////////////////////////
void CMyWnd::Display2D() {	//Wanderer̕ʕ\

	//WandereriԊہjwiijŏ
	cvs.PutBMP(Back.Handle(), man.GetX() * UNIT, man.GetY() * UNIT, 0);	// 0 = PSET
	//Wanderer̎̍sN
	man.GoOn(mz.GetW(), mz.GetH(), mz.GetMaze());
	//WandereriԊہj̕\
	cvs.PutBMP(Ball.Handle(), man.GetX() * UNIT, man.GetY() * UNIT, 0);	// 0 = PSET
}

void CMyWnd::WhenGoal() {
	//S[B̏
	if(man.IsGoal()) {
		KillTimer(m_hWnd, ID_TIMER);
		Show = FALSE;
		MessageBox(m_hWnd, "You Made it!!!", "Congratulations", MB_OK | MB_ICONEXCLAMATION);
		int x = man.GetGoalX();
		int y = man.GetGoalY();
		x = (mz.GetW() - 1) - x;
		y = (mz.GetH() - 1) - y;
		man.SetGoal(x, y);
		cvs.PutBMP(Exit.Handle(), x * UNIT, y * UNIT, 0);	// ʕ\p
		cvs.Color(2);										// ̕\piԐFj
	}
}

void CMyWnd::Display3D() {	//Wanderer̗̕\

	//\ʃTCY
	RECT rec = {0, 0, mz.GetW() * UNIT,  mz.GetH() * UNIT};
	//H̕\֐ċAIɗp
	DisplayMaze(man.GetX(), man.GetY(), man.GetDir(), rec, 6);
	//Wanderer̎̍sN
	man.GoOn(mz.GetW(), mz.GetH(), mz.GetMaze());
	//Fɖ߂
	cvs.Color(0);
}

bool CMyWnd::DisplayMaze(int x, int y, int dir, RECT pos, int dev) {

	//Oǂɒ߂
	int Width = mz.GetW();
	int Height = mz.GetH();
	if(x == 0 || x == Width - 1)	return FALSE;
	if(y == 0 || y == Height - 1)	return FALSE;
	//išiki1/3jŏxAy̍ij
	int diff = (pos.right - pos.left) / dev / 2;	//x, yɓ
	//̃Z̃TCYixAyɍ2Âj
	RECT next;
	next.left = pos.left + diff;
	next.right = pos.right - diff;
	next.top = pos.top + diff;
	next.bottom = pos.bottom - diff;
	//ʃNA[
	cvs.Color(0);	//F
	cvs.Clear();
	//Fŕ`
	cvs.Color(15);
	bool FWall, LWall, RWall;	//ʁAAEǂۂ̃tO
	switch(dir) {				// x, y1Width-2, Height-2ɗ܂
		case 0:	//Up|֐i
				if(Mazedata[x + Width * (y - 1)])
					FWall = TRUE;
				else
					FWall = FALSE;
				if(Mazedata[x - 1 + Width * y])
					LWall = TRUE;
				else
					LWall = FALSE;
				if(Mazedata[x + 1 + Width * y])
					RWall = TRUE;
				else
					RWall = FALSE;
				y--;
				break;
		case 1:	//Right|E֐i
				if(Mazedata[x + 1 + Width * y])
					FWall = TRUE;
				else
					FWall = FALSE;
				if(Mazedata[x + Width * (y - 1)])
					LWall = TRUE;
				else
					LWall = FALSE;
				if(Mazedata[x + Width * (y + 1)])
					RWall = TRUE;
				else
					RWall = FALSE;
				x++;
				break;
		case 2:	//Down|֐i
				if(Mazedata[x + Width * (y + 1)])
					FWall = TRUE;
				else
					FWall = FALSE;
				if(Mazedata[x + 1 + Width * y])
					LWall = TRUE;
				else
					LWall = FALSE;
				if(Mazedata[x - 1 + Width * y])
					RWall = TRUE;
				else
					RWall = FALSE;
				y++;
				break;
		case 3:	//Left|֐i
				if(Mazedata[x - 1 + Width * y])
					FWall = TRUE;
				else
					FWall = FALSE;
				if(Mazedata[x + Width * (y + 1)])
					LWall = TRUE;
				else
					LWall = FALSE;
				if(Mazedata[x + Width * (y - 1)])
					RWall = TRUE;
				else
					RWall = FALSE;
				x--;
				break;
	}
	dev = 3;	//Ƃ͔1/6A̐1/3Â
	if(!FWall)
		DisplayMaze(x, y, dir, next, dev);	//ɉ`悳邽
	//S[BiBƎ̕`悪ԐFȂj
	WhenGoal();
	//ǁAʘH̕`
	if(FWall)	//ʂǂȂlp`
		cvs.Box(next.left, next.top, next.right, next.bottom);
	if(LWall) {	//̕`揈
		cvs.Line(pos.left, pos.top, next.left, next.top);
		cvs.Line(pos.left, pos.bottom, next.left, next.bottom);
	}
	else {
		cvs.Line(pos.left, next.top, next.left, next.top);
		cvs.Line(pos.left, pos.top, pos.left, pos.bottom);
		cvs.Line(pos.left, next.bottom, next.left, next.bottom);
		cvs.Line(next.left, next.top, next.left, next.bottom);
	}
	if(RWall) {	//E̕`揈
		cvs.Line(pos.right, pos.top, next.right, next.top);
		cvs.Line(pos.right, pos.bottom, next.right, next.bottom);
	}
	else {
		cvs.Line(pos.right, next.top, next.right, next.top);
		cvs.Line(pos.right, pos.top, pos.right, pos.bottom);
		cvs.Line(pos.right, next.bottom, next.right, next.bottom);
		cvs.Line(next.right, next.top, next.right, next.bottom);
	}
	Sleep(100);	//`ԂɉĒ
	return TRUE;
}
