//////////////////////////////////////////
// TextToSpeechProc.h
// Copyright (c) 11/19/2020 by BCCSkelton
//////////////////////////////////////////

#define	MAX_LEN	65536	//DISPDLG(IDD_DISPLAY)IDC_EDIT̍ő啶

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnInit(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|SetHandle(hWnd))
	TBar.SetHandle(GetDlgItem(m_hWnd, IDC_TOOLBAR));
	//c[o[{^pJX^rbg}bvǉ
	TBar.AddBmp(m_hInstance, MAKEINTRESOURCE(IDI_TOOLBAR), 10);
	//c[o[{^ǉ
	TBBUTTON tbb[13];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id + 0;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_INPUT;
	tbb[1].iBitmap = TBar.m_id + 1;
	tbb[1].fsState = TBSTATE_ENABLED;
	tbb[1].fsStyle = TBSTYLE_BUTTON;
	tbb[1].idCommand = IDM_CLIP;
	tbb[2].iBitmap = TBar.m_id + 2;
	tbb[2].fsState = TBSTATE_ENABLED;
	tbb[2].fsStyle = TBSTYLE_BUTTON;
	tbb[2].idCommand = IDM_OPEN;
	tbb[3].iBitmap = TBar.m_id + 3;
	tbb[3].fsState = TBSTATE_ENABLED;
	tbb[3].fsStyle = TBSTYLE_BUTTON;
	tbb[3].idCommand = IDM_SAVE;
	tbb[4].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[5].iBitmap = TBar.m_id + 4;
	tbb[5].fsState = TBSTATE_ENABLED;
	tbb[5].fsStyle = TBSTYLE_BUTTON;
	tbb[5].idCommand = IDM_EXIT;
	tbb[6].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[7].iBitmap = TBar.m_id + 5;
	tbb[7].fsState = TBSTATE_ENABLED;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_READ;
	tbb[8].iBitmap = TBar.m_id + 6;
	tbb[8].fsState = TBSTATE_ENABLED;
	tbb[8].fsStyle = TBSTYLE_BUTTON;
	tbb[8].idCommand = IDM_STOP;
	tbb[9].iBitmap = TBar.m_id + 7;
	tbb[9].fsState = TBSTATE_ENABLED;
	tbb[9].fsStyle = TBSTYLE_BUTTON;
	tbb[9].idCommand = IDM_CONTINUE;
	tbb[10].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[11].iBitmap = TBar.m_id + 8;
	tbb[11].fsState = TBSTATE_ENABLED;
	tbb[11].fsStyle = TBSTYLE_BUTTON;
	tbb[11].idCommand = IDM_HELP;
	tbb[12].iBitmap = TBar.m_id + 9;
	tbb[12].fsState = TBSTATE_ENABLED;
	tbb[12].fsStyle = TBSTYLE_BUTTON;
	tbb[12].idCommand = IDM_VERSION;
	TBar.AddButtons(13, tbb);

	//Xe[^Xo[o^|SetHandle(hWnd))
	SBar.SetHandle(GetDlgItem(m_hWnd, IDC_STATUSBAR));
	//Xe[^Xo[ݒ
	int sec[2] = {120, -1};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "TextToSpeech Ver1.0");

	//Xg{bNX̐ݒ
	HWND hLBWnd = GetDlgItem(m_hWnd, IDC_VOICE);	//Xg{bNX̃nh
	Voice.GetVoices(hLBWnd);
	//Xg{bNXiIDC_VOICEj̐XN[ݒ
	int num = SendMessage(hLBWnd, LB_GETCOUNT, 0, (LPARAM)0);
	int len, maxlen = 0;
	char buff[MAX_PATH];
	for(int i = 0; i < num; i++) {
		len = SendMessage(hLBWnd, LB_GETTEXTLEN, i, (LPARAM)0);
		if(len > maxlen) {
			maxlen = len;
			SendMessage(hLBWnd, LB_GETTEXT, i, (LPARAM)buff);
		}
	}
	//LB_SETHORIZONTALEXTENTpixcelŎw肷Kvi1Twip = 1/1440C`j
	SIZE size;
	HDC hDC = GetDC(hLBWnd);	//Xg{bNXDC擾
	GetTextExtentPoint(hDC, buff, maxlen, &size);
	ReleaseDC(hLBWnd, hDC);		//擾DC̊J
	//IDC_LANGUAGE̐XN[o[MAX_PATHp\ɂ
	SendItemMsg(IDC_VOICE, LB_SETHORIZONTALEXTENT, size.cx, (LPARAM)0);

	//ꃊXg{bNXEv̂݁|AGWȂΔs
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 0, (LPARAM)"{");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 1, (LPARAM)"p(US)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 2, (LPARAM)"p(UK)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 3, (LPARAM)"p(Ji_)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 4, (LPARAM)"()");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 5, (LPARAM)"(p)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 6, (LPARAM)"(`)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 7, (LPARAM)"؍");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 8, (LPARAM)"tX(tX)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 9, (LPARAM)"ttX(Ji_)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 10, (LPARAM)"hCc(hCc)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 11, (LPARAM)"C^A(C^A)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 12, (LPARAM)"XyC(LVR)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 13, (LPARAM)"|gK(uW)");
	SendItemMsg(IDC_LANGUAGE, LB_INSERTSTRING, 14, (LPARAM)"I_(I_)");
	//ftHgK΂I
	char* ptLang = Voice.GetLanguage(0);
	if(!lstrcmp(ptLang, "411"))			//{
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 0, (LPARAM)0);
	else if(!lstrcmp(ptLang, "409"))	//ĉp
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 1, (LPARAM)0);
	else if(!lstrcmp(ptLang, "809"))	//pp
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 2, (LPARAM)0);
	else if(!lstrcmp(ptLang, "1009"))	//p(Ji_)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 3, (LPARAM)0);
	else if(!lstrcmp(ptLang, "804"))	//()
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 4, (LPARAM)0);
	else if(!lstrcmp(ptLang, "404"))	//(p)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 5, (LPARAM)0);
	else if(!lstrcmp(ptLang, "C04"))	//(`)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 6, (LPARAM)0);
	else if(!lstrcmp(ptLang, "412"))	//؍
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 7, (LPARAM)0);
	else if(!lstrcmp(ptLang, "40C"))	//tX(tX)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 8, (LPARAM)0);
	else if(!lstrcmp(ptLang, "C0C"))	//tX(Ji_)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 9, (LPARAM)0);
	else if(!lstrcmp(ptLang, "407"))	//hCc(hCc)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 10, (LPARAM)0);
	else if(!lstrcmp(ptLang, "410"))	//C^A(C^A)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 11, (LPARAM)0);
	else if(!lstrcmp(ptLang, "80A"))	//XyC(LVR))
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 12, (LPARAM)0);
	else if(!lstrcmp(ptLang, "416"))	//|gK(uW)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 13, (LPARAM)0);
	else if(!lstrcmp(ptLang, "413"))	//I_(I_)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 14, (LPARAM)0);
	else
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, -1, (LPARAM)0);
	
	//ʃO[v̏ݒijj
	EnableWindow(GetDlgItem(m_hWnd, IDC_MALE), FALSE);
	EnableWindow(GetDlgItem(m_hWnd, IDC_FEMALE), FALSE);
	//p\ɐʂ̊YΗL
	for(int i = 0; i < Voice.GetCount(); i++)
		if(lstrcmp(Voice.GetGender(i), "Female"))
			EnableWindow(GetDlgItem(m_hWnd, IDC_FEMALE), TRUE);
		else
			EnableWindow(GetDlgItem(m_hWnd, IDC_MALE), TRUE);
	//ftHgi0j̐ʂ𒲂ׁA`FbN
	if(!lstrcmp(Voice.GetGender(0), "Female"))
		Button_SetCheck(GetDlgItem(m_hWnd, IDC_FEMALE), BST_CHECKED);
	else
		Button_SetCheck(GetDlgItem(m_hWnd, IDC_MALE), BST_CHECKED);

	//XC_[̐ݒ
	SendItemMsg(IDC_VOLUME, TBM_SETRANGE, TRUE, MAKELPARAM(0, 100));
	SendItemMsg(IDC_VOLUME, TBM_SETTICFREQ, 10, (LPARAM)10);
	SendItemMsg(IDC_VOLUME, TBM_SETPOS, TRUE, (LPARAM)50);
	SendItemMsg(IDC_SPEED, TBM_SETRANGE, TRUE, MAKELPARAM(-10, 10));
	SendItemMsg(IDC_SPEED, TBM_SETTICFREQ, 1, (LPARAM)0);
	SendItemMsg(IDC_SPEED, TBM_SETPOS, TRUE, (LPARAM)0);
	SendItemMsg(IDC_PITCH, TBM_SETRANGE, TRUE, MAKELPARAM(-10, 10));
	SendItemMsg(IDC_PITCH, TBM_SETTICFREQ, 1, (LPARAM)0);
	SendItemMsg(IDC_PITCH, TBM_SETPOS, TRUE, (LPARAM)0);

	//t@C̃hbvł̋N̏ꍇ
	if(g_ByFile) {
		g_SourcePath = Arg.v(1);
		OnOpen();
	}

	//wvt@C̐ݒ
	g_HelpFile = Arg.Path();
	g_HelpFile = g_HelpFile + "\\TextToSpeech.chm";

	//j[nh̎擾
	g_hPopup = GetSubMenu(GetMenu(m_hWnd), 1);

	//Nbv{[h
	cBoard.SetWnd(m_hWnd);

	//Rg[̃TuNX|ResTextToSpeech.hIDC_SELIDC_LANGLABEL13̃Rg[`
	for(int i = 0; i < (IDC_LANGLABEL - IDC_SEL + 1); i++) {
		g_SubClass[i].hWnd = GetDlgItem(m_hWnd, IDC_SEL + i);
		g_SubClass[i].wProc = (WNDPROC)GetWindowLongPtr(g_SubClass[i].hWnd, GWLP_WNDPROC);
		SetWindowLongPtr(g_SubClass[i].hWnd, GWLP_WNDPROC, (LONG_PTR)SubClassProc);
	}

	//hbOAhhbv̎tJn
	DragAcceptFiles(m_hWnd, TRUE);

	return TRUE;
}

bool CMyWnd::OnDropFiles(WPARAM wParam) {

	char FileName[MAX_PATH];
	//hbOAhhbvꂽt@C擾Ə
	DragQueryFile((HDROP)wParam, 0, FileName, MAX_PATH);
	g_SourcePath = FileName;
	g_ByFile = TRUE;
	OnOpen();
	MessageBox(m_hWnd, FileName, "hbOAhhbvꂽt@C", MB_OK | MB_ICONINFORMATION);
	DragFinish((HDROP)wParam);
	return TRUE;
}

bool CMyWnd::OnRButtonUp(WPARAM wParam, LPARAM lParam) {

	//EChËʒu擾
	RECT rec;
	GetWindowRect(m_hWnd, &rec);
	//|bvAbvj[̕\ꏊݒ
	POINT pt;
	GetCursorPos(&pt);
	//|bvAbvj[̕\
	TrackPopupMenu(g_hPopup, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON, pt.x, pt.y, 0, m_hWnd, &rec);
	return TRUE;
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	//c[o[c[`bv
	if(((LPNMHDR)lParam)->code == TTN_NEEDTEXT) {	//TTN_GETDISPINFOƓ
		switch(((LPTOOLTIPTEXT)lParam)->hdr.idFrom) {
		case IDM_INPUT:
			((LPTOOLTIPTEXT)lParam)->lpszText = "XNvg̓";
			break;
		case IDM_CLIP:
			((LPTOOLTIPTEXT)lParam)->lpszText = "Nbv{[h̓";
			break;
		case IDM_OPEN:
			((LPTOOLTIPTEXT)lParam)->lpszText = "t@C";
			break;
		case IDM_SAVE:
			((LPTOOLTIPTEXT)lParam)->lpszText = "XNvgt@C̕ۑ";
			break;
		case IDM_EXIT:
			((LPTOOLTIPTEXT)lParam)->lpszText = "I";
			break;
		case IDM_READ:
			((LPTOOLTIPTEXT)lParam)->lpszText = "eLXgǂݏグ";
			break;
		case IDM_STOP:
			((LPTOOLTIPTEXT)lParam)->lpszText = "ǂݏグꎞ~";
			break;
		case IDM_CONTINUE:
			((LPTOOLTIPTEXT)lParam)->lpszText = "ǂݏグĊJ";
			break;
		case IDM_HELP:
			((LPTOOLTIPTEXT)lParam)->lpszText = "gɂ";
			break;
		case IDM_VERSION:
			((LPTOOLTIPTEXT)lParam)->lpszText = "o[W";
			break;
		}
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	TBar.AutoSize();
	SBar.AutoSize();
	return TRUE;
}

bool CMyWnd::OnHScroll(WPARAM wParam, LPARAM lParam) {

	int value;
	char str[20];
	if(LOWORD(wParam) == TB_THUMBPOSITION || LOWORD(wParam) == TB_THUMBTRACK) {
		value = HIWORD(wParam);
		if((HWND)lParam == GetDlgItem(m_hWnd, IDC_VOLUME)) {
			wsprintf(str, " - %hd", value);
			SendItemMsg(IDC_VOLUMELABEL, WM_SETTEXT, 0, (LPARAM)str);
		}
		else if((HWND)lParam == GetDlgItem(m_hWnd, IDC_SPEED)) {
			wsprintf(str, "x - %hd", value);
			SendItemMsg(IDC_SPEEDLABEL, WM_SETTEXT, 0, (LPARAM)str);
		}
		else if((HWND)lParam == GetDlgItem(m_hWnd, IDC_PITCH)) {
			wsprintf(str, " - %hd", value);
			SendItemMsg(IDC_PITCHLABEL, WM_SETTEXT, 0, (LPARAM)str);
		}
	}
	else {
		if((HWND)lParam == GetDlgItem(m_hWnd, IDC_VOLUME)) {
			value = SendItemMsg(IDC_VOLUME, TBM_GETPOS, 0, (LPARAM)0);
			wsprintf(str, " - %2hd", value);
			SendItemMsg(IDC_VOLUMELABEL, WM_SETTEXT, 0, (LPARAM)str);
		}
		else if((HWND)lParam == GetDlgItem(m_hWnd, IDC_SPEED)) {
			value = SendItemMsg(IDC_SPEED, TBM_GETPOS, 0, (LPARAM)0);
			wsprintf(str, "x - %2hd", value);
			SendItemMsg(IDC_SPEEDLABEL, WM_SETTEXT, 0, (LPARAM)str);
		}
		else if((HWND)lParam == GetDlgItem(m_hWnd, IDC_PITCH)) {
			value = SendItemMsg(IDC_PITCH, TBM_GETPOS, 0, (LPARAM)0);
			wsprintf(str, " - %2hd", value);
			SendItemMsg(IDC_PITCHLABEL, WM_SETTEXT, 0, (LPARAM)str);
		}
	}
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONINFORMATION) == IDYES) {
		//DestroyWindowAPostQuitMessageĂ΂
		EndModal(TRUE);
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

//_CAOx[X̏ꍇ͂ꂪKv
bool CMyWnd::OnDestroy(WPARAM wPram, LPARAM lParam) {

	PostQuitMessage(0);
	return TRUE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnSelect() {

	//Xg{bNX̑Iԍ
	int num;
	//I`FbN{bNX`FbNꂽꍇ
	if(SendItemMsg(IDC_SEL, BM_GETCHECK, 0, 0) == BST_CHECKED) {
		num = SendItemMsg(IDC_VOICE, LB_GETCURSEL, 0, 0);
		if(num == LB_ERR) {
			MessageBox(m_hWnd, "IĂ܂", "G[", MB_OK | MB_ICONERROR);
			SendItemMsg(IDC_SEL, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
			return FALSE;
		}
		else {
			EnableWindow(GetDlgItem(m_hWnd, IDC_VOICE), FALSE);
			EnableLangAndGend(FALSE);
			g_IsSelUsed = TRUE;
		}
	}
	//I`FbN{bNXOꂽꍇ
	else {
		num = 0;	//ftHgIuWFNgɍĐݒ
		EnableWindow(GetDlgItem(m_hWnd, IDC_VOICE), TRUE);
		SendItemMsg(IDC_VOICE, LB_SETCURSEL, -1, (LPARAM)0);
		EnableLangAndGend(TRUE);
		g_IsSelUsed = FALSE;
	}
	//IuWFNgɐݒ
	Voice.SetVoice(num);
	//ʂύX
	if(!lstrcmp(Voice.GetGender(num), "Female")) {
		Button_SetCheck(GetDlgItem(m_hWnd, IDC_FEMALE), BST_CHECKED);
		Button_SetCheck(GetDlgItem(m_hWnd, IDC_MALE), BST_UNCHECKED);
	}
	else {
		Button_SetCheck(GetDlgItem(m_hWnd, IDC_FEMALE), BST_UNCHECKED);
		Button_SetCheck(GetDlgItem(m_hWnd, IDC_MALE), BST_CHECKED);
	}
	//ύX
	char* lang = Voice.GetLanguage(num);
	if(!lstrcmp(lang, "411"))	//{
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 0, (LPARAM)0);
	else if(!lstrcmp(lang, "409"))	//ĉp
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 1, (LPARAM)0);
	else if(!lstrcmp(lang, "809"))	//pp
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 2, (LPARAM)0);
	else if(!lstrcmp(lang, "1009"))	//p(Ji_)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 3, (LPARAM)0);
	else if(!lstrcmp(lang, "804"))	//()
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 4, (LPARAM)0);
	else if(!lstrcmp(lang, "404"))	//(p)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 5, (LPARAM)0);
	else if(!lstrcmp(lang, "C04"))	//(`)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 6, (LPARAM)0);
	else if(!lstrcmp(lang, "412"))	//؍
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 7, (LPARAM)0);
	else if(!lstrcmp(lang, "40C"))	//tX(tX)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 8, (LPARAM)0);
	else if(!lstrcmp(lang, "C0C"))	//tX(Ji_)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 9, (LPARAM)0);
	else if(!lstrcmp(lang, "407"))	//hCc(hCc)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 10, (LPARAM)0);
	else if(!lstrcmp(lang, "410"))	//C^A(C^A)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 11, (LPARAM)0);
	else if(!lstrcmp(lang, "80A"))	//XyC(LVR)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 12, (LPARAM)0);
	else if(!lstrcmp(lang, "416"))	//|gK(uW)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 13, (LPARAM)0);
	else if(!lstrcmp(lang, "413"))	//I_(I_)
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, 14, (LPARAM)0);
	else
		SendItemMsg(IDC_LANGUAGE, LB_SETCURSEL, -1, (LPARAM)0);

	return TRUE;
}

bool CMyWnd::OnInput() {

	displaydlg.DoModal(m_hWnd, "IDD_DISPLAY", displaydlgProc);
	return TRUE;
}

bool CMyWnd::OnClip() {

	char *cp = cBoard.GetText();
	if(!cp) {
		MessageBox(m_hWnd, "Nbv{[hɕf[^͂܂", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
		g_SourceFile = cp;
		SBar.SetText(1, "Nbv{[h");
		return TRUE;
	}
}

bool CMyWnd::OnOpen() {

	if(!g_ByFile) {	//wt@CȂꍇ
		char* cp = cmndlg.GetFileName(m_hWnd, "eLXgt@C(*.txt)\0*.txt\0\0", TRUE, "txt", "eLXgt@CJ");
		if(!cp) {
			MessageBox(m_hWnd, "t@Cǂݍ݂LZ܂", "Error", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		else
			g_SourcePath = cp;
	}
	g_SourceFile.FromFile(g_SourcePath.ToChar());
	SBar.SetText(1, g_SourcePath.ToChar());
	SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)g_SourcePath.ToChar());	//ToolTip
	SendItemMsg(IDC_EDIT, WM_SETTEXT, 0, (LPARAM)g_SourceFile.ToChar());
	g_ByFile = FALSE;
	return TRUE;
}

bool CMyWnd::OnSave() {

	if(!*g_SourcePath.ToChar()) {
		char* cp = cmndlg.GetFileName(m_hWnd, "eLXgt@C(*.txt)\0*.txt\0\0", FALSE, "txt", "eLXgt@Cۑ");
		if(!cp) {
			MessageBox(m_hWnd, "t@C݂LZ܂", "Error", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		else
			g_SourcePath = cp;
	}
	g_SourceFile.ToFile(g_SourcePath.ToChar());
	return TRUE;
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnRead() {

	//ǏグiScriptjƐڔiPostj
	CSTR Script, Post;
	char buff[MAX_PATH];	//wsprintpobt@
	//ǂݏグIvV擾
	int lang = SendItemMsg(IDC_LANGUAGE, LB_GETCURSEL, 0, 0);
   	int sex = (BST_CHECKED == SendItemMsg(IDC_MALE, BM_GETCHECK, 0, 0));
	int volume = SendItemMsg(IDC_VOLUME, TBM_GETPOS, 0, 0);
	int speed = SendItemMsg(IDC_SPEED, TBM_GETPOS, 0, 0);
	int pitch = SendItemMsg(IDC_PITCH, TBM_GETPOS, 0, 0);
	//gp|݂Ysamåł͓{ƕĉp
	if(!g_IsSelUsed) {
		switch(lang) {
		case 0:
			Script = "<lang langid=\"411\">\n";	//{
			break;
		case 1:
			Script = "<lang langid=\"409\">\n";	//ĉp
			break;
		case 2:
			Script = "<lang langid=\"809\">\n";	//pp
			break;
		case 3:
			Script = "<lang langid=\"1009\">\n";//p(Ji_)
			break;
		case 4:
			Script = "<lang langid=\"804\">\n";	//()
			break;
		case 5:
			Script = "<lang langid=\"404\">\n";	//(p)
			break;
		case 6:
			Script = "<lang langid=\"C04\">\n";	//(`)
			break;
		case 7:
			Script = "<lang langid=\"412\">\n";	//؍
			break;
		case 8:
			Script = "<lang langid=\"40C\">\n";	//tX(tX)
			break;
		case 9:
			Script = "<lang langid=\"C0C\">\n";	//tX(Ji_)
			break;
		case 10:
			Script = "<lang langid=\"407\">\n";	//hCc(hCc)
			break;
		case 11:
			Script = "<lang langid=\"410\">\n";	//C^A(C^A)
			break;
		case 12:
			Script = "<lang langid=\"80A\">\n";	//XyC(LVR)
			break;
		case 13:
			Script = "<lang langid=\"416\">\n";	//|gK(uW)
			break;
		case 14:
			Script = "<lang langid=\"413\">\n";	//I_(I_)
			break;
		default:
			//̑̌͌wȂ
			break;
		}
		//
		if(sex)
			Script = Script + "<voice required=\"Gender=Male\">\n";
		else
			Script = Script + "<voice required=\"Gender=Female\">\n";
	}
	//
	wsprintf(buff, "<volume level=\"%d\">\n", volume);
	Script = Script + buff;
	//x
	wsprintf(buff, "<rate speed=\"%d\">\n", speed);
	Script = Script + buff;
	//
	wsprintf(buff, "<pitch absmiddle=\"%d\">\n", pitch);
	Script = Script + buff;
	//{
	Script = Script + g_SourceFile;
	//ڔ
	if(g_IsSelUsed)
		Post = "\n</pitch>\n</rate>\n</volume>";
	else
		Post = "\n</pitch>\n</rate>\n</volume>\n</voice>\n</lang>";
	Script = Script + Post;
	//Ǐグ
	Voice.Speak(Script.ToChar());	//OptionYGWȂǂݏグȂĂSUCCEEDED()ƂȂ
	return TRUE;
}

bool CMyWnd::OnStop() {

	HMENU hMenu = GetMenu(TextToSpeech.GetHandle());	//j[nh̎擾
	//j[o[
	EnableMenuItem(GetSubMenu(hMenu, 1), 0, MF_BYPOSITION | MF_GRAYED);
	//c[o[(MAKELONG}N16bit2unsigned 32bitɂ)
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_READ, MAKELONG(FALSE, 0));
	Voice.Pause();
	return TRUE;
}

bool CMyWnd::OnContinue() {

	HMENU hMenu = GetMenu(TextToSpeech.GetHandle());	//j[nh̎擾
	//j[o[
	EnableMenuItem(GetSubMenu(hMenu, 1), 0, MF_BYPOSITION | MF_ENABLED);
	//c[o[(MAKELONG}N16bit2unsigned 32bitɂ)
	SendMessage(TBar.GetHandle(), TB_ENABLEBUTTON, IDM_READ, MAKELONG(TRUE, 0));
	Voice.Resume();
	return TRUE;
}

bool CMyWnd::OnHelp() {

	CSTR cmd = "hh \"";
	cmd = cmd + g_HelpFile + "\"";
	WinExec(cmd.ToChar(), SW_SHOWNORMAL);
	return TRUE;
}

bool CMyWnd::OnVersion() {

	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

///////////////////////////////
//[U[`֐
//Aʂ𖳌ALɂ
///////////////////////////////
void CMyWnd::EnableLangAndGend(bool state) {

	EnableWindow(GetDlgItem(m_hWnd, IDC_LANGUAGE), state);
	EnableWindow(GetDlgItem(m_hWnd, IDC_MALE), state);
	EnableWindow(GetDlgItem(m_hWnd, IDC_FEMALE), state);
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool DISPLAYDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//IDC_EDIT̍ő啶iTextToSpeech.hQƁj
	SendItemMsg(IDC_EDIT, EM_SETLIMITTEXT, (WPARAM)MAX_LEN, (LPARAM)0);
	//IDC_EDITg_SourceFileǂݍ
	SendItemMsg(IDC_EDIT, WM_SETTEXT,(WPARAM)0, (LPARAM)g_SourceFile.ToChar());
	return TRUE;
}

bool DISPLAYDLG::OnSize(WPARAM wParam, LPARAM lParam) {

	RECT rect;
	GetWindowRect(GetDlgItem(m_hWnd, IDC_EDIT), &rect);
	POINT pt = {rect.left, rect.top};
	ScreenToClient(m_hWnd, &pt);
	GetWindowRect(GetDlgItem(m_hWnd, IDOK), &rect);
	MoveWindow(GetDlgItem(m_hWnd, IDC_EDIT), pt.x, pt.y, LOWORD(lParam) - pt.x * 2, HIWORD(lParam) - (rect.bottom - rect.top) * 2, TRUE);
	MoveWindow(GetDlgItem(m_hWnd, IDOK), (LOWORD(lParam) - (rect.right - rect.left)) / 2,
		HIWORD(lParam) - (rect.bottom - rect.top) - (rect.bottom - rect.top) / 3,
		rect.right - rect.left, rect.bottom - rect.top, TRUE);
	return TRUE;
}

bool DISPLAYDLG::OnIdok() {

	//GfBbgRg[̕񒷂擾
	int len = SendItemMsg(IDC_EDIT, WM_GETTEXTLENGTH, 0, (LPARAM)0);
	//IDC_EDITg_SourceFile֏
	char *pt = new char[len + 1];
	SendItemMsg(IDC_EDIT, WM_GETTEXT, (WPARAM)len + 1, (LPARAM)pt);
	g_SourceFile = pt;
	delete [] pt;
	EndModal(TRUE);
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool VERSIONDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	SendItemMsg(IDC_VERTXT, WM_SETTEXT,
				0, (LPARAM)"TextToSpeech Ver 1.0\r\nCopyright (c) 2020\r\nby ysama");
	return TRUE;
}

bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}
