//////////////////////////////////////////
// TradFilerProc.h
// Copyright (c) 05/13/2020 by BCCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnCreate(WPARAM wParam, LPARAM lParam) {

	//RRg[̏
	InitCommonControls();

	//c[o[o^|Init(hWnd, hIinstance, ID, Style)
	TBar.Init(m_hWnd, m_hInstance, TOOLBAR, WS_CHILD | WS_VISIBLE | TBSTYLE_TOOLTIPS);
	//c[o[{^prbg}bvǉiJX^c[o[{^gpj
	TBar.AddBmp(m_hInstance, "IDI_TBAR", 7);
	//c[o[{^ǉ
	TBBUTTON tbb[11];
	ZeroMemory(tbb, sizeof(tbb));
	tbb[0].iBitmap = TBar.m_id;
	tbb[0].fsState = TBSTATE_ENABLED;
	tbb[0].fsStyle = TBSTYLE_BUTTON;
	tbb[0].idCommand = IDM_EXIT;
	tbb[1].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[2].iBitmap = TBar.m_id + 1;
	tbb[2].fsState = TBSTATE_ENABLED;
	tbb[2].fsStyle = TBSTYLE_BUTTON;
	tbb[2].idCommand = IDM_EXE;
	tbb[3].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[4].iBitmap = TBar.m_id + 2;
	tbb[4].fsState = TBSTATE_ENABLED;
	tbb[4].fsStyle = TBSTYLE_BUTTON;
	tbb[4].idCommand = IDM_DEL;
	tbb[5].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[6].iBitmap = TBar.m_id + 3;
	tbb[6].fsState = TBSTATE_ENABLED;
	tbb[6].fsStyle = TBSTYLE_BUTTON;
	tbb[6].idCommand = IDM_COPY;
	tbb[7].iBitmap = TBar.m_id + 4;
	tbb[7].fsState = TBSTATE_ENABLED;
	tbb[7].fsStyle = TBSTYLE_BUTTON;
	tbb[7].idCommand = IDM_CUT;
	tbb[8].iBitmap = TBar.m_id + 5;
	tbb[8].fsState = TBSTATE_ENABLED;
	tbb[8].fsStyle = TBSTYLE_BUTTON;
	tbb[8].idCommand = IDM_RENAME;
	tbb[9].fsStyle = TBSTYLE_SEP;	//Zp[^[
	tbb[10].iBitmap = TBar.m_id + 6;
	tbb[10].fsState = TBSTATE_ENABLED;
	tbb[10].fsStyle = TBSTYLE_BUTTON;
	tbb[10].idCommand = IDM_VERSION;
	TBar.AddButtons(11, tbb);

	//Xe[^Xo[o^|Init(hWnd, hIinstance, ID, (ȉȗjStyle)
	SBar.Init(m_hWnd, m_hInstance, STATUSBAR);
	//Xe[^Xo[ݒ
	int sec[2] = {200, -1};
	SBar.SetSection(2, sec);
	//Xe[^Xo[ݒ
	SBar.SetText(0, "TradFiler Ver 1.0");

	//c[r[C[WXgւ̃C[W̒ǉ
	tv.AddBitmap(MAKEINTRESOURCE(IDI_CFOLDER), m_hInstance, RGB(16, 16, 16));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_OFOLDER), m_hInstance, RGB(16, 16, 16));
	tv.AddBitmap(MAKEINTRESOURCE(IDI_FILE), m_hInstance, RGB(16, 16, 16));
	//c[r[̍쐬
	tv.Create(m_hWnd, m_hInstance, IDC_TREEVIEW);
	tv.SetFont(9, "lr ");
	//c[r[ACe̒ǉirbg}bvtj
	g_hRoot = tv.InsertItem(g_Root.ToChar(), TVI_LAST, TVI_ROOT, 0, 1);

	//CHISTORYϐinit@Cݒ
	char *pt;
	if(pt = strstr(g_CmdLine, "TradFiler.exe")) {
		lstrcpy(pt, "init.ini");
		history.SetPath(g_CmdLine);
		history.SetMenu(GetSubMenu(GetSubMenu(GetMenu(m_hWnd), 0), 8));
		history.Init();
	}

	return TRUE;
}

bool CMyWnd::OnNotify(WPARAM wParam, LPARAM lParam) {

	if(wParam == IDC_TREEVIEW) {
		switch(((TV_DISPINFO*)lParam)->hdr.code) {
			//bZ[WǂAIύX
			case TVN_SELCHANGED: {
				//IACe擾
				g_hSelected = tv.GetSelection();
				//IACȅ擾
				char Buff[MAX_PATH];
				LPTV_ITEM tvitem_pt = tv.GetItem(g_hSelected, Buff, MAX_PATH);
				int DorF = tvitem_pt->iImage;	//tvitem_pt->iImage̒lL^
				CSTR Path = g_Root;
				//[głȂΐeHA[g܂ł̃pXPathɋL^
				if(g_hSelected != g_hRoot) {
					HTREEITEM hParent, hChild = g_hSelected;
					CSTR temp = Buff;
					//IACe
					while(hParent = tv.GetParent(hChild)) {
						tv.GetItem(hParent, Buff, MAX_PATH);
						temp = "\\" + temp;
						temp = Buff + temp;
						hChild = hParent;
					}
					Path = temp;
				}
				//pX̓Xe[^Xo[ɕ\
				SBar.SetText(1, Path.ToChar());
				SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)Path.ToChar());	//ToolTip
				//IACeɎq΃t@Cł͂ȂAWJ̕KvȂ̂Ŗ߂
				if(tv.GetChild(g_hSelected)) return FALSE;
				//ACRtH[_[t@C𔻕
				if(DorF < 2) {	//tH[_[ACe
					//pXAt@C擾
					Path = Path + "\\*.*";	//t@Cx[XɂȂƋ@\Ȃ
					WIN32_FIND_DATA fd;
					HANDLE hFind = FindFirstFile(Path.ToChar(), &fd);
					if(hFind == INVALID_HANDLE_VALUE) {
						MessageBox(m_hWnd, "̃tH[_[ɂ̓t@C܂", "G[", MB_OK | MB_ICONERROR);
						FindClose(hFind);
						return FALSE;
					}
					else {	//qǉ
						//c[r[ACe̒ǉirbg}bvtj
						do {
							if(*fd.cFileName != '.') {
								if (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)	// Directory
									tv.InsertItem(fd.cFileName, TVI_LAST, g_hSelected, 0, 1);
								else												// Files
									tv.InsertItem(fd.cFileName, TVI_LAST, g_hSelected, 2, 2);
							}
						} while (FindNextFile(hFind, &fd));
					}
					FindClose(hFind);
					g_SelectedFile = "";	//tH[_[̏ꍇ͏ΏۊOŃk
					return TRUE;
				}
				else {	//t@CACe|ΏۂŃpXAt@CL^
					g_SelectedFile = Path;
					return TRUE;
				}
			}
			case TVN_ENDLABELEDIT: {
				//xҏW
				TreeView_SetItem(tv.m_hWnd, &((TV_DISPINFO*)lParam)->item);
				//t@CVxɕύX
				char oldfn[MAX_PATH], newfn[MAX_PATH];
				SendMessage(SBar.m_hWnd, SB_GETTEXT, 1, (LPARAM)oldfn);
				lstrcpy(newfn, oldfn);
				char *fn;
				for(fn = newfn + lstrlen(newfn) - 1; *fn != '\\'; fn--);
				*++fn = 0;
				lstrcat(newfn, ((TV_DISPINFO*)lParam)->item.pszText);
				if(!MoveFile(oldfn, newfn)) {
					MessageBox(m_hWnd, "t@CύXł܂ł", "G[", MB_OK | MB_ICONERROR);
				}
				else {
					//pX̓Xe[^Xo[ɕ\
					SBar.SetText(1, newfn);	//Vt@CɕύX
					SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)newfn);	//ToolTip
					g_SelectedFile = newfn;	//Vt@CɕύX
				}
				//xҏWsɖ߂
				g_Style ^= TVS_EDITLABELS;
				SetWindowLong(tv.m_hWnd, GWL_STYLE, g_Style);
				//xҏW{^𗘗p\ɂ
				SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_RENAME, MAKELONG(TRUE, 0));
				return TRUE;
			}
			case NM_RCLICK: {	//ENbN
				//EChËʒu擾
				RECT rec;
				GetWindowRect(m_hWnd, &rec);
				//|bvAbvj[̕\ꏊݒ
				POINT pt;
				GetCursorPos(&pt);
				//|bvAbvj[̕\
				TrackPopupMenu(GetSubMenu(GetMenu(m_hWnd), 0), TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON, pt.x, pt.y, 0, m_hWnd, &rec);
				break;
			}
			case NM_DBLCLK: {	//_uNbN
				//IACȅ擾
				LPTV_ITEM tvitem_pt = tv.GetItem(g_hSelected, NULL, 0);
				//t@CłOnExe
				if(tvitem_pt->iImage >= 2)
					OnExe();
				break;
			}
		}
	}
	if(((LPNMHDR)lParam)->code == TTN_NEEDTEXT) {
		((LPTOOLTIPTEXT)lParam)->hinst = m_hInstance;
		switch(((LPTOOLTIPTEXT)lParam)->hdr.idFrom) {
		case IDM_EXE:
			((LPTOOLTIPTEXT)lParam)->lpszText = "s";
			break;
		case IDM_DEL:
			((LPTOOLTIPTEXT)lParam)->lpszText = "폜";
			break;
		case IDM_CUT:
			((LPTOOLTIPTEXT)lParam)->lpszText = "t@C̈ړ";
			break;
		case IDM_COPY:
			((LPTOOLTIPTEXT)lParam)->lpszText = "t@C̃Rs[";
			break;
		case IDM_RENAME:
			((LPTOOLTIPTEXT)lParam)->lpszText = "t@CύX";
			break;
		case IDM_VERSION:
			((LPTOOLTIPTEXT)lParam)->lpszText = "o[W";
			break;
		case IDM_EXIT:
			((LPTOOLTIPTEXT)lParam)->lpszText = "I";
			break;
		}
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnSize(WPARAM wParam, LPARAM lParam) {

	TBar.AutoSize();
	SBar.AutoSize();
	//c[r[NCAg̈ɂ킹
	RECT rec;
	int tbhigh, w = LOWORD(lParam), h = HIWORD(lParam);
	GetWindowRect(TBar.m_hWnd, &rec);
	tbhigh = rec.bottom - rec.top;
	GetWindowRect(SBar.m_hWnd, &rec);
	h -= (tbhigh + rec.bottom - rec.top);
	tv.Move(0, tbhigh, w, h);
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wParam, LPARAM lParam) {

	if(MessageBox(m_hWnd, "I܂", "ImF",
					MB_YESNO | MB_ICONQUESTION) == IDYES) {
		//DestroyWindowAPostQuitMessageĂ΂
		history.WriteIni();	//init@Cɏ
		return TRUE;
	}
	else
		//łȂ΃EBhEłDefWindowProc֐returnA_CAOłreturn FALSEƂȂB
		return FALSE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnExe() {

	//IACȅ擾
	char Name[MAX_PATH];
	LPTV_ITEM tvitem_pt = tv.GetItem(g_hSelected, Name, MAX_PATH);
	//tH[_[łΖ߂
	if(tvitem_pt->iImage < 2) {
		MessageBox(m_hWnd, "IĂ̂̓tH[_[ł", "G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	if(*g_SelectedFile.ToChar()) {
		if(WinExec(g_SelectedFile.ToChar(), SW_SHOWNORMAL) < 32) {
			if(MessageBox(m_hWnd, "s\t@Cł͂܂B֘AtꂽvOŊJ܂H",
				"G[", MB_YESNO | MB_ICONERROR) == IDYES) {
				char Path[MAX_PATH];
				lstrcpy(Path, g_SelectedFile.ToChar());
                char *pt = strstr(Path, Name);
				if(pt--) *pt = 0;
				char ExeFile[MAX_PATH];
				if ((int)FindExecutable(Name, Path, ExeFile) > 32) {
					CSTR Cmd = "\"";				//st@CpXAu"vň͂
					Cmd = Cmd + ExeFile;
					Cmd = Cmd + "\" \"";			//f[^t@CpXAu"vň͂
					Cmd = Cmd + g_SelectedFile;
					Cmd = Cmd + "\"";
					WinExec(Cmd.ToChar(), SW_SHOWNORMAL);
				}
				else
					MessageBox(m_hWnd, "֘AtꂽvO܂", "G[", MB_OK | MB_ICONERROR);
			}
		}
		else
			history.AddItem(g_SelectedFile.ToChar());	//st@C𗚗ɋL^
	}
	else
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
	return TRUE;
}

bool CMyWnd::OnDel() {

	if(*g_SelectedFile.ToChar()) {
		CSTR msg = g_SelectedFile;
		msg = msg + "\n폜܂B낵łH";
		int yn = MessageBox(m_hWnd, msg.ToChar(), "t@C폜", MB_YESNO | MB_ICONWARNING);
		if(yn == IDYES) {
			DeleteFile(g_SelectedFile.ToChar());
			tv.DeleteItem(g_hSelected);
			return TRUE;
		}
	}
	else
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
	return FALSE;
}

bool CMyWnd::OnCut() {

	//Ώۃt@CIĂ
	if(*g_SelectedFile.ToChar()) {
		CSTR msg = g_SelectedFile;
		msg = msg + "  ";
		char Target[MAX_PATH] = {0};
		lstrcpy(Target, cmndlg.GetPath(m_hWnd, "ړ"));
		if(!*Target) {
			msg = "ړ悪w肳܂łB";
			MessageBox(m_hWnd, msg.ToChar(), "ړw莸s", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		msg = msg + Target;
		SBar.SetText(1, msg.ToChar());	//t@CړmFp
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)msg.ToChar());	//ToolTip
		char *fn, *item;
		for(fn = g_SelectedFile.ToChar() + lstrlen(g_SelectedFile.ToChar()) - 1; *fn != '\\'; fn--);
		lstrcat(Target, fn);	//"\(file name)"wĂ
		fn++;					//'\'wĂ̂ňi߂
		for(item = Target + lstrlen(Target) - 1; item >= Target && *item != '\\'; item--);
		item++;	//Target'\'߂Ă̂߂
		//t@C̃Rs[
		MoveFile(g_SelectedFile.ToChar(), Target);
		//Rs[̃ACeǉ
		HTREEITEM add = tv.FindItem(g_hRoot, item);
		if(add)
			tv.InsertItem(fn, TVI_LAST, add, 2, 2);
		//̃t@Cƃc[r[̃ACe폜
		DeleteFile(g_SelectedFile.ToChar());
		tv.DeleteItem(g_hSelected);
		return TRUE;
	}
	else
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
	return FALSE;
}

bool CMyWnd::OnCopy() {

	//Ώۃt@CIĂ
	if(*g_SelectedFile.ToChar()) {
		CSTR msg = g_SelectedFile;
		msg = msg + "  ";
		char Target[MAX_PATH] = {0};
		lstrcpy(Target, cmndlg.GetPath(m_hWnd, "Rs["));
		if(!*Target) {
			msg = "Rs[悪w肳܂łB";
			MessageBox(m_hWnd, msg.ToChar(), "Rs[w莸s", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		msg = msg + Target;
		SBar.SetText(1, msg.ToChar());	//t@CړmFp
		SBar.SendMsg(SB_SETTIPTEXT, 1, (LPARAM)msg.ToChar());	//ToolTip
		char *fn, *item;
		for(fn = g_SelectedFile.ToChar() + lstrlen(g_SelectedFile.ToChar()) - 1; *fn != '\\'; fn--);
		lstrcat(Target, fn);	//"\(file name)"wĂ
		fn++;					//'\'wĂ̂ňi߂
		for(item = Target + lstrlen(Target) - 1; item >= Target && *item != '\\'; item--);
		item++;	//Target'\'߂Ă̂߂
		//t@C̃Rs[
		MoveFile(g_SelectedFile.ToChar(), Target);
		//Rs[̃ACeǉ
		HTREEITEM add = tv.FindItem(g_hRoot, item);
		if(add)
			tv.InsertItem(fn, TVI_LAST, add, 2, 2);
		return TRUE;
	}
	else
		MessageBox(m_hWnd, "t@CIĂ܂", "G[", MB_OK | MB_ICONERROR);
	return FALSE;
}

bool CMyWnd::OnRename() {

	if(g_hSelected) {
		//xҏW\ɂ
		g_Style = GetWindowLong(tv.m_hWnd, GWL_STYLE);
		g_Style |= TVS_EDITLABELS;
		SetWindowLong(tv.m_hWnd, GWL_STYLE, g_Style);
		//xҏWJn
		TreeView_EditLabel(tv.m_hWnd, g_hSelected);
		//xҏW{^𗘗psɂ
		SendMessage(TBar.m_hWnd, TB_ENABLEBUTTON, IDM_RENAME, MAKELONG(FALSE, 0));
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnVersion() {

	versiondlg.DoModal(m_hWnd, "IDD_VERSION", versiondlgProc);
	return TRUE;
}

bool CMyWnd::OnDefault(WPARAM wParam) {	//WM_COMMAND̓ꏈ

	char menuitem[MAX_PATH];
	int num = LOWORD(wParam) - IDM_HISTORY;
	if(num >= 0 && num < ITEM_MAX) {
		MENUITEMINFO mii = {0};	//ZeroMemory(&mii, sizeof(MENUITEMINFO));Ɠݒ
		mii.cbSize		= sizeof(MENUITEMINFO);
		mii.fMask		= MIIM_ID | MIIM_TYPE;
		mii.fType		= MFT_STRING;
		mii.dwTypeData	= NULL;
		if(GetMenuItemInfo(GetSubMenu(GetSubMenu(GetMenu(m_hWnd), 0), 8), num, TRUE, &mii)) {
			mii.fType		= MFT_STRING;
			mii.dwTypeData	= menuitem;
			mii.cch++;
			if(GetMenuItemInfo(GetSubMenu(GetSubMenu(GetMenu(m_hWnd), 0), 8), num, TRUE, &mii)) {
				WinExec(mii.dwTypeData, SW_SHOWNORMAL);
			}
		}
	}
	return TRUE;
}

///////////////////////////////
//[U[_CAO̊֐`
//Rg[֐
///////////////////////////////
bool VERSIONDLG::OnIdok() {

	EndModal(TRUE);
	return TRUE;
}

